//
// AdvancedMobileDeviceSearchesAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class AdvancedMobileDeviceSearchesAPI {

    /**
     Get Mobile Device Advanced Search criteria choices 
     
     - parameter criteria: (query)  
     - parameter site: (query)  (optional, default to "-1")
     - parameter contains: (query)  (optional, default to "null")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdvancedMobileDeviceSearchesChoicesGet(criteria: String, site: String? = nil, contains: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AdvancedSearchCriteriaChoices?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdvancedMobileDeviceSearchesChoicesGetWithRequestBuilder(criteria: criteria, site: site, contains: contains).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Mobile Device Advanced Search criteria choices 
     - GET /v1/advanced-mobile-device-searches/choices
     - Gets Mobile Device Advanced Search criteria choices. A list of potentially valid choices can be found by navigating to the Criteria page of the Advanced Mobile Device Search creation process. A few are \"App Name\", \"Building\", and \"Display Name\". 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter criteria: (query)  
     - parameter site: (query)  (optional, default to "-1")
     - parameter contains: (query)  (optional, default to "null")
     - returns: RequestBuilder<AdvancedSearchCriteriaChoices> 
     */
    open class func v1AdvancedMobileDeviceSearchesChoicesGetWithRequestBuilder(criteria: String, site: String? = nil, contains: String? = nil) -> RequestBuilder<AdvancedSearchCriteriaChoices> {
        let localVariablePath = "/v1/advanced-mobile-device-searches/choices"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "criteria": (wrappedValue: criteria.encodeToJSON(), isExplode: true),
            "site": (wrappedValue: site?.encodeToJSON(), isExplode: true),
            "contains": (wrappedValue: contains?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AdvancedSearchCriteriaChoices>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Remove specified Advanced Search objects 
     
     - parameter ids: (body) ids of the building to be deleted 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdvancedMobileDeviceSearchesDeleteMultiplePost(ids: Ids, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdvancedMobileDeviceSearchesDeleteMultiplePostWithRequestBuilder(ids: ids).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Remove specified Advanced Search objects 
     - POST /v1/advanced-mobile-device-searches/delete-multiple
     - Removes specified Advanced Search Objects 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter ids: (body) ids of the building to be deleted 
     - returns: RequestBuilder<Void> 
     */
    open class func v1AdvancedMobileDeviceSearchesDeleteMultiplePostWithRequestBuilder(ids: Ids) -> RequestBuilder<Void> {
        let localVariablePath = "/v1/advanced-mobile-device-searches/delete-multiple"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: ids)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Advanced Search objects 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdvancedMobileDeviceSearchesGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AdvancedSearchSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdvancedMobileDeviceSearchesGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Advanced Search objects 
     - GET /v1/advanced-mobile-device-searches
     - Gets Advanced Search Objects 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<AdvancedSearchSearchResults> 
     */
    open class func v1AdvancedMobileDeviceSearchesGetWithRequestBuilder() -> RequestBuilder<AdvancedSearchSearchResults> {
        let localVariablePath = "/v1/advanced-mobile-device-searches"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AdvancedSearchSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Remove specified Advanced Search object 
     
     - parameter id: (path) instance id of advanced search record 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdvancedMobileDeviceSearchesIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdvancedMobileDeviceSearchesIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Remove specified Advanced Search object 
     - DELETE /v1/advanced-mobile-device-searches/{id}
     - Removes specified Advanced Search Object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) instance id of advanced search record 
     - returns: RequestBuilder<Void> 
     */
    open class func v1AdvancedMobileDeviceSearchesIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/advanced-mobile-device-searches/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get specified Advanced Search object 
     
     - parameter id: (path) id of target Advanced Search 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdvancedMobileDeviceSearchesIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AdvancedSearch?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdvancedMobileDeviceSearchesIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get specified Advanced Search object 
     - GET /v1/advanced-mobile-device-searches/{id}
     - Gets Specified Advanced Search Object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of target Advanced Search 
     - returns: RequestBuilder<AdvancedSearch> 
     */
    open class func v1AdvancedMobileDeviceSearchesIdGetWithRequestBuilder(id: String) -> RequestBuilder<AdvancedSearch> {
        var localVariablePath = "/v1/advanced-mobile-device-searches/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AdvancedSearch>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get specified Advanced Search object 
     
     - parameter id: (path) id of target Advanced Search 
     - parameter advancedSearch: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdvancedMobileDeviceSearchesIdPut(id: String, advancedSearch: AdvancedSearch, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AdvancedSearch?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdvancedMobileDeviceSearchesIdPutWithRequestBuilder(id: id, advancedSearch: advancedSearch).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get specified Advanced Search object 
     - PUT /v1/advanced-mobile-device-searches/{id}
     - Gets Specified Advanced Search Object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of target Advanced Search 
     - parameter advancedSearch: (body)  
     - returns: RequestBuilder<AdvancedSearch> 
     */
    open class func v1AdvancedMobileDeviceSearchesIdPutWithRequestBuilder(id: String, advancedSearch: AdvancedSearch) -> RequestBuilder<AdvancedSearch> {
        var localVariablePath = "/v1/advanced-mobile-device-searches/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: advancedSearch)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AdvancedSearch>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create Advanced Search object 
     
     - parameter advancedSearch: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdvancedMobileDeviceSearchesPost(advancedSearch: AdvancedSearch, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdvancedMobileDeviceSearchesPostWithRequestBuilder(advancedSearch: advancedSearch).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create Advanced Search object 
     - POST /v1/advanced-mobile-device-searches
     - Creates Advanced Search Object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter advancedSearch: (body)  
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v1AdvancedMobileDeviceSearchesPostWithRequestBuilder(advancedSearch: AdvancedSearch) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v1/advanced-mobile-device-searches"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: advancedSearch)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
