//
// AdvancedUserContentSearchesAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class AdvancedUserContentSearchesAPI {

    /**
     Get All Advanced User Content Search objects 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdvancedUserContentSearchesGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AdvancedUserContentSearchSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdvancedUserContentSearchesGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get All Advanced User Content Search objects 
     - GET /v1/advanced-user-content-searches
     - Get All Advanced User Content Search Objects 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<AdvancedUserContentSearchSearchResults> 
     */
    open class func v1AdvancedUserContentSearchesGetWithRequestBuilder() -> RequestBuilder<AdvancedUserContentSearchSearchResults> {
        let localVariablePath = "/v1/advanced-user-content-searches"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AdvancedUserContentSearchSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Remove specified Advanced User Content Search object 
     
     - parameter id: (path) instance id of Advanced User Content Search record 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdvancedUserContentSearchesIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdvancedUserContentSearchesIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Remove specified Advanced User Content Search object 
     - DELETE /v1/advanced-user-content-searches/{id}
     - Removes specified Advanced User Content Search Object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) instance id of Advanced User Content Search record 
     - returns: RequestBuilder<Void> 
     */
    open class func v1AdvancedUserContentSearchesIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/advanced-user-content-searches/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Specified Advanced User Content Search object 
     
     - parameter id: (path) id of target Advanced User Content Search 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdvancedUserContentSearchesIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AdvancedUserContentSearch?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdvancedUserContentSearchesIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Specified Advanced User Content Search object 
     - GET /v1/advanced-user-content-searches/{id}
     - Gets Specified Advanced User Content Search Object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of target Advanced User Content Search 
     - returns: RequestBuilder<AdvancedUserContentSearch> 
     */
    open class func v1AdvancedUserContentSearchesIdGetWithRequestBuilder(id: String) -> RequestBuilder<AdvancedUserContentSearch> {
        var localVariablePath = "/v1/advanced-user-content-searches/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AdvancedUserContentSearch>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Specified Advanced User Content Search object 
     
     - parameter id: (path) id of target Advanced User Content Search 
     - parameter advancedUserContentSearch: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdvancedUserContentSearchesIdPut(id: String, advancedUserContentSearch: AdvancedUserContentSearch, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AdvancedUserContentSearch?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdvancedUserContentSearchesIdPutWithRequestBuilder(id: id, advancedUserContentSearch: advancedUserContentSearch).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Specified Advanced User Content Search object 
     - PUT /v1/advanced-user-content-searches/{id}
     - Gets Specified Advanced User Content Search Object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of target Advanced User Content Search 
     - parameter advancedUserContentSearch: (body)  
     - returns: RequestBuilder<AdvancedUserContentSearch> 
     */
    open class func v1AdvancedUserContentSearchesIdPutWithRequestBuilder(id: String, advancedUserContentSearch: AdvancedUserContentSearch) -> RequestBuilder<AdvancedUserContentSearch> {
        var localVariablePath = "/v1/advanced-user-content-searches/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: advancedUserContentSearch)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AdvancedUserContentSearch>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create Advanced User Content Search object 
     
     - parameter advancedUserContentSearch: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdvancedUserContentSearchesPost(advancedUserContentSearch: AdvancedUserContentSearch, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdvancedUserContentSearchesPostWithRequestBuilder(advancedUserContentSearch: advancedUserContentSearch).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create Advanced User Content Search object 
     - POST /v1/advanced-user-content-searches
     - Creates Advanced User Content Search Object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter advancedUserContentSearch: (body)  
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v1AdvancedUserContentSearchesPostWithRequestBuilder(advancedUserContentSearch: AdvancedUserContentSearch) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v1/advanced-user-content-searches"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: advancedUserContentSearch)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
