//
// ApiRolePrivilegesAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class ApiRolePrivilegesAPI {

    /**
     Get the current Jamf API Role Privileges
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ApiRolePrivilegesGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ApiRolePrivileges?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ApiRolePrivilegesGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get the current Jamf API Role Privileges
     - GET /v1/api-role-privileges
     - Get role privileges
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<ApiRolePrivileges> 
     */
    open class func v1ApiRolePrivilegesGetWithRequestBuilder() -> RequestBuilder<ApiRolePrivileges> {
        let localVariablePath = "/v1/api-role-privileges"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ApiRolePrivileges>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Search the current Jamf API Role Privileges
     
     - parameter name: (query) The partial or complete privilege name we are searching for 
     - parameter limit: (query) Limit the query results, defaults to 15 (optional, default to "15")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ApiRolePrivilegesSearchGet(name: String, limit: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ApiRolePrivileges?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ApiRolePrivilegesSearchGetWithRequestBuilder(name: name, limit: limit).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Search the current Jamf API Role Privileges
     - GET /v1/api-role-privileges/search
     - Search role privileges
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter name: (query) The partial or complete privilege name we are searching for 
     - parameter limit: (query) Limit the query results, defaults to 15 (optional, default to "15")
     - returns: RequestBuilder<ApiRolePrivileges> 
     */
    open class func v1ApiRolePrivilegesSearchGetWithRequestBuilder(name: String, limit: String? = nil) -> RequestBuilder<ApiRolePrivileges> {
        let localVariablePath = "/v1/api-role-privileges/search"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "name": (wrappedValue: name.encodeToJSON(), isExplode: true),
            "limit": (wrappedValue: limit?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ApiRolePrivileges>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
