//
// AppRequestPreviewAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class AppRequestPreviewAPI {

    /**
     Search for Form Input Fields 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AppRequestFormInputFieldsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AppRequestFormInputFieldSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AppRequestFormInputFieldsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Search for Form Input Fields 
     - GET /v1/app-request/form-input-fields
     - Search for form input fields
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<AppRequestFormInputFieldSearchResults> 
     */
    open class func v1AppRequestFormInputFieldsGetWithRequestBuilder() -> RequestBuilder<AppRequestFormInputFieldSearchResults> {
        let localVariablePath = "/v1/app-request/form-input-fields"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AppRequestFormInputFieldSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Remove specified Form Input Field record 
     
     - parameter id: (path) Instance id of form input field record 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AppRequestFormInputFieldsIdDelete(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AppRequestFormInputFieldsIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Remove specified Form Input Field record 
     - DELETE /v1/app-request/form-input-fields/{id}
     - Removes specified form input field record 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Instance id of form input field record 
     - returns: RequestBuilder<Void> 
     */
    open class func v1AppRequestFormInputFieldsIdDeleteWithRequestBuilder(id: Int) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/app-request/form-input-fields/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get specified Form Input Field object 
     
     - parameter id: (path) Instance id of form input field record 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AppRequestFormInputFieldsIdGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AppRequestFormInputField?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AppRequestFormInputFieldsIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get specified Form Input Field object 
     - GET /v1/app-request/form-input-fields/{id}
     - Gets specified form input field object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Instance id of form input field record 
     - returns: RequestBuilder<AppRequestFormInputField> 
     */
    open class func v1AppRequestFormInputFieldsIdGetWithRequestBuilder(id: Int) -> RequestBuilder<AppRequestFormInputField> {
        var localVariablePath = "/v1/app-request/form-input-fields/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AppRequestFormInputField>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update specified Form Input Field object 
     
     - parameter id: (path) Instance id of form input field record 
     - parameter appRequestFormInputField: (body) form input field object to create. ids defined in this body will be ignored 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AppRequestFormInputFieldsIdPut(id: Int, appRequestFormInputField: AppRequestFormInputField, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AppRequestFormInputField?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AppRequestFormInputFieldsIdPutWithRequestBuilder(id: id, appRequestFormInputField: appRequestFormInputField).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update specified Form Input Field object 
     - PUT /v1/app-request/form-input-fields/{id}
     - Update specified form input field object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Instance id of form input field record 
     - parameter appRequestFormInputField: (body) form input field object to create. ids defined in this body will be ignored 
     - returns: RequestBuilder<AppRequestFormInputField> 
     */
    open class func v1AppRequestFormInputFieldsIdPutWithRequestBuilder(id: Int, appRequestFormInputField: AppRequestFormInputField) -> RequestBuilder<AppRequestFormInputField> {
        var localVariablePath = "/v1/app-request/form-input-fields/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: appRequestFormInputField)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AppRequestFormInputField>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create Form Input Field record 
     
     - parameter appRequestFormInputField: (body) form input field object to create. ids defined in this body will be ignored 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AppRequestFormInputFieldsPost(appRequestFormInputField: AppRequestFormInputField, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AppRequestFormInputField?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AppRequestFormInputFieldsPostWithRequestBuilder(appRequestFormInputField: appRequestFormInputField).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create Form Input Field record 
     - POST /v1/app-request/form-input-fields
     - Create form input field record 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter appRequestFormInputField: (body) form input field object to create. ids defined in this body will be ignored 
     - returns: RequestBuilder<AppRequestFormInputField> 
     */
    open class func v1AppRequestFormInputFieldsPostWithRequestBuilder(appRequestFormInputField: AppRequestFormInputField) -> RequestBuilder<AppRequestFormInputField> {
        let localVariablePath = "/v1/app-request/form-input-fields"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: appRequestFormInputField)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AppRequestFormInputField>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Replace all Form Input Fields 
     
     - parameter appRequestFormInputField: (body) list of form input fields to replace all existing fields. Will delete, update, and create all input fields accordingly. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AppRequestFormInputFieldsPut(appRequestFormInputField: [AppRequestFormInputField], apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [AppRequestFormInputField]?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AppRequestFormInputFieldsPutWithRequestBuilder(appRequestFormInputField: appRequestFormInputField).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Replace all Form Input Fields 
     - PUT /v1/app-request/form-input-fields
     - Replace all form input fields. Will delete, update, and create all input fields accordingly. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter appRequestFormInputField: (body) list of form input fields to replace all existing fields. Will delete, update, and create all input fields accordingly. 
     - returns: RequestBuilder<[AppRequestFormInputField]> 
     */
    open class func v1AppRequestFormInputFieldsPutWithRequestBuilder(appRequestFormInputField: [AppRequestFormInputField]) -> RequestBuilder<[AppRequestFormInputField]> {
        let localVariablePath = "/v1/app-request/form-input-fields"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: appRequestFormInputField)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[AppRequestFormInputField]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Applicastion Request Settings 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AppRequestSettingsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AppRequestSettings?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AppRequestSettingsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Applicastion Request Settings 
     - GET /v1/app-request/settings
     - Get app request settings 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<AppRequestSettings> 
     */
    open class func v1AppRequestSettingsGetWithRequestBuilder() -> RequestBuilder<AppRequestSettings> {
        let localVariablePath = "/v1/app-request/settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AppRequestSettings>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Application Request Settings 
     
     - parameter appRequestSettings: (body) App request settings object 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AppRequestSettingsPut(appRequestSettings: AppRequestSettings, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AppRequestSettings?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AppRequestSettingsPutWithRequestBuilder(appRequestSettings: appRequestSettings).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Application Request Settings 
     - PUT /v1/app-request/settings
     - Update app request settings 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter appRequestSettings: (body) App request settings object 
     - returns: RequestBuilder<AppRequestSettings> 
     */
    open class func v1AppRequestSettingsPutWithRequestBuilder(appRequestSettings: AppRequestSettings) -> RequestBuilder<AppRequestSettings> {
        let localVariablePath = "/v1/app-request/settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: appRequestSettings)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AppRequestSettings>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
