//
// AppStoreCountryCodesPreviewAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class AppStoreCountryCodesPreviewAPI {

    /**
     Return a list of Countries and the associated Codes 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AppStoreCountryCodesGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CountryCodes?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AppStoreCountryCodesGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Return a list of Countries and the associated Codes 
     - GET /v1/app-store-country-codes
     - Returns a list of countries and the associated codes that can be use for the App Store locale 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<CountryCodes> 
     */
    open class func v1AppStoreCountryCodesGetWithRequestBuilder() -> RequestBuilder<CountryCodes> {
        let localVariablePath = "/v1/app-store-country-codes"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CountryCodes>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
