//
// CacheSettingsAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class CacheSettingsAPI {

    /**
     Get Cache Settings 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1CacheSettingsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CacheSettings?, _ error: Error?) -> Void)) -> RequestTask {
        return v1CacheSettingsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Cache Settings 
     - GET /v1/cache-settings
     - gets cache settings
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<CacheSettings> 
     */
    open class func v1CacheSettingsGetWithRequestBuilder() -> RequestBuilder<CacheSettings> {
        let localVariablePath = "/v1/cache-settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CacheSettings>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Cache Settings 
     
     - parameter cacheSettings: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1CacheSettingsPut(cacheSettings: CacheSettings, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CacheSettings?, _ error: Error?) -> Void)) -> RequestTask {
        return v1CacheSettingsPutWithRequestBuilder(cacheSettings: cacheSettings).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Cache Settings 
     - PUT /v1/cache-settings
     - updates cache settings 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter cacheSettings: (body)  
     - returns: RequestBuilder<CacheSettings> 
     */
    open class func v1CacheSettingsPutWithRequestBuilder(cacheSettings: CacheSettings) -> RequestBuilder<CacheSettings> {
        let localVariablePath = "/v1/cache-settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: cacheSettings)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CacheSettings>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
