//
// CertificateAuthorityAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class CertificateAuthorityAPI {

    /**
     Returns X.509 of active Certificate Authority (CA) in DER format
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1PkiCertificateAuthorityActiveDerGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: URL?, _ error: Error?) -> Void)) -> RequestTask {
        return v1PkiCertificateAuthorityActiveDerGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Returns X.509 of active Certificate Authority (CA) in DER format
     - GET /v1/pki/certificate-authority/active/der
     - Returns X.509 of active Certificate Authority (CA) in DER format
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<URL> 
     */
    open class func v1PkiCertificateAuthorityActiveDerGetWithRequestBuilder() -> RequestBuilder<URL> {
        let localVariablePath = "/v1/pki/certificate-authority/active/der"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<URL>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Returns X.509 details of the active Certificate Authority (CA)
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1PkiCertificateAuthorityActiveGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CertificateRecord?, _ error: Error?) -> Void)) -> RequestTask {
        return v1PkiCertificateAuthorityActiveGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Returns X.509 details of the active Certificate Authority (CA)
     - GET /v1/pki/certificate-authority/active
     - Returns X.509 details of the active Certificate Authority (CA)
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<CertificateRecord> 
     */
    open class func v1PkiCertificateAuthorityActiveGetWithRequestBuilder() -> RequestBuilder<CertificateRecord> {
        let localVariablePath = "/v1/pki/certificate-authority/active"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CertificateRecord>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Returns active Certificate Authority (CA) in PEM format
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1PkiCertificateAuthorityActivePemGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: URL?, _ error: Error?) -> Void)) -> RequestTask {
        return v1PkiCertificateAuthorityActivePemGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Returns active Certificate Authority (CA) in PEM format
     - GET /v1/pki/certificate-authority/active/pem
     - Returns active Certificate Authority (CA) in PEM format
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<URL> 
     */
    open class func v1PkiCertificateAuthorityActivePemGetWithRequestBuilder() -> RequestBuilder<URL> {
        let localVariablePath = "/v1/pki/certificate-authority/active/pem"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<URL>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Returns X.509 current Certificate Authority (CA) with provided ID in DER format
     
     - parameter id: (path) UUID of the Certificate Authority (CA) 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1PkiCertificateAuthorityIdDerGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: URL?, _ error: Error?) -> Void)) -> RequestTask {
        return v1PkiCertificateAuthorityIdDerGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Returns X.509 current Certificate Authority (CA) with provided ID in DER format
     - GET /v1/pki/certificate-authority/{id}/der
     - Returns X.509 current Certificate Authority (CA) with provided ID in DER format
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) UUID of the Certificate Authority (CA) 
     - returns: RequestBuilder<URL> 
     */
    open class func v1PkiCertificateAuthorityIdDerGetWithRequestBuilder(id: String) -> RequestBuilder<URL> {
        var localVariablePath = "/v1/pki/certificate-authority/{id}/der"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<URL>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Returns X.509 details of Certificate Authority (CA) with provided ID
     
     - parameter id: (path) UUID of the Certificate Authority (CA) 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1PkiCertificateAuthorityIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CertificateRecord?, _ error: Error?) -> Void)) -> RequestTask {
        return v1PkiCertificateAuthorityIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Returns X.509 details of Certificate Authority (CA) with provided ID
     - GET /v1/pki/certificate-authority/{id}
     - Returns X.509 details of Certificate Authority (CA) with provided ID
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) UUID of the Certificate Authority (CA) 
     - returns: RequestBuilder<CertificateRecord> 
     */
    open class func v1PkiCertificateAuthorityIdGetWithRequestBuilder(id: String) -> RequestBuilder<CertificateRecord> {
        var localVariablePath = "/v1/pki/certificate-authority/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CertificateRecord>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Returns current Certificate Authority (CA) with provided ID in PEM format
     
     - parameter id: (path) UUID of the Certificate Authority (CA) 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1PkiCertificateAuthorityIdPemGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: URL?, _ error: Error?) -> Void)) -> RequestTask {
        return v1PkiCertificateAuthorityIdPemGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Returns current Certificate Authority (CA) with provided ID in PEM format
     - GET /v1/pki/certificate-authority/{id}/pem
     - Returns current Certificate Authority (CA) with provided ID in PEM format
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) UUID of the Certificate Authority (CA) 
     - returns: RequestBuilder<URL> 
     */
    open class func v1PkiCertificateAuthorityIdPemGetWithRequestBuilder(id: String) -> RequestBuilder<URL> {
        var localVariablePath = "/v1/pki/certificate-authority/{id}/pem"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<URL>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
