//
// ClassicLdapAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class ClassicLdapAPI {

    /**
     Get mappings for OnPrem Ldap configuration with given id.
     
     - parameter id: (path) OnPrem Ldap identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ClassicLdapIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ClassicLdapMappings?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ClassicLdapIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get mappings for OnPrem Ldap configuration with given id.
     - GET /v1/classic-ldap/{id}
     - Get mappings for OnPrem Ldap configuration with given id.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) OnPrem Ldap identifier 
     - returns: RequestBuilder<ClassicLdapMappings> 
     */
    open class func v1ClassicLdapIdGetWithRequestBuilder(id: String) -> RequestBuilder<ClassicLdapMappings> {
        var localVariablePath = "/v1/classic-ldap/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ClassicLdapMappings>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
