//
// CloudAzureAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class CloudAzureAPI {

    /**
     Get default mappings
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1CloudAzureDefaultsMappingsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AzureMappings?, _ error: Error?) -> Void)) -> RequestTask {
        return v1CloudAzureDefaultsMappingsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get default mappings
     - GET /v1/cloud-azure/defaults/mappings
     - This is the default set of attributes that allows you to return the data you need from Azure AD. Some fields may be empty and may be edited when creating a new configuration.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<AzureMappings> 
     */
    open class func v1CloudAzureDefaultsMappingsGetWithRequestBuilder() -> RequestBuilder<AzureMappings> {
        let localVariablePath = "/v1/cloud-azure/defaults/mappings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AzureMappings>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get default server configuration
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1CloudAzureDefaultsServerConfigurationGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AzureServerConfiguration?, _ error: Error?) -> Void)) -> RequestTask {
        return v1CloudAzureDefaultsServerConfigurationGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get default server configuration
     - GET /v1/cloud-azure/defaults/server-configuration
     - This is the default set of attributes that allows you to return the data you need from Azure AD. Some fields may be empty and may be edited when creating a new configuration.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<AzureServerConfiguration> 
     */
    open class func v1CloudAzureDefaultsServerConfigurationGetWithRequestBuilder() -> RequestBuilder<AzureServerConfiguration> {
        let localVariablePath = "/v1/cloud-azure/defaults/server-configuration"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AzureServerConfiguration>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete Cloud Identity Provider configuration.
     
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1CloudAzureIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1CloudAzureIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete Cloud Identity Provider configuration.
     - DELETE /v1/cloud-azure/{id}
     - Delete Cloud Identity Provider configuration.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Cloud Identity Provider identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v1CloudAzureIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/cloud-azure/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Azure Cloud Identity Provider configuration with given ID.
     
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1CloudAzureIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AzureConfiguration?, _ error: Error?) -> Void)) -> RequestTask {
        return v1CloudAzureIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Azure Cloud Identity Provider configuration with given ID.
     - GET /v1/cloud-azure/{id}
     - Get Azure Cloud Identity Provider configuration with given ID.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Cloud Identity Provider identifier 
     - returns: RequestBuilder<AzureConfiguration> 
     */
    open class func v1CloudAzureIdGetWithRequestBuilder(id: String) -> RequestBuilder<AzureConfiguration> {
        var localVariablePath = "/v1/cloud-azure/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AzureConfiguration>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Azure Cloud Identity Provider configuration
     
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter azureConfigurationUpdate: (body) Azure Cloud Identity Provider configuration to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1CloudAzureIdPut(id: String, azureConfigurationUpdate: AzureConfigurationUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AzureConfiguration?, _ error: Error?) -> Void)) -> RequestTask {
        return v1CloudAzureIdPutWithRequestBuilder(id: id, azureConfigurationUpdate: azureConfigurationUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Azure Cloud Identity Provider configuration
     - PUT /v1/cloud-azure/{id}
     - Update Azure Cloud Identity Provider configuration. Cannot be used for partial updates, all content body must be sent.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter azureConfigurationUpdate: (body) Azure Cloud Identity Provider configuration to update 
     - returns: RequestBuilder<AzureConfiguration> 
     */
    open class func v1CloudAzureIdPutWithRequestBuilder(id: String, azureConfigurationUpdate: AzureConfigurationUpdate) -> RequestBuilder<AzureConfiguration> {
        var localVariablePath = "/v1/cloud-azure/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: azureConfigurationUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AzureConfiguration>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create Azure Cloud Identity Provider configuration
     
     - parameter azureConfigurationRequest: (body) Azure Cloud Identity Provider configuration to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1CloudAzurePost(azureConfigurationRequest: AzureConfigurationRequest, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1CloudAzurePostWithRequestBuilder(azureConfigurationRequest: azureConfigurationRequest).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create Azure Cloud Identity Provider configuration
     - POST /v1/cloud-azure
     - Create new Azure Cloud Identity Provider configuration with unique display name.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter azureConfigurationRequest: (body) Azure Cloud Identity Provider configuration to create 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v1CloudAzurePostWithRequestBuilder(azureConfigurationRequest: AzureConfigurationRequest) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v1/cloud-azure"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: azureConfigurationRequest)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
