//
// CloudInformationAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class CloudInformationAPI {

    /**
     Retrieve information related to cloud setup. 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1CloudInformationGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CloudResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1CloudInformationGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve information related to cloud setup. 
     - GET /v1/cloud-information
     - Retrieve information related to cloud setup. Retrieves information related to cloud setup. Provides details about cloud instance configuration. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<CloudResponse> 
     */
    open class func v1CloudInformationGetWithRequestBuilder() -> RequestBuilder<CloudResponse> {
        let localVariablePath = "/v1/cloud-information"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CloudResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
