//
// CloudLdapAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class CloudLdapAPI {

    /**
     Validate keystore for Cloud Identity Provider secure connection
     
     - parameter cloudLdapKeystoreFile: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1LdapKeystoreVerifyPost(cloudLdapKeystoreFile: CloudLdapKeystoreFile, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CloudLdapKeystore?, _ error: Error?) -> Void)) -> RequestTask {
        return v1LdapKeystoreVerifyPostWithRequestBuilder(cloudLdapKeystoreFile: cloudLdapKeystoreFile).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Validate keystore for Cloud Identity Provider secure connection
     - POST /v1/ldap-keystore/verify
     - Validate keystore for Cloud Identity Provider secure connection
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter cloudLdapKeystoreFile: (body)  
     - returns: RequestBuilder<CloudLdapKeystore> 
     */
    open class func v1LdapKeystoreVerifyPostWithRequestBuilder(cloudLdapKeystoreFile: CloudLdapKeystoreFile) -> RequestBuilder<CloudLdapKeystore> {
        let localVariablePath = "/v1/ldap-keystore/verify"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: cloudLdapKeystoreFile)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CloudLdapKeystore>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get default mappings
     
     - parameter provider: (path) Cloud Identity Provider name 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2CloudLdapsDefaultsProviderMappingsGet(provider: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CloudLdapMappingsResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2CloudLdapsDefaultsProviderMappingsGetWithRequestBuilder(provider: provider).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get default mappings
     - GET /v2/cloud-ldaps/defaults/{provider}/mappings
     - Get default mappings for Cloud Identity Provider Provider.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter provider: (path) Cloud Identity Provider name 
     - returns: RequestBuilder<CloudLdapMappingsResponse> 
     */
    open class func v2CloudLdapsDefaultsProviderMappingsGetWithRequestBuilder(provider: String) -> RequestBuilder<CloudLdapMappingsResponse> {
        var localVariablePath = "/v2/cloud-ldaps/defaults/{provider}/mappings"
        let providerPreEscape = "\(APIHelper.mapValueToPathItem(provider))"
        let providerPostEscape = providerPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{provider}", with: providerPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CloudLdapMappingsResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get default server configuration
     
     - parameter provider: (path) Cloud Identity Provider name 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2CloudLdapsDefaultsProviderServerConfigurationGet(provider: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CloudLdapServerResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2CloudLdapsDefaultsProviderServerConfigurationGetWithRequestBuilder(provider: provider).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get default server configuration
     - GET /v2/cloud-ldaps/defaults/{provider}/server-configuration
     - Get default server configuration for Cloud Identity Provider Identity Provider.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter provider: (path) Cloud Identity Provider name 
     - returns: RequestBuilder<CloudLdapServerResponse> 
     */
    open class func v2CloudLdapsDefaultsProviderServerConfigurationGetWithRequestBuilder(provider: String) -> RequestBuilder<CloudLdapServerResponse> {
        var localVariablePath = "/v2/cloud-ldaps/defaults/{provider}/server-configuration"
        let providerPreEscape = "\(APIHelper.mapValueToPathItem(provider))"
        let providerPostEscape = providerPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{provider}", with: providerPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CloudLdapServerResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get bind connection pool statistics
     
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2CloudLdapsIdConnectionBindGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CloudLdapConnectionPoolStatistics?, _ error: Error?) -> Void)) -> RequestTask {
        return v2CloudLdapsIdConnectionBindGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get bind connection pool statistics
     - GET /v2/cloud-ldaps/{id}/connection/bind
     - Get all search connection pool for chosen Cloud Identity Provider. numConnectionsClosedDefunct - The number of connections that have been closed as defunct. numConnectionsClosedExpired - The number of connections that have been closed because they were expired. numConnectionsClosedUnneeded - The number of connections that have been closed because they were no longer needed. numFailedCheckouts - The number of failed attempts to check out a connection from the pool. numFailedConnectionAttempts - The number of failed attempts to create a connection for use in the pool. numReleasedValid - The number of valid connections released back to the pool. numSuccessfulCheckouts - The number of successful attempts to check out a connection from the pool. numSuccessfulCheckoutsNewConnection - The number of successful checkout attempts that had to create a new connection because none were available. numSuccessfulConnectionAttempts - The number successful attempts to create a connection for use in the pool. maximumAvailableConnections - The maximum number of connections that may be available in the pool at any time. numSuccessfulCheckoutsWithoutWait - The number of successful checkout attempts that were able to take an existing connection without waiting. numSuccessfulCheckoutsAfterWait - The number of successful checkout attempts that retrieved a connection from the pool after waiting for it to become available. numAvailableConnections - The number of connections currently available for use in the pool. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Cloud Identity Provider identifier 
     - returns: RequestBuilder<CloudLdapConnectionPoolStatistics> 
     */
    open class func v2CloudLdapsIdConnectionBindGetWithRequestBuilder(id: String) -> RequestBuilder<CloudLdapConnectionPoolStatistics> {
        var localVariablePath = "/v2/cloud-ldaps/{id}/connection/bind"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CloudLdapConnectionPoolStatistics>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get search connection pool statistics
     
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2CloudLdapsIdConnectionSearchGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CloudLdapConnectionPoolStatistics?, _ error: Error?) -> Void)) -> RequestTask {
        return v2CloudLdapsIdConnectionSearchGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get search connection pool statistics
     - GET /v2/cloud-ldaps/{id}/connection/search
     - Get all search connection pool for chosen Cloud Identity Provider. numConnectionsClosedDefunct - The number of connections that have been closed as defunct. numConnectionsClosedExpired - The number of connections that have been closed because they were expired. numConnectionsClosedUnneeded - The number of connections that have been closed because they were no longer needed. numFailedCheckouts - The number of failed attempts to check out a connection from the pool. numFailedConnectionAttempts - The number of failed attempts to create a connection for use in the pool. numReleasedValid - The number of valid connections released back to the pool. numSuccessfulCheckouts - The number of successful attempts to check out a connection from the pool. numSuccessfulCheckoutsNewConnection - The number of successful checkout attempts that had to create a new connection because none were available. numSuccessfulConnectionAttempts - The number successful attempts to create a connection for use in the pool. maximumAvailableConnections - The maximum number of connections that may be available in the pool at any time. numSuccessfulCheckoutsWithoutWait - The number of successful checkout attempts that were able to take an existing connection without waiting. numSuccessfulCheckoutsAfterWait - The number of successful checkout attempts that retrieved a connection from the pool after waiting for it to become available. numAvailableConnections - The number of connections currently available for use in the pool. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Cloud Identity Provider identifier 
     - returns: RequestBuilder<CloudLdapConnectionPoolStatistics> 
     */
    open class func v2CloudLdapsIdConnectionSearchGetWithRequestBuilder(id: String) -> RequestBuilder<CloudLdapConnectionPoolStatistics> {
        var localVariablePath = "/v2/cloud-ldaps/{id}/connection/search"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CloudLdapConnectionPoolStatistics>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Tests the communication with the specified cloud connection 
     
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2CloudLdapsIdConnectionStatusGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CloudLdapConnectionStatus?, _ error: Error?) -> Void)) -> RequestTask {
        return v2CloudLdapsIdConnectionStatusGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Tests the communication with the specified cloud connection 
     - GET /v2/cloud-ldaps/{id}/connection/status
     - Tests the communication with the specified cloud connection 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Cloud Identity Provider identifier 
     - returns: RequestBuilder<CloudLdapConnectionStatus> 
     */
    open class func v2CloudLdapsIdConnectionStatusGetWithRequestBuilder(id: String) -> RequestBuilder<CloudLdapConnectionStatus> {
        var localVariablePath = "/v2/cloud-ldaps/{id}/connection/status"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CloudLdapConnectionStatus>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete Cloud Identity Provider configuration.
     
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2CloudLdapsIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2CloudLdapsIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete Cloud Identity Provider configuration.
     - DELETE /v2/cloud-ldaps/{id}
     - Delete Cloud Identity Provider configuration.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Cloud Identity Provider identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v2CloudLdapsIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/cloud-ldaps/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Cloud Identity Provider configuration with given id.
     
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2CloudLdapsIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LdapConfigurationResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2CloudLdapsIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Cloud Identity Provider configuration with given id.
     - GET /v2/cloud-ldaps/{id}
     - Get Cloud Identity Provider configuration with given id.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Cloud Identity Provider identifier 
     - returns: RequestBuilder<LdapConfigurationResponse> 
     */
    open class func v2CloudLdapsIdGetWithRequestBuilder(id: String) -> RequestBuilder<LdapConfigurationResponse> {
        var localVariablePath = "/v2/cloud-ldaps/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LdapConfigurationResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get mappings configurations for Cloud Identity Providers server configuration.
     
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2CloudLdapsIdMappingsGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CloudLdapMappingsResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2CloudLdapsIdMappingsGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get mappings configurations for Cloud Identity Providers server configuration.
     - GET /v2/cloud-ldaps/{id}/mappings
     - Get all mappings configurations for Cloud Identity Providers server configuration.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Cloud Identity Provider identifier 
     - returns: RequestBuilder<CloudLdapMappingsResponse> 
     */
    open class func v2CloudLdapsIdMappingsGetWithRequestBuilder(id: String) -> RequestBuilder<CloudLdapMappingsResponse> {
        var localVariablePath = "/v2/cloud-ldaps/{id}/mappings"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CloudLdapMappingsResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Cloud Identity Provider mappings configuration.
     
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter cloudLdapMappingsRequest: (body) Cloud Identity Provider mappings to update. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2CloudLdapsIdMappingsPut(id: String, cloudLdapMappingsRequest: CloudLdapMappingsRequest, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CloudLdapMappingsResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2CloudLdapsIdMappingsPutWithRequestBuilder(id: id, cloudLdapMappingsRequest: cloudLdapMappingsRequest).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Cloud Identity Provider mappings configuration.
     - PUT /v2/cloud-ldaps/{id}/mappings
     - Update Cloud Identity Provider mappings configuration. Cannot be used for partial updates, all content body must be sent.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter cloudLdapMappingsRequest: (body) Cloud Identity Provider mappings to update. 
     - returns: RequestBuilder<CloudLdapMappingsResponse> 
     */
    open class func v2CloudLdapsIdMappingsPutWithRequestBuilder(id: String, cloudLdapMappingsRequest: CloudLdapMappingsRequest) -> RequestBuilder<CloudLdapMappingsResponse> {
        var localVariablePath = "/v2/cloud-ldaps/{id}/mappings"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: cloudLdapMappingsRequest)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CloudLdapMappingsResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Cloud Identity Provider configuration
     
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter ldapConfigurationUpdate: (body) Cloud Identity Provider configuration to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2CloudLdapsIdPut(id: String, ldapConfigurationUpdate: LdapConfigurationUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LdapConfigurationResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2CloudLdapsIdPutWithRequestBuilder(id: id, ldapConfigurationUpdate: ldapConfigurationUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Cloud Identity Provider configuration
     - PUT /v2/cloud-ldaps/{id}
     - Update Cloud Identity Provider configuration. Cannot be used for partial updates, all content body must be sent.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Cloud Identity Provider identifier 
     - parameter ldapConfigurationUpdate: (body) Cloud Identity Provider configuration to update 
     - returns: RequestBuilder<LdapConfigurationResponse> 
     */
    open class func v2CloudLdapsIdPutWithRequestBuilder(id: String, ldapConfigurationUpdate: LdapConfigurationUpdate) -> RequestBuilder<LdapConfigurationResponse> {
        var localVariablePath = "/v2/cloud-ldaps/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: ldapConfigurationUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LdapConfigurationResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create Cloud Identity Provider configuration
     
     - parameter ldapConfigurationRequest: (body) Cloud Identity Provider configuration to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2CloudLdapsPost(ldapConfigurationRequest: LdapConfigurationRequest, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2CloudLdapsPostWithRequestBuilder(ldapConfigurationRequest: ldapConfigurationRequest).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create Cloud Identity Provider configuration
     - POST /v2/cloud-ldaps
     - Create new Cloud Identity Provider configuration with unique display name. If mappings not provided, then defaults will be generated instead.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter ldapConfigurationRequest: (body) Cloud Identity Provider configuration to create 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v2CloudLdapsPostWithRequestBuilder(ldapConfigurationRequest: LdapConfigurationRequest) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v2/cloud-ldaps"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: ldapConfigurationRequest)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
