//
// ComputerPrestagesAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class ComputerPrestagesAPI {

    /**
     Remove device Scope for a specific Computer Prestage 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to remove from scope 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1ComputerPrestagesIdScopeDelete(id: Int, prestageScopeUpdate: PrestageScopeUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ComputerPrestagesIdScopeDeleteWithRequestBuilder(id: id, prestageScopeUpdate: prestageScopeUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Remove device Scope for a specific Computer Prestage 
     - DELETE /v1/computer-prestages/{id}/scope
     - Remove device scope for a specific computer prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to remove from scope 
     - returns: RequestBuilder<PrestageScopeResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1ComputerPrestagesIdScopeDeleteWithRequestBuilder(id: Int, prestageScopeUpdate: PrestageScopeUpdate) -> RequestBuilder<PrestageScopeResponse> {
        var localVariablePath = "/v1/computer-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: prestageScopeUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get device Scope for a specific Computer Prestage 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1ComputerPrestagesIdScopeGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ComputerPrestagesIdScopeGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get device Scope for a specific Computer Prestage 
     - GET /v1/computer-prestages/{id}/scope
     - Get device scope for a specific computer prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - returns: RequestBuilder<PrestageScopeResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1ComputerPrestagesIdScopeGetWithRequestBuilder(id: Int) -> RequestBuilder<PrestageScopeResponse> {
        var localVariablePath = "/v1/computer-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add device Scope for a specific Computer Prestage 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1ComputerPrestagesIdScopePost(id: Int, prestageScopeUpdate: PrestageScopeUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ComputerPrestagesIdScopePostWithRequestBuilder(id: id, prestageScopeUpdate: prestageScopeUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add device Scope for a specific Computer Prestage 
     - POST /v1/computer-prestages/{id}/scope
     - Add device scope for a specific computer prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - returns: RequestBuilder<PrestageScopeResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1ComputerPrestagesIdScopePostWithRequestBuilder(id: Int, prestageScopeUpdate: PrestageScopeUpdate) -> RequestBuilder<PrestageScopeResponse> {
        var localVariablePath = "/v1/computer-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: prestageScopeUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Replace device Scope for a specific Computer Prestage 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1ComputerPrestagesIdScopePut(id: Int, prestageScopeUpdate: PrestageScopeUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ComputerPrestagesIdScopePutWithRequestBuilder(id: id, prestageScopeUpdate: prestageScopeUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Replace device Scope for a specific Computer Prestage 
     - PUT /v1/computer-prestages/{id}/scope
     - Replace device scope for a specific computer prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - returns: RequestBuilder<PrestageScopeResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1ComputerPrestagesIdScopePutWithRequestBuilder(id: Int, prestageScopeUpdate: PrestageScopeUpdate) -> RequestBuilder<PrestageScopeResponse> {
        var localVariablePath = "/v1/computer-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: prestageScopeUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get all device Scope for all Computer Prestages 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1ComputerPrestagesScopeGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScope?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ComputerPrestagesScopeGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get all device Scope for all Computer Prestages 
     - GET /v1/computer-prestages/scope
     - Get all device scope for all computer prestages
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<PrestageScope> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1ComputerPrestagesScopeGetWithRequestBuilder() -> RequestBuilder<PrestageScope> {
        let localVariablePath = "/v1/computer-prestages/scope"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScope>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get sorted and paged Computer Prestages 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2ComputerPrestagesGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ComputerPrestageSearchResultsV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2ComputerPrestagesGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get sorted and paged Computer Prestages 
     - GET /v2/computer-prestages
     - Gets sorted and paged computer prestages
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional)
     - returns: RequestBuilder<ComputerPrestageSearchResultsV2> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2ComputerPrestagesGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<ComputerPrestageSearchResultsV2> {
        let localVariablePath = "/v2/computer-prestages"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ComputerPrestageSearchResultsV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete a Computer Prestage with the supplied id 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2ComputerPrestagesIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2ComputerPrestagesIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete a Computer Prestage with the supplied id 
     - DELETE /v2/computer-prestages/{id}
     - Deletes a Computer Prestage with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - returns: RequestBuilder<Void> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2ComputerPrestagesIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/computer-prestages/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve a Computer Prestage with the supplied id 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2ComputerPrestagesIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetComputerPrestageV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2ComputerPrestagesIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve a Computer Prestage with the supplied id 
     - GET /v2/computer-prestages/{id}
     - Retrieves a Computer Prestage with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - returns: RequestBuilder<GetComputerPrestageV2> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2ComputerPrestagesIdGetWithRequestBuilder(id: String) -> RequestBuilder<GetComputerPrestageV2> {
        var localVariablePath = "/v2/computer-prestages/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetComputerPrestageV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a Computer Prestage 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter putComputerPrestageV2: (body) Computer Prestage to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2ComputerPrestagesIdPut(id: String, putComputerPrestageV2: PutComputerPrestageV2, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetComputerPrestageV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2ComputerPrestagesIdPutWithRequestBuilder(id: id, putComputerPrestageV2: putComputerPrestageV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a Computer Prestage 
     - PUT /v2/computer-prestages/{id}
     - Updates a Computer Prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - parameter putComputerPrestageV2: (body) Computer Prestage to update 
     - returns: RequestBuilder<GetComputerPrestageV2> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2ComputerPrestagesIdPutWithRequestBuilder(id: String, putComputerPrestageV2: PutComputerPrestageV2) -> RequestBuilder<GetComputerPrestageV2> {
        var localVariablePath = "/v2/computer-prestages/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: putComputerPrestageV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetComputerPrestageV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Remove device Scope for a specific Computer Prestage 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to remove from scope 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2ComputerPrestagesIdScopeDeleteMultiplePost(id: String, prestageScopeUpdate: PrestageScopeUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponseV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2ComputerPrestagesIdScopeDeleteMultiplePostWithRequestBuilder(id: id, prestageScopeUpdate: prestageScopeUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Remove device Scope for a specific Computer Prestage 
     - POST /v2/computer-prestages/{id}/scope/delete-multiple
     - Remove device scope for a specific computer prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to remove from scope 
     - returns: RequestBuilder<PrestageScopeResponseV2> 
     */
    open class func v2ComputerPrestagesIdScopeDeleteMultiplePostWithRequestBuilder(id: String, prestageScopeUpdate: PrestageScopeUpdate) -> RequestBuilder<PrestageScopeResponseV2> {
        var localVariablePath = "/v2/computer-prestages/{id}/scope/delete-multiple"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: prestageScopeUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponseV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get device Scope for a specific Computer Prestage 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2ComputerPrestagesIdScopeGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponseV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2ComputerPrestagesIdScopeGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get device Scope for a specific Computer Prestage 
     - GET /v2/computer-prestages/{id}/scope
     - Get device scope for a specific computer prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - returns: RequestBuilder<PrestageScopeResponseV2> 
     */
    open class func v2ComputerPrestagesIdScopeGetWithRequestBuilder(id: String) -> RequestBuilder<PrestageScopeResponseV2> {
        var localVariablePath = "/v2/computer-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponseV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add device Scope for a specific Computer Prestage 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2ComputerPrestagesIdScopePost(id: String, prestageScopeUpdate: PrestageScopeUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponseV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2ComputerPrestagesIdScopePostWithRequestBuilder(id: id, prestageScopeUpdate: prestageScopeUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add device Scope for a specific Computer Prestage 
     - POST /v2/computer-prestages/{id}/scope
     - Add device scope for a specific computer prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - returns: RequestBuilder<PrestageScopeResponseV2> 
     */
    open class func v2ComputerPrestagesIdScopePostWithRequestBuilder(id: String, prestageScopeUpdate: PrestageScopeUpdate) -> RequestBuilder<PrestageScopeResponseV2> {
        var localVariablePath = "/v2/computer-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: prestageScopeUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponseV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Replace device Scope for a specific Computer Prestage 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2ComputerPrestagesIdScopePut(id: String, prestageScopeUpdate: PrestageScopeUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponseV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2ComputerPrestagesIdScopePutWithRequestBuilder(id: id, prestageScopeUpdate: prestageScopeUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Replace device Scope for a specific Computer Prestage 
     - PUT /v2/computer-prestages/{id}/scope
     - Replace device scope for a specific computer prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - returns: RequestBuilder<PrestageScopeResponseV2> 
     */
    open class func v2ComputerPrestagesIdScopePutWithRequestBuilder(id: String, prestageScopeUpdate: PrestageScopeUpdate) -> RequestBuilder<PrestageScopeResponseV2> {
        var localVariablePath = "/v2/computer-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: prestageScopeUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponseV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a Computer Prestage 
     
     - parameter postComputerPrestageV2: (body) Computer Prestage to create. ids defined in this body will be ignored 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2ComputerPrestagesPost(postComputerPrestageV2: PostComputerPrestageV2, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2ComputerPrestagesPostWithRequestBuilder(postComputerPrestageV2: postComputerPrestageV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a Computer Prestage 
     - POST /v2/computer-prestages
     - Create a computer prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter postComputerPrestageV2: (body) Computer Prestage to create. ids defined in this body will be ignored 
     - returns: RequestBuilder<HrefResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2ComputerPrestagesPostWithRequestBuilder(postComputerPrestageV2: PostComputerPrestageV2) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v2/computer-prestages"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: postComputerPrestageV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get all device Scope for all Computer Prestages 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2ComputerPrestagesScopeGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2ComputerPrestagesScopeGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get all device Scope for all Computer Prestages 
     - GET /v2/computer-prestages/scope
     - Get all device scope for all computer prestages
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<PrestageScopeV2> 
     */
    open class func v2ComputerPrestagesScopeGetWithRequestBuilder() -> RequestBuilder<PrestageScopeV2> {
        let localVariablePath = "/v2/computer-prestages/scope"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get sorted and paged Computer Prestages 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3ComputerPrestagesGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ComputerPrestageSearchResultsV3?, _ error: Error?) -> Void)) -> RequestTask {
        return v3ComputerPrestagesGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get sorted and paged Computer Prestages 
     - GET /v3/computer-prestages
     - Gets sorted and paged computer prestages
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional)
     - returns: RequestBuilder<ComputerPrestageSearchResultsV3> 
     */
    open class func v3ComputerPrestagesGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<ComputerPrestageSearchResultsV3> {
        let localVariablePath = "/v3/computer-prestages"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ComputerPrestageSearchResultsV3>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete a Computer Prestage with the supplied id 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3ComputerPrestagesIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v3ComputerPrestagesIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete a Computer Prestage with the supplied id 
     - DELETE /v3/computer-prestages/{id}
     - Deletes a Computer Prestage with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v3ComputerPrestagesIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v3/computer-prestages/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve a Computer Prestage with the supplied id 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3ComputerPrestagesIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetComputerPrestageV3?, _ error: Error?) -> Void)) -> RequestTask {
        return v3ComputerPrestagesIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve a Computer Prestage with the supplied id 
     - GET /v3/computer-prestages/{id}
     - Retrieves a Computer Prestage with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - returns: RequestBuilder<GetComputerPrestageV3> 
     */
    open class func v3ComputerPrestagesIdGetWithRequestBuilder(id: String) -> RequestBuilder<GetComputerPrestageV3> {
        var localVariablePath = "/v3/computer-prestages/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetComputerPrestageV3>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a Computer Prestage 
     
     - parameter id: (path) Computer Prestage identifier 
     - parameter putComputerPrestageV3: (body) Computer Prestage to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3ComputerPrestagesIdPut(id: String, putComputerPrestageV3: PutComputerPrestageV3, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetComputerPrestageV3?, _ error: Error?) -> Void)) -> RequestTask {
        return v3ComputerPrestagesIdPutWithRequestBuilder(id: id, putComputerPrestageV3: putComputerPrestageV3).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a Computer Prestage 
     - PUT /v3/computer-prestages/{id}
     - Updates a Computer Prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Prestage identifier 
     - parameter putComputerPrestageV3: (body) Computer Prestage to update 
     - returns: RequestBuilder<GetComputerPrestageV3> 
     */
    open class func v3ComputerPrestagesIdPutWithRequestBuilder(id: String, putComputerPrestageV3: PutComputerPrestageV3) -> RequestBuilder<GetComputerPrestageV3> {
        var localVariablePath = "/v3/computer-prestages/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: putComputerPrestageV3)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetComputerPrestageV3>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a Computer Prestage 
     
     - parameter postComputerPrestageV3: (body) Computer Prestage to create. ids defined in this body will be ignored 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3ComputerPrestagesPost(postComputerPrestageV3: PostComputerPrestageV3, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v3ComputerPrestagesPostWithRequestBuilder(postComputerPrestageV3: postComputerPrestageV3).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a Computer Prestage 
     - POST /v3/computer-prestages
     - Create a computer prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter postComputerPrestageV3: (body) Computer Prestage to create. ids defined in this body will be ignored 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v3ComputerPrestagesPostWithRequestBuilder(postComputerPrestageV3: PostComputerPrestageV3) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v3/computer-prestages"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: postComputerPrestageV3)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
