//
// ConditionalAccessAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class ConditionalAccessAPI {

    /**
     Get compliance information for a single computer device
     
     - parameter deviceId: (path) ID of the device the query pertains 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ConditionalAccessDeviceComplianceInformationComputerDeviceIdGet(deviceId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [DeviceComplianceInformation]?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ConditionalAccessDeviceComplianceInformationComputerDeviceIdGetWithRequestBuilder(deviceId: deviceId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get compliance information for a single computer device
     - GET /v1/conditional-access/device-compliance-information/computer/{deviceId}
     - Return basic compliance information for the given computer device
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter deviceId: (path) ID of the device the query pertains 
     - returns: RequestBuilder<[DeviceComplianceInformation]> 
     */
    open class func v1ConditionalAccessDeviceComplianceInformationComputerDeviceIdGetWithRequestBuilder(deviceId: String) -> RequestBuilder<[DeviceComplianceInformation]> {
        var localVariablePath = "/v1/conditional-access/device-compliance-information/computer/{deviceId}"
        let deviceIdPreEscape = "\(APIHelper.mapValueToPathItem(deviceId))"
        let deviceIdPostEscape = deviceIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{deviceId}", with: deviceIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[DeviceComplianceInformation]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get compliance information for a single mobile device
     
     - parameter deviceId: (path) ID of the device the query pertains 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ConditionalAccessDeviceComplianceInformationMobileDeviceIdGet(deviceId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [DeviceComplianceInformation]?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ConditionalAccessDeviceComplianceInformationMobileDeviceIdGetWithRequestBuilder(deviceId: deviceId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get compliance information for a single mobile device
     - GET /v1/conditional-access/device-compliance-information/mobile/{deviceId}
     - Return basic compliance information for the given mobile device
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter deviceId: (path) ID of the device the query pertains 
     - returns: RequestBuilder<[DeviceComplianceInformation]> 
     */
    open class func v1ConditionalAccessDeviceComplianceInformationMobileDeviceIdGetWithRequestBuilder(deviceId: String) -> RequestBuilder<[DeviceComplianceInformation]> {
        var localVariablePath = "/v1/conditional-access/device-compliance-information/mobile/{deviceId}"
        let deviceIdPreEscape = "\(APIHelper.mapValueToPathItem(deviceId))"
        let deviceIdPostEscape = deviceIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{deviceId}", with: deviceIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[DeviceComplianceInformation]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
