//
// DeviceCommunicationSettingsAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class DeviceCommunicationSettingsAPI {

    /**
     Retrieves all settings for device communication 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceCommunicationSettingsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: DeviceCommunicationSettings?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceCommunicationSettingsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieves all settings for device communication 
     - GET /v1/device-communication-settings
     - Retrieves all device communication settings, including automatic renewal of the MDM profile. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<DeviceCommunicationSettings> 
     */
    open class func v1DeviceCommunicationSettingsGetWithRequestBuilder() -> RequestBuilder<DeviceCommunicationSettings> {
        let localVariablePath = "/v1/device-communication-settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<DeviceCommunicationSettings>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Device Communication settings history 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is date:desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter history notes collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: username, date, note, details. This param can be combined with paging and sorting. Example: filter&#x3D;username!&#x3D;admin and details&#x3D;&#x3D;*disabled* and date&lt;2019-12-15 (optional, default to "")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceCommunicationSettingsHistoryGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HistorySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceCommunicationSettingsHistoryGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Device Communication settings history 
     - GET /v1/device-communication-settings/history
     - Gets Device Communication settings history 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is date:desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter history notes collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: username, date, note, details. This param can be combined with paging and sorting. Example: filter&#x3D;username!&#x3D;admin and details&#x3D;&#x3D;*disabled* and date&lt;2019-12-15 (optional, default to "")
     - returns: RequestBuilder<HistorySearchResults> 
     */
    open class func v1DeviceCommunicationSettingsHistoryGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil) -> RequestBuilder<HistorySearchResults> {
        let localVariablePath = "/v1/device-communication-settings/history"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HistorySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Device Communication Settings history notes 
     
     - parameter objectHistoryNote: (body) history notes to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceCommunicationSettingsHistoryPost(objectHistoryNote: ObjectHistoryNote, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ObjectHistory?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceCommunicationSettingsHistoryPostWithRequestBuilder(objectHistoryNote: objectHistoryNote).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Device Communication Settings history notes 
     - POST /v1/device-communication-settings/history
     - Adds Device Communication Settings history notes 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter objectHistoryNote: (body) history notes to create 
     - returns: RequestBuilder<ObjectHistory> 
     */
    open class func v1DeviceCommunicationSettingsHistoryPostWithRequestBuilder(objectHistoryNote: ObjectHistoryNote) -> RequestBuilder<ObjectHistory> {
        let localVariablePath = "/v1/device-communication-settings/history"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: objectHistoryNote)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ObjectHistory>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update device communication settings 
     
     - parameter deviceCommunicationSettings: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceCommunicationSettingsPut(deviceCommunicationSettings: DeviceCommunicationSettings, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: DeviceCommunicationSettings?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceCommunicationSettingsPutWithRequestBuilder(deviceCommunicationSettings: deviceCommunicationSettings).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update device communication settings 
     - PUT /v1/device-communication-settings
     - Update device communication settings 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter deviceCommunicationSettings: (body)  
     - returns: RequestBuilder<DeviceCommunicationSettings> 
     */
    open class func v1DeviceCommunicationSettingsPutWithRequestBuilder(deviceCommunicationSettings: DeviceCommunicationSettings) -> RequestBuilder<DeviceCommunicationSettings> {
        let localVariablePath = "/v1/device-communication-settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: deviceCommunicationSettings)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<DeviceCommunicationSettings>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
