//
// DeviceEnrollmentsAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class DeviceEnrollmentsAPI {

    /**
     Read all sorted and paged Device Enrollment instances 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: DeviceEnrollmentInstanceSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Read all sorted and paged Device Enrollment instances 
     - GET /v1/device-enrollments
     - Search for sorted and paged device enrollment instances
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional)
     - returns: RequestBuilder<DeviceEnrollmentInstanceSearchResults> 
     */
    open class func v1DeviceEnrollmentsGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<DeviceEnrollmentInstanceSearchResults> {
        let localVariablePath = "/v1/device-enrollments"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<DeviceEnrollmentInstanceSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete a Device Enrollment Instance with the supplied id 
     
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete a Device Enrollment Instance with the supplied id 
     - DELETE /v1/device-enrollments/{id}
     - Deletes a Device Enrollment Instance with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Device Enrollment Instance identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v1DeviceEnrollmentsIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/device-enrollments/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Disown devices from the given Device Enrollment Instance 
     
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter deviceEnrollmentDisownBody: (body) List of device serial numbers to disown (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsIdDisownPost(id: String, deviceEnrollmentDisownBody: DeviceEnrollmentDisownBody? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: DeviceEnrollmentDisownResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsIdDisownPostWithRequestBuilder(id: id, deviceEnrollmentDisownBody: deviceEnrollmentDisownBody).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Disown devices from the given Device Enrollment Instance 
     - POST /v1/device-enrollments/{id}/disown
     - Disowns devices from the given device enrollment instance
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter deviceEnrollmentDisownBody: (body) List of device serial numbers to disown (optional)
     - returns: RequestBuilder<DeviceEnrollmentDisownResponse> 
     */
    open class func v1DeviceEnrollmentsIdDisownPostWithRequestBuilder(id: String, deviceEnrollmentDisownBody: DeviceEnrollmentDisownBody? = nil) -> RequestBuilder<DeviceEnrollmentDisownResponse> {
        var localVariablePath = "/v1/device-enrollments/{id}/disown"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: deviceEnrollmentDisownBody)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<DeviceEnrollmentDisownResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve a Device Enrollment Instance with the supplied id 
     
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: DeviceEnrollmentInstance?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve a Device Enrollment Instance with the supplied id 
     - GET /v1/device-enrollments/{id}
     - Retrieves a Device Enrollment Instance with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Device Enrollment Instance identifier 
     - returns: RequestBuilder<DeviceEnrollmentInstance> 
     */
    open class func v1DeviceEnrollmentsIdGetWithRequestBuilder(id: String) -> RequestBuilder<DeviceEnrollmentInstance> {
        var localVariablePath = "/v1/device-enrollments/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<DeviceEnrollmentInstance>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get sorted and paged Device Enrollment history objects 
     
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property,asc/desc. Default sort order is descending. Multiple sort criteria are supported and must be entered on separate lines in Swagger UI. In the URI the &#39;sort&#39; query param is duplicated for each sort criterion, e.g., ...&amp;sort&#x3D;name%2Casc&amp;sort&#x3D;date%2Cdesc (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter history notes collection. Default search is empty query - returning all results for the requested page. Fields allowed in the query: username, date, note, details. This param can be combined with paging and sorting. Example: search&#x3D;username!&#x3D;admin and details&#x3D;&#x3D;*disabled* and date&lt;2019-12-15 (optional, default to "")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsIdHistoryGet(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HistorySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsIdHistoryGetWithRequestBuilder(id: id, page: page, pageSize: pageSize, sort: sort, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get sorted and paged Device Enrollment history objects 
     - GET /v1/device-enrollments/{id}/history
     - Gets sorted and paged device enrollment history objects
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property,asc/desc. Default sort order is descending. Multiple sort criteria are supported and must be entered on separate lines in Swagger UI. In the URI the &#39;sort&#39; query param is duplicated for each sort criterion, e.g., ...&amp;sort&#x3D;name%2Casc&amp;sort&#x3D;date%2Cdesc (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter history notes collection. Default search is empty query - returning all results for the requested page. Fields allowed in the query: username, date, note, details. This param can be combined with paging and sorting. Example: search&#x3D;username!&#x3D;admin and details&#x3D;&#x3D;*disabled* and date&lt;2019-12-15 (optional, default to "")
     - returns: RequestBuilder<HistorySearchResults> 
     */
    open class func v1DeviceEnrollmentsIdHistoryGetWithRequestBuilder(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil) -> RequestBuilder<HistorySearchResults> {
        var localVariablePath = "/v1/device-enrollments/{id}/history"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HistorySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Device Enrollment history object notes 
     
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter objectHistoryNote: (body) History notes to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsIdHistoryPost(id: String, objectHistoryNote: ObjectHistoryNote, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsIdHistoryPostWithRequestBuilder(id: id, objectHistoryNote: objectHistoryNote).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Device Enrollment history object notes 
     - POST /v1/device-enrollments/{id}/history
     - Adds device enrollment history object notes
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter objectHistoryNote: (body) History notes to create 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v1DeviceEnrollmentsIdHistoryPostWithRequestBuilder(id: String, objectHistoryNote: ObjectHistoryNote) -> RequestBuilder<HrefResponse> {
        var localVariablePath = "/v1/device-enrollments/{id}/history"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: objectHistoryNote)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a Device Enrollment Instance with the supplied id 
     
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter deviceEnrollmentInstance: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsIdPut(id: String, deviceEnrollmentInstance: DeviceEnrollmentInstance, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: DeviceEnrollmentInstance?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsIdPutWithRequestBuilder(id: id, deviceEnrollmentInstance: deviceEnrollmentInstance).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a Device Enrollment Instance with the supplied id 
     - PUT /v1/device-enrollments/{id}
     - Updates a Device Enrollment Instance with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter deviceEnrollmentInstance: (body)  
     - returns: RequestBuilder<DeviceEnrollmentInstance> 
     */
    open class func v1DeviceEnrollmentsIdPutWithRequestBuilder(id: String, deviceEnrollmentInstance: DeviceEnrollmentInstance) -> RequestBuilder<DeviceEnrollmentInstance> {
        var localVariablePath = "/v1/device-enrollments/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: deviceEnrollmentInstance)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<DeviceEnrollmentInstance>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get all instance sync states for a single Device Enrollment Instance 
     
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsIdSyncsGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [DeviceEnrollmentInstanceSyncStatus]?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsIdSyncsGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get all instance sync states for a single Device Enrollment Instance 
     - GET /v1/device-enrollments/{id}/syncs
     - Get all instance sync states for a single instance
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Device Enrollment Instance identifier 
     - returns: RequestBuilder<[DeviceEnrollmentInstanceSyncStatus]> 
     */
    open class func v1DeviceEnrollmentsIdSyncsGetWithRequestBuilder(id: String) -> RequestBuilder<[DeviceEnrollmentInstanceSyncStatus]> {
        var localVariablePath = "/v1/device-enrollments/{id}/syncs"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[DeviceEnrollmentInstanceSyncStatus]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get the latest sync state for a single Device Enrollment Instance 
     
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsIdSyncsLatestGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: DeviceEnrollmentInstanceSyncStatus?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsIdSyncsLatestGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get the latest sync state for a single Device Enrollment Instance 
     - GET /v1/device-enrollments/{id}/syncs/latest
     - Get the latest sync state for a single instance
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Device Enrollment Instance identifier 
     - returns: RequestBuilder<DeviceEnrollmentInstanceSyncStatus> 
     */
    open class func v1DeviceEnrollmentsIdSyncsLatestGetWithRequestBuilder(id: String) -> RequestBuilder<DeviceEnrollmentInstanceSyncStatus> {
        var localVariablePath = "/v1/device-enrollments/{id}/syncs/latest"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<DeviceEnrollmentInstanceSyncStatus>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a Device Enrollment Instance with the supplied Token 
     
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter deviceEnrollmentToken: (body) The downloaded token base 64 encoded from the MDM server to be used to create a new Device Enrollment Instance. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsIdUploadTokenPut(id: String, deviceEnrollmentToken: DeviceEnrollmentToken, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: DeviceEnrollmentInstance?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsIdUploadTokenPutWithRequestBuilder(id: id, deviceEnrollmentToken: deviceEnrollmentToken).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a Device Enrollment Instance with the supplied Token 
     - PUT /v1/device-enrollments/{id}/upload-token
     - Updates a device enrollment instance with the supplied token.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter deviceEnrollmentToken: (body) The downloaded token base 64 encoded from the MDM server to be used to create a new Device Enrollment Instance. 
     - returns: RequestBuilder<DeviceEnrollmentInstance> 
     */
    open class func v1DeviceEnrollmentsIdUploadTokenPutWithRequestBuilder(id: String, deviceEnrollmentToken: DeviceEnrollmentToken) -> RequestBuilder<DeviceEnrollmentInstance> {
        var localVariablePath = "/v1/device-enrollments/{id}/upload-token"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: deviceEnrollmentToken)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<DeviceEnrollmentInstance>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the Jamf Pro Device Enrollment public key 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsPublicKeyGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: URL?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsPublicKeyGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the Jamf Pro Device Enrollment public key 
     - GET /v1/device-enrollments/public-key
     - Retrieve the Jamf Pro device enrollment public key
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<URL> 
     */
    open class func v1DeviceEnrollmentsPublicKeyGetWithRequestBuilder() -> RequestBuilder<URL> {
        let localVariablePath = "/v1/device-enrollments/public-key"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<URL>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get all instance sync states for all Device Enrollment Instances 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsSyncsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [DeviceEnrollmentInstanceSyncStatus]?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsSyncsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get all instance sync states for all Device Enrollment Instances 
     - GET /v1/device-enrollments/syncs
     - Get all instance sync states for all instances
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<[DeviceEnrollmentInstanceSyncStatus]> 
     */
    open class func v1DeviceEnrollmentsSyncsGetWithRequestBuilder() -> RequestBuilder<[DeviceEnrollmentInstanceSyncStatus]> {
        let localVariablePath = "/v1/device-enrollments/syncs"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[DeviceEnrollmentInstanceSyncStatus]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a Device Enrollment Instance with the supplied Token 
     
     - parameter deviceEnrollmentToken: (body) The downloaded token base 64 encoded from the MDM server to be used to create a new Device Enrollment Instance. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsUploadTokenPost(deviceEnrollmentToken: DeviceEnrollmentToken, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsUploadTokenPostWithRequestBuilder(deviceEnrollmentToken: deviceEnrollmentToken).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a Device Enrollment Instance with the supplied Token 
     - POST /v1/device-enrollments/upload-token
     - Creates a device enrollment instance with the supplied token.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter deviceEnrollmentToken: (body) The downloaded token base 64 encoded from the MDM server to be used to create a new Device Enrollment Instance. 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v1DeviceEnrollmentsUploadTokenPostWithRequestBuilder(deviceEnrollmentToken: DeviceEnrollmentToken) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v1/device-enrollments/upload-token"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: deviceEnrollmentToken)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
