//
// DeviceEnrollmentsDevicesAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class DeviceEnrollmentsDevicesAPI {

    /**
     Retrieve a list of Devices assigned to the supplied id 
     
     - parameter id: (path) Device Enrollment Instance identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeviceEnrollmentsIdDevicesGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: DeviceEnrollmentDeviceSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeviceEnrollmentsIdDevicesGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve a list of Devices assigned to the supplied id 
     - GET /v1/device-enrollments/{id}/devices
     - Retrieves a list of devices assigned to the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Device Enrollment Instance identifier 
     - returns: RequestBuilder<DeviceEnrollmentDeviceSearchResults> 
     */
    open class func v1DeviceEnrollmentsIdDevicesGetWithRequestBuilder(id: String) -> RequestBuilder<DeviceEnrollmentDeviceSearchResults> {
        var localVariablePath = "/v1/device-enrollments/{id}/devices"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<DeviceEnrollmentDeviceSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
