//
// EnrollmentAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class EnrollmentAPI {

    /**
     Retrieve the Account Driven User Enrollment Session Token Settings 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdueSessionTokenSettingsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AccountDrivenUserEnrollmentSessionTokenSettings?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdueSessionTokenSettingsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the Account Driven User Enrollment Session Token Settings 
     - GET /v1/adue-session-token-settings
     - Retrieve the Account Driven User Enrollment Session Token Settings 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<AccountDrivenUserEnrollmentSessionTokenSettings> 
     */
    open class func v1AdueSessionTokenSettingsGetWithRequestBuilder() -> RequestBuilder<AccountDrivenUserEnrollmentSessionTokenSettings> {
        let localVariablePath = "/v1/adue-session-token-settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AccountDrivenUserEnrollmentSessionTokenSettings>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Account Driven User Enrollment Session Token Settings. 
     
     - parameter accountDrivenUserEnrollmentSessionTokenSettings: (body) Update Account Driven User Enrollment Session Token Settings. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1AdueSessionTokenSettingsPut(accountDrivenUserEnrollmentSessionTokenSettings: AccountDrivenUserEnrollmentSessionTokenSettings, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AccountDrivenUserEnrollmentSessionTokenSettings?, _ error: Error?) -> Void)) -> RequestTask {
        return v1AdueSessionTokenSettingsPutWithRequestBuilder(accountDrivenUserEnrollmentSessionTokenSettings: accountDrivenUserEnrollmentSessionTokenSettings).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Account Driven User Enrollment Session Token Settings. 
     - PUT /v1/adue-session-token-settings
     - Update the Account Driven User Enrollment Session Token Settings object. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter accountDrivenUserEnrollmentSessionTokenSettings: (body) Update Account Driven User Enrollment Session Token Settings. 
     - returns: RequestBuilder<AccountDrivenUserEnrollmentSessionTokenSettings> 
     */
    open class func v1AdueSessionTokenSettingsPutWithRequestBuilder(accountDrivenUserEnrollmentSessionTokenSettings: AccountDrivenUserEnrollmentSessionTokenSettings) -> RequestBuilder<AccountDrivenUserEnrollmentSessionTokenSettings> {
        let localVariablePath = "/v1/adue-session-token-settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: accountDrivenUserEnrollmentSessionTokenSettings)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AccountDrivenUserEnrollmentSessionTokenSettings>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the configured LDAP groups configured for User-Initiated Enrollment 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: &#x60;property:asc/desc&#x60;. Default sort is &#x60;name:asc&#x60;. Multiple sort criteria are supported and must be separated with a comma. Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter allUsersOptionFirst: (query) Return \&quot;All LDAP Users\&quot; option on the first position if it is present in the current page (optional, default to false)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentAccessGroupsGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, allUsersOptionFirst: Bool? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AccessGroupsV2SearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentAccessGroupsGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort, allUsersOptionFirst: allUsersOptionFirst).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the configured LDAP groups configured for User-Initiated Enrollment 
     - GET /v2/enrollment/access-groups
     - Retrieves the configured LDAP groups configured for User-Initiated Enrollment.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: &#x60;property:asc/desc&#x60;. Default sort is &#x60;name:asc&#x60;. Multiple sort criteria are supported and must be separated with a comma. Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter allUsersOptionFirst: (query) Return \&quot;All LDAP Users\&quot; option on the first position if it is present in the current page (optional, default to false)
     - returns: RequestBuilder<AccessGroupsV2SearchResults> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentAccessGroupsGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, allUsersOptionFirst: Bool? = nil) -> RequestBuilder<AccessGroupsV2SearchResults> {
        let localVariablePath = "/v2/enrollment/access-groups"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "all-users-option-first": (wrappedValue: allUsersOptionFirst?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AccessGroupsV2SearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add the configured LDAP group for User-Initiated Enrollment. 
     
     - parameter enrollmentAccessGroupV2: (body) Configured LDAP group to create. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentAccessGroupsPost(enrollmentAccessGroupV2: EnrollmentAccessGroupV2, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentAccessGroupsPostWithRequestBuilder(enrollmentAccessGroupV2: enrollmentAccessGroupV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add the configured LDAP group for User-Initiated Enrollment. 
     - POST /v2/enrollment/access-groups
     - Add the configured LDAP group for User-Initiated Enrollment. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter enrollmentAccessGroupV2: (body) Configured LDAP group to create. 
     - returns: RequestBuilder<HrefResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentAccessGroupsPostWithRequestBuilder(enrollmentAccessGroupV2: EnrollmentAccessGroupV2) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v2/enrollment/access-groups"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentAccessGroupV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete an LDAP group's access to user initiated Enrollment 
     
     - parameter serverId: (path) LDAP server id 
     - parameter groupId: (path) LDAP group id. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentAccessGroupsServerIdGroupIdDelete(serverId: String, groupId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentAccessGroupsServerIdGroupIdDeleteWithRequestBuilder(serverId: serverId, groupId: groupId).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete an LDAP group's access to user initiated Enrollment 
     - DELETE /v2/enrollment/access-groups/{serverId}/{groupId}
     - Deletes an LDAP group's access to user initiated enrollment. The group \"All LDAP Users\" cannot be deleted, but it can be modified to disallow User-Initiated Enrollment.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter serverId: (path) LDAP server id 
     - parameter groupId: (path) LDAP group id. 
     - returns: RequestBuilder<Void> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentAccessGroupsServerIdGroupIdDeleteWithRequestBuilder(serverId: String, groupId: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/enrollment/access-groups/{serverId}/{groupId}"
        let serverIdPreEscape = "\(APIHelper.mapValueToPathItem(serverId))"
        let serverIdPostEscape = serverIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{serverId}", with: serverIdPostEscape, options: .literal, range: nil)
        let groupIdPreEscape = "\(APIHelper.mapValueToPathItem(groupId))"
        let groupIdPostEscape = groupIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{groupId}", with: groupIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the configured LDAP groups configured for User-Initiated Enrollment 
     
     - parameter serverId: (path) LDAP server id. 
     - parameter groupId: (path) LDAP group id. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentAccessGroupsServerIdGroupIdGet(serverId: String, groupId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentAccessGroupV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentAccessGroupsServerIdGroupIdGetWithRequestBuilder(serverId: serverId, groupId: groupId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the configured LDAP groups configured for User-Initiated Enrollment 
     - GET /v2/enrollment/access-groups/{serverId}/{groupId}
     - Retrieves the configured LDAP groups configured for User-Initiated Enrollment.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter serverId: (path) LDAP server id. 
     - parameter groupId: (path) LDAP group id. 
     - returns: RequestBuilder<EnrollmentAccessGroupV2> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentAccessGroupsServerIdGroupIdGetWithRequestBuilder(serverId: String, groupId: String) -> RequestBuilder<EnrollmentAccessGroupV2> {
        var localVariablePath = "/v2/enrollment/access-groups/{serverId}/{groupId}"
        let serverIdPreEscape = "\(APIHelper.mapValueToPathItem(serverId))"
        let serverIdPostEscape = serverIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{serverId}", with: serverIdPostEscape, options: .literal, range: nil)
        let groupIdPreEscape = "\(APIHelper.mapValueToPathItem(groupId))"
        let groupIdPostEscape = groupIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{groupId}", with: groupIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentAccessGroupV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Modify the configured LDAP groups configured for User-Initiated Enrollment 
     
     - parameter serverId: (path) LDAP server id. 
     - parameter groupId: (path) LDAP group id. 
     - parameter enrollmentAccessGroupV2: (body)  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentAccessGroupsServerIdGroupIdPut(serverId: String, groupId: String, enrollmentAccessGroupV2: EnrollmentAccessGroupV2? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentAccessGroupV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentAccessGroupsServerIdGroupIdPutWithRequestBuilder(serverId: serverId, groupId: groupId, enrollmentAccessGroupV2: enrollmentAccessGroupV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Modify the configured LDAP groups configured for User-Initiated Enrollment 
     - PUT /v2/enrollment/access-groups/{serverId}/{groupId}
     - Modifies the configured LDAP groups configured for User-Initiated Enrollment.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter serverId: (path) LDAP server id. 
     - parameter groupId: (path) LDAP group id. 
     - parameter enrollmentAccessGroupV2: (body)  (optional)
     - returns: RequestBuilder<EnrollmentAccessGroupV2> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentAccessGroupsServerIdGroupIdPutWithRequestBuilder(serverId: String, groupId: String, enrollmentAccessGroupV2: EnrollmentAccessGroupV2? = nil) -> RequestBuilder<EnrollmentAccessGroupV2> {
        var localVariablePath = "/v2/enrollment/access-groups/{serverId}/{groupId}"
        let serverIdPreEscape = "\(APIHelper.mapValueToPathItem(serverId))"
        let serverIdPostEscape = serverIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{serverId}", with: serverIdPostEscape, options: .literal, range: nil)
        let groupIdPreEscape = "\(APIHelper.mapValueToPathItem(groupId))"
        let groupIdPostEscape = groupIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{groupId}", with: groupIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentAccessGroupV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentAccessGroupV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the list of languages and corresponding ISO 639-1 Codes but only those not already added to Enrollment 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentFilteredLanguageCodesGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [LanguageCode]?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentFilteredLanguageCodesGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the list of languages and corresponding ISO 639-1 Codes but only those not already added to Enrollment 
     - GET /v2/enrollment/filtered-language-codes
     - Retrieves the list of languages and corresponding ISO 639-1 Codes, but only those not already added to Enrollment.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<[LanguageCode]> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentFilteredLanguageCodesGetWithRequestBuilder() -> RequestBuilder<[LanguageCode]> {
        let localVariablePath = "/v2/enrollment/filtered-language-codes"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[LanguageCode]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Enrollment object and Re-enrollment settings 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentSettingsV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Enrollment object and Re-enrollment settings 
     - GET /v2/enrollment
     - Gets Enrollment object and re-enrollment settings. The settings can be altered without providing the existing management password by providing the following value for `managementPassword`: `\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff`. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<EnrollmentSettingsV2> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentGetWithRequestBuilder() -> RequestBuilder<EnrollmentSettingsV2> {
        let localVariablePath = "/v2/enrollment"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentSettingsV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Export enrollment history collection 
     
     - parameter exportFields: (query) Export fields parameter, used to change default order or ignore some of the response properties. Default is empty array, which means that all fields of the response entity will be serialized. Example: export-fields&#x3D;id,username (optional)
     - parameter exportLabels: (query) Export labels parameter, used to customize fieldnames/columns in the exported file. Default is empty array, which means that response properties names will be used. Number of the provided labels must match the number of export-fields Example: export-labels&#x3D;identifier,name with matching: export-fields&#x3D;id,username (optional)
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is id:desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;id:desc,name:asc  (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter history notes collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: id, name. This param can be combined with paging and sorting. Example: name&#x3D;&#x3D;\&quot;*script*\&quot; (optional, default to "")
     - parameter exportParameters: (body) Optional. Override query parameters since they can make URI exceed 2,000 character limit. (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentHistoryExportPost(exportFields: [String]? = nil, exportLabels: [String]? = nil, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, exportParameters: ExportParameters? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AnyCodable?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentHistoryExportPostWithRequestBuilder(exportFields: exportFields, exportLabels: exportLabels, page: page, pageSize: pageSize, sort: sort, filter: filter, exportParameters: exportParameters).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Export enrollment history collection 
     - POST /v2/enrollment/history/export
     - Export enrollment history collection 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter exportFields: (query) Export fields parameter, used to change default order or ignore some of the response properties. Default is empty array, which means that all fields of the response entity will be serialized. Example: export-fields&#x3D;id,username (optional)
     - parameter exportLabels: (query) Export labels parameter, used to customize fieldnames/columns in the exported file. Default is empty array, which means that response properties names will be used. Number of the provided labels must match the number of export-fields Example: export-labels&#x3D;identifier,name with matching: export-fields&#x3D;id,username (optional)
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is id:desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;id:desc,name:asc  (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter history notes collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: id, name. This param can be combined with paging and sorting. Example: name&#x3D;&#x3D;\&quot;*script*\&quot; (optional, default to "")
     - parameter exportParameters: (body) Optional. Override query parameters since they can make URI exceed 2,000 character limit. (optional)
     - returns: RequestBuilder<AnyCodable> 
     */
    open class func v2EnrollmentHistoryExportPostWithRequestBuilder(exportFields: [String]? = nil, exportLabels: [String]? = nil, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, exportParameters: ExportParameters? = nil) -> RequestBuilder<AnyCodable> {
        let localVariablePath = "/v2/enrollment/history/export"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: exportParameters)

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "export-fields": (wrappedValue: exportFields?.encodeToJSON(), isExplode: true),
            "export-labels": (wrappedValue: exportLabels?.encodeToJSON(), isExplode: true),
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AnyCodable>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get sorted and paged Enrollment history object 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: &#x60;property:asc/desc&#x60;. Default sort is &#x60;date:desc&#x60;. Multiple sort criteria are supported and must be separated with a comma. Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentHistoryGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HistorySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentHistoryGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get sorted and paged Enrollment history object 
     - GET /v2/enrollment/history
     - Gets sorted and paged Enrollment history object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: &#x60;property:asc/desc&#x60;. Default sort is &#x60;date:desc&#x60;. Multiple sort criteria are supported and must be separated with a comma. Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - returns: RequestBuilder<HistorySearchResults> 
     */
    open class func v2EnrollmentHistoryGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<HistorySearchResults> {
        let localVariablePath = "/v2/enrollment/history"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HistorySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Enrollment history object notes 
     
     - parameter objectHistoryNote: (body) history notes to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentHistoryPost(objectHistoryNote: ObjectHistoryNote, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentHistoryPostWithRequestBuilder(objectHistoryNote: objectHistoryNote).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Enrollment history object notes 
     - POST /v2/enrollment/history
     - Adds Enrollment history object notes 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter objectHistoryNote: (body) history notes to create 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v2EnrollmentHistoryPostWithRequestBuilder(objectHistoryNote: ObjectHistoryNote) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v2/enrollment/history"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: objectHistoryNote)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the list of languages and corresponding ISO 639-1 Codes 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentLanguageCodesGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [LanguageCode]?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentLanguageCodesGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the list of languages and corresponding ISO 639-1 Codes 
     - GET /v2/enrollment/language-codes
     - Retrieves the list of languages and corresponding ISO 639-1 Codes.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<[LanguageCode]> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentLanguageCodesGetWithRequestBuilder() -> RequestBuilder<[LanguageCode]> {
        let localVariablePath = "/v2/enrollment/language-codes"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[LanguageCode]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete multiple configured languages from User-Initiated Enrollment settings 
     
     - parameter ids: (body) ids of each language to delete 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentLanguagesDeleteMultiplePost(ids: Ids, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentLanguagesDeleteMultiplePostWithRequestBuilder(ids: ids).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete multiple configured languages from User-Initiated Enrollment settings 
     - POST /v2/enrollment/languages/delete-multiple
     - Delete multiple configured languages from User-Initiated Enrollment settings
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter ids: (body) ids of each language to delete 
     - returns: RequestBuilder<Void> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentLanguagesDeleteMultiplePostWithRequestBuilder(ids: Ids) -> RequestBuilder<Void> {
        let localVariablePath = "/v2/enrollment/languages/delete-multiple"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: ids)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get an array of the language codes that have Enrollment messaging 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is &#x60;languageCode:asc&#x60;. Multiple sort criteria are supported and must be separated with a comma. Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentLanguagesGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ProcessTextsSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentLanguagesGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get an array of the language codes that have Enrollment messaging 
     - GET /v2/enrollment/languages
     - Returns an array of the language codes that have enrollment messaging currently configured.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is &#x60;languageCode:asc&#x60;. Multiple sort criteria are supported and must be separated with a comma. Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - returns: RequestBuilder<ProcessTextsSearchResults> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentLanguagesGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<ProcessTextsSearchResults> {
        let localVariablePath = "/v2/enrollment/languages"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ProcessTextsSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete the Enrollment messaging for a language 
     
     - parameter languageId: (path) Two letter ISO 639-1 Language Code 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentLanguagesLanguageIdDelete(languageId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentLanguagesLanguageIdDeleteWithRequestBuilder(languageId: languageId).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete the Enrollment messaging for a language 
     - DELETE /v2/enrollment/languages/{languageId}
     - Delete the enrollment messaging for a language.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter languageId: (path) Two letter ISO 639-1 Language Code 
     - returns: RequestBuilder<Void> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentLanguagesLanguageIdDeleteWithRequestBuilder(languageId: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/enrollment/languages/{languageId}"
        let languageIdPreEscape = "\(APIHelper.mapValueToPathItem(languageId))"
        let languageIdPostEscape = languageIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{languageId}", with: languageIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the Enrollment messaging for a language 
     
     - parameter languageId: (path) Two letter ISO 639-1 Language Code 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentLanguagesLanguageIdGet(languageId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentProcessTextObject?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentLanguagesLanguageIdGetWithRequestBuilder(languageId: languageId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the Enrollment messaging for a language 
     - GET /v2/enrollment/languages/{languageId}
     - Retrieves the enrollment messaging for a language.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter languageId: (path) Two letter ISO 639-1 Language Code 
     - returns: RequestBuilder<EnrollmentProcessTextObject> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentLanguagesLanguageIdGetWithRequestBuilder(languageId: String) -> RequestBuilder<EnrollmentProcessTextObject> {
        var localVariablePath = "/v2/enrollment/languages/{languageId}"
        let languageIdPreEscape = "\(APIHelper.mapValueToPathItem(languageId))"
        let languageIdPostEscape = languageIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{languageId}", with: languageIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentProcessTextObject>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Edit Enrollment messaging for a language 
     
     - parameter languageId: (path) Two letter ISO 639-1 Language Code 
     - parameter enrollmentProcessTextObject: (body)  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentLanguagesLanguageIdPut(languageId: String, enrollmentProcessTextObject: EnrollmentProcessTextObject? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentProcessTextObject?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentLanguagesLanguageIdPutWithRequestBuilder(languageId: languageId, enrollmentProcessTextObject: enrollmentProcessTextObject).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Edit Enrollment messaging for a language 
     - PUT /v2/enrollment/languages/{languageId}
     - Edit enrollment messaging for a language.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter languageId: (path) Two letter ISO 639-1 Language Code 
     - parameter enrollmentProcessTextObject: (body)  (optional)
     - returns: RequestBuilder<EnrollmentProcessTextObject> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentLanguagesLanguageIdPutWithRequestBuilder(languageId: String, enrollmentProcessTextObject: EnrollmentProcessTextObject? = nil) -> RequestBuilder<EnrollmentProcessTextObject> {
        var localVariablePath = "/v2/enrollment/languages/{languageId}"
        let languageIdPreEscape = "\(APIHelper.mapValueToPathItem(languageId))"
        let languageIdPostEscape = languageIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{languageId}", with: languageIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentProcessTextObject)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentProcessTextObject>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Enrollment object 
     
     - parameter enrollmentSettingsV2: (body) Update enrollment 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v2EnrollmentPut(enrollmentSettingsV2: EnrollmentSettingsV2, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentSettingsV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentPutWithRequestBuilder(enrollmentSettingsV2: enrollmentSettingsV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Enrollment object 
     - PUT /v2/enrollment
     - Update enrollment object. Regarding the `developerCertificateIdentity`, if this object is omitted, the certificate will not be deleted from Jamf Pro. The `identityKeystore` is the entire cert file as a base64 encoded string. The `md5Sum` field is not required in the PUT request, but is calculated and returned in the response. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter enrollmentSettingsV2: (body) Update enrollment 
     - returns: RequestBuilder<EnrollmentSettingsV2> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v2EnrollmentPutWithRequestBuilder(enrollmentSettingsV2: EnrollmentSettingsV2) -> RequestBuilder<EnrollmentSettingsV2> {
        let localVariablePath = "/v2/enrollment"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentSettingsV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentSettingsV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the configured LDAP groups configured for User-Initiated Enrollment. 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: &#x60;property:asc/desc&#x60;. Default sort is &#x60;name:asc&#x60;. Multiple sort criteria are supported and must be separated with a comma. Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter allUsersOptionFirst: (query) Return \&quot;All LDAP Users\&quot; option on the first position if it is present in the current page (optional, default to false)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentAccessGroupsGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, allUsersOptionFirst: Bool? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AccessGroupsPreviewSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentAccessGroupsGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort, allUsersOptionFirst: allUsersOptionFirst).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the configured LDAP groups configured for User-Initiated Enrollment. 
     - GET /v3/enrollment/access-groups
     - Retrieves the configured LDAP groups configured for User-Initiated Enrollment. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: &#x60;property:asc/desc&#x60;. Default sort is &#x60;name:asc&#x60;. Multiple sort criteria are supported and must be separated with a comma. Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter allUsersOptionFirst: (query) Return \&quot;All LDAP Users\&quot; option on the first position if it is present in the current page (optional, default to false)
     - returns: RequestBuilder<AccessGroupsPreviewSearchResults> 
     */
    open class func v3EnrollmentAccessGroupsGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, allUsersOptionFirst: Bool? = nil) -> RequestBuilder<AccessGroupsPreviewSearchResults> {
        let localVariablePath = "/v3/enrollment/access-groups"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "all-users-option-first": (wrappedValue: allUsersOptionFirst?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AccessGroupsPreviewSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete an LDAP group's access to user initiated Enrollment. 
     
     - parameter id: (path) Autogenerated Access Group ID. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentAccessGroupsIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentAccessGroupsIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete an LDAP group's access to user initiated Enrollment. 
     - DELETE /v3/enrollment/access-groups/{id}
     - Deletes an LDAP group's access to user initiated enrollment. The group \"All LDAP Users\" cannot be deleted, but it can be modified to disallow User-Initiated Enrollment.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Autogenerated Access Group ID. 
     - returns: RequestBuilder<Void> 
     */
    open class func v3EnrollmentAccessGroupsIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v3/enrollment/access-groups/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the configured LDAP groups configured for User-Initiated Enrollment 
     
     - parameter id: (path) Autogenerated Access Group ID. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentAccessGroupsIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentAccessGroupPreview?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentAccessGroupsIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the configured LDAP groups configured for User-Initiated Enrollment 
     - GET /v3/enrollment/access-groups/{id}
     - Retrieves the configured LDAP groups configured for User-Initiated Enrollment.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Autogenerated Access Group ID. 
     - returns: RequestBuilder<EnrollmentAccessGroupPreview> 
     */
    open class func v3EnrollmentAccessGroupsIdGetWithRequestBuilder(id: String) -> RequestBuilder<EnrollmentAccessGroupPreview> {
        var localVariablePath = "/v3/enrollment/access-groups/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentAccessGroupPreview>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Modify the configured LDAP groups configured for User-Initiated Enrollment. Only exiting Access Groups can be updated. 
     
     - parameter id: (path) Autogenerated Access Group ID. 
     - parameter enrollmentAccessGroupPreview: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentAccessGroupsIdPut(id: String, enrollmentAccessGroupPreview: EnrollmentAccessGroupPreview, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentAccessGroupPreview?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentAccessGroupsIdPutWithRequestBuilder(id: id, enrollmentAccessGroupPreview: enrollmentAccessGroupPreview).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Modify the configured LDAP groups configured for User-Initiated Enrollment. Only exiting Access Groups can be updated. 
     - PUT /v3/enrollment/access-groups/{id}
     - Modify the configured LDAP groups configured for User-Initiated Enrollment. Only exiting Access Groups can be updated. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Autogenerated Access Group ID. 
     - parameter enrollmentAccessGroupPreview: (body)  
     - returns: RequestBuilder<EnrollmentAccessGroupPreview> 
     */
    open class func v3EnrollmentAccessGroupsIdPutWithRequestBuilder(id: String, enrollmentAccessGroupPreview: EnrollmentAccessGroupPreview) -> RequestBuilder<EnrollmentAccessGroupPreview> {
        var localVariablePath = "/v3/enrollment/access-groups/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentAccessGroupPreview)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentAccessGroupPreview>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add the configured LDAP group for User-Initiated Enrollment. 
     
     - parameter enrollmentAccessGroupPreview: (body) Configured LDAP group to create. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentAccessGroupsPost(enrollmentAccessGroupPreview: EnrollmentAccessGroupPreview, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentAccessGroupsPostWithRequestBuilder(enrollmentAccessGroupPreview: enrollmentAccessGroupPreview).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add the configured LDAP group for User-Initiated Enrollment. 
     - POST /v3/enrollment/access-groups
     - Add the configured LDAP group for User-Initiated Enrollment. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter enrollmentAccessGroupPreview: (body) Configured LDAP group to create. 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v3EnrollmentAccessGroupsPostWithRequestBuilder(enrollmentAccessGroupPreview: EnrollmentAccessGroupPreview) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v3/enrollment/access-groups"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentAccessGroupPreview)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the list of languages and corresponding ISO 639-1 Codes but only those not already added to Enrollment 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentFilteredLanguageCodesGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [LanguageCode]?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentFilteredLanguageCodesGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the list of languages and corresponding ISO 639-1 Codes but only those not already added to Enrollment 
     - GET /v3/enrollment/filtered-language-codes
     - Retrieves the list of languages and corresponding ISO 639-1 Codes, but only those not already added to Enrollment.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<[LanguageCode]> 
     */
    open class func v3EnrollmentFilteredLanguageCodesGetWithRequestBuilder() -> RequestBuilder<[LanguageCode]> {
        let localVariablePath = "/v3/enrollment/filtered-language-codes"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[LanguageCode]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Enrollment object and Re-enrollment settings 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentSettingsV3?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Enrollment object and Re-enrollment settings 
     - GET /v3/enrollment
     - Gets Enrollment object and re-enrollment settings. The settings can be altered without providing the existing management password by providing the following value for `managementPassword`: `\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff\\uffff`. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<EnrollmentSettingsV3> 
     */
    open class func v3EnrollmentGetWithRequestBuilder() -> RequestBuilder<EnrollmentSettingsV3> {
        let localVariablePath = "/v3/enrollment"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentSettingsV3>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the list of languages and corresponding ISO 639-1 Codes 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentLanguageCodesGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [LanguageCode]?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentLanguageCodesGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the list of languages and corresponding ISO 639-1 Codes 
     - GET /v3/enrollment/language-codes
     - Retrieves the list of languages and corresponding ISO 639-1 Codes.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<[LanguageCode]> 
     */
    open class func v3EnrollmentLanguageCodesGetWithRequestBuilder() -> RequestBuilder<[LanguageCode]> {
        let localVariablePath = "/v3/enrollment/language-codes"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[LanguageCode]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete multiple configured languages from User-Initiated Enrollment settings 
     
     - parameter ids: (body) ids of each language to delete 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentLanguagesDeleteMultiplePost(ids: Ids, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentLanguagesDeleteMultiplePostWithRequestBuilder(ids: ids).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete multiple configured languages from User-Initiated Enrollment settings 
     - POST /v3/enrollment/languages/delete-multiple
     - Delete multiple configured languages from User-Initiated Enrollment settings
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter ids: (body) ids of each language to delete 
     - returns: RequestBuilder<Void> 
     */
    open class func v3EnrollmentLanguagesDeleteMultiplePostWithRequestBuilder(ids: Ids) -> RequestBuilder<Void> {
        let localVariablePath = "/v3/enrollment/languages/delete-multiple"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: ids)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get an array of the language codes that have Enrollment messaging 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is &#x60;languageCode:asc&#x60;. Multiple sort criteria are supported and must be separated with a comma. Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentLanguagesGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ProcessTextsSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentLanguagesGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get an array of the language codes that have Enrollment messaging 
     - GET /v3/enrollment/languages
     - Returns an array of the language codes that have enrollment messaging currently configured.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is &#x60;languageCode:asc&#x60;. Multiple sort criteria are supported and must be separated with a comma. Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - returns: RequestBuilder<ProcessTextsSearchResults> 
     */
    open class func v3EnrollmentLanguagesGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<ProcessTextsSearchResults> {
        let localVariablePath = "/v3/enrollment/languages"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ProcessTextsSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete the Enrollment messaging for a language 
     
     - parameter languageId: (path) Two letter ISO 639-1 Language Code 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentLanguagesLanguageIdDelete(languageId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentLanguagesLanguageIdDeleteWithRequestBuilder(languageId: languageId).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete the Enrollment messaging for a language 
     - DELETE /v3/enrollment/languages/{languageId}
     - Delete the enrollment messaging for a language.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter languageId: (path) Two letter ISO 639-1 Language Code 
     - returns: RequestBuilder<Void> 
     */
    open class func v3EnrollmentLanguagesLanguageIdDeleteWithRequestBuilder(languageId: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v3/enrollment/languages/{languageId}"
        let languageIdPreEscape = "\(APIHelper.mapValueToPathItem(languageId))"
        let languageIdPostEscape = languageIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{languageId}", with: languageIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the Enrollment messaging for a language 
     
     - parameter languageId: (path) Two letter ISO 639-1 Language Code 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentLanguagesLanguageIdGet(languageId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentProcessTextObject?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentLanguagesLanguageIdGetWithRequestBuilder(languageId: languageId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the Enrollment messaging for a language 
     - GET /v3/enrollment/languages/{languageId}
     - Retrieves the enrollment messaging for a language.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter languageId: (path) Two letter ISO 639-1 Language Code 
     - returns: RequestBuilder<EnrollmentProcessTextObject> 
     */
    open class func v3EnrollmentLanguagesLanguageIdGetWithRequestBuilder(languageId: String) -> RequestBuilder<EnrollmentProcessTextObject> {
        var localVariablePath = "/v3/enrollment/languages/{languageId}"
        let languageIdPreEscape = "\(APIHelper.mapValueToPathItem(languageId))"
        let languageIdPostEscape = languageIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{languageId}", with: languageIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentProcessTextObject>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Edit Enrollment messaging for a language 
     
     - parameter languageId: (path) Two letter ISO 639-1 Language Code 
     - parameter enrollmentProcessTextObject: (body)  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentLanguagesLanguageIdPut(languageId: String, enrollmentProcessTextObject: EnrollmentProcessTextObject? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentProcessTextObject?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentLanguagesLanguageIdPutWithRequestBuilder(languageId: languageId, enrollmentProcessTextObject: enrollmentProcessTextObject).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Edit Enrollment messaging for a language 
     - PUT /v3/enrollment/languages/{languageId}
     - Edit enrollment messaging for a language.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter languageId: (path) Two letter ISO 639-1 Language Code 
     - parameter enrollmentProcessTextObject: (body)  (optional)
     - returns: RequestBuilder<EnrollmentProcessTextObject> 
     */
    open class func v3EnrollmentLanguagesLanguageIdPutWithRequestBuilder(languageId: String, enrollmentProcessTextObject: EnrollmentProcessTextObject? = nil) -> RequestBuilder<EnrollmentProcessTextObject> {
        var localVariablePath = "/v3/enrollment/languages/{languageId}"
        let languageIdPreEscape = "\(APIHelper.mapValueToPathItem(languageId))"
        let languageIdPostEscape = languageIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{languageId}", with: languageIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentProcessTextObject)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentProcessTextObject>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Enrollment object 
     
     - parameter enrollmentSettingsV3: (body) Update enrollment 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v3EnrollmentPut(enrollmentSettingsV3: EnrollmentSettingsV3, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentSettingsV3?, _ error: Error?) -> Void)) -> RequestTask {
        return v3EnrollmentPutWithRequestBuilder(enrollmentSettingsV3: enrollmentSettingsV3).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Enrollment object 
     - PUT /v3/enrollment
     - Update enrollment object. Regarding the `developerCertificateIdentity`, if this object is omitted, the certificate will not be deleted from Jamf Pro. The `identityKeystore` is the entire cert file as a base64 encoded string. The `md5Sum` field is not required in the PUT request, but is calculated and returned in the response. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter enrollmentSettingsV3: (body) Update enrollment 
     - returns: RequestBuilder<EnrollmentSettingsV3> 
     */
    open class func v3EnrollmentPutWithRequestBuilder(enrollmentSettingsV3: EnrollmentSettingsV3) -> RequestBuilder<EnrollmentSettingsV3> {
        let localVariablePath = "/v3/enrollment"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentSettingsV3)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentSettingsV3>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
