//
// EnrollmentCustomizationAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class EnrollmentCustomizationAPI {

    /**
     Retrieve sorted and paged Enrollment Customizations 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "id:asc")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1EnrollmentCustomizationGet(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentCustomizationSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationGetWithRequestBuilder(page: page, size: size, pagesize: pagesize, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve sorted and paged Enrollment Customizations 
     - GET /v1/enrollment-customization
     - Retrieves sorted and paged Enrollment Customizations
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "id:asc")
     - returns: RequestBuilder<EnrollmentCustomizationSearchResults> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1EnrollmentCustomizationGetWithRequestBuilder(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil) -> RequestBuilder<EnrollmentCustomizationSearchResults> {
        let localVariablePath = "/v1/enrollment-customization"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "size": (wrappedValue: size?.encodeToJSON(), isExplode: true),
            "pagesize": (wrappedValue: pagesize?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentCustomizationSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete an Enrollment Customization with the supplied id 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1EnrollmentCustomizationIdDelete(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete an Enrollment Customization with the supplied id 
     - DELETE /v1/enrollment-customization/{id}
     - Deletes an Enrollment Customization with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - returns: RequestBuilder<Void> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1EnrollmentCustomizationIdDeleteWithRequestBuilder(id: Int) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/enrollment-customization/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve an Enrollment Customization with the supplied id 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1EnrollmentCustomizationIdGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomization?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve an Enrollment Customization with the supplied id 
     - GET /v1/enrollment-customization/{id}
     - Retrieves an Enrollment Customization with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - returns: RequestBuilder<GetEnrollmentCustomization> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1EnrollmentCustomizationIdGetWithRequestBuilder(id: Int) -> RequestBuilder<GetEnrollmentCustomization> {
        var localVariablePath = "/v1/enrollment-customization/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomization>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get sorted and paged Enrollment Customization history objects 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property,asc/desc. Default sort order is descending. Multiple sort criteria are supported and must be entered on separate lines in Swagger UI. In the URI the &#39;sort&#39; query param is duplicated for each sort criterion, e.g., ...&amp;sort&#x3D;name%2Casc&amp;sort&#x3D;date%2Cdesc (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1EnrollmentCustomizationIdHistoryGet(id: Int, page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HistorySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdHistoryGetWithRequestBuilder(id: id, page: page, size: size, pagesize: pagesize, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get sorted and paged Enrollment Customization history objects 
     - GET /v1/enrollment-customization/{id}/history
     - Gets sorted and paged enrollment customization history objects
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property,asc/desc. Default sort order is descending. Multiple sort criteria are supported and must be entered on separate lines in Swagger UI. In the URI the &#39;sort&#39; query param is duplicated for each sort criterion, e.g., ...&amp;sort&#x3D;name%2Casc&amp;sort&#x3D;date%2Cdesc (optional)
     - returns: RequestBuilder<HistorySearchResults> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1EnrollmentCustomizationIdHistoryGetWithRequestBuilder(id: Int, page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<HistorySearchResults> {
        var localVariablePath = "/v1/enrollment-customization/{id}/history"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "size": (wrappedValue: size?.encodeToJSON(), isExplode: true),
            "pagesize": (wrappedValue: pagesize?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HistorySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Enrollment Customization history object notes 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter objectHistoryNote: (body) History notes to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1EnrollmentCustomizationIdHistoryPost(id: Int, objectHistoryNote: ObjectHistoryNote, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ObjectHistory?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdHistoryPostWithRequestBuilder(id: id, objectHistoryNote: objectHistoryNote).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Enrollment Customization history object notes 
     - POST /v1/enrollment-customization/{id}/history
     - Adds enrollment customization history object notes
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter objectHistoryNote: (body) History notes to create 
     - returns: RequestBuilder<ObjectHistory> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1EnrollmentCustomizationIdHistoryPostWithRequestBuilder(id: Int, objectHistoryNote: ObjectHistoryNote) -> RequestBuilder<ObjectHistory> {
        var localVariablePath = "/v1/enrollment-customization/{id}/history"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: objectHistoryNote)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ObjectHistory>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the list of Prestages using this Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1EnrollmentCustomizationIdPrestagesGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageDependencies?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdPrestagesGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the list of Prestages using this Enrollment Customization 
     - GET /v1/enrollment-customization/{id}/prestages
     - Retrieves the list of Prestages using this Enrollment Customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - returns: RequestBuilder<PrestageDependencies> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1EnrollmentCustomizationIdPrestagesGetWithRequestBuilder(id: Int) -> RequestBuilder<PrestageDependencies> {
        var localVariablePath = "/v1/enrollment-customization/{id}/prestages"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageDependencies>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update an Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter enrollmentCustomization: (body) Enrollment Customization to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1EnrollmentCustomizationIdPut(id: Int, enrollmentCustomization: EnrollmentCustomization, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomization?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdPutWithRequestBuilder(id: id, enrollmentCustomization: enrollmentCustomization).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update an Enrollment Customization 
     - PUT /v1/enrollment-customization/{id}
     - Updates an Enrollment Customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter enrollmentCustomization: (body) Enrollment Customization to update 
     - returns: RequestBuilder<GetEnrollmentCustomization> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1EnrollmentCustomizationIdPutWithRequestBuilder(id: Int, enrollmentCustomization: EnrollmentCustomization) -> RequestBuilder<GetEnrollmentCustomization> {
        var localVariablePath = "/v1/enrollment-customization/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentCustomization)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomization>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Upload an image
     
     - parameter file: (form) The file to upload 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1EnrollmentCustomizationImagesPost(file: URL, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: BrandingImageUrl?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationImagesPostWithRequestBuilder(file: file).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Upload an image
     - POST /v1/enrollment-customization/images
     - Uploads an image
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter file: (form) The file to upload 
     - returns: RequestBuilder<BrandingImageUrl> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1EnrollmentCustomizationImagesPostWithRequestBuilder(file: URL) -> RequestBuilder<BrandingImageUrl> {
        let localVariablePath = "/v1/enrollment-customization/images"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableFormParams: [String: Any?] = [
            "file": file.encodeToJSON(),
        ]

        let localVariableNonNullParameters = APIHelper.rejectNil(localVariableFormParams)
        let localVariableParameters = APIHelper.convertBoolToString(localVariableNonNullParameters)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            "Content-Type": "multipart/form-data",
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<BrandingImageUrl>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create an Enrollment Customization 
     
     - parameter enrollmentCustomization: (body) Enrollment customization to create. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1EnrollmentCustomizationPost(enrollmentCustomization: EnrollmentCustomization, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomization?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationPostWithRequestBuilder(enrollmentCustomization: enrollmentCustomization).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create an Enrollment Customization 
     - POST /v1/enrollment-customization
     - Create an enrollment customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter enrollmentCustomization: (body) Enrollment customization to create. 
     - returns: RequestBuilder<GetEnrollmentCustomization> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1EnrollmentCustomizationPostWithRequestBuilder(enrollmentCustomization: EnrollmentCustomization) -> RequestBuilder<GetEnrollmentCustomization> {
        let localVariablePath = "/v1/enrollment-customization"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentCustomization)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomization>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve sorted and paged Enrollment Customizations 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentCustomizationsGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentCustomizationSearchResultsV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentCustomizationsGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve sorted and paged Enrollment Customizations 
     - GET /v2/enrollment-customizations
     - Retrieves sorted and paged Enrollment Customizations
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional)
     - returns: RequestBuilder<EnrollmentCustomizationSearchResultsV2> 
     */
    open class func v2EnrollmentCustomizationsGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<EnrollmentCustomizationSearchResultsV2> {
        let localVariablePath = "/v2/enrollment-customizations"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentCustomizationSearchResultsV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete an Enrollment Customization with the supplied id 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentCustomizationsIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentCustomizationsIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete an Enrollment Customization with the supplied id 
     - DELETE /v2/enrollment-customizations/{id}
     - Deletes an Enrollment Customization with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v2EnrollmentCustomizationsIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/enrollment-customizations/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve an Enrollment Customization with the supplied id 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentCustomizationsIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentCustomizationV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentCustomizationsIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve an Enrollment Customization with the supplied id 
     - GET /v2/enrollment-customizations/{id}
     - Retrieves an Enrollment Customization with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - returns: RequestBuilder<EnrollmentCustomizationV2> 
     */
    open class func v2EnrollmentCustomizationsIdGetWithRequestBuilder(id: String) -> RequestBuilder<EnrollmentCustomizationV2> {
        var localVariablePath = "/v2/enrollment-customizations/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentCustomizationV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get sorted and paged Enrollment Customization history objects 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property,asc/desc. Default sort order is descending. Multiple sort criteria are supported and must be entered on separate lines in Swagger UI. In the URI the &#39;sort&#39; query param is duplicated for each sort criterion, e.g., ...&amp;sort&#x3D;name%2Casc&amp;sort&#x3D;date%2Cdesc (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentCustomizationsIdHistoryGet(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HistorySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentCustomizationsIdHistoryGetWithRequestBuilder(id: id, page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get sorted and paged Enrollment Customization history objects 
     - GET /v2/enrollment-customizations/{id}/history
     - Gets sorted and paged enrollment customization history objects
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property,asc/desc. Default sort order is descending. Multiple sort criteria are supported and must be entered on separate lines in Swagger UI. In the URI the &#39;sort&#39; query param is duplicated for each sort criterion, e.g., ...&amp;sort&#x3D;name%2Casc&amp;sort&#x3D;date%2Cdesc (optional)
     - returns: RequestBuilder<HistorySearchResults> 
     */
    open class func v2EnrollmentCustomizationsIdHistoryGetWithRequestBuilder(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<HistorySearchResults> {
        var localVariablePath = "/v2/enrollment-customizations/{id}/history"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HistorySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Enrollment Customization history object notes 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter objectHistoryNote: (body) History notes to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentCustomizationsIdHistoryPost(id: String, objectHistoryNote: ObjectHistoryNote, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ObjectHistory?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentCustomizationsIdHistoryPostWithRequestBuilder(id: id, objectHistoryNote: objectHistoryNote).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Enrollment Customization history object notes 
     - POST /v2/enrollment-customizations/{id}/history
     - Adds enrollment customization history object notes
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter objectHistoryNote: (body) History notes to create 
     - returns: RequestBuilder<ObjectHistory> 
     */
    open class func v2EnrollmentCustomizationsIdHistoryPostWithRequestBuilder(id: String, objectHistoryNote: ObjectHistoryNote) -> RequestBuilder<ObjectHistory> {
        var localVariablePath = "/v2/enrollment-customizations/{id}/history"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: objectHistoryNote)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ObjectHistory>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the list of Prestages using this Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentCustomizationsIdPrestagesGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageDependencies?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentCustomizationsIdPrestagesGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the list of Prestages using this Enrollment Customization 
     - GET /v2/enrollment-customizations/{id}/prestages
     - Retrieves the list of Prestages using this Enrollment Customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - returns: RequestBuilder<PrestageDependencies> 
     */
    open class func v2EnrollmentCustomizationsIdPrestagesGetWithRequestBuilder(id: String) -> RequestBuilder<PrestageDependencies> {
        var localVariablePath = "/v2/enrollment-customizations/{id}/prestages"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageDependencies>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update an Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter enrollmentCustomizationV2: (body) Enrollment Customization to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentCustomizationsIdPut(id: String, enrollmentCustomizationV2: EnrollmentCustomizationV2, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentCustomizationV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentCustomizationsIdPutWithRequestBuilder(id: id, enrollmentCustomizationV2: enrollmentCustomizationV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update an Enrollment Customization 
     - PUT /v2/enrollment-customizations/{id}
     - Updates an Enrollment Customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter enrollmentCustomizationV2: (body) Enrollment Customization to update 
     - returns: RequestBuilder<EnrollmentCustomizationV2> 
     */
    open class func v2EnrollmentCustomizationsIdPutWithRequestBuilder(id: String, enrollmentCustomizationV2: EnrollmentCustomizationV2) -> RequestBuilder<EnrollmentCustomizationV2> {
        var localVariablePath = "/v2/enrollment-customizations/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentCustomizationV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentCustomizationV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Download an enrollment customization image 
     
     - parameter id: (path) id of the enrollment customization image 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentCustomizationsImagesIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: URL?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentCustomizationsImagesIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Download an enrollment customization image 
     - GET /v2/enrollment-customizations/images/{id}
     - Download an enrollment customization image
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of the enrollment customization image 
     - returns: RequestBuilder<URL> 
     */
    open class func v2EnrollmentCustomizationsImagesIdGetWithRequestBuilder(id: String) -> RequestBuilder<URL> {
        var localVariablePath = "/v2/enrollment-customizations/images/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<URL>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Upload an image
     
     - parameter file: (form) The file to upload 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentCustomizationsImagesPost(file: URL, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: BrandingImageUrl?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentCustomizationsImagesPostWithRequestBuilder(file: file).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Upload an image
     - POST /v2/enrollment-customizations/images
     - Uploads an image
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter file: (form) The file to upload 
     - returns: RequestBuilder<BrandingImageUrl> 
     */
    open class func v2EnrollmentCustomizationsImagesPostWithRequestBuilder(file: URL) -> RequestBuilder<BrandingImageUrl> {
        let localVariablePath = "/v2/enrollment-customizations/images"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableFormParams: [String: Any?] = [
            "file": file.encodeToJSON(),
        ]

        let localVariableNonNullParameters = APIHelper.rejectNil(localVariableFormParams)
        let localVariableParameters = APIHelper.convertBoolToString(localVariableNonNullParameters)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            "Content-Type": "multipart/form-data",
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<BrandingImageUrl>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create an Enrollment Customization 
     
     - parameter enrollmentCustomizationV2: (body) Enrollment customization to create. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2EnrollmentCustomizationsPost(enrollmentCustomizationV2: EnrollmentCustomizationV2, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2EnrollmentCustomizationsPostWithRequestBuilder(enrollmentCustomizationV2: enrollmentCustomizationV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create an Enrollment Customization 
     - POST /v2/enrollment-customizations
     - Create an enrollment customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter enrollmentCustomizationV2: (body) Enrollment customization to create. 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v2EnrollmentCustomizationsPostWithRequestBuilder(enrollmentCustomizationV2: EnrollmentCustomizationV2) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v2/enrollment-customizations"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentCustomizationV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
