//
// EnrollmentCustomizationPreviewAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class EnrollmentCustomizationPreviewAPI {

    /**
     Get all Panels for single Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdAllGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: EnrollmentCustomizationPanelList?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdAllGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get all Panels for single Enrollment Customization 
     - GET /v1/enrollment-customization/{id}/all
     - Get all panels for single enrollment customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - returns: RequestBuilder<EnrollmentCustomizationPanelList> 
     */
    open class func v1EnrollmentCustomizationIdAllGetWithRequestBuilder(id: Int) -> RequestBuilder<EnrollmentCustomizationPanelList> {
        var localVariablePath = "/v1/enrollment-customization/{id}/all"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<EnrollmentCustomizationPanelList>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete a single Panel from an Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdAllPanelIdDelete(id: Int, panelId: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdAllPanelIdDeleteWithRequestBuilder(id: id, panelId: panelId).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete a single Panel from an Enrollment Customization 
     - DELETE /v1/enrollment-customization/{id}/all/{panel-id}
     - Delete a single panel from an Enrollment Customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v1EnrollmentCustomizationIdAllPanelIdDeleteWithRequestBuilder(id: Int, panelId: Int) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/enrollment-customization/{id}/all/{panel-id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let panelIdPreEscape = "\(APIHelper.mapValueToPathItem(panelId))"
        let panelIdPostEscape = panelIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{panel-id}", with: panelIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get a single Panel for a single Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdAllPanelIdGet(id: Int, panelId: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomizationPanel?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdAllPanelIdGetWithRequestBuilder(id: id, panelId: panelId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get a single Panel for a single Enrollment Customization 
     - GET /v1/enrollment-customization/{id}/all/{panel-id}
     - Get a single panel for a single enrollment customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - returns: RequestBuilder<GetEnrollmentCustomizationPanel> 
     */
    open class func v1EnrollmentCustomizationIdAllPanelIdGetWithRequestBuilder(id: Int, panelId: Int) -> RequestBuilder<GetEnrollmentCustomizationPanel> {
        var localVariablePath = "/v1/enrollment-customization/{id}/all/{panel-id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let panelIdPreEscape = "\(APIHelper.mapValueToPathItem(panelId))"
        let panelIdPostEscape = panelIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{panel-id}", with: panelIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomizationPanel>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete an LDAP single panel from an Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdLdapPanelIdDelete(id: Int, panelId: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdLdapPanelIdDeleteWithRequestBuilder(id: id, panelId: panelId).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete an LDAP single panel from an Enrollment Customization 
     - DELETE /v1/enrollment-customization/{id}/ldap/{panel-id}
     - Delete an LDAP single Panel from an Enrollment Customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v1EnrollmentCustomizationIdLdapPanelIdDeleteWithRequestBuilder(id: Int, panelId: Int) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/enrollment-customization/{id}/ldap/{panel-id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let panelIdPreEscape = "\(APIHelper.mapValueToPathItem(panelId))"
        let panelIdPostEscape = panelIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{panel-id}", with: panelIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get a single LDAP panel for a single Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdLdapPanelIdGet(id: Int, panelId: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomizationPanelLdapAuth?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdLdapPanelIdGetWithRequestBuilder(id: id, panelId: panelId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get a single LDAP panel for a single Enrollment Customization 
     - GET /v1/enrollment-customization/{id}/ldap/{panel-id}
     - Get a single LDAP panel for a single enrollment customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - returns: RequestBuilder<GetEnrollmentCustomizationPanelLdapAuth> 
     */
    open class func v1EnrollmentCustomizationIdLdapPanelIdGetWithRequestBuilder(id: Int, panelId: Int) -> RequestBuilder<GetEnrollmentCustomizationPanelLdapAuth> {
        var localVariablePath = "/v1/enrollment-customization/{id}/ldap/{panel-id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let panelIdPreEscape = "\(APIHelper.mapValueToPathItem(panelId))"
        let panelIdPostEscape = panelIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{panel-id}", with: panelIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomizationPanelLdapAuth>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a single LDAP Panel for a single Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter enrollmentCustomizationPanelLdapAuth: (body) Enrollment Customization Panel to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdLdapPanelIdPut(id: Int, panelId: Int, enrollmentCustomizationPanelLdapAuth: EnrollmentCustomizationPanelLdapAuth, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomizationPanelLdapAuth?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdLdapPanelIdPutWithRequestBuilder(id: id, panelId: panelId, enrollmentCustomizationPanelLdapAuth: enrollmentCustomizationPanelLdapAuth).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a single LDAP Panel for a single Enrollment Customization 
     - PUT /v1/enrollment-customization/{id}/ldap/{panel-id}
     - Update a single LDAP panel for a single enrollment customization. If multiple LDAP access groups are defined with the same name and id, only one will be saved.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter enrollmentCustomizationPanelLdapAuth: (body) Enrollment Customization Panel to update 
     - returns: RequestBuilder<GetEnrollmentCustomizationPanelLdapAuth> 
     */
    open class func v1EnrollmentCustomizationIdLdapPanelIdPutWithRequestBuilder(id: Int, panelId: Int, enrollmentCustomizationPanelLdapAuth: EnrollmentCustomizationPanelLdapAuth) -> RequestBuilder<GetEnrollmentCustomizationPanelLdapAuth> {
        var localVariablePath = "/v1/enrollment-customization/{id}/ldap/{panel-id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let panelIdPreEscape = "\(APIHelper.mapValueToPathItem(panelId))"
        let panelIdPostEscape = panelIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{panel-id}", with: panelIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentCustomizationPanelLdapAuth)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomizationPanelLdapAuth>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create an LDAP Panel for a single Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter enrollmentCustomizationPanelLdapAuth: (body) Enrollment Customization Panel to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdLdapPost(id: Int, enrollmentCustomizationPanelLdapAuth: EnrollmentCustomizationPanelLdapAuth, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomizationPanelLdapAuth?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdLdapPostWithRequestBuilder(id: id, enrollmentCustomizationPanelLdapAuth: enrollmentCustomizationPanelLdapAuth).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create an LDAP Panel for a single Enrollment Customization 
     - POST /v1/enrollment-customization/{id}/ldap
     - Create an LDAP panel for a single enrollment customization. If multiple LDAP access groups are defined with the same name and id, only one will be saved.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter enrollmentCustomizationPanelLdapAuth: (body) Enrollment Customization Panel to create 
     - returns: RequestBuilder<GetEnrollmentCustomizationPanelLdapAuth> 
     */
    open class func v1EnrollmentCustomizationIdLdapPostWithRequestBuilder(id: Int, enrollmentCustomizationPanelLdapAuth: EnrollmentCustomizationPanelLdapAuth) -> RequestBuilder<GetEnrollmentCustomizationPanelLdapAuth> {
        var localVariablePath = "/v1/enrollment-customization/{id}/ldap"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentCustomizationPanelLdapAuth)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomizationPanelLdapAuth>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete a single SSO Panel from an Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdSsoPanelIdDelete(id: Int, panelId: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdSsoPanelIdDeleteWithRequestBuilder(id: id, panelId: panelId).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete a single SSO Panel from an Enrollment Customization 
     - DELETE /v1/enrollment-customization/{id}/sso/{panel-id}
     - Delete a single SSO panel from an Enrollment Customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v1EnrollmentCustomizationIdSsoPanelIdDeleteWithRequestBuilder(id: Int, panelId: Int) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/enrollment-customization/{id}/sso/{panel-id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let panelIdPreEscape = "\(APIHelper.mapValueToPathItem(panelId))"
        let panelIdPostEscape = panelIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{panel-id}", with: panelIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get a single SSO Panel for a single Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdSsoPanelIdGet(id: Int, panelId: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomizationPanelSsoAuth?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdSsoPanelIdGetWithRequestBuilder(id: id, panelId: panelId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get a single SSO Panel for a single Enrollment Customization 
     - GET /v1/enrollment-customization/{id}/sso/{panel-id}
     - Get a single SSO panel for a single enrollment customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - returns: RequestBuilder<GetEnrollmentCustomizationPanelSsoAuth> 
     */
    open class func v1EnrollmentCustomizationIdSsoPanelIdGetWithRequestBuilder(id: Int, panelId: Int) -> RequestBuilder<GetEnrollmentCustomizationPanelSsoAuth> {
        var localVariablePath = "/v1/enrollment-customization/{id}/sso/{panel-id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let panelIdPreEscape = "\(APIHelper.mapValueToPathItem(panelId))"
        let panelIdPostEscape = panelIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{panel-id}", with: panelIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomizationPanelSsoAuth>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a single SSO Panel for a single Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter enrollmentCustomizationPanelSsoAuth: (body) Enrollment Customization Panel to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdSsoPanelIdPut(id: Int, panelId: Int, enrollmentCustomizationPanelSsoAuth: EnrollmentCustomizationPanelSsoAuth, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomizationPanelSsoAuth?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdSsoPanelIdPutWithRequestBuilder(id: id, panelId: panelId, enrollmentCustomizationPanelSsoAuth: enrollmentCustomizationPanelSsoAuth).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a single SSO Panel for a single Enrollment Customization 
     - PUT /v1/enrollment-customization/{id}/sso/{panel-id}
     - Update a single SSO panel for a single enrollment customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter enrollmentCustomizationPanelSsoAuth: (body) Enrollment Customization Panel to update 
     - returns: RequestBuilder<GetEnrollmentCustomizationPanelSsoAuth> 
     */
    open class func v1EnrollmentCustomizationIdSsoPanelIdPutWithRequestBuilder(id: Int, panelId: Int, enrollmentCustomizationPanelSsoAuth: EnrollmentCustomizationPanelSsoAuth) -> RequestBuilder<GetEnrollmentCustomizationPanelSsoAuth> {
        var localVariablePath = "/v1/enrollment-customization/{id}/sso/{panel-id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let panelIdPreEscape = "\(APIHelper.mapValueToPathItem(panelId))"
        let panelIdPostEscape = panelIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{panel-id}", with: panelIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentCustomizationPanelSsoAuth)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomizationPanelSsoAuth>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create an SSO Panel for a single Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter enrollmentCustomizationPanelSsoAuth: (body) Enrollment Customization Panel to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdSsoPost(id: Int, enrollmentCustomizationPanelSsoAuth: EnrollmentCustomizationPanelSsoAuth, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomizationPanelSsoAuth?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdSsoPostWithRequestBuilder(id: id, enrollmentCustomizationPanelSsoAuth: enrollmentCustomizationPanelSsoAuth).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create an SSO Panel for a single Enrollment Customization 
     - POST /v1/enrollment-customization/{id}/sso
     - Create an SSO panel for a single enrollment customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter enrollmentCustomizationPanelSsoAuth: (body) Enrollment Customization Panel to create 
     - returns: RequestBuilder<GetEnrollmentCustomizationPanelSsoAuth> 
     */
    open class func v1EnrollmentCustomizationIdSsoPostWithRequestBuilder(id: Int, enrollmentCustomizationPanelSsoAuth: EnrollmentCustomizationPanelSsoAuth) -> RequestBuilder<GetEnrollmentCustomizationPanelSsoAuth> {
        var localVariablePath = "/v1/enrollment-customization/{id}/sso"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentCustomizationPanelSsoAuth)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomizationPanelSsoAuth>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete a Text single Panel from an Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdTextPanelIdDelete(id: Int, panelId: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdTextPanelIdDeleteWithRequestBuilder(id: id, panelId: panelId).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete a Text single Panel from an Enrollment Customization 
     - DELETE /v1/enrollment-customization/{id}/text/{panel-id}
     - Delete a Text single panel from an Enrollment Customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v1EnrollmentCustomizationIdTextPanelIdDeleteWithRequestBuilder(id: Int, panelId: Int) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/enrollment-customization/{id}/text/{panel-id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let panelIdPreEscape = "\(APIHelper.mapValueToPathItem(panelId))"
        let panelIdPostEscape = panelIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{panel-id}", with: panelIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get a single Text Panel for a single Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdTextPanelIdGet(id: Int, panelId: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomizationPanelText?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdTextPanelIdGetWithRequestBuilder(id: id, panelId: panelId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get a single Text Panel for a single Enrollment Customization 
     - GET /v1/enrollment-customization/{id}/text/{panel-id}
     - Get a single Text panel for a single enrollment customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - returns: RequestBuilder<GetEnrollmentCustomizationPanelText> 
     */
    open class func v1EnrollmentCustomizationIdTextPanelIdGetWithRequestBuilder(id: Int, panelId: Int) -> RequestBuilder<GetEnrollmentCustomizationPanelText> {
        var localVariablePath = "/v1/enrollment-customization/{id}/text/{panel-id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let panelIdPreEscape = "\(APIHelper.mapValueToPathItem(panelId))"
        let panelIdPostEscape = panelIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{panel-id}", with: panelIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomizationPanelText>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get the markdown output of a single Text Panel for a single Enrollment 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdTextPanelIdMarkdownGet(id: Int, panelId: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Markdown?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdTextPanelIdMarkdownGetWithRequestBuilder(id: id, panelId: panelId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get the markdown output of a single Text Panel for a single Enrollment 
     - GET /v1/enrollment-customization/{id}/text/{panel-id}/markdown
     - Get the markdown output of a single Text panel for a single enrollment customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - returns: RequestBuilder<Markdown> 
     */
    open class func v1EnrollmentCustomizationIdTextPanelIdMarkdownGetWithRequestBuilder(id: Int, panelId: Int) -> RequestBuilder<Markdown> {
        var localVariablePath = "/v1/enrollment-customization/{id}/text/{panel-id}/markdown"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let panelIdPreEscape = "\(APIHelper.mapValueToPathItem(panelId))"
        let panelIdPostEscape = panelIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{panel-id}", with: panelIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Markdown>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a single Text Panel for a single Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter enrollmentCustomizationPanelText: (body) Enrollment Customization Panel to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdTextPanelIdPut(id: Int, panelId: Int, enrollmentCustomizationPanelText: EnrollmentCustomizationPanelText, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomizationPanelText?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdTextPanelIdPutWithRequestBuilder(id: id, panelId: panelId, enrollmentCustomizationPanelText: enrollmentCustomizationPanelText).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a single Text Panel for a single Enrollment Customization 
     - PUT /v1/enrollment-customization/{id}/text/{panel-id}
     - Update a single Text panel for a single enrollment customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter panelId: (path) Panel object identifier 
     - parameter enrollmentCustomizationPanelText: (body) Enrollment Customization Panel to update 
     - returns: RequestBuilder<GetEnrollmentCustomizationPanelText> 
     */
    open class func v1EnrollmentCustomizationIdTextPanelIdPutWithRequestBuilder(id: Int, panelId: Int, enrollmentCustomizationPanelText: EnrollmentCustomizationPanelText) -> RequestBuilder<GetEnrollmentCustomizationPanelText> {
        var localVariablePath = "/v1/enrollment-customization/{id}/text/{panel-id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let panelIdPreEscape = "\(APIHelper.mapValueToPathItem(panelId))"
        let panelIdPostEscape = panelIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{panel-id}", with: panelIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentCustomizationPanelText)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomizationPanelText>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a Text Panel for a single Enrollment Customization 
     
     - parameter id: (path) Enrollment Customization identifier 
     - parameter enrollmentCustomizationPanelText: (body) Enrollment Customization Panel to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationIdTextPost(id: Int, enrollmentCustomizationPanelText: EnrollmentCustomizationPanelText, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetEnrollmentCustomizationPanelText?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationIdTextPostWithRequestBuilder(id: id, enrollmentCustomizationPanelText: enrollmentCustomizationPanelText).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a Text Panel for a single Enrollment Customization 
     - POST /v1/enrollment-customization/{id}/text
     - Create a Text panel for a single enrollment customization
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Enrollment Customization identifier 
     - parameter enrollmentCustomizationPanelText: (body) Enrollment Customization Panel to create 
     - returns: RequestBuilder<GetEnrollmentCustomizationPanelText> 
     */
    open class func v1EnrollmentCustomizationIdTextPostWithRequestBuilder(id: Int, enrollmentCustomizationPanelText: EnrollmentCustomizationPanelText) -> RequestBuilder<GetEnrollmentCustomizationPanelText> {
        var localVariablePath = "/v1/enrollment-customization/{id}/text"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: enrollmentCustomizationPanelText)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetEnrollmentCustomizationPanelText>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Parse the given string as markdown text and return Html output 
     
     - parameter markdown: (body) Enrollment Customization Panel to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1EnrollmentCustomizationParseMarkdownPost(markdown: Markdown, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Markdown?, _ error: Error?) -> Void)) -> RequestTask {
        return v1EnrollmentCustomizationParseMarkdownPostWithRequestBuilder(markdown: markdown).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Parse the given string as markdown text and return Html output 
     - POST /v1/enrollment-customization/parse-markdown
     - Parse the given string as markdown text and return Html output
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter markdown: (body) Enrollment Customization Panel to create 
     - returns: RequestBuilder<Markdown> 
     */
    open class func v1EnrollmentCustomizationParseMarkdownPostWithRequestBuilder(markdown: Markdown) -> RequestBuilder<Markdown> {
        let localVariablePath = "/v1/enrollment-customization/parse-markdown"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: markdown)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Markdown>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
