//
// IconAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class IconAPI {

    /**
     Download a self service icon 
     
     - parameter id: (path) id of the self service icon 
     - parameter res: (query) request a specific resolution of original, 300, or 512; invalid options will result in original resolution (optional, default to "original")
     - parameter scale: (query) request a scale; 0 results in original image, non-0 results in scaled to 300 (optional, default to "0")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1IconDownloadIdGet(id: String, res: String? = nil, scale: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: URL?, _ error: Error?) -> Void)) -> RequestTask {
        return v1IconDownloadIdGetWithRequestBuilder(id: id, res: res, scale: scale).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Download a self service icon 
     - GET /v1/icon/download/{id}
     - Download a self service icon
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of the self service icon 
     - parameter res: (query) request a specific resolution of original, 300, or 512; invalid options will result in original resolution (optional, default to "original")
     - parameter scale: (query) request a scale; 0 results in original image, non-0 results in scaled to 300 (optional, default to "0")
     - returns: RequestBuilder<URL> 
     */
    open class func v1IconDownloadIdGetWithRequestBuilder(id: String, res: String? = nil, scale: String? = nil) -> RequestBuilder<URL> {
        var localVariablePath = "/v1/icon/download/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "res": (wrappedValue: res?.encodeToJSON(), isExplode: true),
            "scale": (wrappedValue: scale?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<URL>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get an icon 
     
     - parameter id: (path) id of the icon 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1IconIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: IconResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1IconIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get an icon 
     - GET /v1/icon/{id}
     - Get an icon
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of the icon 
     - returns: RequestBuilder<IconResponse> 
     */
    open class func v1IconIdGetWithRequestBuilder(id: String) -> RequestBuilder<IconResponse> {
        var localVariablePath = "/v1/icon/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<IconResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Upload an icon 
     
     - parameter file: (form) The file to upload 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1IconPost(file: URL, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: IconResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1IconPostWithRequestBuilder(file: file).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Upload an icon 
     - POST /v1/icon
     - Uploads an icon
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter file: (form) The file to upload 
     - returns: RequestBuilder<IconResponse> 
     */
    open class func v1IconPostWithRequestBuilder(file: URL) -> RequestBuilder<IconResponse> {
        let localVariablePath = "/v1/icon"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableFormParams: [String: Any?] = [
            "file": file.encodeToJSON(),
        ]

        let localVariableNonNullParameters = APIHelper.rejectNil(localVariableFormParams)
        let localVariableParameters = APIHelper.convertBoolToString(localVariableNonNullParameters)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            "Content-Type": "multipart/form-data",
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<IconResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
