//
// InventoryInformationAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class InventoryInformationAPI {

    /**
     Get statistics about managed/unmanaged devices and computers in the inventory 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1InventoryInformationGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryInformation?, _ error: Error?) -> Void)) -> RequestTask {
        return v1InventoryInformationGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get statistics about managed/unmanaged devices and computers in the inventory 
     - GET /v1/inventory-information
     - Gets statistics about managed/unmanaged devices and computers in the inventory. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<InventoryInformation> 
     */
    open class func v1InventoryInformationGetWithRequestBuilder() -> RequestBuilder<InventoryInformation> {
        let localVariablePath = "/v1/inventory-information"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryInformation>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
