//
// InventoryPreloadAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class InventoryPreloadAPI {

    /**
     Get the Inventory Preload CSV template 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func inventoryPreloadCsvTemplateGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AnyCodable?, _ error: Error?) -> Void)) -> RequestTask {
        return inventoryPreloadCsvTemplateGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get the Inventory Preload CSV template 
     - GET /inventory-preload/csv-template
     - Retrieves the Inventory Preload CSV template.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<AnyCodable> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func inventoryPreloadCsvTemplateGetWithRequestBuilder() -> RequestBuilder<AnyCodable> {
        let localVariablePath = "/inventory-preload/csv-template"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AnyCodable>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete all Inventory Preload records 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func inventoryPreloadDelete(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return inventoryPreloadDeleteWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete all Inventory Preload records 
     - DELETE /inventory-preload
     - Deletes all Inventory Preload records.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<Void> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func inventoryPreloadDeleteWithRequestBuilder() -> RequestBuilder<Void> {
        let localVariablePath = "/inventory-preload"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     * enum for parameter sort
     */
    public enum Sort_inventoryPreloadGet: String, CaseIterable {
        case asc = "ASC"
        case desc = "DESC"
    }

    /**
     Return all Inventory Preload records 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter sort: (query)  (optional, default to .asc)
     - parameter sortBy: (query)  (optional, default to "id")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func inventoryPreloadGet(page: Int? = nil, pagesize: Int? = nil, sort: Sort_inventoryPreloadGet? = nil, sortBy: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [InventoryPreloadRecordSearchResults]?, _ error: Error?) -> Void)) -> RequestTask {
        return inventoryPreloadGetWithRequestBuilder(page: page, pagesize: pagesize, sort: sort, sortBy: sortBy).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Return all Inventory Preload records 
     - GET /inventory-preload
     - Returns all Inventory Preload records.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter sort: (query)  (optional, default to .asc)
     - parameter sortBy: (query)  (optional, default to "id")
     - returns: RequestBuilder<[InventoryPreloadRecordSearchResults]> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func inventoryPreloadGetWithRequestBuilder(page: Int? = nil, pagesize: Int? = nil, sort: Sort_inventoryPreloadGet? = nil, sortBy: String? = nil) -> RequestBuilder<[InventoryPreloadRecordSearchResults]> {
        let localVariablePath = "/inventory-preload"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "pagesize": (wrappedValue: pagesize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "sortBy": (wrappedValue: sortBy?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[InventoryPreloadRecordSearchResults]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Inventory Preload history entries 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is date:desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "date:desc")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func inventoryPreloadHistoryGet(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HistorySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return inventoryPreloadHistoryGetWithRequestBuilder(page: page, size: size, pagesize: pagesize, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Inventory Preload history entries 
     - GET /inventory-preload/history
     - Gets Inventory Preload history entries.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is date:desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "date:desc")
     - returns: RequestBuilder<HistorySearchResults> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func inventoryPreloadHistoryGetWithRequestBuilder(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil) -> RequestBuilder<HistorySearchResults> {
        let localVariablePath = "/inventory-preload/history"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "size": (wrappedValue: size?.encodeToJSON(), isExplode: true),
            "pagesize": (wrappedValue: pagesize?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HistorySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Inventory Preload history object notes 
     
     - parameter objectHistoryNote: (body) History notes to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func inventoryPreloadHistoryNotesPost(objectHistoryNote: ObjectHistoryNote, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ObjectHistory?, _ error: Error?) -> Void)) -> RequestTask {
        return inventoryPreloadHistoryNotesPostWithRequestBuilder(objectHistoryNote: objectHistoryNote).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Inventory Preload history object notes 
     - POST /inventory-preload/history/notes
     - Adds Inventory Preload history object notes.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter objectHistoryNote: (body) History notes to create 
     - returns: RequestBuilder<ObjectHistory> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func inventoryPreloadHistoryNotesPostWithRequestBuilder(objectHistoryNote: ObjectHistoryNote) -> RequestBuilder<ObjectHistory> {
        let localVariablePath = "/inventory-preload/history/notes"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: objectHistoryNote)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ObjectHistory>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete an Inventory Preload record 
     
     - parameter id: (path) Inventory Preload identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func inventoryPreloadIdDelete(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return inventoryPreloadIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete an Inventory Preload record 
     - DELETE /inventory-preload/{id}
     - Deletes an Inventory Preload record.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Inventory Preload identifier 
     - returns: RequestBuilder<Void> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func inventoryPreloadIdDeleteWithRequestBuilder(id: Int) -> RequestBuilder<Void> {
        var localVariablePath = "/inventory-preload/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get an Inventory Preload record 
     
     - parameter id: (path) Inventory Preload identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func inventoryPreloadIdGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadRecord?, _ error: Error?) -> Void)) -> RequestTask {
        return inventoryPreloadIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get an Inventory Preload record 
     - GET /inventory-preload/{id}
     - Retrieves an Inventory Preload record.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Inventory Preload identifier 
     - returns: RequestBuilder<InventoryPreloadRecord> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func inventoryPreloadIdGetWithRequestBuilder(id: Int) -> RequestBuilder<InventoryPreloadRecord> {
        var localVariablePath = "/inventory-preload/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadRecord>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update an Inventory Preload record 
     
     - parameter id: (path) Inventory Preload identifier 
     - parameter inventoryPreloadRecord: (body) Inventory Preload record to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func inventoryPreloadIdPut(id: Int, inventoryPreloadRecord: InventoryPreloadRecord, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadRecord?, _ error: Error?) -> Void)) -> RequestTask {
        return inventoryPreloadIdPutWithRequestBuilder(id: id, inventoryPreloadRecord: inventoryPreloadRecord).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update an Inventory Preload record 
     - PUT /inventory-preload/{id}
     - Updates an Inventory Preload record.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Inventory Preload identifier 
     - parameter inventoryPreloadRecord: (body) Inventory Preload record to update 
     - returns: RequestBuilder<InventoryPreloadRecord> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func inventoryPreloadIdPutWithRequestBuilder(id: Int, inventoryPreloadRecord: InventoryPreloadRecord) -> RequestBuilder<InventoryPreloadRecord> {
        var localVariablePath = "/inventory-preload/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: inventoryPreloadRecord)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadRecord>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a new Inventory Preload record using JSON or CSV 
     
     - parameter inventoryPreloadRecord: (body) Inventory Preload record or records to be created 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func inventoryPreloadPost(inventoryPreloadRecord: InventoryPreloadRecord, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadRecord?, _ error: Error?) -> Void)) -> RequestTask {
        return inventoryPreloadPostWithRequestBuilder(inventoryPreloadRecord: inventoryPreloadRecord).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a new Inventory Preload record using JSON or CSV 
     - POST /inventory-preload
     - Create a new Inventory Preload record using JSON or CSV. A CSV template can be downloaded from /api/inventory-preload/csv-template. Serial number and device type are required. All other fields are optional. When a matching serial number exists in the Inventory Preload data, the record will be overwritten with the CSV data. If the CSV file contains a new username and an email address is provided, the new user is created in Jamf Pro. If the CSV file contains an existing username, the following user-related fields are updated in Jamf Pro. Full Name, Email Address, Phone Number, Position. This endpoint does not do full validation of each record in the CSV data. To do full validation, use the /inventory-preload/validate-csv endpoint first. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter inventoryPreloadRecord: (body) Inventory Preload record or records to be created 
     - returns: RequestBuilder<InventoryPreloadRecord> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func inventoryPreloadPostWithRequestBuilder(inventoryPreloadRecord: InventoryPreloadRecord) -> RequestBuilder<InventoryPreloadRecord> {
        let localVariablePath = "/inventory-preload"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: inventoryPreloadRecord)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadRecord>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Validate a given CSV file 
     
     - parameter body: (body) Inventory Preload records to be validated. A CSV template can be downloaded from /api/inventory-preload/csv-template 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func inventoryPreloadValidateCsvPost(body: AnyCodable, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadCsvValidationSuccess?, _ error: Error?) -> Void)) -> RequestTask {
        return inventoryPreloadValidateCsvPostWithRequestBuilder(body: body).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Validate a given CSV file 
     - POST /inventory-preload/validate-csv
     - Validate a given CSV file. Serial number and device type are required. All other fields are optional. A CSV template can be downloaded from /api/inventory-preload/csv-template. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter body: (body) Inventory Preload records to be validated. A CSV template can be downloaded from /api/inventory-preload/csv-template 
     - returns: RequestBuilder<InventoryPreloadCsvValidationSuccess> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func inventoryPreloadValidateCsvPostWithRequestBuilder(body: AnyCodable) -> RequestBuilder<InventoryPreloadCsvValidationSuccess> {
        let localVariablePath = "/inventory-preload/validate-csv"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadCsvValidationSuccess>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the Inventory Preload CSV template 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1InventoryPreloadCsvTemplateGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AnyCodable?, _ error: Error?) -> Void)) -> RequestTask {
        return v1InventoryPreloadCsvTemplateGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the Inventory Preload CSV template 
     - GET /v1/inventory-preload/csv-template
     - Retrieves the Inventory Preload CSV template.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<AnyCodable> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1InventoryPreloadCsvTemplateGetWithRequestBuilder() -> RequestBuilder<AnyCodable> {
        let localVariablePath = "/v1/inventory-preload/csv-template"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AnyCodable>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete all Inventory Preload records 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1InventoryPreloadDelete(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1InventoryPreloadDeleteWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete all Inventory Preload records 
     - DELETE /v1/inventory-preload
     - Deletes all Inventory Preload records.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<Void> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1InventoryPreloadDeleteWithRequestBuilder() -> RequestBuilder<Void> {
        let localVariablePath = "/v1/inventory-preload"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Return all Inventory Preload records 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is id:asc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "id:asc")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1InventoryPreloadGet(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadRecordSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1InventoryPreloadGetWithRequestBuilder(page: page, size: size, pagesize: pagesize, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Return all Inventory Preload records 
     - GET /v1/inventory-preload
     - Returns all Inventory Preload records.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is id:asc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "id:asc")
     - returns: RequestBuilder<InventoryPreloadRecordSearchResults> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1InventoryPreloadGetWithRequestBuilder(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil) -> RequestBuilder<InventoryPreloadRecordSearchResults> {
        let localVariablePath = "/v1/inventory-preload"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "size": (wrappedValue: size?.encodeToJSON(), isExplode: true),
            "pagesize": (wrappedValue: pagesize?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadRecordSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Inventory Preload history entries 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is date:desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "date:desc")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1InventoryPreloadHistoryGet(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HistorySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1InventoryPreloadHistoryGetWithRequestBuilder(page: page, size: size, pagesize: pagesize, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Inventory Preload history entries 
     - GET /v1/inventory-preload/history
     - Gets Inventory Preload history entries.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is date:desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "date:desc")
     - returns: RequestBuilder<HistorySearchResults> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1InventoryPreloadHistoryGetWithRequestBuilder(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil) -> RequestBuilder<HistorySearchResults> {
        let localVariablePath = "/v1/inventory-preload/history"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "size": (wrappedValue: size?.encodeToJSON(), isExplode: true),
            "pagesize": (wrappedValue: pagesize?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HistorySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Inventory Preload history object notes 
     
     - parameter objectHistoryNote: (body) History notes to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1InventoryPreloadHistoryPost(objectHistoryNote: ObjectHistoryNote, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ObjectHistory?, _ error: Error?) -> Void)) -> RequestTask {
        return v1InventoryPreloadHistoryPostWithRequestBuilder(objectHistoryNote: objectHistoryNote).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Inventory Preload history object notes 
     - POST /v1/inventory-preload/history
     - Adds Inventory Preload history object notes.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter objectHistoryNote: (body) History notes to create 
     - returns: RequestBuilder<ObjectHistory> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1InventoryPreloadHistoryPostWithRequestBuilder(objectHistoryNote: ObjectHistoryNote) -> RequestBuilder<ObjectHistory> {
        let localVariablePath = "/v1/inventory-preload/history"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: objectHistoryNote)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ObjectHistory>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete an Inventory Preload record 
     
     - parameter id: (path) Inventory Preload identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1InventoryPreloadIdDelete(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1InventoryPreloadIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete an Inventory Preload record 
     - DELETE /v1/inventory-preload/{id}
     - Deletes an Inventory Preload record.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Inventory Preload identifier 
     - returns: RequestBuilder<Void> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1InventoryPreloadIdDeleteWithRequestBuilder(id: Int) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/inventory-preload/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get an Inventory Preload record 
     
     - parameter id: (path) Inventory Preload identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1InventoryPreloadIdGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadRecord?, _ error: Error?) -> Void)) -> RequestTask {
        return v1InventoryPreloadIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get an Inventory Preload record 
     - GET /v1/inventory-preload/{id}
     - Retrieves an Inventory Preload record.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Inventory Preload identifier 
     - returns: RequestBuilder<InventoryPreloadRecord> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1InventoryPreloadIdGetWithRequestBuilder(id: Int) -> RequestBuilder<InventoryPreloadRecord> {
        var localVariablePath = "/v1/inventory-preload/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadRecord>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update an Inventory Preload record 
     
     - parameter id: (path) Inventory Preload identifier 
     - parameter inventoryPreloadRecord: (body) Inventory Preload record to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1InventoryPreloadIdPut(id: Int, inventoryPreloadRecord: InventoryPreloadRecord, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadRecord?, _ error: Error?) -> Void)) -> RequestTask {
        return v1InventoryPreloadIdPutWithRequestBuilder(id: id, inventoryPreloadRecord: inventoryPreloadRecord).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update an Inventory Preload record 
     - PUT /v1/inventory-preload/{id}
     - Updates an Inventory Preload record.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Inventory Preload identifier 
     - parameter inventoryPreloadRecord: (body) Inventory Preload record to update 
     - returns: RequestBuilder<InventoryPreloadRecord> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1InventoryPreloadIdPutWithRequestBuilder(id: Int, inventoryPreloadRecord: InventoryPreloadRecord) -> RequestBuilder<InventoryPreloadRecord> {
        var localVariablePath = "/v1/inventory-preload/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: inventoryPreloadRecord)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadRecord>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a new Inventory Preload record using JSON or CSV 
     
     - parameter inventoryPreloadRecord: (body) Inventory Preload record or records to be created 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1InventoryPreloadPost(inventoryPreloadRecord: InventoryPreloadRecord, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadRecord?, _ error: Error?) -> Void)) -> RequestTask {
        return v1InventoryPreloadPostWithRequestBuilder(inventoryPreloadRecord: inventoryPreloadRecord).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a new Inventory Preload record using JSON or CSV 
     - POST /v1/inventory-preload
     - Create a new Inventory Preload record using JSON or CSV. A CSV template can be downloaded from /api/inventory-preload/csv-template. Serial number and device type are required. All other fields are optional. When a matching serial number exists in the Inventory Preload data, the record will be overwritten with the CSV data. If the CSV file contains a new username and an email address is provided, the new user is created in Jamf Pro. If the CSV file contains an existing username, the following user-related fields are updated in Jamf Pro. Full Name, Email Address, Phone Number, Position. This endpoint does not do full validation of each record in the CSV data. To do full validation, use the /inventory-preload/validate-csv endpoint first. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter inventoryPreloadRecord: (body) Inventory Preload record or records to be created 
     - returns: RequestBuilder<InventoryPreloadRecord> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1InventoryPreloadPostWithRequestBuilder(inventoryPreloadRecord: InventoryPreloadRecord) -> RequestBuilder<InventoryPreloadRecord> {
        let localVariablePath = "/v1/inventory-preload"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: inventoryPreloadRecord)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadRecord>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Validate a given CSV file 
     
     - parameter body: (body) Inventory Preload records to be validated. A CSV template can be downloaded from /api/inventory-preload/csv-template 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1InventoryPreloadValidateCsvPost(body: AnyCodable, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadCsvValidationSuccess?, _ error: Error?) -> Void)) -> RequestTask {
        return v1InventoryPreloadValidateCsvPostWithRequestBuilder(body: body).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Validate a given CSV file 
     - POST /v1/inventory-preload/validate-csv
     - Validate a given CSV file. Serial number and device type are required. All other fields are optional. A CSV template can be downloaded from /api/inventory-preload/csv-template. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter body: (body) Inventory Preload records to be validated. A CSV template can be downloaded from /api/inventory-preload/csv-template 
     - returns: RequestBuilder<InventoryPreloadCsvValidationSuccess> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1InventoryPreloadValidateCsvPostWithRequestBuilder(body: AnyCodable) -> RequestBuilder<InventoryPreloadCsvValidationSuccess> {
        let localVariablePath = "/v1/inventory-preload/validate-csv"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadCsvValidationSuccess>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Download all Inventory Preload records
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadCsvGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: String?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadCsvGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Download all Inventory Preload records
     - GET /v2/inventory-preload/csv
     - Returns all Inventory Preload records as a CSV file.
     - Bearer Token:
       - type: http
       - name: Bearer
     - responseHeaders: [Content-Disposition(String)]
     - returns: RequestBuilder<String> 
     */
    open class func v2InventoryPreloadCsvGetWithRequestBuilder() -> RequestBuilder<String> {
        let localVariablePath = "/v2/inventory-preload/csv"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<String>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create one or more new Inventory Preload records using CSV 
     
     - parameter file: (form) The CSV file to upload 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadCsvPost(file: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [HrefResponse]?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadCsvPostWithRequestBuilder(file: file).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create one or more new Inventory Preload records using CSV 
     - POST /v2/inventory-preload/csv
     - Create one or more new Inventory Preload records using CSV. A CSV template can be downloaded from /v2/inventory-preload/csv-template. Serial number and device type are required. All other fields are optional. When a matching serial number exists in the Inventory Preload data, the record will be overwritten with the CSV data. If the CSV file contains a new username and an email address is provided, the new user is created in Jamf Pro. If the CSV file contains an existing username, the following user-related fields are updated in Jamf Pro. Full Name, Email Address, Phone Number, Position. This endpoint does not do full validation of each record in the CSV data. To do full validation, use the `/v2/inventory-preload/csv-validate` endpoint first. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter file: (form) The CSV file to upload 
     - returns: RequestBuilder<[HrefResponse]> 
     */
    open class func v2InventoryPreloadCsvPostWithRequestBuilder(file: String) -> RequestBuilder<[HrefResponse]> {
        let localVariablePath = "/v2/inventory-preload/csv"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableFormParams: [String: Any?] = [
            "file": file.encodeToJSON(),
        ]

        let localVariableNonNullParameters = APIHelper.rejectNil(localVariableFormParams)
        let localVariableParameters = APIHelper.convertBoolToString(localVariableNonNullParameters)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            "Content-Type": "multipart/form-data",
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[HrefResponse]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Download the Inventory Preload CSV template
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadCsvTemplateGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: String?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadCsvTemplateGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Download the Inventory Preload CSV template
     - GET /v2/inventory-preload/csv-template
     - Retrieves the Inventory Preload CSV file template.
     - Bearer Token:
       - type: http
       - name: Bearer
     - responseHeaders: [Content-Disposition(String)]
     - returns: RequestBuilder<String> 
     */
    open class func v2InventoryPreloadCsvTemplateGetWithRequestBuilder() -> RequestBuilder<String> {
        let localVariablePath = "/v2/inventory-preload/csv-template"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<String>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Validate a given CSV file 
     
     - parameter file: (form) The CSV file to upload 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadCsvValidatePost(file: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadCsvValidationSuccess?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadCsvValidatePostWithRequestBuilder(file: file).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Validate a given CSV file 
     - POST /v2/inventory-preload/csv-validate
     - Validate a given CSV file. Serial number and device type are required. All other fields are optional. A CSV template can be downloaded from `/v2/inventory-preload/csv-template`. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter file: (form) The CSV file to upload 
     - returns: RequestBuilder<InventoryPreloadCsvValidationSuccess> 
     */
    open class func v2InventoryPreloadCsvValidatePostWithRequestBuilder(file: String) -> RequestBuilder<InventoryPreloadCsvValidationSuccess> {
        let localVariablePath = "/v2/inventory-preload/csv-validate"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableFormParams: [String: Any?] = [
            "file": file.encodeToJSON(),
        ]

        let localVariableNonNullParameters = APIHelper.rejectNil(localVariableFormParams)
        let localVariableParameters = APIHelper.convertBoolToString(localVariableNonNullParameters)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            "Content-Type": "multipart/form-data",
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadCsvValidationSuccess>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve a list of extension attribute columns 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadEaColumnsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadExtensionAttributeColumnResult?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadEaColumnsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve a list of extension attribute columns 
     - GET /v2/inventory-preload/ea-columns
     - Retrieve a list of extension attribute columns currently associated with inventory preload records 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<InventoryPreloadExtensionAttributeColumnResult> 
     */
    open class func v2InventoryPreloadEaColumnsGetWithRequestBuilder() -> RequestBuilder<InventoryPreloadExtensionAttributeColumnResult> {
        let localVariablePath = "/v2/inventory-preload/ea-columns"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadExtensionAttributeColumnResult>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Export a collection of inventory preload records 
     
     - parameter exportFields: (query) Export fields parameter, used to change default order or ignore some of the response properties. Default is empty array, which means that all fields of the response entity will be serialized. Example: export-fields&#x3D;id,username (optional)
     - parameter exportLabels: (query) Export labels parameter, used to customize fieldnames/columns in the exported file. Default is empty array, which means that response properties names will be used. Number of the provided labels must match the number of export-fields Example: export-labels&#x3D;identifier,name with matching: export-fields&#x3D;id,username (optional)
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: &#x60;property:asc/desc&#x60;. Default sort is &#x60;id:asc&#x60;. Multiple sort criteria are supported and must be separated with a comma. All inventory preload fields are supported, however fields added by extension attributes are not supported. If sorting by deviceType, use &#x60;0&#x60; for Computer and &#x60;1&#x60; for Mobile Device.  Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter filter: (query) Allowing to filter inventory preload records. Default search is empty query - returning all results for the requested page. All inventory preload fields are supported, however fields added by extension attributes are not supported. If filtering by deviceType, use &#x60;0&#x60; for Computer and &#x60;1&#x60; for Mobile Device.  Query in the RSQL format, allowing &#x60;&#x3D;&#x3D;&#x60;, &#x60;!&#x3D;&#x60;, &#x60;&gt;&#x60;, &#x60;&lt;&#x60;, and &#x60;&#x3D;in&#x3D;&#x60;.  Example: &#x60;filter&#x3D;categoryName&#x3D;&#x3D;\&quot;Category\&quot;&#x60;  (optional, default to "")
     - parameter exportParameters: (body) Optional. Override query parameters since they can make URI exceed 2,000 character limit. (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadExportPost(exportFields: [String]? = nil, exportLabels: [String]? = nil, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, exportParameters: ExportParameters? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AnyCodable?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadExportPostWithRequestBuilder(exportFields: exportFields, exportLabels: exportLabels, page: page, pageSize: pageSize, sort: sort, filter: filter, exportParameters: exportParameters).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Export a collection of inventory preload records 
     - POST /v2/inventory-preload/export
     - Export a collection of inventory preload records 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter exportFields: (query) Export fields parameter, used to change default order or ignore some of the response properties. Default is empty array, which means that all fields of the response entity will be serialized. Example: export-fields&#x3D;id,username (optional)
     - parameter exportLabels: (query) Export labels parameter, used to customize fieldnames/columns in the exported file. Default is empty array, which means that response properties names will be used. Number of the provided labels must match the number of export-fields Example: export-labels&#x3D;identifier,name with matching: export-fields&#x3D;id,username (optional)
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: &#x60;property:asc/desc&#x60;. Default sort is &#x60;id:asc&#x60;. Multiple sort criteria are supported and must be separated with a comma. All inventory preload fields are supported, however fields added by extension attributes are not supported. If sorting by deviceType, use &#x60;0&#x60; for Computer and &#x60;1&#x60; for Mobile Device.  Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter filter: (query) Allowing to filter inventory preload records. Default search is empty query - returning all results for the requested page. All inventory preload fields are supported, however fields added by extension attributes are not supported. If filtering by deviceType, use &#x60;0&#x60; for Computer and &#x60;1&#x60; for Mobile Device.  Query in the RSQL format, allowing &#x60;&#x3D;&#x3D;&#x60;, &#x60;!&#x3D;&#x60;, &#x60;&gt;&#x60;, &#x60;&lt;&#x60;, and &#x60;&#x3D;in&#x3D;&#x60;.  Example: &#x60;filter&#x3D;categoryName&#x3D;&#x3D;\&quot;Category\&quot;&#x60;  (optional, default to "")
     - parameter exportParameters: (body) Optional. Override query parameters since they can make URI exceed 2,000 character limit. (optional)
     - returns: RequestBuilder<AnyCodable> 
     */
    open class func v2InventoryPreloadExportPostWithRequestBuilder(exportFields: [String]? = nil, exportLabels: [String]? = nil, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, exportParameters: ExportParameters? = nil) -> RequestBuilder<AnyCodable> {
        let localVariablePath = "/v2/inventory-preload/export"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: exportParameters)

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "export-fields": (wrappedValue: exportFields?.encodeToJSON(), isExplode: true),
            "export-labels": (wrappedValue: exportLabels?.encodeToJSON(), isExplode: true),
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AnyCodable>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Inventory Preload history entries 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: &#x60;property:asc/desc&#x60;. Default sort is &#x60;date:desc&#x60;. Multiple sort criteria are supported and must be separated with a comma.  Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter filter: (query) Allows filtering inventory preload history records. Default search is empty query - returning all results for the requested page. All inventory preload history fields are supported.  Query in the RSQL format, allowing &#x60;&#x3D;&#x3D;&#x60;, &#x60;!&#x3D;&#x60;, &#x60;&gt;&#x60;, &#x60;&lt;&#x60;, and &#x60;&#x3D;in&#x3D;&#x60;.  Example: &#x60;filter&#x3D;username&#x3D;&#x3D;\&quot;admin\&quot;&#x60;  (optional, default to "")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadHistoryGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HistorySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadHistoryGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Inventory Preload history entries 
     - GET /v2/inventory-preload/history
     - Gets Inventory Preload history entries.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: &#x60;property:asc/desc&#x60;. Default sort is &#x60;date:desc&#x60;. Multiple sort criteria are supported and must be separated with a comma.  Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter filter: (query) Allows filtering inventory preload history records. Default search is empty query - returning all results for the requested page. All inventory preload history fields are supported.  Query in the RSQL format, allowing &#x60;&#x3D;&#x3D;&#x60;, &#x60;!&#x3D;&#x60;, &#x60;&gt;&#x60;, &#x60;&lt;&#x60;, and &#x60;&#x3D;in&#x3D;&#x60;.  Example: &#x60;filter&#x3D;username&#x3D;&#x3D;\&quot;admin\&quot;&#x60;  (optional, default to "")
     - returns: RequestBuilder<HistorySearchResults> 
     */
    open class func v2InventoryPreloadHistoryGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil) -> RequestBuilder<HistorySearchResults> {
        let localVariablePath = "/v2/inventory-preload/history"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HistorySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Inventory Preload history object notes
     
     - parameter objectHistoryNote: (body) History notes to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadHistoryPost(objectHistoryNote: ObjectHistoryNote, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadHistoryPostWithRequestBuilder(objectHistoryNote: objectHistoryNote).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Inventory Preload history object notes
     - POST /v2/inventory-preload/history
     - Adds Inventory Preload history object notes.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter objectHistoryNote: (body) History notes to create 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v2InventoryPreloadHistoryPostWithRequestBuilder(objectHistoryNote: ObjectHistoryNote) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v2/inventory-preload/history"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: objectHistoryNote)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete all Inventory Preload records 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadRecordsDeleteAllPost(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadRecordsDeleteAllPostWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete all Inventory Preload records 
     - POST /v2/inventory-preload/records/delete-all
     - Deletes all Inventory Preload records.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<Void> 
     */
    open class func v2InventoryPreloadRecordsDeleteAllPostWithRequestBuilder() -> RequestBuilder<Void> {
        let localVariablePath = "/v2/inventory-preload/records/delete-all"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Return all Inventory Preload records
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: &#x60;property:asc/desc&#x60;. Default sort is &#x60;id:asc&#x60;. Multiple sort criteria are supported and must be separated with a comma. All inventory preload fields are supported, however fields added by extension attributes are not supported. If sorting by deviceType, use &#x60;0&#x60; for Computer and &#x60;1&#x60; for Mobile Device.  Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter filter: (query) Allowing to filter inventory preload records. Default search is empty query - returning all results for the requested page. All inventory preload fields are supported, however fields added by extension attributes are not supported. If filtering by deviceType, use &#x60;0&#x60; for Computer and &#x60;1&#x60; for Mobile Device.  Query in the RSQL format, allowing &#x60;&#x3D;&#x3D;&#x60;, &#x60;!&#x3D;&#x60;, &#x60;&gt;&#x60;, &#x60;&lt;&#x60;, and &#x60;&#x3D;in&#x3D;&#x60;.  Example: &#x60;filter&#x3D;categoryName&#x3D;&#x3D;\&quot;Category\&quot;&#x60;  (optional, default to "")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadRecordsGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadRecordSearchResultsV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadRecordsGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Return all Inventory Preload records
     - GET /v2/inventory-preload/records
     - Returns all Inventory Preload records.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: &#x60;property:asc/desc&#x60;. Default sort is &#x60;id:asc&#x60;. Multiple sort criteria are supported and must be separated with a comma. All inventory preload fields are supported, however fields added by extension attributes are not supported. If sorting by deviceType, use &#x60;0&#x60; for Computer and &#x60;1&#x60; for Mobile Device.  Example: &#x60;sort&#x3D;date:desc,name:asc&#x60;.  (optional)
     - parameter filter: (query) Allowing to filter inventory preload records. Default search is empty query - returning all results for the requested page. All inventory preload fields are supported, however fields added by extension attributes are not supported. If filtering by deviceType, use &#x60;0&#x60; for Computer and &#x60;1&#x60; for Mobile Device.  Query in the RSQL format, allowing &#x60;&#x3D;&#x3D;&#x60;, &#x60;!&#x3D;&#x60;, &#x60;&gt;&#x60;, &#x60;&lt;&#x60;, and &#x60;&#x3D;in&#x3D;&#x60;.  Example: &#x60;filter&#x3D;categoryName&#x3D;&#x3D;\&quot;Category\&quot;&#x60;  (optional, default to "")
     - returns: RequestBuilder<InventoryPreloadRecordSearchResultsV2> 
     */
    open class func v2InventoryPreloadRecordsGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil) -> RequestBuilder<InventoryPreloadRecordSearchResultsV2> {
        let localVariablePath = "/v2/inventory-preload/records"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadRecordSearchResultsV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete an Inventory Preload record 
     
     - parameter id: (path) Inventory Preload identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadRecordsIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadRecordsIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete an Inventory Preload record 
     - DELETE /v2/inventory-preload/records/{id}
     - Deletes an Inventory Preload record.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Inventory Preload identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v2InventoryPreloadRecordsIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/inventory-preload/records/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get an Inventory Preload record
     
     - parameter id: (path) Inventory Preload identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadRecordsIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadRecordV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadRecordsIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get an Inventory Preload record
     - GET /v2/inventory-preload/records/{id}
     - Retrieves an Inventory Preload record.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Inventory Preload identifier 
     - returns: RequestBuilder<InventoryPreloadRecordV2> 
     */
    open class func v2InventoryPreloadRecordsIdGetWithRequestBuilder(id: String) -> RequestBuilder<InventoryPreloadRecordV2> {
        var localVariablePath = "/v2/inventory-preload/records/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadRecordV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update an Inventory Preload record
     
     - parameter id: (path) Inventory Preload identifier 
     - parameter inventoryPreloadRecordV2: (body) Inventory Preload record to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadRecordsIdPut(id: String, inventoryPreloadRecordV2: InventoryPreloadRecordV2, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: InventoryPreloadRecordV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadRecordsIdPutWithRequestBuilder(id: id, inventoryPreloadRecordV2: inventoryPreloadRecordV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update an Inventory Preload record
     - PUT /v2/inventory-preload/records/{id}
     - Updates an Inventory Preload record.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Inventory Preload identifier 
     - parameter inventoryPreloadRecordV2: (body) Inventory Preload record to update 
     - returns: RequestBuilder<InventoryPreloadRecordV2> 
     */
    open class func v2InventoryPreloadRecordsIdPutWithRequestBuilder(id: String, inventoryPreloadRecordV2: InventoryPreloadRecordV2) -> RequestBuilder<InventoryPreloadRecordV2> {
        var localVariablePath = "/v2/inventory-preload/records/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: inventoryPreloadRecordV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<InventoryPreloadRecordV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a new Inventory Preload record using JSON
     
     - parameter inventoryPreloadRecordV2: (body) Inventory Preload record to be created. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2InventoryPreloadRecordsPost(inventoryPreloadRecordV2: InventoryPreloadRecordV2, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2InventoryPreloadRecordsPostWithRequestBuilder(inventoryPreloadRecordV2: inventoryPreloadRecordV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a new Inventory Preload record using JSON
     - POST /v2/inventory-preload/records
     - Create a new Inventory Preload record using JSON.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter inventoryPreloadRecordV2: (body) Inventory Preload record to be created. 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v2InventoryPreloadRecordsPostWithRequestBuilder(inventoryPreloadRecordV2: InventoryPreloadRecordV2) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v2/inventory-preload/records"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: inventoryPreloadRecordV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
