//
// JamfManagementFrameworkAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class JamfManagementFrameworkAPI {

    /**
     Redeploy Jamf Management Framework 
     
     - parameter id: (path) instance id of computer 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1JamfManagementFrameworkRedeployIdPost(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: RedeployJamfManagementFrameworkResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1JamfManagementFrameworkRedeployIdPostWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Redeploy Jamf Management Framework 
     - POST /v1/jamf-management-framework/redeploy/{id}
     - Redeploys the Jamf Management Framework for enrolled device 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) instance id of computer 
     - returns: RequestBuilder<RedeployJamfManagementFrameworkResponse> 
     */
    open class func v1JamfManagementFrameworkRedeployIdPostWithRequestBuilder(id: String) -> RequestBuilder<RedeployJamfManagementFrameworkResponse> {
        var localVariablePath = "/v1/jamf-management-framework/redeploy/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<RedeployJamfManagementFrameworkResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
