//
// JamfPackageAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class JamfPackageAPI {

    /**
     Get the packages for a given Jamf application 
     
     - parameter application: (query) The Jamf Application key. The only supported values are protect and connect. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1JamfPackageGet(application: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [JamfPackageResponse]?, _ error: Error?) -> Void)) -> RequestTask {
        return v1JamfPackageGetWithRequestBuilder(application: application).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get the packages for a given Jamf application 
     - GET /v1/jamf-package
     - Get the packages for a given Jamf application.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter application: (query) The Jamf Application key. The only supported values are protect and connect. 
     - returns: RequestBuilder<[JamfPackageResponse]> 
     */
    open class func v1JamfPackageGetWithRequestBuilder(application: String) -> RequestBuilder<[JamfPackageResponse]> {
        let localVariablePath = "/v1/jamf-package"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "application": (wrappedValue: application.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[JamfPackageResponse]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get the packages for a given Jamf application 
     
     - parameter application: (query) The Jamf Application key. The only supported values are protect and connect. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2JamfPackageGet(application: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: JamfApplicationResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2JamfPackageGetWithRequestBuilder(application: application).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get the packages for a given Jamf application 
     - GET /v2/jamf-package
     - Get the packages for a given Jamf application.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter application: (query) The Jamf Application key. The only supported values are protect and connect. 
     - returns: RequestBuilder<JamfApplicationResponse> 
     */
    open class func v2JamfPackageGetWithRequestBuilder(application: String) -> RequestBuilder<JamfApplicationResponse> {
        let localVariablePath = "/v2/jamf-package"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "application": (wrappedValue: application.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<JamfApplicationResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
