//
// JamfProInformationAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class JamfProInformationAPI {

    /**
     Get basic information about the Jamf Pro Server 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1JamfProInformationGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: JamfProInformation?, _ error: Error?) -> Void)) -> RequestTask {
        return v1JamfProInformationGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get basic information about the Jamf Pro Server 
     - GET /v1/jamf-pro-information
     - Deprecated version of the endpoint. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<JamfProInformation> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1JamfProInformationGetWithRequestBuilder() -> RequestBuilder<JamfProInformation> {
        let localVariablePath = "/v1/jamf-pro-information"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<JamfProInformation>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get basic information about the Jamf Pro Server 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2JamfProInformationGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: JamfProInformationV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2JamfProInformationGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get basic information about the Jamf Pro Server 
     - GET /v2/jamf-pro-information
     - Get basic information about the Jamf Pro Server 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<JamfProInformationV2> 
     */
    open class func v2JamfProInformationGetWithRequestBuilder() -> RequestBuilder<JamfProInformationV2> {
        let localVariablePath = "/v2/jamf-pro-information"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<JamfProInformationV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
