//
// JamfProServerUrlPreviewAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class JamfProServerUrlPreviewAPI {

    /**
     Get Jamf Pro Server URL settings 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1JamfProServerUrlGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: JamfProServerUrl?, _ error: Error?) -> Void)) -> RequestTask {
        return v1JamfProServerUrlGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Jamf Pro Server URL settings 
     - GET /v1/jamf-pro-server-url
     - Get Jamf Pro Server URL settings
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<JamfProServerUrl> 
     */
    open class func v1JamfProServerUrlGetWithRequestBuilder() -> RequestBuilder<JamfProServerUrl> {
        let localVariablePath = "/v1/jamf-pro-server-url"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<JamfProServerUrl>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Jamf Pro Server URL settings history 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is date:desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "date:desc")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1JamfProServerUrlHistoryGet(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HistorySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1JamfProServerUrlHistoryGetWithRequestBuilder(page: page, size: size, pagesize: pagesize, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Jamf Pro Server URL settings history 
     - GET /v1/jamf-pro-server-url/history
     - Gets Jamf Pro Server URL settings history
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is date:desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "date:desc")
     - returns: RequestBuilder<HistorySearchResults> 
     */
    open class func v1JamfProServerUrlHistoryGetWithRequestBuilder(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil) -> RequestBuilder<HistorySearchResults> {
        let localVariablePath = "/v1/jamf-pro-server-url/history"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "size": (wrappedValue: size?.encodeToJSON(), isExplode: true),
            "pagesize": (wrappedValue: pagesize?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HistorySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Jamf Pro Server URL settings history notes 
     
     - parameter objectHistoryNote: (body) History notes to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1JamfProServerUrlHistoryPost(objectHistoryNote: ObjectHistoryNote, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ObjectHistory?, _ error: Error?) -> Void)) -> RequestTask {
        return v1JamfProServerUrlHistoryPostWithRequestBuilder(objectHistoryNote: objectHistoryNote).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Jamf Pro Server URL settings history notes 
     - POST /v1/jamf-pro-server-url/history
     - Adds Jamf Pro Server URL settings history notes
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter objectHistoryNote: (body) History notes to create 
     - returns: RequestBuilder<ObjectHistory> 
     */
    open class func v1JamfProServerUrlHistoryPostWithRequestBuilder(objectHistoryNote: ObjectHistoryNote) -> RequestBuilder<ObjectHistory> {
        let localVariablePath = "/v1/jamf-pro-server-url/history"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: objectHistoryNote)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ObjectHistory>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Jamf Pro Server URL settings 
     
     - parameter jamfProServerUrl: (body) Jamf Pro Server URL settings object 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1JamfProServerUrlPut(jamfProServerUrl: JamfProServerUrl, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: JamfProServerUrl?, _ error: Error?) -> Void)) -> RequestTask {
        return v1JamfProServerUrlPutWithRequestBuilder(jamfProServerUrl: jamfProServerUrl).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Jamf Pro Server URL settings 
     - PUT /v1/jamf-pro-server-url
     - Update Jamf Pro Server URL settings
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter jamfProServerUrl: (body) Jamf Pro Server URL settings object 
     - returns: RequestBuilder<JamfProServerUrl> 
     */
    open class func v1JamfProServerUrlPutWithRequestBuilder(jamfProServerUrl: JamfProServerUrl) -> RequestBuilder<JamfProServerUrl> {
        let localVariablePath = "/v1/jamf-pro-server-url"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: jamfProServerUrl)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<JamfProServerUrl>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
