//
// JamfProVersionAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class JamfProVersionAPI {

    /**
     Return information about the Jamf Pro including the current version 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1JamfProVersionGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: JamfProVersion?, _ error: Error?) -> Void)) -> RequestTask {
        return v1JamfProVersionGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Return information about the Jamf Pro including the current version 
     - GET /v1/jamf-pro-version
     - Returns information about the Jamf Pro including the current version. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<JamfProVersion> 
     */
    open class func v1JamfProVersionGetWithRequestBuilder() -> RequestBuilder<JamfProVersion> {
        let localVariablePath = "/v1/jamf-pro-version"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<JamfProVersion>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
