//
// LdapAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class LdapAPI {

    /**
     Retrieve the configured access groups that contain the text in the search param 
     
     - parameter q: (query) Will perform a \&quot;contains\&quot; search on the names of access groups (optional, default to "null")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func ldapGroupsGet(q: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LdapGroupSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return ldapGroupsGetWithRequestBuilder(q: q).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the configured access groups that contain the text in the search param 
     - GET /ldap/groups
     - Retrieves the configured access groups that contain the text in the searchParam.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter q: (query) Will perform a \&quot;contains\&quot; search on the names of access groups (optional, default to "null")
     - returns: RequestBuilder<LdapGroupSearchResults> 
     */
    open class func ldapGroupsGetWithRequestBuilder(q: String? = nil) -> RequestBuilder<LdapGroupSearchResults> {
        let localVariablePath = "/ldap/groups"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "q": (wrappedValue: q?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LdapGroupSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve all Servers including LDAP and Cloud Identity Providers. 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func ldapServersGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [LdapServer]?, _ error: Error?) -> Void)) -> RequestTask {
        return ldapServersGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve all Servers including LDAP and Cloud Identity Providers. 
     - GET /ldap/servers
     - Retrieve all Servers including LDAP and Cloud Identity Providers.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<[LdapServer]> 
     */
    open class func ldapServersGetWithRequestBuilder() -> RequestBuilder<[LdapServer]> {
        let localVariablePath = "/ldap/servers"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[LdapServer]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the configured access groups that contain the text in the search param 
     
     - parameter q: (query) Will perform a \&quot;contains\&quot; search on the names of access groups (optional, default to "null")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1LdapGroupsGet(q: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LdapGroupSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1LdapGroupsGetWithRequestBuilder(q: q).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the configured access groups that contain the text in the search param 
     - GET /v1/ldap/groups
     - Retrieves the configured access groups that contain the text in the searchParam.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter q: (query) Will perform a \&quot;contains\&quot; search on the names of access groups (optional, default to "null")
     - returns: RequestBuilder<LdapGroupSearchResults> 
     */
    open class func v1LdapGroupsGetWithRequestBuilder(q: String? = nil) -> RequestBuilder<LdapGroupSearchResults> {
        let localVariablePath = "/v1/ldap/groups"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "q": (wrappedValue: q?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LdapGroupSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve all LDAP Servers. 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1LdapLdapServersGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [LdapServer]?, _ error: Error?) -> Void)) -> RequestTask {
        return v1LdapLdapServersGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve all LDAP Servers. 
     - GET /v1/ldap/ldap-servers
     - Retrieves all not migrated, LDAP Servers.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<[LdapServer]> 
     */
    open class func v1LdapLdapServersGetWithRequestBuilder() -> RequestBuilder<[LdapServer]> {
        let localVariablePath = "/v1/ldap/ldap-servers"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[LdapServer]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve all Servers including LDAP and Cloud Identity Providers. 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1LdapServersGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [LdapServer]?, _ error: Error?) -> Void)) -> RequestTask {
        return v1LdapServersGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve all Servers including LDAP and Cloud Identity Providers. 
     - GET /v1/ldap/servers
     - Retrieve all active Servers including LDAP and Cloud Identity Providers.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<[LdapServer]> 
     */
    open class func v1LdapServersGetWithRequestBuilder() -> RequestBuilder<[LdapServer]> {
        let localVariablePath = "/v1/ldap/servers"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[LdapServer]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
