//
// LocalAdminPasswordAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class LocalAdminPasswordAPI {

    /**
     Get LAPS password viewed history.
     
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter username: (path) user name to view audit information for 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1LocalAdminPasswordClientManagementIdAccountUsernameAuditGet(clientManagementId: String, username: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsPasswordAuditsResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1LocalAdminPasswordClientManagementIdAccountUsernameAuditGetWithRequestBuilder(clientManagementId: clientManagementId, username: username).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get LAPS password viewed history.
     - GET /v1/local-admin-password/{clientManagementId}/account/{username}/audit
     - Get the full history of all local admin passwords for a specific username on a target device. History will include password, who viewed the password and when it was viewed. Get audit history by using the client management id and username as the path parameters.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter username: (path) user name to view audit information for 
     - returns: RequestBuilder<LapsPasswordAuditsResults> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1LocalAdminPasswordClientManagementIdAccountUsernameAuditGetWithRequestBuilder(clientManagementId: String, username: String) -> RequestBuilder<LapsPasswordAuditsResults> {
        var localVariablePath = "/v1/local-admin-password/{clientManagementId}/account/{username}/audit"
        let clientManagementIdPreEscape = "\(APIHelper.mapValueToPathItem(clientManagementId))"
        let clientManagementIdPostEscape = clientManagementIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{clientManagementId}", with: clientManagementIdPostEscape, options: .literal, range: nil)
        let usernamePreEscape = "\(APIHelper.mapValueToPathItem(username))"
        let usernamePostEscape = usernamePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{username}", with: usernamePostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsPasswordAuditsResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get current LAPS password for specified username on a client.
     
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter username: (path) user name for the account 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1LocalAdminPasswordClientManagementIdAccountUsernamePasswordGet(clientManagementId: String, username: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsPasswordResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1LocalAdminPasswordClientManagementIdAccountUsernamePasswordGetWithRequestBuilder(clientManagementId: clientManagementId, username: username).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get current LAPS password for specified username on a client.
     - GET /v1/local-admin-password/{clientManagementId}/account/{username}/password
     - Get current LAPS password for specified client by using the client management id and username as the path parameters. Once the password is viewed it will be rotated out with a new password based on the rotation time settings.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter username: (path) user name for the account 
     - returns: RequestBuilder<LapsPasswordResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1LocalAdminPasswordClientManagementIdAccountUsernamePasswordGetWithRequestBuilder(clientManagementId: String, username: String) -> RequestBuilder<LapsPasswordResponse> {
        var localVariablePath = "/v1/local-admin-password/{clientManagementId}/account/{username}/password"
        let clientManagementIdPreEscape = "\(APIHelper.mapValueToPathItem(clientManagementId))"
        let clientManagementIdPostEscape = clientManagementIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{clientManagementId}", with: clientManagementIdPostEscape, options: .literal, range: nil)
        let usernamePreEscape = "\(APIHelper.mapValueToPathItem(username))"
        let usernamePostEscape = usernamePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{username}", with: usernamePostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsPasswordResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get the LAPS capable admin accounts for a device.
     
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1LocalAdminPasswordClientManagementIdAccountsGet(clientManagementId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsUserResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1LocalAdminPasswordClientManagementIdAccountsGetWithRequestBuilder(clientManagementId: clientManagementId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get the LAPS capable admin accounts for a device.
     - GET /v1/local-admin-password/{clientManagementId}/accounts
     - Get a full list of admin accounts that are LAPS capable. Capable accounts are returned in the AutoSetupAdminAccounts from QueryResponses.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter clientManagementId: (path) client management id of target device. 
     - returns: RequestBuilder<LapsUserResults> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1LocalAdminPasswordClientManagementIdAccountsGetWithRequestBuilder(clientManagementId: String) -> RequestBuilder<LapsUserResults> {
        var localVariablePath = "/v1/local-admin-password/{clientManagementId}/accounts"
        let clientManagementIdPreEscape = "\(APIHelper.mapValueToPathItem(clientManagementId))"
        let clientManagementIdPostEscape = clientManagementIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{clientManagementId}", with: clientManagementIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsUserResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Set the LAPS password for a device.
     
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter lapsUserPasswordRequest: (body) LAPS password to set 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1LocalAdminPasswordClientManagementIdSetPasswordPut(clientManagementId: String, lapsUserPasswordRequest: LapsUserPasswordRequest, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsUserPasswordResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1LocalAdminPasswordClientManagementIdSetPasswordPutWithRequestBuilder(clientManagementId: clientManagementId, lapsUserPasswordRequest: lapsUserPasswordRequest).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Set the LAPS password for a device.
     - PUT /v1/local-admin-password/{clientManagementId}/set-password
     - Set the LAPS password for a device. This will set the password for all LAPS capable accounts.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter lapsUserPasswordRequest: (body) LAPS password to set 
     - returns: RequestBuilder<LapsUserPasswordResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1LocalAdminPasswordClientManagementIdSetPasswordPutWithRequestBuilder(clientManagementId: String, lapsUserPasswordRequest: LapsUserPasswordRequest) -> RequestBuilder<LapsUserPasswordResponse> {
        var localVariablePath = "/v1/local-admin-password/{clientManagementId}/set-password"
        let clientManagementIdPreEscape = "\(APIHelper.mapValueToPathItem(clientManagementId))"
        let clientManagementIdPostEscape = clientManagementIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{clientManagementId}", with: clientManagementIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: lapsUserPasswordRequest)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsUserPasswordResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get the current LAPS settings.
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1LocalAdminPasswordSettingsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsSettingsResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1LocalAdminPasswordSettingsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get the current LAPS settings.
     - GET /v1/local-admin-password/settings
     - Return information about the current LAPS settings.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<LapsSettingsResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1LocalAdminPasswordSettingsGetWithRequestBuilder() -> RequestBuilder<LapsSettingsResponse> {
        let localVariablePath = "/v1/local-admin-password/settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsSettingsResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update settings for LAPS.
     
     - parameter lapsSettingsRequest: (body) LAPS settings to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1LocalAdminPasswordSettingsPut(lapsSettingsRequest: LapsSettingsRequest, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsSettingsResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1LocalAdminPasswordSettingsPutWithRequestBuilder(lapsSettingsRequest: lapsSettingsRequest).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update settings for LAPS.
     - PUT /v1/local-admin-password/settings
     - Update settings for LAPS.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter lapsSettingsRequest: (body) LAPS settings to update 
     - returns: RequestBuilder<LapsSettingsResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1LocalAdminPasswordSettingsPutWithRequestBuilder(lapsSettingsRequest: LapsSettingsRequest) -> RequestBuilder<LapsSettingsResponse> {
        let localVariablePath = "/v1/local-admin-password/settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: lapsSettingsRequest)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsSettingsResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get LAPS password viewed history.
     
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter username: (path) user name to view audit information for 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2LocalAdminPasswordClientManagementIdAccountUsernameAuditGet(clientManagementId: String, username: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsPasswordAuditsResultsV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2LocalAdminPasswordClientManagementIdAccountUsernameAuditGetWithRequestBuilder(clientManagementId: clientManagementId, username: username).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get LAPS password viewed history.
     - GET /v2/local-admin-password/{clientManagementId}/account/{username}/audit
     - Get the full history of all local admin passwords for a specific username on a target device. History will include password, who viewed the password and when it was viewed. Get audit history by using the client management id and username as the path parameters.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter username: (path) user name to view audit information for 
     - returns: RequestBuilder<LapsPasswordAuditsResultsV2> 
     */
    open class func v2LocalAdminPasswordClientManagementIdAccountUsernameAuditGetWithRequestBuilder(clientManagementId: String, username: String) -> RequestBuilder<LapsPasswordAuditsResultsV2> {
        var localVariablePath = "/v2/local-admin-password/{clientManagementId}/account/{username}/audit"
        let clientManagementIdPreEscape = "\(APIHelper.mapValueToPathItem(clientManagementId))"
        let clientManagementIdPostEscape = clientManagementIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{clientManagementId}", with: clientManagementIdPostEscape, options: .literal, range: nil)
        let usernamePreEscape = "\(APIHelper.mapValueToPathItem(username))"
        let usernamePostEscape = usernamePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{username}", with: usernamePostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsPasswordAuditsResultsV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get LAPS historical records for target device and username.
     
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter username: (path) user name to view history for 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2LocalAdminPasswordClientManagementIdAccountUsernameHistoryGet(clientManagementId: String, username: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsHistoryResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2LocalAdminPasswordClientManagementIdAccountUsernameHistoryGetWithRequestBuilder(clientManagementId: clientManagementId, username: username).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get LAPS historical records for target device and username.
     - GET /v2/local-admin-password/{clientManagementId}/account/{username}/history
     - Get the full history of all for a specific username on a target device. History will include date created, date last seen, expiration time, and rotational status. Get audit history by using the client management id and username as the path parameters.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter username: (path) user name to view history for 
     - returns: RequestBuilder<LapsHistoryResponse> 
     */
    open class func v2LocalAdminPasswordClientManagementIdAccountUsernameHistoryGetWithRequestBuilder(clientManagementId: String, username: String) -> RequestBuilder<LapsHistoryResponse> {
        var localVariablePath = "/v2/local-admin-password/{clientManagementId}/account/{username}/history"
        let clientManagementIdPreEscape = "\(APIHelper.mapValueToPathItem(clientManagementId))"
        let clientManagementIdPostEscape = clientManagementIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{clientManagementId}", with: clientManagementIdPostEscape, options: .literal, range: nil)
        let usernamePreEscape = "\(APIHelper.mapValueToPathItem(username))"
        let usernamePostEscape = usernamePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{username}", with: usernamePostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsHistoryResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get current LAPS password for specified username on a client.
     
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter username: (path) user name for the account 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2LocalAdminPasswordClientManagementIdAccountUsernamePasswordGet(clientManagementId: String, username: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsPasswordResponseV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2LocalAdminPasswordClientManagementIdAccountUsernamePasswordGetWithRequestBuilder(clientManagementId: clientManagementId, username: username).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get current LAPS password for specified username on a client.
     - GET /v2/local-admin-password/{clientManagementId}/account/{username}/password
     - Get current LAPS password for specified client by using the client management id and username as the path parameters. Once the password is viewed it will be rotated out with a new password based on the rotation time settings.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter username: (path) user name for the account 
     - returns: RequestBuilder<LapsPasswordResponseV2> 
     */
    open class func v2LocalAdminPasswordClientManagementIdAccountUsernamePasswordGetWithRequestBuilder(clientManagementId: String, username: String) -> RequestBuilder<LapsPasswordResponseV2> {
        var localVariablePath = "/v2/local-admin-password/{clientManagementId}/account/{username}/password"
        let clientManagementIdPreEscape = "\(APIHelper.mapValueToPathItem(clientManagementId))"
        let clientManagementIdPostEscape = clientManagementIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{clientManagementId}", with: clientManagementIdPostEscape, options: .literal, range: nil)
        let usernamePreEscape = "\(APIHelper.mapValueToPathItem(username))"
        let usernamePostEscape = usernamePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{username}", with: usernamePostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsPasswordResponseV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get the LAPS capable admin accounts for a device.
     
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2LocalAdminPasswordClientManagementIdAccountsGet(clientManagementId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsUserResultsV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2LocalAdminPasswordClientManagementIdAccountsGetWithRequestBuilder(clientManagementId: clientManagementId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get the LAPS capable admin accounts for a device.
     - GET /v2/local-admin-password/{clientManagementId}/accounts
     - Get a full list of admin accounts that are LAPS capable. Capable accounts are returned in the AutoSetupAdminAccounts from QueryResponses.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter clientManagementId: (path) client management id of target device. 
     - returns: RequestBuilder<LapsUserResultsV2> 
     */
    open class func v2LocalAdminPasswordClientManagementIdAccountsGetWithRequestBuilder(clientManagementId: String) -> RequestBuilder<LapsUserResultsV2> {
        var localVariablePath = "/v2/local-admin-password/{clientManagementId}/accounts"
        let clientManagementIdPreEscape = "\(APIHelper.mapValueToPathItem(clientManagementId))"
        let clientManagementIdPostEscape = clientManagementIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{clientManagementId}", with: clientManagementIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsUserResultsV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Set the LAPS password for a device.
     
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter lapsUserPasswordRequestV2: (body) LAPS password to set 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2LocalAdminPasswordClientManagementIdSetPasswordPut(clientManagementId: String, lapsUserPasswordRequestV2: LapsUserPasswordRequestV2, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsUserPasswordResponseV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2LocalAdminPasswordClientManagementIdSetPasswordPutWithRequestBuilder(clientManagementId: clientManagementId, lapsUserPasswordRequestV2: lapsUserPasswordRequestV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Set the LAPS password for a device.
     - PUT /v2/local-admin-password/{clientManagementId}/set-password
     - Set the LAPS password for a device. This will set the password for all LAPS capable accounts.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter clientManagementId: (path) client management id of target device. 
     - parameter lapsUserPasswordRequestV2: (body) LAPS password to set 
     - returns: RequestBuilder<LapsUserPasswordResponseV2> 
     */
    open class func v2LocalAdminPasswordClientManagementIdSetPasswordPutWithRequestBuilder(clientManagementId: String, lapsUserPasswordRequestV2: LapsUserPasswordRequestV2) -> RequestBuilder<LapsUserPasswordResponseV2> {
        var localVariablePath = "/v2/local-admin-password/{clientManagementId}/set-password"
        let clientManagementIdPreEscape = "\(APIHelper.mapValueToPathItem(clientManagementId))"
        let clientManagementIdPostEscape = clientManagementIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{clientManagementId}", with: clientManagementIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: lapsUserPasswordRequestV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsUserPasswordResponseV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get a list of the current devices and usernames with pending LAPS rotations
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2LocalAdminPasswordPendingRotationsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsPendingRotationResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2LocalAdminPasswordPendingRotationsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get a list of the current devices and usernames with pending LAPS rotations
     - GET /v2/local-admin-password/pending-rotations
     - Return information about all devices and usernames currently in the state of a pending LAPS rotation
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<LapsPendingRotationResponse> 
     */
    open class func v2LocalAdminPasswordPendingRotationsGetWithRequestBuilder() -> RequestBuilder<LapsPendingRotationResponse> {
        let localVariablePath = "/v2/local-admin-password/pending-rotations"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsPendingRotationResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get the current LAPS settings.
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2LocalAdminPasswordSettingsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsSettingsResponseV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2LocalAdminPasswordSettingsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get the current LAPS settings.
     - GET /v2/local-admin-password/settings
     - Return information about the current LAPS settings.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<LapsSettingsResponseV2> 
     */
    open class func v2LocalAdminPasswordSettingsGetWithRequestBuilder() -> RequestBuilder<LapsSettingsResponseV2> {
        let localVariablePath = "/v2/local-admin-password/settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsSettingsResponseV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update settings for LAPS.
     
     - parameter lapsSettingsRequestV2: (body) LAPS settings to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2LocalAdminPasswordSettingsPut(lapsSettingsRequestV2: LapsSettingsRequestV2, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: LapsSettingsResponseV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2LocalAdminPasswordSettingsPutWithRequestBuilder(lapsSettingsRequestV2: lapsSettingsRequestV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update settings for LAPS.
     - PUT /v2/local-admin-password/settings
     - Update settings for LAPS.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter lapsSettingsRequestV2: (body) LAPS settings to update 
     - returns: RequestBuilder<LapsSettingsResponseV2> 
     */
    open class func v2LocalAdminPasswordSettingsPutWithRequestBuilder(lapsSettingsRequestV2: LapsSettingsRequestV2) -> RequestBuilder<LapsSettingsResponseV2> {
        let localVariablePath = "/v2/local-admin-password/settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: lapsSettingsRequestV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<LapsSettingsResponseV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
