//
// MacosManagedSoftwareUpdatesAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class MacosManagedSoftwareUpdatesAPI {

    /**
     Retrieve available MacOs Managed Software Updates
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MacosManagedSoftwareUpdatesAvailableUpdatesGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AvailableUpdates?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MacosManagedSoftwareUpdatesAvailableUpdatesGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve available MacOs Managed Software Updates
     - GET /v1/macos-managed-software-updates/available-updates
     - Retrieves available MacOs Managed Software Updates
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<AvailableUpdates> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MacosManagedSoftwareUpdatesAvailableUpdatesGetWithRequestBuilder() -> RequestBuilder<AvailableUpdates> {
        let localVariablePath = "/v1/macos-managed-software-updates/available-updates"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AvailableUpdates>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Send MacOs Managed Software Updates
     
     - parameter macOsManagedSoftwareUpdate: (body) MacOs Managed Software Update to send 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MacosManagedSoftwareUpdatesSendUpdatesPost(macOsManagedSoftwareUpdate: MacOsManagedSoftwareUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: MacOsManagedSoftwareUpdateResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MacosManagedSoftwareUpdatesSendUpdatesPostWithRequestBuilder(macOsManagedSoftwareUpdate: macOsManagedSoftwareUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Send MacOs Managed Software Updates
     - POST /v1/macos-managed-software-updates/send-updates
     - Sends MacOs Managed Software Updates
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter macOsManagedSoftwareUpdate: (body) MacOs Managed Software Update to send 
     - returns: RequestBuilder<MacOsManagedSoftwareUpdateResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MacosManagedSoftwareUpdatesSendUpdatesPostWithRequestBuilder(macOsManagedSoftwareUpdate: MacOsManagedSoftwareUpdate) -> RequestBuilder<MacOsManagedSoftwareUpdateResponse> {
        let localVariablePath = "/v1/macos-managed-software-updates/send-updates"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: macOsManagedSoftwareUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<MacOsManagedSoftwareUpdateResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
