//
// ManagedSoftwareUpdatesAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class ManagedSoftwareUpdatesAPI {

    /**
     Retrieve available macOS and iOS Managed Software Updates
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesAvailableUpdatesGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AvailableOsUpdates?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesAvailableUpdatesGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve available macOS and iOS Managed Software Updates
     - GET /v1/managed-software-updates/available-updates
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Retrieves available macOS and iOS Managed Software Updates 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<AvailableOsUpdates> 
     */
    open class func v1ManagedSoftwareUpdatesAvailableUpdatesGetWithRequestBuilder() -> RequestBuilder<AvailableOsUpdates> {
        let localVariablePath = "/v1/managed-software-updates/available-updates"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AvailableOsUpdates>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve Status of the Feature Toggle
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesPlansFeatureToggleGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ManagedSoftwareUpdatePlanToggle?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesPlansFeatureToggleGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Status of the Feature Toggle
     - GET /v1/managed-software-updates/plans/feature-toggle
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Retrieves Status of the Feature Toggle 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<ManagedSoftwareUpdatePlanToggle> 
     */
    open class func v1ManagedSoftwareUpdatesPlansFeatureToggleGetWithRequestBuilder() -> RequestBuilder<ManagedSoftwareUpdatePlanToggle> {
        let localVariablePath = "/v1/managed-software-updates/plans/feature-toggle"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ManagedSoftwareUpdatePlanToggle>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Updates Feature Toggle Value
     
     - parameter managedSoftwareUpdatePlanToggle: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesPlansFeatureTogglePut(managedSoftwareUpdatePlanToggle: ManagedSoftwareUpdatePlanToggle, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ManagedSoftwareUpdatePlanToggle?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesPlansFeatureTogglePutWithRequestBuilder(managedSoftwareUpdatePlanToggle: managedSoftwareUpdatePlanToggle).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Updates Feature Toggle Value
     - PUT /v1/managed-software-updates/plans/feature-toggle
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Updates the value of the Feature Toggle 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter managedSoftwareUpdatePlanToggle: (body)  
     - returns: RequestBuilder<ManagedSoftwareUpdatePlanToggle> 
     */
    open class func v1ManagedSoftwareUpdatesPlansFeatureTogglePutWithRequestBuilder(managedSoftwareUpdatePlanToggle: ManagedSoftwareUpdatePlanToggle) -> RequestBuilder<ManagedSoftwareUpdatePlanToggle> {
        let localVariablePath = "/v1/managed-software-updates/plans/feature-toggle"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: managedSoftwareUpdatePlanToggle)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ManagedSoftwareUpdatePlanToggle>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve Managed Software Update Plans
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is planUuid:asc. Multiple sort criteria are supported and must be separated with a comma. (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter Managed Software Updates collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: planUuid, device.deviceId, device.objectType, updateAction, versionType, specificVersion, maxDeferrals, forceInstallLocalDateTime, state. (optional, default to "")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesPlansGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ManagedSoftwareUpdatePlans?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesPlansGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Managed Software Update Plans
     - GET /v1/managed-software-updates/plans
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Retrieve Managed Software Update Plans 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is planUuid:asc. Multiple sort criteria are supported and must be separated with a comma. (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter Managed Software Updates collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: planUuid, device.deviceId, device.objectType, updateAction, versionType, specificVersion, maxDeferrals, forceInstallLocalDateTime, state. (optional, default to "")
     - returns: RequestBuilder<ManagedSoftwareUpdatePlans> 
     */
    open class func v1ManagedSoftwareUpdatesPlansGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil) -> RequestBuilder<ManagedSoftwareUpdatePlans> {
        let localVariablePath = "/v1/managed-software-updates/plans"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ManagedSoftwareUpdatePlans>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     * enum for parameter groupType
     */
    public enum GroupType_v1ManagedSoftwareUpdatesPlansGroupIdGet: String, CaseIterable {
        case computerGroup = "COMPUTER_GROUP"
        case mobileDeviceGroup = "MOBILE_DEVICE_GROUP"
    }

    /**
     Retrieve Managed Software Update Plans for a Group
     
     - parameter id: (path) Managed Software Update Group Id 
     - parameter groupType: (query) Managed Software Update Group Type, Available options are \&quot;COMPUTER_GROUP\&quot; or \&quot;MOBILE_DEVICE_GROUP\&quot; 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesPlansGroupIdGet(id: String, groupType: GroupType_v1ManagedSoftwareUpdatesPlansGroupIdGet, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ManagedSoftwareUpdatePlans?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesPlansGroupIdGetWithRequestBuilder(id: id, groupType: groupType).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Managed Software Update Plans for a Group
     - GET /v1/managed-software-updates/plans/group/{id}
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Retrieves Managed Software Update Plans for a Group 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Managed Software Update Group Id 
     - parameter groupType: (query) Managed Software Update Group Type, Available options are \&quot;COMPUTER_GROUP\&quot; or \&quot;MOBILE_DEVICE_GROUP\&quot; 
     - returns: RequestBuilder<ManagedSoftwareUpdatePlans> 
     */
    open class func v1ManagedSoftwareUpdatesPlansGroupIdGetWithRequestBuilder(id: String, groupType: GroupType_v1ManagedSoftwareUpdatesPlansGroupIdGet) -> RequestBuilder<ManagedSoftwareUpdatePlans> {
        var localVariablePath = "/v1/managed-software-updates/plans/group/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "group-type": (wrappedValue: groupType.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ManagedSoftwareUpdatePlans>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create Managed Software Update Plans for a Group
     
     - parameter managedSoftwareUpdatePlanGroupPost: (body) Managed Software Update Plan to create for Group 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesPlansGroupPost(managedSoftwareUpdatePlanGroupPost: ManagedSoftwareUpdatePlanGroupPost, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ManagedSoftwareUpdatePlanPostResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesPlansGroupPostWithRequestBuilder(managedSoftwareUpdatePlanGroupPost: managedSoftwareUpdatePlanGroupPost).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create Managed Software Update Plans for a Group
     - POST /v1/managed-software-updates/plans/group
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Creates Managed Software Update Plans for a Group 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter managedSoftwareUpdatePlanGroupPost: (body) Managed Software Update Plan to create for Group 
     - returns: RequestBuilder<ManagedSoftwareUpdatePlanPostResponse> 
     */
    open class func v1ManagedSoftwareUpdatesPlansGroupPostWithRequestBuilder(managedSoftwareUpdatePlanGroupPost: ManagedSoftwareUpdatePlanGroupPost) -> RequestBuilder<ManagedSoftwareUpdatePlanPostResponse> {
        let localVariablePath = "/v1/managed-software-updates/plans/group"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: managedSoftwareUpdatePlanGroupPost)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ManagedSoftwareUpdatePlanPostResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve a Managed Software Update Plan
     
     - parameter id: (path) Managed Software Update Plan Uuid 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesPlansIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ManagedSoftwareUpdatePlan?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesPlansIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve a Managed Software Update Plan
     - GET /v1/managed-software-updates/plans/{id}
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Retrieves a Managed Software Update Plan 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Managed Software Update Plan Uuid 
     - returns: RequestBuilder<ManagedSoftwareUpdatePlan> 
     */
    open class func v1ManagedSoftwareUpdatesPlansIdGetWithRequestBuilder(id: String) -> RequestBuilder<ManagedSoftwareUpdatePlan> {
        var localVariablePath = "/v1/managed-software-updates/plans/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ManagedSoftwareUpdatePlan>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a Managed Software Update Plan
     
     - parameter managedSoftwareUpdatePlanPost: (body) Managed Software Update Plan to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesPlansPost(managedSoftwareUpdatePlanPost: ManagedSoftwareUpdatePlanPost, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ManagedSoftwareUpdatePlanPostResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesPlansPostWithRequestBuilder(managedSoftwareUpdatePlanPost: managedSoftwareUpdatePlanPost).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a Managed Software Update Plan
     - POST /v1/managed-software-updates/plans
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Creates a Managed Software Update Plan. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter managedSoftwareUpdatePlanPost: (body) Managed Software Update Plan to create 
     - returns: RequestBuilder<ManagedSoftwareUpdatePlanPostResponse> 
     */
    open class func v1ManagedSoftwareUpdatesPlansPostWithRequestBuilder(managedSoftwareUpdatePlanPost: ManagedSoftwareUpdatePlanPost) -> RequestBuilder<ManagedSoftwareUpdatePlanPostResponse> {
        let localVariablePath = "/v1/managed-software-updates/plans"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: managedSoftwareUpdatePlanPost)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ManagedSoftwareUpdatePlanPostResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve Managed Software Update Statuses for Computer Groups
     
     - parameter id: (path) Computer Group identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesUpdateStatusesComputerGroupsIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ManagedSoftwareUpdateStatuses?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesUpdateStatusesComputerGroupsIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Managed Software Update Statuses for Computer Groups
     - GET /v1/managed-software-updates/update-statuses/computer-groups/{id}
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Retrieve Managed Software Update Statuses for Computer Groups 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer Group identifier 
     - returns: RequestBuilder<ManagedSoftwareUpdateStatuses> 
     */
    open class func v1ManagedSoftwareUpdatesUpdateStatusesComputerGroupsIdGetWithRequestBuilder(id: String) -> RequestBuilder<ManagedSoftwareUpdateStatuses> {
        var localVariablePath = "/v1/managed-software-updates/update-statuses/computer-groups/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ManagedSoftwareUpdateStatuses>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve Managed Software Update Statuses for Computers
     
     - parameter id: (path) Computer identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesUpdateStatusesComputersIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ManagedSoftwareUpdateStatuses?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesUpdateStatusesComputersIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Managed Software Update Statuses for Computers
     - GET /v1/managed-software-updates/update-statuses/computers/{id}
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Retrieve Managed Software Update Statuses for Computers 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Computer identifier 
     - returns: RequestBuilder<ManagedSoftwareUpdateStatuses> 
     */
    open class func v1ManagedSoftwareUpdatesUpdateStatusesComputersIdGetWithRequestBuilder(id: String) -> RequestBuilder<ManagedSoftwareUpdateStatuses> {
        var localVariablePath = "/v1/managed-software-updates/update-statuses/computers/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ManagedSoftwareUpdateStatuses>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve Managed Software Update Statuses
     
     - parameter filter: (query) Query in the RSQL format, allowing to filter Managed Software Updates collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: osUpdatesStatusId, device.deviceId, device.objectType, downloaded, downloadPercentComplete, productKey, status, deferralsRemaining, maxDeferrals, nextScheduledInstall, created and updated. (optional, default to "")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesUpdateStatusesGet(filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ManagedSoftwareUpdateStatuses?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesUpdateStatusesGetWithRequestBuilder(filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Managed Software Update Statuses
     - GET /v1/managed-software-updates/update-statuses
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Retrieve Managed Software Update Statuses 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter filter: (query) Query in the RSQL format, allowing to filter Managed Software Updates collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: osUpdatesStatusId, device.deviceId, device.objectType, downloaded, downloadPercentComplete, productKey, status, deferralsRemaining, maxDeferrals, nextScheduledInstall, created and updated. (optional, default to "")
     - returns: RequestBuilder<ManagedSoftwareUpdateStatuses> 
     */
    open class func v1ManagedSoftwareUpdatesUpdateStatusesGetWithRequestBuilder(filter: String? = nil) -> RequestBuilder<ManagedSoftwareUpdateStatuses> {
        let localVariablePath = "/v1/managed-software-updates/update-statuses"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ManagedSoftwareUpdateStatuses>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve Managed Software Update Statuses for Mobile Device Groups
     
     - parameter id: (path) Mobile Device Group identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesUpdateStatusesMobileDeviceGroupsIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ManagedSoftwareUpdateStatuses?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesUpdateStatusesMobileDeviceGroupsIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Managed Software Update Statuses for Mobile Device Groups
     - GET /v1/managed-software-updates/update-statuses/mobile-device-groups/{id}
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Retrieve Managed Software Update Statuses for Mobile Device Groups 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Group identifier 
     - returns: RequestBuilder<ManagedSoftwareUpdateStatuses> 
     */
    open class func v1ManagedSoftwareUpdatesUpdateStatusesMobileDeviceGroupsIdGetWithRequestBuilder(id: String) -> RequestBuilder<ManagedSoftwareUpdateStatuses> {
        var localVariablePath = "/v1/managed-software-updates/update-statuses/mobile-device-groups/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ManagedSoftwareUpdateStatuses>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve Managed Software Update Statuses for Mobile Devices
     
     - parameter id: (path) Mobile Device identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1ManagedSoftwareUpdatesUpdateStatusesMobileDevicesIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ManagedSoftwareUpdateStatuses?, _ error: Error?) -> Void)) -> RequestTask {
        return v1ManagedSoftwareUpdatesUpdateStatusesMobileDevicesIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Managed Software Update Statuses for Mobile Devices
     - GET /v1/managed-software-updates/update-statuses/mobile-devices/{id}
     - ## BETA    These endpoints are available for use in your workflows. It is extremely important to exercise caution when implementing these endpoints, because elements such as the URL or the response could change while this feature is in Beta. If this is the case, we will communicate that upcoming change but there will be no deprecation timeline. Any breaking changes to the API that occur *after* the Beta phase __will be__ held to the standard year-long deprecation timeline.    Retrieve Managed Software Update Statuses for Mobile Devices 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device identifier 
     - returns: RequestBuilder<ManagedSoftwareUpdateStatuses> 
     */
    open class func v1ManagedSoftwareUpdatesUpdateStatusesMobileDevicesIdGetWithRequestBuilder(id: String) -> RequestBuilder<ManagedSoftwareUpdateStatuses> {
        var localVariablePath = "/v1/managed-software-updates/update-statuses/mobile-devices/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ManagedSoftwareUpdateStatuses>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
