//
// MdmAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class MdmAPI {

    /**
     Post a command for creation and queuing 
     
     - parameter mdmCommandRequest: (body) The mdm command object to create and queue (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func previewMdmCommandsPost(mdmCommandRequest: MdmCommandRequest? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [HrefResponse]?, _ error: Error?) -> Void)) -> RequestTask {
        return previewMdmCommandsPostWithRequestBuilder(mdmCommandRequest: mdmCommandRequest).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Post a command for creation and queuing 
     - POST /preview/mdm/commands
     - Provided an MDM command type and appropriate information, will create and then queue said command.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter mdmCommandRequest: (body) The mdm command object to create and queue (optional)
     - returns: RequestBuilder<[HrefResponse]> 
     */
    open class func previewMdmCommandsPostWithRequestBuilder(mdmCommandRequest: MdmCommandRequest? = nil) -> RequestBuilder<[HrefResponse]> {
        let localVariablePath = "/preview/mdm/commands"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: mdmCommandRequest)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[HrefResponse]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Deploy packages using MDM
     
     - parameter installPackage: (body)  
     - parameter verbose: (query) Enables the &#39;verbose&#39; response, which includes information about the commands queued as well as information about commands that failed to queue. (optional, default to false)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1DeployPackagePost(installPackage: InstallPackage, verbose: Bool? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: VerbosePackageDeploymentResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1DeployPackagePostWithRequestBuilder(installPackage: installPackage, verbose: verbose).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Deploy packages using MDM
     - POST /v1/deploy-package
     - Deploys packages to macOS devices using the InstallEnterpriseApplication MDM command.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter installPackage: (body)  
     - parameter verbose: (query) Enables the &#39;verbose&#39; response, which includes information about the commands queued as well as information about commands that failed to queue. (optional, default to false)
     - returns: RequestBuilder<VerbosePackageDeploymentResponse?> 
     */
    open class func v1DeployPackagePostWithRequestBuilder(installPackage: InstallPackage, verbose: Bool? = nil) -> RequestBuilder<VerbosePackageDeploymentResponse?> {
        let localVariablePath = "/v1/deploy-package"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: installPackage)

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "verbose": (wrappedValue: verbose?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<VerbosePackageDeploymentResponse?>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get information about mdm commands made by Jamf Pro.
     
     - parameter uuids: (query) A list of the UUIDs of the commands being searched for.  Limited to 40 UUIDs in length. Choose one of two parameters, but not both. (optional)
     - parameter clientManagementId: (query) The client management id used to search for a list of commands. Choose one of two parameters, but not both. (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1MdmCommandsGet(uuids: [String]? = nil, clientManagementId: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [MdmCommand]?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MdmCommandsGetWithRequestBuilder(uuids: uuids, clientManagementId: clientManagementId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get information about mdm commands made by Jamf Pro.
     - GET /v1/mdm/commands
     - Get information about mdm commands made by Jamf Pro.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter uuids: (query) A list of the UUIDs of the commands being searched for.  Limited to 40 UUIDs in length. Choose one of two parameters, but not both. (optional)
     - parameter clientManagementId: (query) The client management id used to search for a list of commands. Choose one of two parameters, but not both. (optional)
     - returns: RequestBuilder<[MdmCommand]> 
     */
    open class func v1MdmCommandsGetWithRequestBuilder(uuids: [String]? = nil, clientManagementId: String? = nil) -> RequestBuilder<[MdmCommand]> {
        let localVariablePath = "/v1/mdm/commands"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "uuids": (wrappedValue: uuids?.encodeToJSON(), isExplode: true),
            "client-management-id": (wrappedValue: clientManagementId?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[MdmCommand]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Renew MDM Profile 
     
     - parameter udids: (body) List of devices&#39; UDIDs to perform MDM profile renewal 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1MdmRenewProfilePost(udids: Udids, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: RenewMdmProfileResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MdmRenewProfilePostWithRequestBuilder(udids: udids).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Renew MDM Profile 
     - POST /v1/mdm/renew-profile
     - Renews the device's MDM Profile, including the device identity certificate within the MDM Profile. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter udids: (body) List of devices&#39; UDIDs to perform MDM profile renewal 
     - returns: RequestBuilder<RenewMdmProfileResponse> 
     */
    open class func v1MdmRenewProfilePostWithRequestBuilder(udids: Udids) -> RequestBuilder<RenewMdmProfileResponse> {
        let localVariablePath = "/v1/mdm/renew-profile"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: udids)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<RenewMdmProfileResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get information about mdm commands made by Jamf Pro. 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Default sort is dateSent:asc. Multiple sort criteria are supported and must be separated with a comma. (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter, for a list of commands. All url must contain minimum one filter field. Fields allowed in the query: uuid, clientManagementId, command, status, clientType, dateSent, validAfter, dateCompleted, profileIdentifier, and active. This param can be combined with paging. Please note that any date filters must be used with gt, lt, ge, le Example: clientManagementId&#x3D;&#x3D;fb511aae-c557-474f-a9c1-5dc845b90d0f;status&#x3D;&#x3D;Pending;command&#x3D;&#x3D;INSTALL_PROFILE;uuid&#x3D;&#x3D;9e18f849-e689-4f2d-b616-a99d3da7db42;clientType&#x3D;&#x3D;COMPUTER_USER;profileIdentifier&#x3D;&#x3D;18cc61c2-01fc-11ed-b939-0242ac120002;dateCompleted&#x3D;ge&#x3D;2021-08-04T14:25:18.26Z;dateCompleted&#x3D;le&#x3D;2021-08-04T14:25:18.26Z;validAfter&#x3D;ge&#x3D;2021-08-05T14:25:18.26Z;active&#x3D;&#x3D;true (optional, default to "")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MdmCommandsGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: MdmCommandResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MdmCommandsGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get information about mdm commands made by Jamf Pro. 
     - GET /v2/mdm/commands
     - Get information about mdm commands made by Jamf Pro.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Default sort is dateSent:asc. Multiple sort criteria are supported and must be separated with a comma. (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter, for a list of commands. All url must contain minimum one filter field. Fields allowed in the query: uuid, clientManagementId, command, status, clientType, dateSent, validAfter, dateCompleted, profileIdentifier, and active. This param can be combined with paging. Please note that any date filters must be used with gt, lt, ge, le Example: clientManagementId&#x3D;&#x3D;fb511aae-c557-474f-a9c1-5dc845b90d0f;status&#x3D;&#x3D;Pending;command&#x3D;&#x3D;INSTALL_PROFILE;uuid&#x3D;&#x3D;9e18f849-e689-4f2d-b616-a99d3da7db42;clientType&#x3D;&#x3D;COMPUTER_USER;profileIdentifier&#x3D;&#x3D;18cc61c2-01fc-11ed-b939-0242ac120002;dateCompleted&#x3D;ge&#x3D;2021-08-04T14:25:18.26Z;dateCompleted&#x3D;le&#x3D;2021-08-04T14:25:18.26Z;validAfter&#x3D;ge&#x3D;2021-08-05T14:25:18.26Z;active&#x3D;&#x3D;true (optional, default to "")
     - returns: RequestBuilder<MdmCommandResults> 
     */
    open class func v2MdmCommandsGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil) -> RequestBuilder<MdmCommandResults> {
        let localVariablePath = "/v2/mdm/commands"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<MdmCommandResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
