//
// MobileDeviceAppsAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class MobileDeviceAppsAPI {

    /**
     Reinstall App Config for Managed iOS Apps 
     
     - parameter appConfigReinstallCode: (body) The $APP_CONFIG_REINSTALL_CODE variable for the specific device and app supplied by the managed iOS app&#39;s current App Config.  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1MobileDeviceAppsReinstallAppConfigPost(appConfigReinstallCode: AppConfigReinstallCode, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDeviceAppsReinstallAppConfigPostWithRequestBuilder(appConfigReinstallCode: appConfigReinstallCode).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Reinstall App Config for Managed iOS Apps 
     - POST /v1/mobile-device-apps/reinstall-app-config
     - Redeploys the managed app configuration for a specific app on a specific device using the $APP_CONFIG_REINSTALL_CODE generated during deployment.  This endpoint does not require authorization, only the re-install code. The code does not contain any user authentication information.  For example usage, see the following Teacher app documentation: [Teacher App Manged App Configuration](https://learn.jamf.com/bundle/jamf-teacher-configuration-guide/page/Jamf_Teacher_Integration_with_Jamf_Pro.html) 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter appConfigReinstallCode: (body) The $APP_CONFIG_REINSTALL_CODE variable for the specific device and app supplied by the managed iOS app&#39;s current App Config.  
     - returns: RequestBuilder<Void> 
     */
    open class func v1MobileDeviceAppsReinstallAppConfigPostWithRequestBuilder(appConfigReinstallCode: AppConfigReinstallCode) -> RequestBuilder<Void> {
        let localVariablePath = "/v1/mobile-device-apps/reinstall-app-config"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: appConfigReinstallCode)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
