//
// MobileDeviceExtensionAttributesPreviewAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class MobileDeviceExtensionAttributesPreviewAPI {

    /**
     Get Mobile Device Extension Attribute values placed in select paramter 
     
     - parameter select: (query) Acceptable values currently include: * name  (optional, default to "name")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func devicesExtensionAttributesGet(select: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: MobileDeviceExtensionAttributeResults?, _ error: Error?) -> Void)) -> RequestTask {
        return devicesExtensionAttributesGetWithRequestBuilder(select: select).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Mobile Device Extension Attribute values placed in select paramter 
     - GET /devices/extensionAttributes
     - Gets Mobile Device Extension Attribute values placed in select parameter.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter select: (query) Acceptable values currently include: * name  (optional, default to "name")
     - returns: RequestBuilder<MobileDeviceExtensionAttributeResults> 
     */
    open class func devicesExtensionAttributesGetWithRequestBuilder(select: String? = nil) -> RequestBuilder<MobileDeviceExtensionAttributeResults> {
        let localVariablePath = "/devices/extensionAttributes"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "select": (wrappedValue: select?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<MobileDeviceExtensionAttributeResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
