//
// MobileDevicePrestagesAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class MobileDevicePrestagesAPI {

    /**
     Search for sorted and paged Mobile Device Prestages 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "id:asc")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesGet(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: MobileDevicePrestageSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesGetWithRequestBuilder(page: page, size: size, pagesize: pagesize, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Search for sorted and paged Mobile Device Prestages 
     - GET /v1/mobile-device-prestages
     - Search for sorted and paged mobile device prestages
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "id:asc")
     - returns: RequestBuilder<MobileDevicePrestageSearchResults> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesGetWithRequestBuilder(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil) -> RequestBuilder<MobileDevicePrestageSearchResults> {
        let localVariablePath = "/v1/mobile-device-prestages"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "size": (wrappedValue: size?.encodeToJSON(), isExplode: true),
            "pagesize": (wrappedValue: pagesize?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<MobileDevicePrestageSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Remove an attachment for a Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter fileAttachmentDelete: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesIdAttachmentsDelete(id: Int, fileAttachmentDelete: FileAttachmentDelete, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesIdAttachmentsDeleteWithRequestBuilder(id: id, fileAttachmentDelete: fileAttachmentDelete).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Remove an attachment for a Mobile Device Prestage 
     - DELETE /v1/mobile-device-prestages/{id}/attachments
     - Remove an attachment for a Mobile Device Prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter fileAttachmentDelete: (body)  
     - returns: RequestBuilder<Void> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesIdAttachmentsDeleteWithRequestBuilder(id: Int, fileAttachmentDelete: FileAttachmentDelete) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/mobile-device-prestages/{id}/attachments"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: fileAttachmentDelete)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get attachments for a Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesIdAttachmentsGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [FileAttachment]?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesIdAttachmentsGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get attachments for a Mobile Device Prestage 
     - GET /v1/mobile-device-prestages/{id}/attachments
     - Get attachments for a Mobile Device Prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - returns: RequestBuilder<[FileAttachment]> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesIdAttachmentsGetWithRequestBuilder(id: Int) -> RequestBuilder<[FileAttachment]> {
        var localVariablePath = "/v1/mobile-device-prestages/{id}/attachments"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[FileAttachment]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add an attachment to a Mobile Device Prestage 
     
     - parameter id: (path) Identifier of the Mobile Device Prestage the attachment should be assigned to 
     - parameter file: (form) The file to upload 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesIdAttachmentsPost(id: Int, file: URL, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageFileAttachment?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesIdAttachmentsPostWithRequestBuilder(id: id, file: file).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add an attachment to a Mobile Device Prestage 
     - POST /v1/mobile-device-prestages/{id}/attachments
     - Add an attachment to a Mobile Device prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Identifier of the Mobile Device Prestage the attachment should be assigned to 
     - parameter file: (form) The file to upload 
     - returns: RequestBuilder<PrestageFileAttachment> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesIdAttachmentsPostWithRequestBuilder(id: Int, file: URL) -> RequestBuilder<PrestageFileAttachment> {
        var localVariablePath = "/v1/mobile-device-prestages/{id}/attachments"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableFormParams: [String: Any?] = [
            "file": file.encodeToJSON(),
        ]

        let localVariableNonNullParameters = APIHelper.rejectNil(localVariableFormParams)
        let localVariableParameters = APIHelper.convertBoolToString(localVariableNonNullParameters)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            "Content-Type": "multipart/form-data",
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageFileAttachment>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete a Mobile Device Prestage with the supplied id 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesIdDelete(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete a Mobile Device Prestage with the supplied id 
     - DELETE /v1/mobile-device-prestages/{id}
     - Deletes a Mobile Device Prestage with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - returns: RequestBuilder<Void> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesIdDeleteWithRequestBuilder(id: Int) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/mobile-device-prestages/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve a Mobile Device Prestage with the supplied id 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesIdGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetMobileDevicePrestage?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve a Mobile Device Prestage with the supplied id 
     - GET /v1/mobile-device-prestages/{id}
     - Retrieves a Mobile Device Prestage with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - returns: RequestBuilder<GetMobileDevicePrestage> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesIdGetWithRequestBuilder(id: Int) -> RequestBuilder<GetMobileDevicePrestage> {
        var localVariablePath = "/v1/mobile-device-prestages/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetMobileDevicePrestage>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get sorted and paged Mobile Device Prestage history objects 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property,asc/desc. Default sort order is descending. Multiple sort criteria are supported and must be entered on separate lines in Swagger UI. In the URI the &#39;sort&#39; query param is duplicated for each sort criterion, e.g., ...&amp;sort&#x3D;name%2Casc&amp;sort&#x3D;date%2Cdesc (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesIdHistoryGet(id: Int, page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HistorySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesIdHistoryGetWithRequestBuilder(id: id, page: page, size: size, pagesize: pagesize, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get sorted and paged Mobile Device Prestage history objects 
     - GET /v1/mobile-device-prestages/{id}/history
     - Gets sorted and paged mobile device prestage history objects
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property,asc/desc. Default sort order is descending. Multiple sort criteria are supported and must be entered on separate lines in Swagger UI. In the URI the &#39;sort&#39; query param is duplicated for each sort criterion, e.g., ...&amp;sort&#x3D;name%2Casc&amp;sort&#x3D;date%2Cdesc (optional)
     - returns: RequestBuilder<HistorySearchResults> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesIdHistoryGetWithRequestBuilder(id: Int, page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<HistorySearchResults> {
        var localVariablePath = "/v1/mobile-device-prestages/{id}/history"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "size": (wrappedValue: size?.encodeToJSON(), isExplode: true),
            "pagesize": (wrappedValue: pagesize?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HistorySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Mobile Device Prestage history object notes 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter objectHistoryNote: (body) History notes to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesIdHistoryPost(id: Int, objectHistoryNote: ObjectHistoryNote, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ObjectHistory?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesIdHistoryPostWithRequestBuilder(id: id, objectHistoryNote: objectHistoryNote).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Mobile Device Prestage history object notes 
     - POST /v1/mobile-device-prestages/{id}/history
     - Adds mobile device prestage history object notes
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter objectHistoryNote: (body) History notes to create 
     - returns: RequestBuilder<ObjectHistory> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesIdHistoryPostWithRequestBuilder(id: Int, objectHistoryNote: ObjectHistoryNote) -> RequestBuilder<ObjectHistory> {
        var localVariablePath = "/v1/mobile-device-prestages/{id}/history"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: objectHistoryNote)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ObjectHistory>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter putMobileDevicePrestage: (body) Mobile Device Prestage to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesIdPut(id: Int, putMobileDevicePrestage: PutMobileDevicePrestage, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetMobileDevicePrestage?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesIdPutWithRequestBuilder(id: id, putMobileDevicePrestage: putMobileDevicePrestage).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a Mobile Device Prestage 
     - PUT /v1/mobile-device-prestages/{id}
     - Updates a Mobile Device Prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter putMobileDevicePrestage: (body) Mobile Device Prestage to update 
     - returns: RequestBuilder<GetMobileDevicePrestage> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesIdPutWithRequestBuilder(id: Int, putMobileDevicePrestage: PutMobileDevicePrestage) -> RequestBuilder<GetMobileDevicePrestage> {
        var localVariablePath = "/v1/mobile-device-prestages/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: putMobileDevicePrestage)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetMobileDevicePrestage>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Remove Device Scope for a specific Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to remove from scope 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesIdScopeDelete(id: Int, prestageScopeUpdate: PrestageScopeUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesIdScopeDeleteWithRequestBuilder(id: id, prestageScopeUpdate: prestageScopeUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Remove Device Scope for a specific Mobile Device Prestage 
     - DELETE /v1/mobile-device-prestages/{id}/scope
     - Remove device scope for a specific mobile device prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to remove from scope 
     - returns: RequestBuilder<PrestageScopeResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesIdScopeDeleteWithRequestBuilder(id: Int, prestageScopeUpdate: PrestageScopeUpdate) -> RequestBuilder<PrestageScopeResponse> {
        var localVariablePath = "/v1/mobile-device-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: prestageScopeUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Device Scope for a specific Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesIdScopeGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesIdScopeGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Device Scope for a specific Mobile Device Prestage 
     - GET /v1/mobile-device-prestages/{id}/scope
     - Get device scope for a specific mobile device prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - returns: RequestBuilder<PrestageScopeResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesIdScopeGetWithRequestBuilder(id: Int) -> RequestBuilder<PrestageScopeResponse> {
        var localVariablePath = "/v1/mobile-device-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Device Scope for a specific Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesIdScopePost(id: Int, prestageScopeUpdate: PrestageScopeUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesIdScopePostWithRequestBuilder(id: id, prestageScopeUpdate: prestageScopeUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Device Scope for a specific Mobile Device Prestage 
     - POST /v1/mobile-device-prestages/{id}/scope
     - Add device scope for a specific mobile device prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - returns: RequestBuilder<PrestageScopeResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesIdScopePostWithRequestBuilder(id: Int, prestageScopeUpdate: PrestageScopeUpdate) -> RequestBuilder<PrestageScopeResponse> {
        var localVariablePath = "/v1/mobile-device-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: prestageScopeUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Replace Device Scope for a specific Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesIdScopePut(id: Int, prestageScopeUpdate: PrestageScopeUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesIdScopePutWithRequestBuilder(id: id, prestageScopeUpdate: prestageScopeUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Replace Device Scope for a specific Mobile Device Prestage 
     - PUT /v1/mobile-device-prestages/{id}/scope
     - Replace device scope for a specific mobile device prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - returns: RequestBuilder<PrestageScopeResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesIdScopePutWithRequestBuilder(id: Int, prestageScopeUpdate: PrestageScopeUpdate) -> RequestBuilder<PrestageScopeResponse> {
        var localVariablePath = "/v1/mobile-device-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: prestageScopeUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a Mobile Device Prestage 
     
     - parameter mobileDevicePrestage: (body) Mobile Device Prestage to create. ids defined in this body will be ignored 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesPost(mobileDevicePrestage: MobileDevicePrestage, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetMobileDevicePrestage?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesPostWithRequestBuilder(mobileDevicePrestage: mobileDevicePrestage).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a Mobile Device Prestage 
     - POST /v1/mobile-device-prestages
     - Create a mobile device prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter mobileDevicePrestage: (body) Mobile Device Prestage to create. ids defined in this body will be ignored 
     - returns: RequestBuilder<GetMobileDevicePrestage> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesPostWithRequestBuilder(mobileDevicePrestage: MobileDevicePrestage) -> RequestBuilder<GetMobileDevicePrestage> {
        let localVariablePath = "/v1/mobile-device-prestages"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: mobileDevicePrestage)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetMobileDevicePrestage>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get all Device Scope for all Mobile Device Prestages 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesScopeGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScope?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesScopeGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get all Device Scope for all Mobile Device Prestages 
     - GET /v1/mobile-device-prestages/scope
     - Get all device scope for all mobile device prestages
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<PrestageScope> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesScopeGetWithRequestBuilder() -> RequestBuilder<PrestageScope> {
        let localVariablePath = "/v1/mobile-device-prestages/scope"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScope>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get all Prestage sync States for all prestages 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesSyncGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [PrestageSyncStatus]?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesSyncGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get all Prestage sync States for all prestages 
     - GET /v1/mobile-device-prestages/sync
     - Get all prestage sync states for all prestages
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<[PrestageSyncStatus]> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesSyncGetWithRequestBuilder() -> RequestBuilder<[PrestageSyncStatus]> {
        let localVariablePath = "/v1/mobile-device-prestages/sync"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[PrestageSyncStatus]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get all prestage sync states for a single prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesSyncIdGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [PrestageSyncStatus]?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesSyncIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get all prestage sync states for a single prestage 
     - GET /v1/mobile-device-prestages/sync/{id}
     - Get all prestage sync states for a single prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - returns: RequestBuilder<[PrestageSyncStatus]> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesSyncIdGetWithRequestBuilder(id: Int) -> RequestBuilder<[PrestageSyncStatus]> {
        var localVariablePath = "/v1/mobile-device-prestages/sync/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[PrestageSyncStatus]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get the latest Sync State for a single Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1MobileDevicePrestagesSyncIdLatestGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageSyncStatus?, _ error: Error?) -> Void)) -> RequestTask {
        return v1MobileDevicePrestagesSyncIdLatestGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get the latest Sync State for a single Prestage 
     - GET /v1/mobile-device-prestages/sync/{id}/latest
     - Get the latest sync state for a single prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - returns: RequestBuilder<PrestageSyncStatus> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1MobileDevicePrestagesSyncIdLatestGetWithRequestBuilder(id: Int) -> RequestBuilder<PrestageSyncStatus> {
        var localVariablePath = "/v1/mobile-device-prestages/sync/{id}/latest"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageSyncStatus>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get sorted and paged Mobile Device Prestages 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: MobileDevicePrestageSearchResultsV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get sorted and paged Mobile Device Prestages 
     - GET /v2/mobile-device-prestages
     - Gets sorted and paged mobile device prestages
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional)
     - returns: RequestBuilder<MobileDevicePrestageSearchResultsV2> 
     */
    open class func v2MobileDevicePrestagesGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<MobileDevicePrestageSearchResultsV2> {
        let localVariablePath = "/v2/mobile-device-prestages"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<MobileDevicePrestageSearchResultsV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Remove an attachment for a Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter ids: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdAttachmentsDeleteMultiplePost(id: String, ids: Ids, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdAttachmentsDeleteMultiplePostWithRequestBuilder(id: id, ids: ids).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Remove an attachment for a Mobile Device Prestage 
     - POST /v2/mobile-device-prestages/{id}/attachments/delete-multiple
     - Remove an attachment for a Mobile Device Prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter ids: (body)  
     - returns: RequestBuilder<Void> 
     */
    open class func v2MobileDevicePrestagesIdAttachmentsDeleteMultiplePostWithRequestBuilder(id: String, ids: Ids) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}/attachments/delete-multiple"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: ids)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get attachments for a Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdAttachmentsGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [FileAttachmentV2]?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdAttachmentsGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get attachments for a Mobile Device Prestage 
     - GET /v2/mobile-device-prestages/{id}/attachments
     - Get attachments for a Mobile Device Prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - returns: RequestBuilder<[FileAttachmentV2]> 
     */
    open class func v2MobileDevicePrestagesIdAttachmentsGetWithRequestBuilder(id: String) -> RequestBuilder<[FileAttachmentV2]> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}/attachments"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[FileAttachmentV2]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add an attachment to a Mobile Device Prestage 
     
     - parameter id: (path) Identifier of the Mobile Device Prestage the attachment should be assigned to 
     - parameter file: (form) The file to upload 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdAttachmentsPost(id: String, file: URL, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageFileAttachmentV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdAttachmentsPostWithRequestBuilder(id: id, file: file).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add an attachment to a Mobile Device Prestage 
     - POST /v2/mobile-device-prestages/{id}/attachments
     - Add an attachment to a Mobile Device prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Identifier of the Mobile Device Prestage the attachment should be assigned to 
     - parameter file: (form) The file to upload 
     - returns: RequestBuilder<PrestageFileAttachmentV2> 
     */
    open class func v2MobileDevicePrestagesIdAttachmentsPostWithRequestBuilder(id: String, file: URL) -> RequestBuilder<PrestageFileAttachmentV2> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}/attachments"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableFormParams: [String: Any?] = [
            "file": file.encodeToJSON(),
        ]

        let localVariableNonNullParameters = APIHelper.rejectNil(localVariableFormParams)
        let localVariableParameters = APIHelper.convertBoolToString(localVariableNonNullParameters)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            "Content-Type": "multipart/form-data",
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageFileAttachmentV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete a Mobile Device Prestage with the supplied id 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete a Mobile Device Prestage with the supplied id 
     - DELETE /v2/mobile-device-prestages/{id}
     - Deletes a Mobile Device Prestage with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v2MobileDevicePrestagesIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve a Mobile Device Prestage with the supplied id 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetMobileDevicePrestageV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve a Mobile Device Prestage with the supplied id 
     - GET /v2/mobile-device-prestages/{id}
     - Retrieves a Mobile Device Prestage with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - returns: RequestBuilder<GetMobileDevicePrestageV2> 
     */
    open class func v2MobileDevicePrestagesIdGetWithRequestBuilder(id: String) -> RequestBuilder<GetMobileDevicePrestageV2> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetMobileDevicePrestageV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get sorted and paged Mobile Device Prestage history objects 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property,asc/desc. Default sort order is descending. Multiple sort criteria are supported and must be entered on separate lines in Swagger UI. In the URI the &#39;sort&#39; query param is duplicated for each sort criterion, e.g., ...&amp;sort&#x3D;name%2Casc&amp;sort&#x3D;date%2Cdesc (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdHistoryGet(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HistorySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdHistoryGetWithRequestBuilder(id: id, page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get sorted and paged Mobile Device Prestage history objects 
     - GET /v2/mobile-device-prestages/{id}/history
     - Gets sorted and paged mobile device prestage history objects
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property,asc/desc. Default sort order is descending. Multiple sort criteria are supported and must be entered on separate lines in Swagger UI. In the URI the &#39;sort&#39; query param is duplicated for each sort criterion, e.g., ...&amp;sort&#x3D;name%2Casc&amp;sort&#x3D;date%2Cdesc (optional)
     - returns: RequestBuilder<HistorySearchResults> 
     */
    open class func v2MobileDevicePrestagesIdHistoryGetWithRequestBuilder(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<HistorySearchResults> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}/history"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HistorySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Mobile Device Prestage history object notes 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter objectHistoryNote: (body) History notes to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdHistoryPost(id: String, objectHistoryNote: ObjectHistoryNote, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdHistoryPostWithRequestBuilder(id: id, objectHistoryNote: objectHistoryNote).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Mobile Device Prestage history object notes 
     - POST /v2/mobile-device-prestages/{id}/history
     - Adds mobile device prestage history object notes
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter objectHistoryNote: (body) History notes to create 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v2MobileDevicePrestagesIdHistoryPostWithRequestBuilder(id: String, objectHistoryNote: ObjectHistoryNote) -> RequestBuilder<HrefResponse> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}/history"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: objectHistoryNote)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter putMobileDevicePrestageV2: (body) Mobile Device Prestage to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdPut(id: String, putMobileDevicePrestageV2: PutMobileDevicePrestageV2, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetMobileDevicePrestageV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdPutWithRequestBuilder(id: id, putMobileDevicePrestageV2: putMobileDevicePrestageV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a Mobile Device Prestage 
     - PUT /v2/mobile-device-prestages/{id}
     - Updates a Mobile Device Prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter putMobileDevicePrestageV2: (body) Mobile Device Prestage to update 
     - returns: RequestBuilder<GetMobileDevicePrestageV2> 
     */
    open class func v2MobileDevicePrestagesIdPutWithRequestBuilder(id: String, putMobileDevicePrestageV2: PutMobileDevicePrestageV2) -> RequestBuilder<GetMobileDevicePrestageV2> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: putMobileDevicePrestageV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetMobileDevicePrestageV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Remove Device Scope for a specific Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to remove from scope 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdScopeDeleteMultiplePost(id: String, prestageScopeUpdate: PrestageScopeUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponseV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdScopeDeleteMultiplePostWithRequestBuilder(id: id, prestageScopeUpdate: prestageScopeUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Remove Device Scope for a specific Mobile Device Prestage 
     - POST /v2/mobile-device-prestages/{id}/scope/delete-multiple
     - Remove device scope for a specific mobile device prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to remove from scope 
     - returns: RequestBuilder<PrestageScopeResponseV2> 
     */
    open class func v2MobileDevicePrestagesIdScopeDeleteMultiplePostWithRequestBuilder(id: String, prestageScopeUpdate: PrestageScopeUpdate) -> RequestBuilder<PrestageScopeResponseV2> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}/scope/delete-multiple"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: prestageScopeUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponseV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Device Scope for a specific Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdScopeGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponseV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdScopeGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Device Scope for a specific Mobile Device Prestage 
     - GET /v2/mobile-device-prestages/{id}/scope
     - Get device scope for a specific mobile device prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - returns: RequestBuilder<PrestageScopeResponseV2> 
     */
    open class func v2MobileDevicePrestagesIdScopeGetWithRequestBuilder(id: String) -> RequestBuilder<PrestageScopeResponseV2> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponseV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Device Scope for a specific Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdScopePost(id: String, prestageScopeUpdate: PrestageScopeUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponseV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdScopePostWithRequestBuilder(id: id, prestageScopeUpdate: prestageScopeUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Device Scope for a specific Mobile Device Prestage 
     - POST /v2/mobile-device-prestages/{id}/scope
     - Add device scope for a specific mobile device prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - returns: RequestBuilder<PrestageScopeResponseV2> 
     */
    open class func v2MobileDevicePrestagesIdScopePostWithRequestBuilder(id: String, prestageScopeUpdate: PrestageScopeUpdate) -> RequestBuilder<PrestageScopeResponseV2> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: prestageScopeUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponseV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Replace Device Scope for a specific Mobile Device Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdScopePut(id: String, prestageScopeUpdate: PrestageScopeUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeResponseV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdScopePutWithRequestBuilder(id: id, prestageScopeUpdate: prestageScopeUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Replace Device Scope for a specific Mobile Device Prestage 
     - PUT /v2/mobile-device-prestages/{id}/scope
     - Replace device scope for a specific mobile device prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter prestageScopeUpdate: (body) Serial Numbers to scope 
     - returns: RequestBuilder<PrestageScopeResponseV2> 
     */
    open class func v2MobileDevicePrestagesIdScopePutWithRequestBuilder(id: String, prestageScopeUpdate: PrestageScopeUpdate) -> RequestBuilder<PrestageScopeResponseV2> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}/scope"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: prestageScopeUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeResponseV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get all prestage sync states for a single prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdSyncsGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [PrestageSyncStatusV2]?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdSyncsGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get all prestage sync states for a single prestage 
     - GET /v2/mobile-device-prestages/{id}/syncs
     - Get all prestage sync states for a single prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - returns: RequestBuilder<[PrestageSyncStatusV2]> 
     */
    open class func v2MobileDevicePrestagesIdSyncsGetWithRequestBuilder(id: String) -> RequestBuilder<[PrestageSyncStatusV2]> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}/syncs"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[PrestageSyncStatusV2]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get the latest Sync State for a single Prestage 
     
     - parameter id: (path) Mobile Device Prestage identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesIdSyncsLatestGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageSyncStatusV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesIdSyncsLatestGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get the latest Sync State for a single Prestage 
     - GET /v2/mobile-device-prestages/{id}/syncs/latest
     - Get the latest sync state for a single prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Mobile Device Prestage identifier 
     - returns: RequestBuilder<PrestageSyncStatusV2> 
     */
    open class func v2MobileDevicePrestagesIdSyncsLatestGetWithRequestBuilder(id: String) -> RequestBuilder<PrestageSyncStatusV2> {
        var localVariablePath = "/v2/mobile-device-prestages/{id}/syncs/latest"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageSyncStatusV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a Mobile Device Prestage 
     
     - parameter mobileDevicePrestageV2: (body) Mobile Device Prestage to create. ids defined in this body will be ignored 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesPost(mobileDevicePrestageV2: MobileDevicePrestageV2, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesPostWithRequestBuilder(mobileDevicePrestageV2: mobileDevicePrestageV2).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a Mobile Device Prestage 
     - POST /v2/mobile-device-prestages
     - Create a mobile device prestage
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter mobileDevicePrestageV2: (body) Mobile Device Prestage to create. ids defined in this body will be ignored 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v2MobileDevicePrestagesPostWithRequestBuilder(mobileDevicePrestageV2: MobileDevicePrestageV2) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v2/mobile-device-prestages"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: mobileDevicePrestageV2)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get all Device Scope for all Mobile Device Prestages 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesScopeGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PrestageScopeV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesScopeGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get all Device Scope for all Mobile Device Prestages 
     - GET /v2/mobile-device-prestages/scope
     - Get all device scope for all mobile device prestages
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<PrestageScopeV2> 
     */
    open class func v2MobileDevicePrestagesScopeGetWithRequestBuilder() -> RequestBuilder<PrestageScopeV2> {
        let localVariablePath = "/v2/mobile-device-prestages/scope"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PrestageScopeV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get all Prestage sync States for all prestages 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2MobileDevicePrestagesSyncsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [PrestageSyncStatusV2]?, _ error: Error?) -> Void)) -> RequestTask {
        return v2MobileDevicePrestagesSyncsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get all Prestage sync States for all prestages 
     - GET /v2/mobile-device-prestages/syncs
     - Get all prestage sync states for all prestages
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<[PrestageSyncStatusV2]> 
     */
    open class func v2MobileDevicePrestagesSyncsGetWithRequestBuilder() -> RequestBuilder<[PrestageSyncStatusV2]> {
        let localVariablePath = "/v2/mobile-device-prestages/syncs"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[PrestageSyncStatusV2]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
