//
// PatchPolicyLogsAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class PatchPolicyLogsAPI {

    /**
     Return attempt details for a specific log
     
     - parameter id: (path) patch policy id 
     - parameter deviceId: (path) device id 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchPoliciesIdLogsDeviceIdDetailsGet(id: String, deviceId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [PatchPolicyLogDetail]?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchPoliciesIdLogsDeviceIdDetailsGetWithRequestBuilder(id: id, deviceId: deviceId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Return attempt details for a specific log
     - GET /v2/patch-policies/{id}/logs/{deviceId}/details
     - Return attempt details for a specific log
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) patch policy id 
     - parameter deviceId: (path) device id 
     - returns: RequestBuilder<[PatchPolicyLogDetail]> 
     */
    open class func v2PatchPoliciesIdLogsDeviceIdDetailsGetWithRequestBuilder(id: String, deviceId: String) -> RequestBuilder<[PatchPolicyLogDetail]> {
        var localVariablePath = "/v2/patch-policies/{id}/logs/{deviceId}/details"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let deviceIdPreEscape = "\(APIHelper.mapValueToPathItem(deviceId))"
        let deviceIdPostEscape = deviceIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{deviceId}", with: deviceIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[PatchPolicyLogDetail]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieves a single Patch Policy Log 
     
     - parameter id: (path) patch policy id 
     - parameter deviceId: (path) device id 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchPoliciesIdLogsDeviceIdGet(id: String, deviceId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PatchPolicyLogV2?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchPoliciesIdLogsDeviceIdGetWithRequestBuilder(id: id, deviceId: deviceId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieves a single Patch Policy Log 
     - GET /v2/patch-policies/{id}/logs/{deviceId}
     - Retrieves a single Patch Policy Log
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) patch policy id 
     - parameter deviceId: (path) device id 
     - returns: RequestBuilder<PatchPolicyLogV2> 
     */
    open class func v2PatchPoliciesIdLogsDeviceIdGetWithRequestBuilder(id: String, deviceId: String) -> RequestBuilder<PatchPolicyLogV2> {
        var localVariablePath = "/v2/patch-policies/{id}/logs/{deviceId}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let deviceIdPreEscape = "\(APIHelper.mapValueToPathItem(deviceId))"
        let deviceIdPostEscape = deviceIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{deviceId}", with: deviceIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PatchPolicyLogV2>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Return the count of the Patch Policy Logs for the patch policy id that are eligible for a retry attempt 
     
     - parameter id: (path) patch policy id 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchPoliciesIdLogsEligibleRetryCountGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PatchPolicyLogEligibleRetryCount?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchPoliciesIdLogsEligibleRetryCountGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Return the count of the Patch Policy Logs for the patch policy id that are eligible for a retry attempt 
     - GET /v2/patch-policies/{id}/logs/eligible-retry-count
     - return the count of the patch policy logs for the patch policy id that  are eligible for a retry attempt
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) patch policy id 
     - returns: RequestBuilder<PatchPolicyLogEligibleRetryCount> 
     */
    open class func v2PatchPoliciesIdLogsEligibleRetryCountGetWithRequestBuilder(id: String) -> RequestBuilder<PatchPolicyLogEligibleRetryCount> {
        var localVariablePath = "/v2/patch-policies/{id}/logs/eligible-retry-count"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PatchPolicyLogEligibleRetryCount>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve Patch Policy Logs 
     
     - parameter id: (path) patch policy id 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is deviceName:asc. Multiple sort criteria are supported and must be separated with a comma. (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter Patch Policy Logs collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: deviceId, deviceName, statusCode, statusDate, attemptNumber, ignoredForPatchPolicyId. This param can be combined with paging and sorting. (optional, default to "")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchPoliciesIdLogsGet(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PatchPolicyLogs?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchPoliciesIdLogsGetWithRequestBuilder(id: id, page: page, pageSize: pageSize, sort: sort, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Patch Policy Logs 
     - GET /v2/patch-policies/{id}/logs
     - Retrieves Patch Policy Logs
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) patch policy id 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is deviceName:asc. Multiple sort criteria are supported and must be separated with a comma. (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter Patch Policy Logs collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: deviceId, deviceName, statusCode, statusDate, attemptNumber, ignoredForPatchPolicyId. This param can be combined with paging and sorting. (optional, default to "")
     - returns: RequestBuilder<PatchPolicyLogs> 
     */
    open class func v2PatchPoliciesIdLogsGetWithRequestBuilder(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil) -> RequestBuilder<PatchPolicyLogs> {
        var localVariablePath = "/v2/patch-policies/{id}/logs"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PatchPolicyLogs>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Send retry attempts for all devices
     
     - parameter id: (path) patch policy id 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchPoliciesIdLogsRetryAllPost(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchPoliciesIdLogsRetryAllPostWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Send retry attempts for all devices
     - POST /v2/patch-policies/{id}/logs/retry-all
     - Send retry attempts for all devices
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) patch policy id 
     - returns: RequestBuilder<Void> 
     */
    open class func v2PatchPoliciesIdLogsRetryAllPostWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/patch-policies/{id}/logs/retry-all"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Send retry attempts for specific devices
     
     - parameter id: (path) patch policy id 
     - parameter patchPolicyLogRetry: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchPoliciesIdLogsRetryPost(id: String, patchPolicyLogRetry: PatchPolicyLogRetry, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchPoliciesIdLogsRetryPostWithRequestBuilder(id: id, patchPolicyLogRetry: patchPolicyLogRetry).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Send retry attempts for specific devices
     - POST /v2/patch-policies/{id}/logs/retry
     - Send retry attempts for specific devices
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) patch policy id 
     - parameter patchPolicyLogRetry: (body)  
     - returns: RequestBuilder<Void> 
     */
    open class func v2PatchPoliciesIdLogsRetryPostWithRequestBuilder(id: String, patchPolicyLogRetry: PatchPolicyLogRetry) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/patch-policies/{id}/logs/retry"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: patchPolicyLogRetry)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
