//
// PatchSoftwareTitleConfigurationsAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class PatchSoftwareTitleConfigurationsAPI {

    /**
     Retrieve Patch Software Title Configurations
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [PatchSoftwareTitleConfiguration]?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Patch Software Title Configurations
     - GET /v2/patch-software-title-configurations
     - Retrieves patch software title configurations
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<[PatchSoftwareTitleConfiguration]> 
     */
    open class func v2PatchSoftwareTitleConfigurationsGetWithRequestBuilder() -> RequestBuilder<[PatchSoftwareTitleConfiguration]> {
        let localVariablePath = "/v2/patch-software-title-configurations"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[PatchSoftwareTitleConfiguration]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Remove a software title configuration from the dashboard 
     
     - parameter id: (path) software title configuration id 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdDashboardDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdDashboardDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Remove a software title configuration from the dashboard 
     - DELETE /v2/patch-software-title-configurations/{id}/dashboard
     - Removes a software title configuration from the dashboard.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) software title configuration id 
     - returns: RequestBuilder<Void> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdDashboardDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}/dashboard"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Return whether or not the requested software title configuration is on the dashboard 
     
     - parameter id: (path) software title configuration id 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdDashboardGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SoftwareTitleConfigurationOnDashboard?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdDashboardGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Return whether or not the requested software title configuration is on the dashboard 
     - GET /v2/patch-software-title-configurations/{id}/dashboard
     - Returns whether or not the requested software title configuration is on the dashboard
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) software title configuration id 
     - returns: RequestBuilder<SoftwareTitleConfigurationOnDashboard> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdDashboardGetWithRequestBuilder(id: String) -> RequestBuilder<SoftwareTitleConfigurationOnDashboard> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}/dashboard"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SoftwareTitleConfigurationOnDashboard>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add a software title configuration to the dashboard 
     
     - parameter id: (path) software title configuration id 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdDashboardPost(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdDashboardPostWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add a software title configuration to the dashboard 
     - POST /v2/patch-software-title-configurations/{id}/dashboard
     - Adds asoftware title configuration to the dashboard.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) software title configuration id 
     - returns: RequestBuilder<Void> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdDashboardPostWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}/dashboard"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve Patch Software Title Definitions with the supplied id
     
     - parameter id: (path) Patch Software Title identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is absoluteOrderId:asc. Multiple sort criteria are supported and must be separated with a comma. (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter Patch Software Title Definition collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: id, version, minimumOperatingSystem, releaseDate, reboot, standalone and absoluteOrderId. This param can be combined with paging and sorting. (optional, default to "")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdDefinitionsGet(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PatchSoftwareTitleDefinitions?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdDefinitionsGetWithRequestBuilder(id: id, page: page, pageSize: pageSize, sort: sort, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Patch Software Title Definitions with the supplied id
     - GET /v2/patch-software-title-configurations/{id}/definitions
     - Retrieves patch software title definitions with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Patch Software Title identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is absoluteOrderId:asc. Multiple sort criteria are supported and must be separated with a comma. (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter Patch Software Title Definition collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: id, version, minimumOperatingSystem, releaseDate, reboot, standalone and absoluteOrderId. This param can be combined with paging and sorting. (optional, default to "")
     - returns: RequestBuilder<PatchSoftwareTitleDefinitions> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdDefinitionsGetWithRequestBuilder(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil) -> RequestBuilder<PatchSoftwareTitleDefinitions> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}/definitions"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PatchSoftwareTitleDefinitions>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete Patch Software Title Configurations with the supplied id
     
     - parameter id: (path) Patch Software Title Configurations identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete Patch Software Title Configurations with the supplied id
     - DELETE /v2/patch-software-title-configurations/{id}
     - Deletes Patch Software Title Configurations with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Patch Software Title Configurations identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve list of Patch Software Title Configuration Dependencies
     
     - parameter id: (path) Patch Software Title Configuration Id 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdDependenciesGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PatchSoftwareTitleConfigurationDependencies?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdDependenciesGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve list of Patch Software Title Configuration Dependencies
     - GET /v2/patch-software-title-configurations/{id}/dependencies
     - Retrieve list of Patch Software Title Configuration Dependencies
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Patch Software Title Configuration Id 
     - returns: RequestBuilder<PatchSoftwareTitleConfigurationDependencies> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdDependenciesGetWithRequestBuilder(id: String) -> RequestBuilder<PatchSoftwareTitleConfigurationDependencies> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}/dependencies"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PatchSoftwareTitleConfigurationDependencies>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Export Patch Reporting Data
     
     - parameter id: (path) Patch Software Title Configurations identifier 
     - parameter columnsToExport: (query) List of column names to export 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query) Leave blank for full export (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is computerName:asc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;id:desc,name:asc Supported fields: computerName, deviceId, username, operatingSystemVersion, lastContactTime, buildingName, departmentName, siteName, version (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter Patch Report collection on version equality only. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: version. Comparators allowed in the query: &#x3D;&#x3D;, !&#x3D; This param can be combined with paging and sorting. (optional, default to "")
     - parameter accept: (header) File (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdExportReportGet(id: String, columnsToExport: [String], page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, accept: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: AnyCodable?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdExportReportGetWithRequestBuilder(id: id, columnsToExport: columnsToExport, page: page, pageSize: pageSize, sort: sort, filter: filter, accept: accept).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Export Patch Reporting Data
     - GET /v2/patch-software-title-configurations/{id}/export-report
     - Export Patch Reporting Data
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Patch Software Title Configurations identifier 
     - parameter columnsToExport: (query) List of column names to export 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query) Leave blank for full export (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is computerName:asc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;id:desc,name:asc Supported fields: computerName, deviceId, username, operatingSystemVersion, lastContactTime, buildingName, departmentName, siteName, version (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter Patch Report collection on version equality only. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: version. Comparators allowed in the query: &#x3D;&#x3D;, !&#x3D; This param can be combined with paging and sorting. (optional, default to "")
     - parameter accept: (header) File (optional)
     - returns: RequestBuilder<AnyCodable> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdExportReportGetWithRequestBuilder(id: String, columnsToExport: [String], page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, accept: String? = nil) -> RequestBuilder<AnyCodable> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}/export-report"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
            "columns-to-export": (wrappedValue: columnsToExport.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            "accept": accept?.encodeToJSON(),
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<AnyCodable>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve Software Title Extension Attributes with the supplied id
     
     - parameter id: (path) Patch Software Title identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdExtensionAttributesGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [PatchSoftwareTitleExtensionAttributes]?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdExtensionAttributesGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Software Title Extension Attributes with the supplied id
     - GET /v2/patch-software-title-configurations/{id}/extension-attributes
     - Retrieves software title extension attributes with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Patch Software Title identifier 
     - returns: RequestBuilder<[PatchSoftwareTitleExtensionAttributes]> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdExtensionAttributesGetWithRequestBuilder(id: String) -> RequestBuilder<[PatchSoftwareTitleExtensionAttributes]> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}/extension-attributes"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[PatchSoftwareTitleExtensionAttributes]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve Patch Software Title Configurations with the supplied id
     
     - parameter id: (path) Patch Software Title Configurations identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PatchSoftwareTitleConfiguration?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Patch Software Title Configurations with the supplied id
     - GET /v2/patch-software-title-configurations/{id}
     - Retrieves Patch Software Title Configurations with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Patch Software Title Configurations identifier 
     - returns: RequestBuilder<PatchSoftwareTitleConfiguration> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdGetWithRequestBuilder(id: String) -> RequestBuilder<PatchSoftwareTitleConfiguration> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PatchSoftwareTitleConfiguration>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get specified Patch Software Title Configuration history object 
     
     - parameter id: (path) Patch Software Title Configuration Id 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is date:desc. Multiple sort criteria are supported and must be separated with a comma.  (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter history notes collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: username, date, note, details. This param can be combined with paging and sorting. Example: filter&#x3D;username!&#x3D;admin and details&#x3D;&#x3D;*disabled* and date&lt;2019-12-15 (optional, default to "")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdHistoryGet(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HistorySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdHistoryGetWithRequestBuilder(id: id, page: page, pageSize: pageSize, sort: sort, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get specified Patch Software Title Configuration history object 
     - GET /v2/patch-software-title-configurations/{id}/history
     - Gets specified Patch Software Title Configuration history object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Patch Software Title Configuration Id 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is date:desc. Multiple sort criteria are supported and must be separated with a comma.  (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter history notes collection. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: username, date, note, details. This param can be combined with paging and sorting. Example: filter&#x3D;username!&#x3D;admin and details&#x3D;&#x3D;*disabled* and date&lt;2019-12-15 (optional, default to "")
     - returns: RequestBuilder<HistorySearchResults> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdHistoryGetWithRequestBuilder(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil) -> RequestBuilder<HistorySearchResults> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}/history"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HistorySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Add Patch Software Title Configuration history object notes 
     
     - parameter id: (path) Patch Software Title Configuration Id 
     - parameter objectHistoryNote: (body) History notes to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdHistoryPost(id: String, objectHistoryNote: ObjectHistoryNote, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdHistoryPostWithRequestBuilder(id: id, objectHistoryNote: objectHistoryNote).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Add Patch Software Title Configuration history object notes 
     - POST /v2/patch-software-title-configurations/{id}/history
     - Adds Patch Software Title Configuration history object notes
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Patch Software Title Configuration Id 
     - parameter objectHistoryNote: (body) History notes to create 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdHistoryPostWithRequestBuilder(id: String, objectHistoryNote: ObjectHistoryNote) -> RequestBuilder<HrefResponse> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}/history"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: objectHistoryNote)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Patch Software Title Configurations
     
     - parameter id: (path) Patch Software Title Configurations identifier 
     - parameter patchSoftwareTitleConfigurationPatch: (body) Patch Software Title Configurations to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdPatch(id: String, patchSoftwareTitleConfigurationPatch: PatchSoftwareTitleConfigurationPatch, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PatchSoftwareTitleConfiguration?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdPatchWithRequestBuilder(id: id, patchSoftwareTitleConfigurationPatch: patchSoftwareTitleConfigurationPatch).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Patch Software Title Configurations
     - PATCH /v2/patch-software-title-configurations/{id}
     - Updates Patch Software Title Configurations
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Patch Software Title Configurations identifier 
     - parameter patchSoftwareTitleConfigurationPatch: (body) Patch Software Title Configurations to update 
     - returns: RequestBuilder<PatchSoftwareTitleConfiguration> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdPatchWithRequestBuilder(id: String, patchSoftwareTitleConfigurationPatch: PatchSoftwareTitleConfigurationPatch) -> RequestBuilder<PatchSoftwareTitleConfiguration> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: patchSoftwareTitleConfigurationPatch)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PatchSoftwareTitleConfiguration>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PATCH", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve Patch Software Title Configuration Patch Report
     
     - parameter id: (path) Patch Software Title Configurations identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is computerName:asc. Multiple sort criteria are supported and must be separated with a comma. Supported fields: computerName, deviceId, username, operatingSystemVersion, lastContactTime, buildingName, departmentName, siteName, version (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter Patch Report collection on version equality only. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: version. Comparators allowed in the query: &#x3D;&#x3D;, !&#x3D; This param can be combined with paging and sorting. (optional, default to "")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdPatchReportGet(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PatchSoftwareTitleReportSearchResult?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdPatchReportGetWithRequestBuilder(id: id, page: page, pageSize: pageSize, sort: sort, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Patch Software Title Configuration Patch Report
     - GET /v2/patch-software-title-configurations/{id}/patch-report
     - Retrieve Patch Software Title Configuration Patch Report
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Patch Software Title Configurations identifier 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is computerName:asc. Multiple sort criteria are supported and must be separated with a comma. Supported fields: computerName, deviceId, username, operatingSystemVersion, lastContactTime, buildingName, departmentName, siteName, version (optional)
     - parameter filter: (query) Query in the RSQL format, allowing to filter Patch Report collection on version equality only. Default filter is empty query - returning all results for the requested page. Fields allowed in the query: version. Comparators allowed in the query: &#x3D;&#x3D;, !&#x3D; This param can be combined with paging and sorting. (optional, default to "")
     - returns: RequestBuilder<PatchSoftwareTitleReportSearchResult> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdPatchReportGetWithRequestBuilder(id: String, page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, filter: String? = nil) -> RequestBuilder<PatchSoftwareTitleReportSearchResult> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}/patch-report"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PatchSoftwareTitleReportSearchResult>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Return Active Patch Summary
     
     - parameter id: (path) Patch id 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdPatchSummaryGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PatchSummary?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdPatchSummaryGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Return Active Patch Summary
     - GET /v2/patch-software-title-configurations/{id}/patch-summary
     - Returns active patch summary.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Patch id 
     - returns: RequestBuilder<PatchSummary> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdPatchSummaryGetWithRequestBuilder(id: String) -> RequestBuilder<PatchSummary> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}/patch-summary"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PatchSummary>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Returns patch versions
     
     - parameter id: (path) Patch id 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsIdPatchSummaryVersionsGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [PatchSummaryVersion]?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsIdPatchSummaryVersionsGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Returns patch versions
     - GET /v2/patch-software-title-configurations/{id}/patch-summary/versions
     - Returns patch versions
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Patch id 
     - returns: RequestBuilder<[PatchSummaryVersion]> 
     */
    open class func v2PatchSoftwareTitleConfigurationsIdPatchSummaryVersionsGetWithRequestBuilder(id: String) -> RequestBuilder<[PatchSummaryVersion]> {
        var localVariablePath = "/v2/patch-software-title-configurations/{id}/patch-summary/versions"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[PatchSummaryVersion]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create Patch Software Title Configurations
     
     - parameter patchSoftwareTitleConfigurationBase: (body) Software title configurations to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v2PatchSoftwareTitleConfigurationsPost(patchSoftwareTitleConfigurationBase: PatchSoftwareTitleConfigurationBase, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v2PatchSoftwareTitleConfigurationsPostWithRequestBuilder(patchSoftwareTitleConfigurationBase: patchSoftwareTitleConfigurationBase).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create Patch Software Title Configurations
     - POST /v2/patch-software-title-configurations
     - Creates Patch Software Title Configurations using sToken
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter patchSoftwareTitleConfigurationBase: (body) Software title configurations to create 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v2PatchSoftwareTitleConfigurationsPostWithRequestBuilder(patchSoftwareTitleConfigurationBase: PatchSoftwareTitleConfigurationBase) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v2/patch-software-title-configurations"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: patchSoftwareTitleConfigurationBase)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
