//
// PoliciesPreviewAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class PoliciesPreviewAPI {

    /**
     Get Policy Properties object 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func settingsObjPolicyPropertiesGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PolicyProperties?, _ error: Error?) -> Void)) -> RequestTask {
        return settingsObjPolicyPropertiesGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Policy Properties object 
     - GET /settings/obj/policyProperties
     - Gets `Policy Properties` object. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<PolicyProperties> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func settingsObjPolicyPropertiesGetWithRequestBuilder() -> RequestBuilder<PolicyProperties> {
        let localVariablePath = "/settings/obj/policyProperties"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PolicyProperties>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Policy Properties object 
     
     - parameter policyProperties: (body) Policy Properties object to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func settingsObjPolicyPropertiesPut(policyProperties: PolicyProperties, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PolicyProperties?, _ error: Error?) -> Void)) -> RequestTask {
        return settingsObjPolicyPropertiesPutWithRequestBuilder(policyProperties: policyProperties).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Policy Properties object 
     - PUT /settings/obj/policyProperties
     - Update Policy Properties object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter policyProperties: (body) Policy Properties object to update 
     - returns: RequestBuilder<PolicyProperties> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func settingsObjPolicyPropertiesPutWithRequestBuilder(policyProperties: PolicyProperties) -> RequestBuilder<PolicyProperties> {
        let localVariablePath = "/settings/obj/policyProperties"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: policyProperties)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PolicyProperties>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Policy Properties object 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1PolicyPropertiesGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PolicyPropertiesV1?, _ error: Error?) -> Void)) -> RequestTask {
        return v1PolicyPropertiesGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Policy Properties object 
     - GET /v1/policy-properties
     - Gets `Policy Properties` object. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<PolicyPropertiesV1> 
     */
    open class func v1PolicyPropertiesGetWithRequestBuilder() -> RequestBuilder<PolicyPropertiesV1> {
        let localVariablePath = "/v1/policy-properties"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PolicyPropertiesV1>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Policy Properties object 
     
     - parameter policyPropertiesV1: (body) Policy Properties object to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1PolicyPropertiesPut(policyPropertiesV1: PolicyPropertiesV1, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: PolicyPropertiesV1?, _ error: Error?) -> Void)) -> RequestTask {
        return v1PolicyPropertiesPutWithRequestBuilder(policyPropertiesV1: policyPropertiesV1).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Policy Properties object 
     - PUT /v1/policy-properties
     - Update Policy Properties object 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter policyPropertiesV1: (body) Policy Properties object to update 
     - returns: RequestBuilder<PolicyPropertiesV1> 
     */
    open class func v1PolicyPropertiesPutWithRequestBuilder(policyPropertiesV1: PolicyPropertiesV1) -> RequestBuilder<PolicyPropertiesV1> {
        let localVariablePath = "/v1/policy-properties"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: policyPropertiesV1)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<PolicyPropertiesV1>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
