//
// SelfServiceAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class SelfServiceAPI {

    /**
     Get an object representation of Self Service settings 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SelfServiceSettingsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SelfServiceSettings?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SelfServiceSettingsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get an object representation of Self Service settings 
     - GET /v1/self-service/settings
     - gets an object representation of Self Service settings 
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<SelfServiceSettings> 
     */
    open class func v1SelfServiceSettingsGetWithRequestBuilder() -> RequestBuilder<SelfServiceSettings> {
        let localVariablePath = "/v1/self-service/settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SelfServiceSettings>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Put an object representation of Self Service settings 
     
     - parameter selfServiceSettings: (body) object that contains all editable global fields to alter Self Service settings  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SelfServiceSettingsPut(selfServiceSettings: SelfServiceSettings, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SelfServiceSettings?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SelfServiceSettingsPutWithRequestBuilder(selfServiceSettings: selfServiceSettings).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Put an object representation of Self Service settings 
     - PUT /v1/self-service/settings
     - puts an object representation of Self Service settings 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter selfServiceSettings: (body) object that contains all editable global fields to alter Self Service settings  
     - returns: RequestBuilder<SelfServiceSettings> 
     */
    open class func v1SelfServiceSettingsPutWithRequestBuilder(selfServiceSettings: SelfServiceSettings) -> RequestBuilder<SelfServiceSettings> {
        let localVariablePath = "/v1/self-service/settings"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: selfServiceSettings)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SelfServiceSettings>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
