//
// SelfServiceBrandingIosAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class SelfServiceBrandingIosAPI {

    /**
     Search for sorted and paged iOS branding configurations 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is id:asc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;id:desc,brandingName:asc  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SelfServiceBrandingIosGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: IosBrandingSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SelfServiceBrandingIosGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Search for sorted and paged iOS branding configurations 
     - GET /v1/self-service/branding/ios
     - Search for sorted and paged iOS branding configurations
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is id:asc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;id:desc,brandingName:asc  (optional)
     - returns: RequestBuilder<IosBrandingSearchResults> 
     */
    open class func v1SelfServiceBrandingIosGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<IosBrandingSearchResults> {
        let localVariablePath = "/v1/self-service/branding/ios"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<IosBrandingSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete the Self Service iOS branding configuration indicated by the provided id 
     
     - parameter id: (path) id of iOS branding configuration 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SelfServiceBrandingIosIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SelfServiceBrandingIosIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete the Self Service iOS branding configuration indicated by the provided id 
     - DELETE /v1/self-service/branding/ios/{id}
     - Delete the Self Service iOS branding configuration indicated by the provided id.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of iOS branding configuration 
     - returns: RequestBuilder<Void> 
     */
    open class func v1SelfServiceBrandingIosIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/self-service/branding/ios/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Read a single Self Service iOS branding configuration indicated by the provided id 
     
     - parameter id: (path) id of iOS branding configuration 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SelfServiceBrandingIosIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: IosBrandingConfiguration?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SelfServiceBrandingIosIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Read a single Self Service iOS branding configuration indicated by the provided id 
     - GET /v1/self-service/branding/ios/{id}
     - Read a single Self Service iOS branding configuration indicated by the provided id.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of iOS branding configuration 
     - returns: RequestBuilder<IosBrandingConfiguration> 
     */
    open class func v1SelfServiceBrandingIosIdGetWithRequestBuilder(id: String) -> RequestBuilder<IosBrandingConfiguration> {
        var localVariablePath = "/v1/self-service/branding/ios/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<IosBrandingConfiguration>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a Self Service iOS branding configuration with the supplied details 
     
     - parameter id: (path) id of iOS branding configuration 
     - parameter iosBrandingConfiguration: (body) The iOS branding configuration values to update (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SelfServiceBrandingIosIdPut(id: String, iosBrandingConfiguration: IosBrandingConfiguration? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: IosBrandingConfiguration?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SelfServiceBrandingIosIdPutWithRequestBuilder(id: id, iosBrandingConfiguration: iosBrandingConfiguration).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a Self Service iOS branding configuration with the supplied details 
     - PUT /v1/self-service/branding/ios/{id}
     - Update a Self Service iOS branding configuration with the supplied details
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of iOS branding configuration 
     - parameter iosBrandingConfiguration: (body) The iOS branding configuration values to update (optional)
     - returns: RequestBuilder<IosBrandingConfiguration> 
     */
    open class func v1SelfServiceBrandingIosIdPutWithRequestBuilder(id: String, iosBrandingConfiguration: IosBrandingConfiguration? = nil) -> RequestBuilder<IosBrandingConfiguration> {
        var localVariablePath = "/v1/self-service/branding/ios/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: iosBrandingConfiguration)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<IosBrandingConfiguration>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a Self Service iOS branding configuration with the supplied 
     
     - parameter iosBrandingConfiguration: (body) The iOS branding configuration to create (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SelfServiceBrandingIosPost(iosBrandingConfiguration: IosBrandingConfiguration? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SelfServiceBrandingIosPostWithRequestBuilder(iosBrandingConfiguration: iosBrandingConfiguration).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a Self Service iOS branding configuration with the supplied 
     - POST /v1/self-service/branding/ios
     - Create a Self Service iOS branding configuration with the supplied details
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter iosBrandingConfiguration: (body) The iOS branding configuration to create (optional)
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v1SelfServiceBrandingIosPostWithRequestBuilder(iosBrandingConfiguration: IosBrandingConfiguration? = nil) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v1/self-service/branding/ios"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: iosBrandingConfiguration)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
