//
// SelfServiceBrandingMacosAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class SelfServiceBrandingMacosAPI {

    /**
     Search for sorted and paged macOS branding configurations 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is id:asc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;id:desc,brandingName:asc  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SelfServiceBrandingMacosGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: MacOsBrandingSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SelfServiceBrandingMacosGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Search for sorted and paged macOS branding configurations 
     - GET /v1/self-service/branding/macos
     - Search for sorted and paged macOS branding configurations
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is id:asc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;id:desc,brandingName:asc  (optional)
     - returns: RequestBuilder<MacOsBrandingSearchResults> 
     */
    open class func v1SelfServiceBrandingMacosGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<MacOsBrandingSearchResults> {
        let localVariablePath = "/v1/self-service/branding/macos"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<MacOsBrandingSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete the Self Service macOS branding configuration indicated by the provided id 
     
     - parameter id: (path) id of macOS branding configuration 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SelfServiceBrandingMacosIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SelfServiceBrandingMacosIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete the Self Service macOS branding configuration indicated by the provided id 
     - DELETE /v1/self-service/branding/macos/{id}
     - Delete the Self Service macOS branding configuration indicated by the provided id.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of macOS branding configuration 
     - returns: RequestBuilder<Void> 
     */
    open class func v1SelfServiceBrandingMacosIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/self-service/branding/macos/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Read a single Self Service macOS branding configuration indicated by the provided id 
     
     - parameter id: (path) id of macOS branding configuration 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SelfServiceBrandingMacosIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: MacOsBrandingConfiguration?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SelfServiceBrandingMacosIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Read a single Self Service macOS branding configuration indicated by the provided id 
     - GET /v1/self-service/branding/macos/{id}
     - Read a single Self Service macOS branding configuration indicated by the provided id.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of macOS branding configuration 
     - returns: RequestBuilder<MacOsBrandingConfiguration> 
     */
    open class func v1SelfServiceBrandingMacosIdGetWithRequestBuilder(id: String) -> RequestBuilder<MacOsBrandingConfiguration> {
        var localVariablePath = "/v1/self-service/branding/macos/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<MacOsBrandingConfiguration>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a Self Service macOS branding configuration with the supplied details 
     
     - parameter id: (path) id of macOS branding configuration 
     - parameter macOsBrandingConfiguration: (body) The macOS branding configuration values to update (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SelfServiceBrandingMacosIdPut(id: String, macOsBrandingConfiguration: MacOsBrandingConfiguration? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: MacOsBrandingConfiguration?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SelfServiceBrandingMacosIdPutWithRequestBuilder(id: id, macOsBrandingConfiguration: macOsBrandingConfiguration).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a Self Service macOS branding configuration with the supplied details 
     - PUT /v1/self-service/branding/macos/{id}
     - Update a Self Service macOS branding configuration with the supplied details
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of macOS branding configuration 
     - parameter macOsBrandingConfiguration: (body) The macOS branding configuration values to update (optional)
     - returns: RequestBuilder<MacOsBrandingConfiguration> 
     */
    open class func v1SelfServiceBrandingMacosIdPutWithRequestBuilder(id: String, macOsBrandingConfiguration: MacOsBrandingConfiguration? = nil) -> RequestBuilder<MacOsBrandingConfiguration> {
        var localVariablePath = "/v1/self-service/branding/macos/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: macOsBrandingConfiguration)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<MacOsBrandingConfiguration>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a Self Service macOS branding configuration with the supplied 
     
     - parameter macOsBrandingConfiguration: (body) The macOS branding configuration to create (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SelfServiceBrandingMacosPost(macOsBrandingConfiguration: MacOsBrandingConfiguration? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SelfServiceBrandingMacosPostWithRequestBuilder(macOsBrandingConfiguration: macOsBrandingConfiguration).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a Self Service macOS branding configuration with the supplied 
     - POST /v1/self-service/branding/macos
     - Create a Self Service macOS branding configuration with the supplied details
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter macOsBrandingConfiguration: (body) The macOS branding configuration to create (optional)
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v1SelfServiceBrandingMacosPostWithRequestBuilder(macOsBrandingConfiguration: MacOsBrandingConfiguration? = nil) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v1/self-service/branding/macos"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: macOsBrandingConfiguration)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
