//
// SelfServiceBrandingPreviewAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class SelfServiceBrandingPreviewAPI {

    /**
     Upload an image 
     
     - parameter file: (form) The file to upload 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func selfServiceBrandingImagesPost(file: URL, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: BrandingImageUrl?, _ error: Error?) -> Void)) -> RequestTask {
        return selfServiceBrandingImagesPostWithRequestBuilder(file: file).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Upload an image 
     - POST /self-service/branding/images
     - Uploads an image
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter file: (form) The file to upload 
     - returns: RequestBuilder<BrandingImageUrl> 
     */
    open class func selfServiceBrandingImagesPostWithRequestBuilder(file: URL) -> RequestBuilder<BrandingImageUrl> {
        let localVariablePath = "/self-service/branding/images"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableFormParams: [String: Any?] = [
            "file": file.encodeToJSON(),
        ]

        let localVariableNonNullParameters = APIHelper.rejectNil(localVariableFormParams)
        let localVariableParameters = APIHelper.convertBoolToString(localVariableNonNullParameters)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            "Content-Type": "multipart/form-data",
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<BrandingImageUrl>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
