//
// SmartUserGroupsPreviewAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class SmartUserGroupsPreviewAPI {

    /**
     Recalculate the smart group for the given id and then return the ids for the users in the smart group 
     
     - parameter id: (path) instance id of smart group 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SmartUserGroupsIdRecalculatePost(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: RecalculationResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SmartUserGroupsIdRecalculatePostWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Recalculate the smart group for the given id and then return the ids for the users in the smart group 
     - POST /v1/smart-user-groups/{id}/recalculate
     - Recalculates the smart group for the given id and then returns the ids for the users in the smart group 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) instance id of smart group 
     - returns: RequestBuilder<RecalculationResults> 
     */
    open class func v1SmartUserGroupsIdRecalculatePostWithRequestBuilder(id: Int) -> RequestBuilder<RecalculationResults> {
        var localVariablePath = "/v1/smart-user-groups/{id}/recalculate"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<RecalculationResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Recalculate a smart group for the given user id and then return the count of smart groups the user falls into 
     
     - parameter id: (path) id of user 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1UsersIdRecalculateSmartGroupsPost(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: RecalculationResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1UsersIdRecalculateSmartGroupsPostWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Recalculate a smart group for the given user id and then return the count of smart groups the user falls into 
     - POST /v1/users/{id}/recalculate-smart-groups
     - Recalculates a smart group for the given user id and then returns the count of smart groups the user falls into 
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) id of user 
     - returns: RequestBuilder<RecalculationResults> 
     */
    open class func v1UsersIdRecalculateSmartGroupsPostWithRequestBuilder(id: Int) -> RequestBuilder<RecalculationResults> {
        var localVariablePath = "/v1/users/{id}/recalculate-smart-groups"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<RecalculationResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
