//
// SsoCertificatePreviewAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class SsoCertificatePreviewAPI {

    /**
     Delete the currently configured certificate used by SSO 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1SsoCertDelete(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SsoCertDeleteWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete the currently configured certificate used by SSO 
     - DELETE /v1/sso/cert
     - Deletes the currently configured certificate used by SSO.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<Void> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1SsoCertDeleteWithRequestBuilder() -> RequestBuilder<Void> {
        let localVariablePath = "/v1/sso/cert"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Download the certificate currently configured for use with Jamf Pro's SSO configuration 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1SsoCertDownloadGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: URL?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SsoCertDownloadGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Download the certificate currently configured for use with Jamf Pro's SSO configuration 
     - GET /v1/sso/cert/download
     - Downloads the certificate currently configured for use with Jamf Pro's SSO configuration
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<URL> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1SsoCertDownloadGetWithRequestBuilder() -> RequestBuilder<URL> {
        let localVariablePath = "/v1/sso/cert/download"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<URL>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve the certificate currently configured for use with SSO 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1SsoCertGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SsoKeystoreWithDetails?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SsoCertGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve the certificate currently configured for use with SSO 
     - GET /v1/sso/cert
     - Retrieves the certificate currently configured for use with SSO.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<SsoKeystoreWithDetails> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1SsoCertGetWithRequestBuilder() -> RequestBuilder<SsoKeystoreWithDetails> {
        let localVariablePath = "/v1/sso/cert"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SsoKeystoreWithDetails>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Parse the certificate to get details about certificate type and keys needed to upload certificate file 
     
     - parameter ssoKeystoreParse: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1SsoCertParsePost(ssoKeystoreParse: SsoKeystoreParse, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SsoKeystoreCertParseResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SsoCertParsePostWithRequestBuilder(ssoKeystoreParse: ssoKeystoreParse).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Parse the certificate to get details about certificate type and keys needed to upload certificate file 
     - POST /v1/sso/cert/parse
     - Parse the certificate to get details about certificate type and keys needed to upload certificate file.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter ssoKeystoreParse: (body)  
     - returns: RequestBuilder<SsoKeystoreCertParseResponse> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1SsoCertParsePostWithRequestBuilder(ssoKeystoreParse: SsoKeystoreParse) -> RequestBuilder<SsoKeystoreCertParseResponse> {
        let localVariablePath = "/v1/sso/cert/parse"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: ssoKeystoreParse)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SsoKeystoreCertParseResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Jamf Pro will generate a new certificate and use it to sign SSO 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1SsoCertPost(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SsoKeystoreWithDetails?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SsoCertPostWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Jamf Pro will generate a new certificate and use it to sign SSO 
     - POST /v1/sso/cert
     - Jamf Pro will generate a new certificate and use it to sign SSO requests to the identity provider.
     - Bearer Token:
       - type: http
       - name: Bearer
     - returns: RequestBuilder<SsoKeystoreWithDetails> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1SsoCertPostWithRequestBuilder() -> RequestBuilder<SsoKeystoreWithDetails> {
        let localVariablePath = "/v1/sso/cert"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SsoKeystoreWithDetails>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update the certificate used by Jamf Pro to sign SSO requests to the identify provider 
     
     - parameter ssoKeystore: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func v1SsoCertPut(ssoKeystore: SsoKeystore, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SsoKeystoreWithDetails?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SsoCertPutWithRequestBuilder(ssoKeystore: ssoKeystore).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update the certificate used by Jamf Pro to sign SSO requests to the identify provider 
     - PUT /v1/sso/cert
     - Update the certificate used by Jamf Pro to sign SSO requests to the identify provider.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter ssoKeystore: (body)  
     - returns: RequestBuilder<SsoKeystoreWithDetails> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func v1SsoCertPutWithRequestBuilder(ssoKeystore: SsoKeystore) -> RequestBuilder<SsoKeystoreWithDetails> {
        let localVariablePath = "/v1/sso/cert"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: ssoKeystore)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SsoKeystoreWithDetails>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
