//
// SupervisionIdentitiesPreviewAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class SupervisionIdentitiesPreviewAPI {

    /**
     Search for sorted and paged Supervision Identities 
     
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "id:asc")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SupervisionIdentitiesGet(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SupervisionIdentitySearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SupervisionIdentitiesGetWithRequestBuilder(page: page, size: size, pagesize: pagesize, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Search for sorted and paged Supervision Identities 
     - GET /v1/supervision-identities
     - Search for sorted and paged supervision identities
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter size: (query)  (optional, default to 100)
     - parameter pagesize: (query)  (optional, default to 100)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Multiple sort criteria are supported and must be separated with a comma. Example: sort&#x3D;date:desc,name:asc  (optional, default to "id:asc")
     - returns: RequestBuilder<SupervisionIdentitySearchResults> 
     */
    open class func v1SupervisionIdentitiesGetWithRequestBuilder(page: Int? = nil, size: Int? = nil, pagesize: Int? = nil, pageSize: Int? = nil, sort: String? = nil) -> RequestBuilder<SupervisionIdentitySearchResults> {
        let localVariablePath = "/v1/supervision-identities"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "size": (wrappedValue: size?.encodeToJSON(), isExplode: true),
            "pagesize": (wrappedValue: pagesize?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SupervisionIdentitySearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete a Supervision Identity with the supplied id 
     
     - parameter id: (path) Supervision Identity identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SupervisionIdentitiesIdDelete(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SupervisionIdentitiesIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete a Supervision Identity with the supplied id 
     - DELETE /v1/supervision-identities/{id}
     - Deletes a Supervision Identity with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Supervision Identity identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v1SupervisionIdentitiesIdDeleteWithRequestBuilder(id: Int) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/supervision-identities/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Download the Supervision Identity .p12 file 
     
     - parameter id: (path) Supervision Identity identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SupervisionIdentitiesIdDownloadGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: URL?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SupervisionIdentitiesIdDownloadGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Download the Supervision Identity .p12 file 
     - GET /v1/supervision-identities/{id}/download
     - Download the Supervision Identity .p12 file
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Supervision Identity identifier 
     - returns: RequestBuilder<URL> 
     */
    open class func v1SupervisionIdentitiesIdDownloadGetWithRequestBuilder(id: Int) -> RequestBuilder<URL> {
        var localVariablePath = "/v1/supervision-identities/{id}/download"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<URL>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve a Supervision Identity with the supplied id 
     
     - parameter id: (path) Supervision Identity identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SupervisionIdentitiesIdGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SupervisionIdentity?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SupervisionIdentitiesIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve a Supervision Identity with the supplied id 
     - GET /v1/supervision-identities/{id}
     - Retrieves a Supervision Identity with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Supervision Identity identifier 
     - returns: RequestBuilder<SupervisionIdentity> 
     */
    open class func v1SupervisionIdentitiesIdGetWithRequestBuilder(id: Int) -> RequestBuilder<SupervisionIdentity> {
        var localVariablePath = "/v1/supervision-identities/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SupervisionIdentity>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a Supervision Identity with the supplied information 
     
     - parameter id: (path) Supervision Identity identifier 
     - parameter supervisionIdentityUpdate: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SupervisionIdentitiesIdPut(id: Int, supervisionIdentityUpdate: SupervisionIdentityUpdate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SupervisionIdentity?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SupervisionIdentitiesIdPutWithRequestBuilder(id: id, supervisionIdentityUpdate: supervisionIdentityUpdate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a Supervision Identity with the supplied information 
     - PUT /v1/supervision-identities/{id}
     - Updates a Supervision Identity with the supplied information
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Supervision Identity identifier 
     - parameter supervisionIdentityUpdate: (body)  
     - returns: RequestBuilder<SupervisionIdentity> 
     */
    open class func v1SupervisionIdentitiesIdPutWithRequestBuilder(id: Int, supervisionIdentityUpdate: SupervisionIdentityUpdate) -> RequestBuilder<SupervisionIdentity> {
        var localVariablePath = "/v1/supervision-identities/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: supervisionIdentityUpdate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SupervisionIdentity>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a Supervision Identity for the supplied information 
     
     - parameter supervisionIdentityCreate: (body)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SupervisionIdentitiesPost(supervisionIdentityCreate: SupervisionIdentityCreate, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SupervisionIdentity?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SupervisionIdentitiesPostWithRequestBuilder(supervisionIdentityCreate: supervisionIdentityCreate).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a Supervision Identity for the supplied information 
     - POST /v1/supervision-identities
     - Creates a Supervision Identity for the supplied information
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter supervisionIdentityCreate: (body)  
     - returns: RequestBuilder<SupervisionIdentity> 
     */
    open class func v1SupervisionIdentitiesPostWithRequestBuilder(supervisionIdentityCreate: SupervisionIdentityCreate) -> RequestBuilder<SupervisionIdentity> {
        let localVariablePath = "/v1/supervision-identities"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: supervisionIdentityCreate)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SupervisionIdentity>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Upload the Supervision Identity .p12 file 
     
     - parameter supervisionIdentityCertificateUpload: (body) The base 64 encoded .p12 file alone with other needed information 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1SupervisionIdentitiesUploadPost(supervisionIdentityCertificateUpload: SupervisionIdentityCertificateUpload, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SupervisionIdentity?, _ error: Error?) -> Void)) -> RequestTask {
        return v1SupervisionIdentitiesUploadPostWithRequestBuilder(supervisionIdentityCertificateUpload: supervisionIdentityCertificateUpload).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Upload the Supervision Identity .p12 file 
     - POST /v1/supervision-identities/upload
     - Uploads the Supervision Identity .p12 file
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter supervisionIdentityCertificateUpload: (body) The base 64 encoded .p12 file alone with other needed information 
     - returns: RequestBuilder<SupervisionIdentity> 
     */
    open class func v1SupervisionIdentitiesUploadPostWithRequestBuilder(supervisionIdentityCertificateUpload: SupervisionIdentityCertificateUpload) -> RequestBuilder<SupervisionIdentity> {
        let localVariablePath = "/v1/supervision-identities/upload"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: supervisionIdentityCertificateUpload)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SupervisionIdentity>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
