//
// TeamViewerRemoteAdministrationAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class TeamViewerRemoteAdministrationAPI {

    /**
     Get a paginated list of sessions 
     
     - parameter configurationId: (path) ID of the Team Viewer connection configuration 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter filter: (query) Query in the RSQL format, allowing to filter sessions collection. Default filter is empty query - returning all results for the requested page.  Fields allowed in the query: &#x60;deviceId&#x60;, &#x60;deviceType&#x60;, &#x60;state&#x60;  This param can be combined with paging.  (optional, default to "")
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsGet(configurationId: String, page: Int? = nil, pageSize: Int? = nil, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SessionDetailsSearchResults?, _ error: Error?) -> Void)) -> RequestTask {
        return previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsGetWithRequestBuilder(configurationId: configurationId, page: page, pageSize: pageSize, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get a paginated list of sessions 
     - GET /preview/remote-administration-configurations/team-viewer/{configurationId}/sessions
     - Returns a paginated list of sessions for a given configuration ID
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter configurationId: (path) ID of the Team Viewer connection configuration 
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter filter: (query) Query in the RSQL format, allowing to filter sessions collection. Default filter is empty query - returning all results for the requested page.  Fields allowed in the query: &#x60;deviceId&#x60;, &#x60;deviceType&#x60;, &#x60;state&#x60;  This param can be combined with paging.  (optional, default to "")
     - returns: RequestBuilder<SessionDetailsSearchResults> 
     */
    open class func previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsGetWithRequestBuilder(configurationId: String, page: Int? = nil, pageSize: Int? = nil, filter: String? = nil) -> RequestBuilder<SessionDetailsSearchResults> {
        var localVariablePath = "/preview/remote-administration-configurations/team-viewer/{configurationId}/sessions"
        let configurationIdPreEscape = "\(APIHelper.mapValueToPathItem(configurationId))"
        let configurationIdPostEscape = configurationIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{configurationId}", with: configurationIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "filter": (wrappedValue: filter?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SessionDetailsSearchResults>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a new session
     
     - parameter configurationId: (path) ID of the Team Viewer connection configuration 
     - parameter sessionCandidateRequest: (body) Team Viewer session attributes 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsPost(configurationId: String, sessionCandidateRequest: SessionCandidateRequest, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsPostWithRequestBuilder(configurationId: configurationId, sessionCandidateRequest: sessionCandidateRequest).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a new session
     - POST /preview/remote-administration-configurations/team-viewer/{configurationId}/sessions
     - Creates a new Team Viewer session to be used to establish a remote connection
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter configurationId: (path) ID of the Team Viewer connection configuration 
     - parameter sessionCandidateRequest: (body) Team Viewer session attributes 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsPostWithRequestBuilder(configurationId: String, sessionCandidateRequest: SessionCandidateRequest) -> RequestBuilder<HrefResponse> {
        var localVariablePath = "/preview/remote-administration-configurations/team-viewer/{configurationId}/sessions"
        let configurationIdPreEscape = "\(APIHelper.mapValueToPathItem(configurationId))"
        let configurationIdPostEscape = configurationIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{configurationId}", with: configurationIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: sessionCandidateRequest)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Close a session
     
     - parameter configurationId: (path) ID of the Team Viewer connection configuration 
     - parameter sessionId: (path) ID of the Team Viewer session 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdClosePost(configurationId: String, sessionId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdClosePostWithRequestBuilder(configurationId: configurationId, sessionId: sessionId).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Close a session
     - POST /preview/remote-administration-configurations/team-viewer/{configurationId}/sessions/{sessionId}/close
     - Changes the session state from open to close. Closing a session means it is not possible to establish new remote connection between devices
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter configurationId: (path) ID of the Team Viewer connection configuration 
     - parameter sessionId: (path) ID of the Team Viewer session 
     - returns: RequestBuilder<Void> 
     */
    open class func previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdClosePostWithRequestBuilder(configurationId: String, sessionId: String) -> RequestBuilder<Void> {
        var localVariablePath = "/preview/remote-administration-configurations/team-viewer/{configurationId}/sessions/{sessionId}/close"
        let configurationIdPreEscape = "\(APIHelper.mapValueToPathItem(configurationId))"
        let configurationIdPostEscape = configurationIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{configurationId}", with: configurationIdPostEscape, options: .literal, range: nil)
        let sessionIdPreEscape = "\(APIHelper.mapValueToPathItem(sessionId))"
        let sessionIdPostEscape = sessionIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{sessionId}", with: sessionIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get a session by its ID 
     
     - parameter configurationId: (path) ID of the Team Viewer connection configuration 
     - parameter sessionId: (path) ID of the Team Viewer session 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdGet(configurationId: String, sessionId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SessionDetails?, _ error: Error?) -> Void)) -> RequestTask {
        return previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdGetWithRequestBuilder(configurationId: configurationId, sessionId: sessionId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get a session by its ID 
     - GET /preview/remote-administration-configurations/team-viewer/{configurationId}/sessions/{sessionId}
     - Returns a session details if found.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter configurationId: (path) ID of the Team Viewer connection configuration 
     - parameter sessionId: (path) ID of the Team Viewer session 
     - returns: RequestBuilder<SessionDetails> 
     */
    open class func previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdGetWithRequestBuilder(configurationId: String, sessionId: String) -> RequestBuilder<SessionDetails> {
        var localVariablePath = "/preview/remote-administration-configurations/team-viewer/{configurationId}/sessions/{sessionId}"
        let configurationIdPreEscape = "\(APIHelper.mapValueToPathItem(configurationId))"
        let configurationIdPostEscape = configurationIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{configurationId}", with: configurationIdPostEscape, options: .literal, range: nil)
        let sessionIdPreEscape = "\(APIHelper.mapValueToPathItem(sessionId))"
        let sessionIdPostEscape = sessionIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{sessionId}", with: sessionIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SessionDetails>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Resend nofications for a session
     
     - parameter configurationId: (path) ID of the Team Viewer connection configuration 
     - parameter sessionId: (path) ID of the Team Viewer session 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdResendNotificationPost(configurationId: String, sessionId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdResendNotificationPostWithRequestBuilder(configurationId: configurationId, sessionId: sessionId).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Resend nofications for a session
     - POST /preview/remote-administration-configurations/team-viewer/{configurationId}/sessions/{sessionId}/resend-notification
     - Resends configured notifications (e.g. Self Service push notifications).
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter configurationId: (path) ID of the Team Viewer connection configuration 
     - parameter sessionId: (path) ID of the Team Viewer session 
     - returns: RequestBuilder<Void> 
     */
    open class func previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdResendNotificationPostWithRequestBuilder(configurationId: String, sessionId: String) -> RequestBuilder<Void> {
        var localVariablePath = "/preview/remote-administration-configurations/team-viewer/{configurationId}/sessions/{sessionId}/resend-notification"
        let configurationIdPreEscape = "\(APIHelper.mapValueToPathItem(configurationId))"
        let configurationIdPostEscape = configurationIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{configurationId}", with: configurationIdPostEscape, options: .literal, range: nil)
        let sessionIdPreEscape = "\(APIHelper.mapValueToPathItem(sessionId))"
        let sessionIdPostEscape = sessionIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{sessionId}", with: sessionIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get a session status by its ID 
     
     - parameter configurationId: (path) ID of the Team Viewer connection configuration 
     - parameter sessionId: (path) ID of the Team Viewer session 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdStatusGet(configurationId: String, sessionId: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: SessionStatus?, _ error: Error?) -> Void)) -> RequestTask {
        return previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdStatusGetWithRequestBuilder(configurationId: configurationId, sessionId: sessionId).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get a session status by its ID 
     - GET /preview/remote-administration-configurations/team-viewer/{configurationId}/sessions/{sessionId}/status
     - Returns a session status if found.
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter configurationId: (path) ID of the Team Viewer connection configuration 
     - parameter sessionId: (path) ID of the Team Viewer session 
     - returns: RequestBuilder<SessionStatus> 
     */
    open class func previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdStatusGetWithRequestBuilder(configurationId: String, sessionId: String) -> RequestBuilder<SessionStatus> {
        var localVariablePath = "/preview/remote-administration-configurations/team-viewer/{configurationId}/sessions/{sessionId}/status"
        let configurationIdPreEscape = "\(APIHelper.mapValueToPathItem(configurationId))"
        let configurationIdPostEscape = configurationIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{configurationId}", with: configurationIdPostEscape, options: .literal, range: nil)
        let sessionIdPreEscape = "\(APIHelper.mapValueToPathItem(sessionId))"
        let sessionIdPostEscape = sessionIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{sessionId}", with: sessionIdPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<SessionStatus>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete Team Viewer Remote Administration connection configuration
     
     - parameter id: (path) ID of the Team Viewer connection configuration 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func previewRemoteAdministrationConfigurationsTeamViewerIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return previewRemoteAdministrationConfigurationsTeamViewerIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete Team Viewer Remote Administration connection configuration
     - DELETE /preview/remote-administration-configurations/team-viewer/{id}
     - Deletes Team Viewer Remote Administration connection configuration
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) ID of the Team Viewer connection configuration 
     - returns: RequestBuilder<Void> 
     */
    open class func previewRemoteAdministrationConfigurationsTeamViewerIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/preview/remote-administration-configurations/team-viewer/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Team Viewer Remote Administration connection configuration
     
     - parameter id: (path) ID of the Team Viewer connection configuration 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func previewRemoteAdministrationConfigurationsTeamViewerIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ConnectionConfigurationResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return previewRemoteAdministrationConfigurationsTeamViewerIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Team Viewer Remote Administration connection configuration
     - GET /preview/remote-administration-configurations/team-viewer/{id}
     - Returns Team Viewer Remote Administration connection configuration
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) ID of the Team Viewer connection configuration 
     - returns: RequestBuilder<ConnectionConfigurationResponse> 
     */
    open class func previewRemoteAdministrationConfigurationsTeamViewerIdGetWithRequestBuilder(id: String) -> RequestBuilder<ConnectionConfigurationResponse> {
        var localVariablePath = "/preview/remote-administration-configurations/team-viewer/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ConnectionConfigurationResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update Team Viewer Remote Administration connection configuration
     
     - parameter id: (path) ID of the Team Viewer connection configuration 
     - parameter connectionConfigurationUpdateRequest: (body) Team Viewer connection configuration update request 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func previewRemoteAdministrationConfigurationsTeamViewerIdPatch(id: String, connectionConfigurationUpdateRequest: ConnectionConfigurationUpdateRequest, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ConnectionConfigurationResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return previewRemoteAdministrationConfigurationsTeamViewerIdPatchWithRequestBuilder(id: id, connectionConfigurationUpdateRequest: connectionConfigurationUpdateRequest).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update Team Viewer Remote Administration connection configuration
     - PATCH /preview/remote-administration-configurations/team-viewer/{id}
     - Updates Team Viewer Remote Administration connection configuration
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) ID of the Team Viewer connection configuration 
     - parameter connectionConfigurationUpdateRequest: (body) Team Viewer connection configuration update request 
     - returns: RequestBuilder<ConnectionConfigurationResponse> 
     */
    open class func previewRemoteAdministrationConfigurationsTeamViewerIdPatchWithRequestBuilder(id: String, connectionConfigurationUpdateRequest: ConnectionConfigurationUpdateRequest) -> RequestBuilder<ConnectionConfigurationResponse> {
        var localVariablePath = "/preview/remote-administration-configurations/team-viewer/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: connectionConfigurationUpdateRequest)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ConnectionConfigurationResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PATCH", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Team Viewer Remote Administration connection status
     
     - parameter id: (path) ID of the Team Viewer connection configuration 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func previewRemoteAdministrationConfigurationsTeamViewerIdStatusGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: ConnectionConfigurationStatusResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return previewRemoteAdministrationConfigurationsTeamViewerIdStatusGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Team Viewer Remote Administration connection status
     - GET /preview/remote-administration-configurations/team-viewer/{id}/status
     - Returns Team Viewer Remote Administration connection status
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) ID of the Team Viewer connection configuration 
     - returns: RequestBuilder<ConnectionConfigurationStatusResponse> 
     */
    open class func previewRemoteAdministrationConfigurationsTeamViewerIdStatusGetWithRequestBuilder(id: String) -> RequestBuilder<ConnectionConfigurationStatusResponse> {
        var localVariablePath = "/preview/remote-administration-configurations/team-viewer/{id}/status"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<ConnectionConfigurationStatusResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create Team Viewer Remote Administration connection configuration
     
     - parameter connectionConfigurationCandidateRequest: (body) Team Viewer connection configuration create definition 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func previewRemoteAdministrationConfigurationsTeamViewerPost(connectionConfigurationCandidateRequest: ConnectionConfigurationCandidateRequest, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return previewRemoteAdministrationConfigurationsTeamViewerPostWithRequestBuilder(connectionConfigurationCandidateRequest: connectionConfigurationCandidateRequest).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create Team Viewer Remote Administration connection configuration
     - POST /preview/remote-administration-configurations/team-viewer
     - Creates Team Viewer Remote Administration connection configuration
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter connectionConfigurationCandidateRequest: (body) Team Viewer connection configuration create definition 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func previewRemoteAdministrationConfigurationsTeamViewerPostWithRequestBuilder(connectionConfigurationCandidateRequest: ConnectionConfigurationCandidateRequest) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/preview/remote-administration-configurations/team-viewer"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: connectionConfigurationCandidateRequest)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
