//
// VolumePurchasingSubscriptionsAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class VolumePurchasingSubscriptionsAPI {

    /**
     Retrieve Volume Purchasing Subscriptions
     
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is id:asc. Multiple sort criteria are supported and must be separated with a comma. Allowable properties are id, name, and enabled. (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1VolumePurchasingSubscriptionsGet(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: VolumePurchasingSubscriptions?, _ error: Error?) -> Void)) -> RequestTask {
        return v1VolumePurchasingSubscriptionsGetWithRequestBuilder(page: page, pageSize: pageSize, sort: sort).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve Volume Purchasing Subscriptions
     - GET /v1/volume-purchasing-subscriptions
     - Retrieves Volume Purchasing Subscriptions
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter page: (query)  (optional, default to 0)
     - parameter pageSize: (query)  (optional, default to 100)
     - parameter sort: (query) Sorting criteria in the format: property:asc/desc. Default sort is id:asc. Multiple sort criteria are supported and must be separated with a comma. Allowable properties are id, name, and enabled. (optional)
     - returns: RequestBuilder<VolumePurchasingSubscriptions> 
     */
    open class func v1VolumePurchasingSubscriptionsGetWithRequestBuilder(page: Int? = nil, pageSize: Int? = nil, sort: [String]? = nil) -> RequestBuilder<VolumePurchasingSubscriptions> {
        let localVariablePath = "/v1/volume-purchasing-subscriptions"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "page": (wrappedValue: page?.encodeToJSON(), isExplode: true),
            "page-size": (wrappedValue: pageSize?.encodeToJSON(), isExplode: true),
            "sort": (wrappedValue: sort?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<VolumePurchasingSubscriptions>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Delete a Volume Purchasing Subscription with the supplied id
     
     - parameter id: (path) Volume Purchasing Subscription identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1VolumePurchasingSubscriptionsIdDelete(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return v1VolumePurchasingSubscriptionsIdDeleteWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Delete a Volume Purchasing Subscription with the supplied id
     - DELETE /v1/volume-purchasing-subscriptions/{id}
     - Deletes a Volume Purchasing Subscription with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Volume Purchasing Subscription identifier 
     - returns: RequestBuilder<Void> 
     */
    open class func v1VolumePurchasingSubscriptionsIdDeleteWithRequestBuilder(id: String) -> RequestBuilder<Void> {
        var localVariablePath = "/v1/volume-purchasing-subscriptions/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "DELETE", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Retrieve a Volume Purchasing Subscription with the supplied id
     
     - parameter id: (path) Volume Purchasing Subscription identifier 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1VolumePurchasingSubscriptionsIdGet(id: String, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: VolumePurchasingSubscription?, _ error: Error?) -> Void)) -> RequestTask {
        return v1VolumePurchasingSubscriptionsIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Retrieve a Volume Purchasing Subscription with the supplied id
     - GET /v1/volume-purchasing-subscriptions/{id}
     - Retrieves a Volume Purchasing Subscription with the supplied id
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Volume Purchasing Subscription identifier 
     - returns: RequestBuilder<VolumePurchasingSubscription> 
     */
    open class func v1VolumePurchasingSubscriptionsIdGetWithRequestBuilder(id: String) -> RequestBuilder<VolumePurchasingSubscription> {
        var localVariablePath = "/v1/volume-purchasing-subscriptions/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<VolumePurchasingSubscription>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Update a Volume Purchasing Subscription
     
     - parameter id: (path) Volume Purchasing Subscription identifier 
     - parameter volumePurchasingSubscriptionBase: (body) Volume Purchasing Subscription to update 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1VolumePurchasingSubscriptionsIdPut(id: String, volumePurchasingSubscriptionBase: VolumePurchasingSubscriptionBase, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: VolumePurchasingSubscription?, _ error: Error?) -> Void)) -> RequestTask {
        return v1VolumePurchasingSubscriptionsIdPutWithRequestBuilder(id: id, volumePurchasingSubscriptionBase: volumePurchasingSubscriptionBase).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Update a Volume Purchasing Subscription
     - PUT /v1/volume-purchasing-subscriptions/{id}
     - Updates a Volume Purchasing Subscription
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter id: (path) Volume Purchasing Subscription identifier 
     - parameter volumePurchasingSubscriptionBase: (body) Volume Purchasing Subscription to update 
     - returns: RequestBuilder<VolumePurchasingSubscription> 
     */
    open class func v1VolumePurchasingSubscriptionsIdPutWithRequestBuilder(id: String, volumePurchasingSubscriptionBase: VolumePurchasingSubscriptionBase) -> RequestBuilder<VolumePurchasingSubscription> {
        var localVariablePath = "/v1/volume-purchasing-subscriptions/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: volumePurchasingSubscriptionBase)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<VolumePurchasingSubscription>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "PUT", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Create a Volume Purchasing Subscription
     
     - parameter volumePurchasingSubscriptionBase: (body) Volume Purchasing Subscription to create 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func v1VolumePurchasingSubscriptionsPost(volumePurchasingSubscriptionBase: VolumePurchasingSubscriptionBase, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: HrefResponse?, _ error: Error?) -> Void)) -> RequestTask {
        return v1VolumePurchasingSubscriptionsPostWithRequestBuilder(volumePurchasingSubscriptionBase: volumePurchasingSubscriptionBase).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Create a Volume Purchasing Subscription
     - POST /v1/volume-purchasing-subscriptions
     - Creates a Volume Purchasing Subscription
     - Bearer Token:
       - type: http
       - name: Bearer
     - parameter volumePurchasingSubscriptionBase: (body) Volume Purchasing Subscription to create 
     - returns: RequestBuilder<HrefResponse> 
     */
    open class func v1VolumePurchasingSubscriptionsPostWithRequestBuilder(volumePurchasingSubscriptionBase: VolumePurchasingSubscriptionBase) -> RequestBuilder<HrefResponse> {
        let localVariablePath = "/v1/volume-purchasing-subscriptions"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters = JSONEncodingHelper.encodingParameters(forEncodableObject: volumePurchasingSubscriptionBase)

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<HrefResponse>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "POST", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
