//
// VppSubscriptionsPreviewAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class VppSubscriptionsPreviewAPI {

    /**
     Found all VPP - subscriptions 
     
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func vppSubscriptionsGet(apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [VppTokenSubscription]?, _ error: Error?) -> Void)) -> RequestTask {
        return vppSubscriptionsGetWithRequestBuilder().execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Found all VPP - subscriptions 
     - GET /vpp/subscriptions
     - Found all vpp - subscriptions. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - responseHeaders: [Deprecation(String)]
     - returns: RequestBuilder<[VppTokenSubscription]> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func vppSubscriptionsGetWithRequestBuilder() -> RequestBuilder<[VppTokenSubscription]> {
        let localVariablePath = "/vpp/subscriptions"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[VppTokenSubscription]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Found VPP subscription by id 
     
     - parameter id: (path) id of vpp subscription to be retrieved 
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    @discardableResult
    open class func vppSubscriptionsIdGet(id: Int, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: VppTokenSubscription?, _ error: Error?) -> Void)) -> RequestTask {
        return vppSubscriptionsIdGetWithRequestBuilder(id: id).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Found VPP subscription by id 
     - GET /vpp/subscriptions/{id}
     - Found vpp subscription by id. 
     - Bearer Token:
       - type: http
       - name: Bearer
     - responseHeaders: [Deprecation(String)]
     - parameter id: (path) id of vpp subscription to be retrieved 
     - returns: RequestBuilder<VppTokenSubscription> 
     */
    @available(*, deprecated, message: "This operation is deprecated.")
    open class func vppSubscriptionsIdGetWithRequestBuilder(id: Int) -> RequestBuilder<VppTokenSubscription> {
        var localVariablePath = "/vpp/subscriptions/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<VppTokenSubscription>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
