//
// AccountGroup.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct AccountGroup: Codable, JSONEncodable, Hashable {

    public enum AccessLevel: String, Codable, CaseIterable {
        case fullAccess = "FullAccess"
        case siteAccess = "SiteAccess"
        case groupBasedAccess = "GroupBasedAccess"
    }
    public enum PrivilegeSet: String, Codable, CaseIterable {
        case administrator = "ADMINISTRATOR"
        case auditor = "AUDITOR"
        case enrollment = "ENROLLMENT"
        case custom = "CUSTOM"
    }
    public var accessLevel: AccessLevel?
    public var privilegeSet: PrivilegeSet?
    public var siteId: Int?
    public var privileges: [String]?
    public var memberUserIds: [Int]?

    public init(accessLevel: AccessLevel? = nil, privilegeSet: PrivilegeSet? = nil, siteId: Int? = nil, privileges: [String]? = nil, memberUserIds: [Int]? = nil) {
        self.accessLevel = accessLevel
        self.privilegeSet = privilegeSet
        self.siteId = siteId
        self.privileges = privileges
        self.memberUserIds = memberUserIds
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case accessLevel
        case privilegeSet
        case siteId
        case privileges
        case memberUserIds
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(accessLevel, forKey: .accessLevel)
        try container.encodeIfPresent(privilegeSet, forKey: .privilegeSet)
        try container.encodeIfPresent(siteId, forKey: .siteId)
        try container.encodeIfPresent(privileges, forKey: .privileges)
        try container.encodeIfPresent(memberUserIds, forKey: .memberUserIds)
    }
}

