//
// AccountSettingsResponse.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct AccountSettingsResponse: Codable, JSONEncodable, Hashable {

    public enum UserAccountType: String, Codable, CaseIterable {
        case administrator = "ADMINISTRATOR"
        case standard = "STANDARD"
        case skip = "SKIP"
    }
    static let adminUsernameRule = StringRule(minLength: 0, maxLength: nil, pattern: nil)
    static let versionLockRule = NumericRule<Int>(minimum: 0, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    static let prefillAccountFullNameRule = StringRule(minLength: 0, maxLength: nil, pattern: nil)
    static let prefillAccountUserNameRule = StringRule(minLength: 0, maxLength: nil, pattern: nil)
    /** id of Account Settings */
    public var id: String?
    public var payloadConfigured: Bool? = false
    public var localAdminAccountEnabled: Bool? = false
    public var adminUsername: String? = ""
    public var hiddenAdminAccount: Bool? = false
    public var localUserManaged: Bool? = false
    public var userAccountType: UserAccountType? = .standard
    public var versionLock: Int? = 0
    public var prefillPrimaryAccountInfoFeatureEnabled: Bool? = false
    /** Values accepted are only CUSTOM and DEVICE_OWNER */
    public var prefillType: String? = "CUSTOM"
    public var prefillAccountFullName: String? = ""
    public var prefillAccountUserName: String? = ""
    public var preventPrefillInfoFromModification: Bool? = false

    public init(id: String? = nil, payloadConfigured: Bool? = false, localAdminAccountEnabled: Bool? = false, adminUsername: String? = "", hiddenAdminAccount: Bool? = false, localUserManaged: Bool? = false, userAccountType: UserAccountType? = .standard, versionLock: Int? = 0, prefillPrimaryAccountInfoFeatureEnabled: Bool? = false, prefillType: String? = "CUSTOM", prefillAccountFullName: String? = "", prefillAccountUserName: String? = "", preventPrefillInfoFromModification: Bool? = false) {
        self.id = id
        self.payloadConfigured = payloadConfigured
        self.localAdminAccountEnabled = localAdminAccountEnabled
        self.adminUsername = adminUsername
        self.hiddenAdminAccount = hiddenAdminAccount
        self.localUserManaged = localUserManaged
        self.userAccountType = userAccountType
        self.versionLock = versionLock
        self.prefillPrimaryAccountInfoFeatureEnabled = prefillPrimaryAccountInfoFeatureEnabled
        self.prefillType = prefillType
        self.prefillAccountFullName = prefillAccountFullName
        self.prefillAccountUserName = prefillAccountUserName
        self.preventPrefillInfoFromModification = preventPrefillInfoFromModification
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case payloadConfigured
        case localAdminAccountEnabled
        case adminUsername
        case hiddenAdminAccount
        case localUserManaged
        case userAccountType
        case versionLock
        case prefillPrimaryAccountInfoFeatureEnabled
        case prefillType
        case prefillAccountFullName
        case prefillAccountUserName
        case preventPrefillInfoFromModification
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(payloadConfigured, forKey: .payloadConfigured)
        try container.encodeIfPresent(localAdminAccountEnabled, forKey: .localAdminAccountEnabled)
        try container.encodeIfPresent(adminUsername, forKey: .adminUsername)
        try container.encodeIfPresent(hiddenAdminAccount, forKey: .hiddenAdminAccount)
        try container.encodeIfPresent(localUserManaged, forKey: .localUserManaged)
        try container.encodeIfPresent(userAccountType, forKey: .userAccountType)
        try container.encodeIfPresent(versionLock, forKey: .versionLock)
        try container.encodeIfPresent(prefillPrimaryAccountInfoFeatureEnabled, forKey: .prefillPrimaryAccountInfoFeatureEnabled)
        try container.encodeIfPresent(prefillType, forKey: .prefillType)
        try container.encodeIfPresent(prefillAccountFullName, forKey: .prefillAccountFullName)
        try container.encodeIfPresent(prefillAccountUserName, forKey: .prefillAccountUserName)
        try container.encodeIfPresent(preventPrefillInfoFromModification, forKey: .preventPrefillInfoFromModification)
    }
}

