//
// ApiIntegrationResponse.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ApiIntegrationResponse: Codable, JSONEncodable, Hashable {

    public enum AppType: String, Codable, CaseIterable {
        case clientCredentials = "CLIENT_CREDENTIALS"
        case nativeAppOauth = "NATIVE_APP_OAUTH"
        case _none = "NONE"
    }
    public var id: Int
    public var authorizationScopes: [String]
    public var displayName: String
    public var enabled: Bool
    public var accessTokenLifetimeSeconds: Int?
    /** Type of API Client:     * `CLIENT_CREDENTIALS` - A client ID and secret have been generated for this integration.     * `NATIVE_APP_OAUTH` - A native app (i.e., Jamf Reset) has been linked to this integration for auth code grant type via Managed App Config.     * `NONE` - No client is currently associated with this integration.  */
    public var appType: AppType
    public var clientId: String

    public init(id: Int, authorizationScopes: [String], displayName: String, enabled: Bool, accessTokenLifetimeSeconds: Int? = nil, appType: AppType, clientId: String) {
        self.id = id
        self.authorizationScopes = authorizationScopes
        self.displayName = displayName
        self.enabled = enabled
        self.accessTokenLifetimeSeconds = accessTokenLifetimeSeconds
        self.appType = appType
        self.clientId = clientId
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case authorizationScopes
        case displayName
        case enabled
        case accessTokenLifetimeSeconds
        case appType
        case clientId
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(id, forKey: .id)
        try container.encode(authorizationScopes, forKey: .authorizationScopes)
        try container.encode(displayName, forKey: .displayName)
        try container.encode(enabled, forKey: .enabled)
        try container.encodeIfPresent(accessTokenLifetimeSeconds, forKey: .accessTokenLifetimeSeconds)
        try container.encode(appType, forKey: .appType)
        try container.encode(clientId, forKey: .clientId)
    }
}

