//
// AuthAccount.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct AuthAccount: Codable, JSONEncodable, Hashable {

    public enum AccessLevel: String, Codable, CaseIterable {
        case fullAccess = "FullAccess"
        case siteAccess = "SiteAccess"
        case groupBasedAccess = "GroupBasedAccess"
    }
    public enum PrivilegeSet: String, Codable, CaseIterable {
        case administrator = "ADMINISTRATOR"
        case auditor = "AUDITOR"
        case enrollment = "ENROLLMENT"
        case custom = "CUSTOM"
    }
    static let idRule = NumericRule<Int>(minimum: 1, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    public var id: Int?
    public var username: String?
    public var realName: String?
    public var email: String?
    public var preferences: AccountPreferences?
    public var isMultiSiteAdmin: Bool?
    public var accessLevel: AccessLevel?
    public var privilegeSet: PrivilegeSet?
    public var privilegesBySite: [String: [String]]?
    public var groupIds: [Int]?
    public var currentSiteId: Int?

    public init(id: Int? = nil, username: String? = nil, realName: String? = nil, email: String? = nil, preferences: AccountPreferences? = nil, isMultiSiteAdmin: Bool? = nil, accessLevel: AccessLevel? = nil, privilegeSet: PrivilegeSet? = nil, privilegesBySite: [String: [String]]? = nil, groupIds: [Int]? = nil, currentSiteId: Int? = nil) {
        self.id = id
        self.username = username
        self.realName = realName
        self.email = email
        self.preferences = preferences
        self.isMultiSiteAdmin = isMultiSiteAdmin
        self.accessLevel = accessLevel
        self.privilegeSet = privilegeSet
        self.privilegesBySite = privilegesBySite
        self.groupIds = groupIds
        self.currentSiteId = currentSiteId
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case username
        case realName
        case email
        case preferences
        case isMultiSiteAdmin
        case accessLevel
        case privilegeSet
        case privilegesBySite
        case groupIds
        case currentSiteId
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(username, forKey: .username)
        try container.encodeIfPresent(realName, forKey: .realName)
        try container.encodeIfPresent(email, forKey: .email)
        try container.encodeIfPresent(preferences, forKey: .preferences)
        try container.encodeIfPresent(isMultiSiteAdmin, forKey: .isMultiSiteAdmin)
        try container.encodeIfPresent(accessLevel, forKey: .accessLevel)
        try container.encodeIfPresent(privilegeSet, forKey: .privilegeSet)
        try container.encodeIfPresent(privilegesBySite, forKey: .privilegesBySite)
        try container.encodeIfPresent(groupIds, forKey: .groupIds)
        try container.encodeIfPresent(currentSiteId, forKey: .currentSiteId)
    }
}

