//
// AzureServerConfigurationRequest.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** Azure Cloud Identity Provider configuration request */
public struct AzureServerConfigurationRequest: Codable, JSONEncodable, Hashable {

    static let searchTimeoutRule = NumericRule<Int>(minimum: 5, exclusiveMinimum: false, maximum: 600, exclusiveMaximum: false, multipleOf: nil)
    public var id: String?
    public var tenantId: String
    public var enabled: Bool
    public var mappings: AzureMappings
    public var searchTimeout: Int
    /** Use this field to enable transitive membership lookup with Single Sign On */
    public var transitiveMembershipEnabled: Bool
    /** Use this field to set user field mapping for transitive membership lookup with Single Sign On */
    public var transitiveMembershipUserField: String
    /** Use this field to enable transitive membership lookup. This setting would not apply to Single Sign On */
    public var transitiveDirectoryMembershipEnabled: Bool
    /** Use this field to enable membership calculation optimization. This setting would not apply to Single Sign On */
    public var membershipCalculationOptimizationEnabled: Bool?
    public var code: String

    public init(id: String? = nil, tenantId: String, enabled: Bool, mappings: AzureMappings, searchTimeout: Int, transitiveMembershipEnabled: Bool, transitiveMembershipUserField: String, transitiveDirectoryMembershipEnabled: Bool, membershipCalculationOptimizationEnabled: Bool? = nil, code: String) {
        self.id = id
        self.tenantId = tenantId
        self.enabled = enabled
        self.mappings = mappings
        self.searchTimeout = searchTimeout
        self.transitiveMembershipEnabled = transitiveMembershipEnabled
        self.transitiveMembershipUserField = transitiveMembershipUserField
        self.transitiveDirectoryMembershipEnabled = transitiveDirectoryMembershipEnabled
        self.membershipCalculationOptimizationEnabled = membershipCalculationOptimizationEnabled
        self.code = code
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case tenantId
        case enabled
        case mappings
        case searchTimeout
        case transitiveMembershipEnabled
        case transitiveMembershipUserField
        case transitiveDirectoryMembershipEnabled
        case membershipCalculationOptimizationEnabled
        case code
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encode(tenantId, forKey: .tenantId)
        try container.encode(enabled, forKey: .enabled)
        try container.encode(mappings, forKey: .mappings)
        try container.encode(searchTimeout, forKey: .searchTimeout)
        try container.encode(transitiveMembershipEnabled, forKey: .transitiveMembershipEnabled)
        try container.encode(transitiveMembershipUserField, forKey: .transitiveMembershipUserField)
        try container.encode(transitiveDirectoryMembershipEnabled, forKey: .transitiveDirectoryMembershipEnabled)
        try container.encodeIfPresent(membershipCalculationOptimizationEnabled, forKey: .membershipCalculationOptimizationEnabled)
        try container.encode(code, forKey: .code)
    }
}

