//
// CacheSettings.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct CacheSettings: Codable, JSONEncodable, Hashable {

    static let idRule = StringRule(minLength: 1, maxLength: nil, pattern: nil)
    public var id: String? = "0"
    public var name: String? = "cache configuration"
    public var cacheType: String
    public var timeToLiveSeconds: Int
    public var timeToIdleSeconds: Int?
    public var directoryTimeToLiveSeconds: Int?
    public var ehcacheMaxBytesLocalHeap: String? = "null"
    /** The default is for Jamf Pro to generate a UUID, so we can only give an example instead. */
    public var cacheUniqueId: String
    public var elasticache: Bool? = false
    public var memcachedEndpoints: [MemcachedEndpoints]

    public init(id: String? = "0", name: String? = "cache configuration", cacheType: String, timeToLiveSeconds: Int, timeToIdleSeconds: Int? = nil, directoryTimeToLiveSeconds: Int? = nil, ehcacheMaxBytesLocalHeap: String? = "null", cacheUniqueId: String, elasticache: Bool? = false, memcachedEndpoints: [MemcachedEndpoints]) {
        self.id = id
        self.name = name
        self.cacheType = cacheType
        self.timeToLiveSeconds = timeToLiveSeconds
        self.timeToIdleSeconds = timeToIdleSeconds
        self.directoryTimeToLiveSeconds = directoryTimeToLiveSeconds
        self.ehcacheMaxBytesLocalHeap = ehcacheMaxBytesLocalHeap
        self.cacheUniqueId = cacheUniqueId
        self.elasticache = elasticache
        self.memcachedEndpoints = memcachedEndpoints
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case name
        case cacheType
        case timeToLiveSeconds
        case timeToIdleSeconds
        case directoryTimeToLiveSeconds
        case ehcacheMaxBytesLocalHeap
        case cacheUniqueId
        case elasticache
        case memcachedEndpoints
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(name, forKey: .name)
        try container.encode(cacheType, forKey: .cacheType)
        try container.encode(timeToLiveSeconds, forKey: .timeToLiveSeconds)
        try container.encodeIfPresent(timeToIdleSeconds, forKey: .timeToIdleSeconds)
        try container.encodeIfPresent(directoryTimeToLiveSeconds, forKey: .directoryTimeToLiveSeconds)
        try container.encodeIfPresent(ehcacheMaxBytesLocalHeap, forKey: .ehcacheMaxBytesLocalHeap)
        try container.encode(cacheUniqueId, forKey: .cacheUniqueId)
        try container.encodeIfPresent(elasticache, forKey: .elasticache)
        try container.encode(memcachedEndpoints, forKey: .memcachedEndpoints)
    }
}

