//
// CloudLdapServerResponse.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** A Cloud Identity Provider LDAP server configuration for responses */
public struct CloudLdapServerResponse: Codable, JSONEncodable, Hashable {

    public enum ConnectionType: String, Codable, CaseIterable {
        case ldaps = "LDAPS"
        case startTls = "START_TLS"
    }
    static let portRule = NumericRule<Int>(minimum: 1, exclusiveMinimum: false, maximum: 65535, exclusiveMaximum: false, multipleOf: nil)
    static let connectionTimeoutRule = NumericRule<Int>(minimum: 5, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    static let searchTimeoutRule = NumericRule<Int>(minimum: 5, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    public var id: String?
    public var enabled: Bool?
    public var serverUrl: String?
    public var domainName: String?
    public var port: Int?
    public var keystore: CloudLdapKeystore?
    public var connectionTimeout: Int?
    public var searchTimeout: Int?
    public var useWildcards: Bool?
    public var connectionType: ConnectionType?
    public var membershipCalculationOptimizationEnabled: Bool?

    public init(id: String? = nil, enabled: Bool? = nil, serverUrl: String? = nil, domainName: String? = nil, port: Int? = nil, keystore: CloudLdapKeystore? = nil, connectionTimeout: Int? = nil, searchTimeout: Int? = nil, useWildcards: Bool? = nil, connectionType: ConnectionType? = nil, membershipCalculationOptimizationEnabled: Bool? = nil) {
        self.id = id
        self.enabled = enabled
        self.serverUrl = serverUrl
        self.domainName = domainName
        self.port = port
        self.keystore = keystore
        self.connectionTimeout = connectionTimeout
        self.searchTimeout = searchTimeout
        self.useWildcards = useWildcards
        self.connectionType = connectionType
        self.membershipCalculationOptimizationEnabled = membershipCalculationOptimizationEnabled
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case enabled
        case serverUrl
        case domainName
        case port
        case keystore
        case connectionTimeout
        case searchTimeout
        case useWildcards
        case connectionType
        case membershipCalculationOptimizationEnabled
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(enabled, forKey: .enabled)
        try container.encodeIfPresent(serverUrl, forKey: .serverUrl)
        try container.encodeIfPresent(domainName, forKey: .domainName)
        try container.encodeIfPresent(port, forKey: .port)
        try container.encodeIfPresent(keystore, forKey: .keystore)
        try container.encodeIfPresent(connectionTimeout, forKey: .connectionTimeout)
        try container.encodeIfPresent(searchTimeout, forKey: .searchTimeout)
        try container.encodeIfPresent(useWildcards, forKey: .useWildcards)
        try container.encodeIfPresent(connectionType, forKey: .connectionType)
        try container.encodeIfPresent(membershipCalculationOptimizationEnabled, forKey: .membershipCalculationOptimizationEnabled)
    }
}

