//
// CloudLdapServerUpdate.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** A Cloud Identity Provider LDAP server configuration for updates */
public struct CloudLdapServerUpdate: Codable, JSONEncodable, Hashable {

    public enum ConnectionType: String, Codable, CaseIterable {
        case ldaps = "LDAPS"
        case startTls = "START_TLS"
    }
    static let portRule = NumericRule<Int>(minimum: 1, exclusiveMinimum: false, maximum: 65535, exclusiveMaximum: false, multipleOf: nil)
    static let connectionTimeoutRule = NumericRule<Int>(minimum: 1, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    static let searchTimeoutRule = NumericRule<Int>(minimum: 1, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    public var serverUrl: String
    public var enabled: Bool
    public var domainName: String
    public var port: Int
    public var keystore: CloudLdapKeystoreFile?
    public var connectionTimeout: Int
    public var searchTimeout: Int
    public var useWildcards: Bool
    public var connectionType: ConnectionType
    public var membershipCalculationOptimizationEnabled: Bool?

    public init(serverUrl: String, enabled: Bool, domainName: String, port: Int, keystore: CloudLdapKeystoreFile? = nil, connectionTimeout: Int, searchTimeout: Int, useWildcards: Bool, connectionType: ConnectionType, membershipCalculationOptimizationEnabled: Bool? = nil) {
        self.serverUrl = serverUrl
        self.enabled = enabled
        self.domainName = domainName
        self.port = port
        self.keystore = keystore
        self.connectionTimeout = connectionTimeout
        self.searchTimeout = searchTimeout
        self.useWildcards = useWildcards
        self.connectionType = connectionType
        self.membershipCalculationOptimizationEnabled = membershipCalculationOptimizationEnabled
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case serverUrl
        case enabled
        case domainName
        case port
        case keystore
        case connectionTimeout
        case searchTimeout
        case useWildcards
        case connectionType
        case membershipCalculationOptimizationEnabled
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(serverUrl, forKey: .serverUrl)
        try container.encode(enabled, forKey: .enabled)
        try container.encode(domainName, forKey: .domainName)
        try container.encode(port, forKey: .port)
        try container.encodeIfPresent(keystore, forKey: .keystore)
        try container.encode(connectionTimeout, forKey: .connectionTimeout)
        try container.encode(searchTimeout, forKey: .searchTimeout)
        try container.encode(useWildcards, forKey: .useWildcards)
        try container.encode(connectionType, forKey: .connectionType)
        try container.encodeIfPresent(membershipCalculationOptimizationEnabled, forKey: .membershipCalculationOptimizationEnabled)
    }
}

