//
// ComputerContentCaching.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ComputerContentCaching: Codable, JSONEncodable, Hashable {

    public enum RegistrationStatus: String, Codable, CaseIterable {
        case failed = "CONTENT_CACHING_FAILED"
        case pending = "CONTENT_CACHING_PENDING"
        case succeeded = "CONTENT_CACHING_SUCCEEDED"
    }
    public enum TetheratorStatus: String, Codable, CaseIterable {
        case unknown = "CONTENT_CACHING_UNKNOWN"
        case disabled = "CONTENT_CACHING_DISABLED"
        case enabled = "CONTENT_CACHING_ENABLED"
    }
    public var computerContentCachingInformationId: String?
    public var parents: [ComputerContentCachingParent]?
    public var alerts: [ComputerContentCachingAlert]?
    public var activated: Bool?
    public var active: Bool?
    public var actualCacheBytesUsed: Int64?
    public var cacheDetails: [ComputerContentCachingCacheDetail]?
    public var cacheBytesFree: Int64?
    public var cacheBytesLimit: Int64?
    public var cacheStatus: String?
    public var cacheBytesUsed: Int64?
    public var dataMigrationCompleted: Bool?
    public var dataMigrationProgressPercentage: Int?
    public var dataMigrationError: ComputerContentCachingDataMigrationError?
    public var maxCachePressureLast1HourPercentage: Int?
    public var personalCacheBytesFree: Int64?
    public var personalCacheBytesLimit: Int64?
    public var personalCacheBytesUsed: Int64?
    public var port: Int64?
    public var publicAddress: String?
    public var registrationError: String?
    public var registrationResponseCode: Int64?
    public var registrationStarted: String?
    public var registrationStatus: RegistrationStatus?
    public var restrictedMedia: Bool?
    public var serverGuid: String?
    public var startupStatus: String?
    public var tetheratorStatus: TetheratorStatus?
    public var totalBytesAreSince: String?
    public var totalBytesDropped: Int64?
    public var totalBytesImported: Int64?
    public var totalBytesReturnedToChildren: Int64?
    public var totalBytesReturnedToClients: Int64?
    public var totalBytesReturnedToPeers: Int64?
    public var totalBytesStoredFromOrigin: Int64?
    public var totalBytesStoredFromParents: Int64?
    public var totalBytesStoredFromPeers: Int64?

    public init(computerContentCachingInformationId: String? = nil, parents: [ComputerContentCachingParent]? = nil, alerts: [ComputerContentCachingAlert]? = nil, activated: Bool? = nil, active: Bool? = nil, actualCacheBytesUsed: Int64? = nil, cacheDetails: [ComputerContentCachingCacheDetail]? = nil, cacheBytesFree: Int64? = nil, cacheBytesLimit: Int64? = nil, cacheStatus: String? = nil, cacheBytesUsed: Int64? = nil, dataMigrationCompleted: Bool? = nil, dataMigrationProgressPercentage: Int? = nil, dataMigrationError: ComputerContentCachingDataMigrationError? = nil, maxCachePressureLast1HourPercentage: Int? = nil, personalCacheBytesFree: Int64? = nil, personalCacheBytesLimit: Int64? = nil, personalCacheBytesUsed: Int64? = nil, port: Int64? = nil, publicAddress: String? = nil, registrationError: String? = nil, registrationResponseCode: Int64? = nil, registrationStarted: String? = nil, registrationStatus: RegistrationStatus? = nil, restrictedMedia: Bool? = nil, serverGuid: String? = nil, startupStatus: String? = nil, tetheratorStatus: TetheratorStatus? = nil, totalBytesAreSince: String? = nil, totalBytesDropped: Int64? = nil, totalBytesImported: Int64? = nil, totalBytesReturnedToChildren: Int64? = nil, totalBytesReturnedToClients: Int64? = nil, totalBytesReturnedToPeers: Int64? = nil, totalBytesStoredFromOrigin: Int64? = nil, totalBytesStoredFromParents: Int64? = nil, totalBytesStoredFromPeers: Int64? = nil) {
        self.computerContentCachingInformationId = computerContentCachingInformationId
        self.parents = parents
        self.alerts = alerts
        self.activated = activated
        self.active = active
        self.actualCacheBytesUsed = actualCacheBytesUsed
        self.cacheDetails = cacheDetails
        self.cacheBytesFree = cacheBytesFree
        self.cacheBytesLimit = cacheBytesLimit
        self.cacheStatus = cacheStatus
        self.cacheBytesUsed = cacheBytesUsed
        self.dataMigrationCompleted = dataMigrationCompleted
        self.dataMigrationProgressPercentage = dataMigrationProgressPercentage
        self.dataMigrationError = dataMigrationError
        self.maxCachePressureLast1HourPercentage = maxCachePressureLast1HourPercentage
        self.personalCacheBytesFree = personalCacheBytesFree
        self.personalCacheBytesLimit = personalCacheBytesLimit
        self.personalCacheBytesUsed = personalCacheBytesUsed
        self.port = port
        self.publicAddress = publicAddress
        self.registrationError = registrationError
        self.registrationResponseCode = registrationResponseCode
        self.registrationStarted = registrationStarted
        self.registrationStatus = registrationStatus
        self.restrictedMedia = restrictedMedia
        self.serverGuid = serverGuid
        self.startupStatus = startupStatus
        self.tetheratorStatus = tetheratorStatus
        self.totalBytesAreSince = totalBytesAreSince
        self.totalBytesDropped = totalBytesDropped
        self.totalBytesImported = totalBytesImported
        self.totalBytesReturnedToChildren = totalBytesReturnedToChildren
        self.totalBytesReturnedToClients = totalBytesReturnedToClients
        self.totalBytesReturnedToPeers = totalBytesReturnedToPeers
        self.totalBytesStoredFromOrigin = totalBytesStoredFromOrigin
        self.totalBytesStoredFromParents = totalBytesStoredFromParents
        self.totalBytesStoredFromPeers = totalBytesStoredFromPeers
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case computerContentCachingInformationId
        case parents
        case alerts
        case activated
        case active
        case actualCacheBytesUsed
        case cacheDetails
        case cacheBytesFree
        case cacheBytesLimit
        case cacheStatus
        case cacheBytesUsed
        case dataMigrationCompleted
        case dataMigrationProgressPercentage
        case dataMigrationError
        case maxCachePressureLast1HourPercentage
        case personalCacheBytesFree
        case personalCacheBytesLimit
        case personalCacheBytesUsed
        case port
        case publicAddress
        case registrationError
        case registrationResponseCode
        case registrationStarted
        case registrationStatus
        case restrictedMedia
        case serverGuid
        case startupStatus
        case tetheratorStatus
        case totalBytesAreSince
        case totalBytesDropped
        case totalBytesImported
        case totalBytesReturnedToChildren
        case totalBytesReturnedToClients
        case totalBytesReturnedToPeers
        case totalBytesStoredFromOrigin
        case totalBytesStoredFromParents
        case totalBytesStoredFromPeers
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(computerContentCachingInformationId, forKey: .computerContentCachingInformationId)
        try container.encodeIfPresent(parents, forKey: .parents)
        try container.encodeIfPresent(alerts, forKey: .alerts)
        try container.encodeIfPresent(activated, forKey: .activated)
        try container.encodeIfPresent(active, forKey: .active)
        try container.encodeIfPresent(actualCacheBytesUsed, forKey: .actualCacheBytesUsed)
        try container.encodeIfPresent(cacheDetails, forKey: .cacheDetails)
        try container.encodeIfPresent(cacheBytesFree, forKey: .cacheBytesFree)
        try container.encodeIfPresent(cacheBytesLimit, forKey: .cacheBytesLimit)
        try container.encodeIfPresent(cacheStatus, forKey: .cacheStatus)
        try container.encodeIfPresent(cacheBytesUsed, forKey: .cacheBytesUsed)
        try container.encodeIfPresent(dataMigrationCompleted, forKey: .dataMigrationCompleted)
        try container.encodeIfPresent(dataMigrationProgressPercentage, forKey: .dataMigrationProgressPercentage)
        try container.encodeIfPresent(dataMigrationError, forKey: .dataMigrationError)
        try container.encodeIfPresent(maxCachePressureLast1HourPercentage, forKey: .maxCachePressureLast1HourPercentage)
        try container.encodeIfPresent(personalCacheBytesFree, forKey: .personalCacheBytesFree)
        try container.encodeIfPresent(personalCacheBytesLimit, forKey: .personalCacheBytesLimit)
        try container.encodeIfPresent(personalCacheBytesUsed, forKey: .personalCacheBytesUsed)
        try container.encodeIfPresent(port, forKey: .port)
        try container.encodeIfPresent(publicAddress, forKey: .publicAddress)
        try container.encodeIfPresent(registrationError, forKey: .registrationError)
        try container.encodeIfPresent(registrationResponseCode, forKey: .registrationResponseCode)
        try container.encodeIfPresent(registrationStarted, forKey: .registrationStarted)
        try container.encodeIfPresent(registrationStatus, forKey: .registrationStatus)
        try container.encodeIfPresent(restrictedMedia, forKey: .restrictedMedia)
        try container.encodeIfPresent(serverGuid, forKey: .serverGuid)
        try container.encodeIfPresent(startupStatus, forKey: .startupStatus)
        try container.encodeIfPresent(tetheratorStatus, forKey: .tetheratorStatus)
        try container.encodeIfPresent(totalBytesAreSince, forKey: .totalBytesAreSince)
        try container.encodeIfPresent(totalBytesDropped, forKey: .totalBytesDropped)
        try container.encodeIfPresent(totalBytesImported, forKey: .totalBytesImported)
        try container.encodeIfPresent(totalBytesReturnedToChildren, forKey: .totalBytesReturnedToChildren)
        try container.encodeIfPresent(totalBytesReturnedToClients, forKey: .totalBytesReturnedToClients)
        try container.encodeIfPresent(totalBytesReturnedToPeers, forKey: .totalBytesReturnedToPeers)
        try container.encodeIfPresent(totalBytesStoredFromOrigin, forKey: .totalBytesStoredFromOrigin)
        try container.encodeIfPresent(totalBytesStoredFromParents, forKey: .totalBytesStoredFromParents)
        try container.encodeIfPresent(totalBytesStoredFromPeers, forKey: .totalBytesStoredFromPeers)
    }
}

