//
// ComputerExtensionAttribute.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ComputerExtensionAttribute: Codable, JSONEncodable, Hashable {

    public enum DataType: String, Codable, CaseIterable {
        case string = "STRING"
        case integer = "INTEGER"
        case dateTime = "DATE_TIME"
    }
    public enum InputType: String, Codable, CaseIterable {
        case text = "TEXT"
        case popup = "POPUP"
        case script = "SCRIPT"
        case ldap = "LDAP"
    }
    /** An identifier of extension attribute definition. */
    public var definitionId: String?
    /** A human-readable name by which attribute can be referred to. */
    public var name: String?
    /** An additional explanation of exact attribute meaning, possible values, etc. */
    public var description: String?
    public var enabled: Bool?
    public var multiValue: Bool?
    /** A value of extension attribute, in some rare cases there may be multiple values present, hence the array.  */
    public var values: [String]?
    /** A data type of extension attribute. */
    public var dataType: DataType?
    /** A closed list of possible values (applies to `popup` input type).  */
    public var options: [String]?
    /** The input method. `text` is most common and means simply free text, `popup` i a closed list of values from which one or many can be selected and `script` value is calculated and can never be set directly.  */
    public var inputType: InputType?

    public init(definitionId: String? = nil, name: String? = nil, description: String? = nil, enabled: Bool? = nil, multiValue: Bool? = nil, values: [String]? = nil, dataType: DataType? = nil, options: [String]? = nil, inputType: InputType? = nil) {
        self.definitionId = definitionId
        self.name = name
        self.description = description
        self.enabled = enabled
        self.multiValue = multiValue
        self.values = values
        self.dataType = dataType
        self.options = options
        self.inputType = inputType
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case definitionId
        case name
        case description
        case enabled
        case multiValue
        case values
        case dataType
        case options
        case inputType
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(definitionId, forKey: .definitionId)
        try container.encodeIfPresent(name, forKey: .name)
        try container.encodeIfPresent(description, forKey: .description)
        try container.encodeIfPresent(enabled, forKey: .enabled)
        try container.encodeIfPresent(multiValue, forKey: .multiValue)
        try container.encodeIfPresent(values, forKey: .values)
        try container.encodeIfPresent(dataType, forKey: .dataType)
        try container.encodeIfPresent(options, forKey: .options)
        try container.encodeIfPresent(inputType, forKey: .inputType)
    }
}

