//
// ComputerGeneral.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ComputerGeneral: Codable, JSONEncodable, Hashable {

    static let nameRule = StringRule(minLength: 1, maxLength: nil, pattern: nil)
    public var name: String?
    public var lastIpAddress: String?
    public var lastReportedIp: String?
    public var jamfBinaryVersion: String?
    public var platform: String?
    public var barcode1: String?
    public var barcode2: String?
    public var assetTag: String?
    public var remoteManagement: ComputerRemoteManagement?
    public var supervised: Bool?
    public var mdmCapable: ComputerMdmCapability?
    public var reportDate: String?
    public var lastContactTime: String?
    public var lastCloudBackupDate: String?
    public var lastEnrolledDate: String?
    public var mdmProfileExpiration: String?
    public var initialEntryDate: String?
    public var distributionPoint: String?
    public var enrollmentMethod: EnrollmentMethod?
    public var site: V1Site?
    public var itunesStoreAccountActive: Bool?
    public var enrolledViaAutomatedDeviceEnrollment: Bool?
    public var userApprovedMdm: Bool?
    public var declarativeDeviceManagementEnabled: Bool?
    public var extensionAttributes: [ComputerExtensionAttribute]?
    public var managementId: String?

    public init(name: String? = nil, lastIpAddress: String? = nil, lastReportedIp: String? = nil, jamfBinaryVersion: String? = nil, platform: String? = nil, barcode1: String? = nil, barcode2: String? = nil, assetTag: String? = nil, remoteManagement: ComputerRemoteManagement? = nil, supervised: Bool? = nil, mdmCapable: ComputerMdmCapability? = nil, reportDate: String? = nil, lastContactTime: String? = nil, lastCloudBackupDate: String? = nil, lastEnrolledDate: String? = nil, mdmProfileExpiration: String? = nil, initialEntryDate: String? = nil, distributionPoint: String? = nil, enrollmentMethod: EnrollmentMethod? = nil, site: V1Site? = nil, itunesStoreAccountActive: Bool? = nil, enrolledViaAutomatedDeviceEnrollment: Bool? = nil, userApprovedMdm: Bool? = nil, declarativeDeviceManagementEnabled: Bool? = nil, extensionAttributes: [ComputerExtensionAttribute]? = nil, managementId: String? = nil) {
        self.name = name
        self.lastIpAddress = lastIpAddress
        self.lastReportedIp = lastReportedIp
        self.jamfBinaryVersion = jamfBinaryVersion
        self.platform = platform
        self.barcode1 = barcode1
        self.barcode2 = barcode2
        self.assetTag = assetTag
        self.remoteManagement = remoteManagement
        self.supervised = supervised
        self.mdmCapable = mdmCapable
        self.reportDate = reportDate
        self.lastContactTime = lastContactTime
        self.lastCloudBackupDate = lastCloudBackupDate
        self.lastEnrolledDate = lastEnrolledDate
        self.mdmProfileExpiration = mdmProfileExpiration
        self.initialEntryDate = initialEntryDate
        self.distributionPoint = distributionPoint
        self.enrollmentMethod = enrollmentMethod
        self.site = site
        self.itunesStoreAccountActive = itunesStoreAccountActive
        self.enrolledViaAutomatedDeviceEnrollment = enrolledViaAutomatedDeviceEnrollment
        self.userApprovedMdm = userApprovedMdm
        self.declarativeDeviceManagementEnabled = declarativeDeviceManagementEnabled
        self.extensionAttributes = extensionAttributes
        self.managementId = managementId
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case name
        case lastIpAddress
        case lastReportedIp
        case jamfBinaryVersion
        case platform
        case barcode1
        case barcode2
        case assetTag
        case remoteManagement
        case supervised
        case mdmCapable
        case reportDate
        case lastContactTime
        case lastCloudBackupDate
        case lastEnrolledDate
        case mdmProfileExpiration
        case initialEntryDate
        case distributionPoint
        case enrollmentMethod
        case site
        case itunesStoreAccountActive
        case enrolledViaAutomatedDeviceEnrollment
        case userApprovedMdm
        case declarativeDeviceManagementEnabled
        case extensionAttributes
        case managementId
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(name, forKey: .name)
        try container.encodeIfPresent(lastIpAddress, forKey: .lastIpAddress)
        try container.encodeIfPresent(lastReportedIp, forKey: .lastReportedIp)
        try container.encodeIfPresent(jamfBinaryVersion, forKey: .jamfBinaryVersion)
        try container.encodeIfPresent(platform, forKey: .platform)
        try container.encodeIfPresent(barcode1, forKey: .barcode1)
        try container.encodeIfPresent(barcode2, forKey: .barcode2)
        try container.encodeIfPresent(assetTag, forKey: .assetTag)
        try container.encodeIfPresent(remoteManagement, forKey: .remoteManagement)
        try container.encodeIfPresent(supervised, forKey: .supervised)
        try container.encodeIfPresent(mdmCapable, forKey: .mdmCapable)
        try container.encodeIfPresent(reportDate, forKey: .reportDate)
        try container.encodeIfPresent(lastContactTime, forKey: .lastContactTime)
        try container.encodeIfPresent(lastCloudBackupDate, forKey: .lastCloudBackupDate)
        try container.encodeIfPresent(lastEnrolledDate, forKey: .lastEnrolledDate)
        try container.encodeIfPresent(mdmProfileExpiration, forKey: .mdmProfileExpiration)
        try container.encodeIfPresent(initialEntryDate, forKey: .initialEntryDate)
        try container.encodeIfPresent(distributionPoint, forKey: .distributionPoint)
        try container.encodeIfPresent(enrollmentMethod, forKey: .enrollmentMethod)
        try container.encodeIfPresent(site, forKey: .site)
        try container.encodeIfPresent(itunesStoreAccountActive, forKey: .itunesStoreAccountActive)
        try container.encodeIfPresent(enrolledViaAutomatedDeviceEnrollment, forKey: .enrolledViaAutomatedDeviceEnrollment)
        try container.encodeIfPresent(userApprovedMdm, forKey: .userApprovedMdm)
        try container.encodeIfPresent(declarativeDeviceManagementEnabled, forKey: .declarativeDeviceManagementEnabled)
        try container.encodeIfPresent(extensionAttributes, forKey: .extensionAttributes)
        try container.encodeIfPresent(managementId, forKey: .managementId)
    }
}

