//
// ComputerHardware.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ComputerHardware: Codable, JSONEncodable, Hashable {

    static let batteryCapacityPercentRule = NumericRule<Int>(minimum: 0, exclusiveMinimum: false, maximum: 100, exclusiveMaximum: false, multipleOf: nil)
    public var make: String?
    public var model: String?
    public var modelIdentifier: String?
    public var serialNumber: String?
    /** Processor Speed in MHz. */
    public var processorSpeedMhz: Int64?
    public var processorCount: Int?
    public var coreCount: Int?
    public var processorType: String?
    public var processorArchitecture: String?
    public var busSpeedMhz: Int64?
    /** Cache Size in KB. */
    public var cacheSizeKilobytes: Int64?
    public var networkAdapterType: String?
    public var macAddress: String?
    public var altNetworkAdapterType: String?
    public var altMacAddress: String?
    /** Total RAM Size in MB. */
    public var totalRamMegabytes: Int64?
    /** Available RAM slots. */
    public var openRamSlots: Int?
    /** Remaining percentage of battery power. */
    public var batteryCapacityPercent: Int?
    public var smcVersion: String?
    public var nicSpeed: String?
    public var opticalDrive: String?
    public var bootRom: String?
    public var bleCapable: Bool?
    public var supportsIosAppInstalls: Bool?
    public var appleSilicon: Bool?
    public var extensionAttributes: [ComputerExtensionAttribute]?

    public init(make: String? = nil, model: String? = nil, modelIdentifier: String? = nil, serialNumber: String? = nil, processorSpeedMhz: Int64? = nil, processorCount: Int? = nil, coreCount: Int? = nil, processorType: String? = nil, processorArchitecture: String? = nil, busSpeedMhz: Int64? = nil, cacheSizeKilobytes: Int64? = nil, networkAdapterType: String? = nil, macAddress: String? = nil, altNetworkAdapterType: String? = nil, altMacAddress: String? = nil, totalRamMegabytes: Int64? = nil, openRamSlots: Int? = nil, batteryCapacityPercent: Int? = nil, smcVersion: String? = nil, nicSpeed: String? = nil, opticalDrive: String? = nil, bootRom: String? = nil, bleCapable: Bool? = nil, supportsIosAppInstalls: Bool? = nil, appleSilicon: Bool? = nil, extensionAttributes: [ComputerExtensionAttribute]? = nil) {
        self.make = make
        self.model = model
        self.modelIdentifier = modelIdentifier
        self.serialNumber = serialNumber
        self.processorSpeedMhz = processorSpeedMhz
        self.processorCount = processorCount
        self.coreCount = coreCount
        self.processorType = processorType
        self.processorArchitecture = processorArchitecture
        self.busSpeedMhz = busSpeedMhz
        self.cacheSizeKilobytes = cacheSizeKilobytes
        self.networkAdapterType = networkAdapterType
        self.macAddress = macAddress
        self.altNetworkAdapterType = altNetworkAdapterType
        self.altMacAddress = altMacAddress
        self.totalRamMegabytes = totalRamMegabytes
        self.openRamSlots = openRamSlots
        self.batteryCapacityPercent = batteryCapacityPercent
        self.smcVersion = smcVersion
        self.nicSpeed = nicSpeed
        self.opticalDrive = opticalDrive
        self.bootRom = bootRom
        self.bleCapable = bleCapable
        self.supportsIosAppInstalls = supportsIosAppInstalls
        self.appleSilicon = appleSilicon
        self.extensionAttributes = extensionAttributes
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case make
        case model
        case modelIdentifier
        case serialNumber
        case processorSpeedMhz
        case processorCount
        case coreCount
        case processorType
        case processorArchitecture
        case busSpeedMhz
        case cacheSizeKilobytes
        case networkAdapterType
        case macAddress
        case altNetworkAdapterType
        case altMacAddress
        case totalRamMegabytes
        case openRamSlots
        case batteryCapacityPercent
        case smcVersion
        case nicSpeed
        case opticalDrive
        case bootRom
        case bleCapable
        case supportsIosAppInstalls
        case appleSilicon
        case extensionAttributes
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(make, forKey: .make)
        try container.encodeIfPresent(model, forKey: .model)
        try container.encodeIfPresent(modelIdentifier, forKey: .modelIdentifier)
        try container.encodeIfPresent(serialNumber, forKey: .serialNumber)
        try container.encodeIfPresent(processorSpeedMhz, forKey: .processorSpeedMhz)
        try container.encodeIfPresent(processorCount, forKey: .processorCount)
        try container.encodeIfPresent(coreCount, forKey: .coreCount)
        try container.encodeIfPresent(processorType, forKey: .processorType)
        try container.encodeIfPresent(processorArchitecture, forKey: .processorArchitecture)
        try container.encodeIfPresent(busSpeedMhz, forKey: .busSpeedMhz)
        try container.encodeIfPresent(cacheSizeKilobytes, forKey: .cacheSizeKilobytes)
        try container.encodeIfPresent(networkAdapterType, forKey: .networkAdapterType)
        try container.encodeIfPresent(macAddress, forKey: .macAddress)
        try container.encodeIfPresent(altNetworkAdapterType, forKey: .altNetworkAdapterType)
        try container.encodeIfPresent(altMacAddress, forKey: .altMacAddress)
        try container.encodeIfPresent(totalRamMegabytes, forKey: .totalRamMegabytes)
        try container.encodeIfPresent(openRamSlots, forKey: .openRamSlots)
        try container.encodeIfPresent(batteryCapacityPercent, forKey: .batteryCapacityPercent)
        try container.encodeIfPresent(smcVersion, forKey: .smcVersion)
        try container.encodeIfPresent(nicSpeed, forKey: .nicSpeed)
        try container.encodeIfPresent(opticalDrive, forKey: .opticalDrive)
        try container.encodeIfPresent(bootRom, forKey: .bootRom)
        try container.encodeIfPresent(bleCapable, forKey: .bleCapable)
        try container.encodeIfPresent(supportsIosAppInstalls, forKey: .supportsIosAppInstalls)
        try container.encodeIfPresent(appleSilicon, forKey: .appleSilicon)
        try container.encodeIfPresent(extensionAttributes, forKey: .extensionAttributes)
    }
}

