//
// ComputerLocalUserAccount.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ComputerLocalUserAccount: Codable, JSONEncodable, Hashable {

    public enum UserAccountType: String, Codable, CaseIterable {
        case local = "LOCAL"
        case mobile = "MOBILE"
        case unknown = "UNKNOWN"
    }
    public enum AzureActiveDirectoryId: String, Codable, CaseIterable {
        case activated = "ACTIVATED"
        case deactivated = "DEACTIVATED"
        case unresponsive = "UNRESPONSIVE"
        case unknown = "UNKNOWN"
    }
    public var uid: String?
    public var userGuid: String?
    public var username: String?
    public var fullName: String?
    public var admin: Bool?
    public var homeDirectory: String?
    /** Home directory size in MB. */
    public var homeDirectorySizeMb: Int64?
    public var fileVault2Enabled: Bool?
    public var userAccountType: UserAccountType?
    public var passwordMinLength: Int?
    public var passwordMaxAge: Int?
    public var passwordMinComplexCharacters: Int?
    public var passwordHistoryDepth: Int?
    public var passwordRequireAlphanumeric: Bool?
    public var computerAzureActiveDirectoryId: String?
    public var userAzureActiveDirectoryId: String?
    public var azureActiveDirectoryId: AzureActiveDirectoryId?

    public init(uid: String? = nil, userGuid: String? = nil, username: String? = nil, fullName: String? = nil, admin: Bool? = nil, homeDirectory: String? = nil, homeDirectorySizeMb: Int64? = nil, fileVault2Enabled: Bool? = nil, userAccountType: UserAccountType? = nil, passwordMinLength: Int? = nil, passwordMaxAge: Int? = nil, passwordMinComplexCharacters: Int? = nil, passwordHistoryDepth: Int? = nil, passwordRequireAlphanumeric: Bool? = nil, computerAzureActiveDirectoryId: String? = nil, userAzureActiveDirectoryId: String? = nil, azureActiveDirectoryId: AzureActiveDirectoryId? = nil) {
        self.uid = uid
        self.userGuid = userGuid
        self.username = username
        self.fullName = fullName
        self.admin = admin
        self.homeDirectory = homeDirectory
        self.homeDirectorySizeMb = homeDirectorySizeMb
        self.fileVault2Enabled = fileVault2Enabled
        self.userAccountType = userAccountType
        self.passwordMinLength = passwordMinLength
        self.passwordMaxAge = passwordMaxAge
        self.passwordMinComplexCharacters = passwordMinComplexCharacters
        self.passwordHistoryDepth = passwordHistoryDepth
        self.passwordRequireAlphanumeric = passwordRequireAlphanumeric
        self.computerAzureActiveDirectoryId = computerAzureActiveDirectoryId
        self.userAzureActiveDirectoryId = userAzureActiveDirectoryId
        self.azureActiveDirectoryId = azureActiveDirectoryId
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case uid
        case userGuid
        case username
        case fullName
        case admin
        case homeDirectory
        case homeDirectorySizeMb
        case fileVault2Enabled
        case userAccountType
        case passwordMinLength
        case passwordMaxAge
        case passwordMinComplexCharacters
        case passwordHistoryDepth
        case passwordRequireAlphanumeric
        case computerAzureActiveDirectoryId
        case userAzureActiveDirectoryId
        case azureActiveDirectoryId
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(uid, forKey: .uid)
        try container.encodeIfPresent(userGuid, forKey: .userGuid)
        try container.encodeIfPresent(username, forKey: .username)
        try container.encodeIfPresent(fullName, forKey: .fullName)
        try container.encodeIfPresent(admin, forKey: .admin)
        try container.encodeIfPresent(homeDirectory, forKey: .homeDirectory)
        try container.encodeIfPresent(homeDirectorySizeMb, forKey: .homeDirectorySizeMb)
        try container.encodeIfPresent(fileVault2Enabled, forKey: .fileVault2Enabled)
        try container.encodeIfPresent(userAccountType, forKey: .userAccountType)
        try container.encodeIfPresent(passwordMinLength, forKey: .passwordMinLength)
        try container.encodeIfPresent(passwordMaxAge, forKey: .passwordMaxAge)
        try container.encodeIfPresent(passwordMinComplexCharacters, forKey: .passwordMinComplexCharacters)
        try container.encodeIfPresent(passwordHistoryDepth, forKey: .passwordHistoryDepth)
        try container.encodeIfPresent(passwordRequireAlphanumeric, forKey: .passwordRequireAlphanumeric)
        try container.encodeIfPresent(computerAzureActiveDirectoryId, forKey: .computerAzureActiveDirectoryId)
        try container.encodeIfPresent(userAzureActiveDirectoryId, forKey: .userAzureActiveDirectoryId)
        try container.encodeIfPresent(azureActiveDirectoryId, forKey: .azureActiveDirectoryId)
    }
}

