//
// ComputerOperatingSystem.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ComputerOperatingSystem: Codable, JSONEncodable, Hashable {

    public enum FileVault2Status: String, Codable, CaseIterable {
        case notApplicable = "NOT_APPLICABLE"
        case notEncrypted = "NOT_ENCRYPTED"
        case bootEncrypted = "BOOT_ENCRYPTED"
        case someEncrypted = "SOME_ENCRYPTED"
        case allEncrypted = "ALL_ENCRYPTED"
    }
    public var name: String?
    public var version: String?
    public var build: String?
    /** Collected for macOS 13.0 or later */
    public var supplementalBuildVersion: String?
    /** Collected for macOS 13.0 or later */
    public var rapidSecurityResponse: String?
    public var activeDirectoryStatus: String?
    public var fileVault2Status: FileVault2Status?
    public var softwareUpdateDeviceId: String?
    public var extensionAttributes: [ComputerExtensionAttribute]?

    public init(name: String? = nil, version: String? = nil, build: String? = nil, supplementalBuildVersion: String? = nil, rapidSecurityResponse: String? = nil, activeDirectoryStatus: String? = nil, fileVault2Status: FileVault2Status? = nil, softwareUpdateDeviceId: String? = nil, extensionAttributes: [ComputerExtensionAttribute]? = nil) {
        self.name = name
        self.version = version
        self.build = build
        self.supplementalBuildVersion = supplementalBuildVersion
        self.rapidSecurityResponse = rapidSecurityResponse
        self.activeDirectoryStatus = activeDirectoryStatus
        self.fileVault2Status = fileVault2Status
        self.softwareUpdateDeviceId = softwareUpdateDeviceId
        self.extensionAttributes = extensionAttributes
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case name
        case version
        case build
        case supplementalBuildVersion
        case rapidSecurityResponse
        case activeDirectoryStatus
        case fileVault2Status
        case softwareUpdateDeviceId
        case extensionAttributes
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(name, forKey: .name)
        try container.encodeIfPresent(version, forKey: .version)
        try container.encodeIfPresent(build, forKey: .build)
        try container.encodeIfPresent(supplementalBuildVersion, forKey: .supplementalBuildVersion)
        try container.encodeIfPresent(rapidSecurityResponse, forKey: .rapidSecurityResponse)
        try container.encodeIfPresent(activeDirectoryStatus, forKey: .activeDirectoryStatus)
        try container.encodeIfPresent(fileVault2Status, forKey: .fileVault2Status)
        try container.encodeIfPresent(softwareUpdateDeviceId, forKey: .softwareUpdateDeviceId)
        try container.encodeIfPresent(extensionAttributes, forKey: .extensionAttributes)
    }
}

