//
// ComputerPartition.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ComputerPartition: Codable, JSONEncodable, Hashable {

    public enum PartitionType: String, Codable, CaseIterable {
        case boot = "BOOT"
        case recovery = "RECOVERY"
        case other = "OTHER"
    }
    static let percentUsedRule = NumericRule<Int>(minimum: 0, exclusiveMinimum: false, maximum: 100, exclusiveMaximum: false, multipleOf: nil)
    public var name: String?
    /** Partition Size in MB. */
    public var sizeMegabytes: Int64?
    /** Available space in MB. */
    public var availableMegabytes: Int64?
    public var partitionType: PartitionType?
    /** Percentage of space used. */
    public var percentUsed: Int?
    public var fileVault2State: ComputerPartitionFileVault2State?
    /** Percentage progress of current FileVault 2 operation. */
    public var fileVault2ProgressPercent: Int?
    public var lvmManaged: Bool?

    public init(name: String? = nil, sizeMegabytes: Int64? = nil, availableMegabytes: Int64? = nil, partitionType: PartitionType? = nil, percentUsed: Int? = nil, fileVault2State: ComputerPartitionFileVault2State? = nil, fileVault2ProgressPercent: Int? = nil, lvmManaged: Bool? = nil) {
        self.name = name
        self.sizeMegabytes = sizeMegabytes
        self.availableMegabytes = availableMegabytes
        self.partitionType = partitionType
        self.percentUsed = percentUsed
        self.fileVault2State = fileVault2State
        self.fileVault2ProgressPercent = fileVault2ProgressPercent
        self.lvmManaged = lvmManaged
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case name
        case sizeMegabytes
        case availableMegabytes
        case partitionType
        case percentUsed
        case fileVault2State
        case fileVault2ProgressPercent
        case lvmManaged
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(name, forKey: .name)
        try container.encodeIfPresent(sizeMegabytes, forKey: .sizeMegabytes)
        try container.encodeIfPresent(availableMegabytes, forKey: .availableMegabytes)
        try container.encodeIfPresent(partitionType, forKey: .partitionType)
        try container.encodeIfPresent(percentUsed, forKey: .percentUsed)
        try container.encodeIfPresent(fileVault2State, forKey: .fileVault2State)
        try container.encodeIfPresent(fileVault2ProgressPercent, forKey: .fileVault2ProgressPercent)
        try container.encodeIfPresent(lvmManaged, forKey: .lvmManaged)
    }
}

