//
// ComputerSecurity.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ComputerSecurity: Codable, JSONEncodable, Hashable {

    public enum SipStatus: String, Codable, CaseIterable {
        case notCollected = "NOT_COLLECTED"
        case notAvailable = "NOT_AVAILABLE"
        case disabled = "DISABLED"
        case enabled = "ENABLED"
    }
    public enum GatekeeperStatus: String, Codable, CaseIterable {
        case notCollected = "NOT_COLLECTED"
        case disabled = "DISABLED"
        case appStoreAndIdentifiedDevelopers = "APP_STORE_AND_IDENTIFIED_DEVELOPERS"
        case appStore = "APP_STORE"
    }
    public enum SecureBootLevel: String, Codable, CaseIterable {
        case noSecurity = "NO_SECURITY"
        case mediumSecurity = "MEDIUM_SECURITY"
        case fullSecurity = "FULL_SECURITY"
        case notSupported = "NOT_SUPPORTED"
        case unknown = "UNKNOWN"
    }
    public enum ExternalBootLevel: String, Codable, CaseIterable {
        case allowBootingFromExternalMedia = "ALLOW_BOOTING_FROM_EXTERNAL_MEDIA"
        case disallowBootingFromExternalMedia = "DISALLOW_BOOTING_FROM_EXTERNAL_MEDIA"
        case notSupported = "NOT_SUPPORTED"
        case unknown = "UNKNOWN"
    }
    public var sipStatus: SipStatus?
    public var gatekeeperStatus: GatekeeperStatus?
    public var xprotectVersion: String?
    public var autoLoginDisabled: Bool?
    /** Collected for macOS 10.14.4 or later */
    public var remoteDesktopEnabled: Bool?
    /** Collected for macOS 10.15.0 or later */
    public var activationLockEnabled: Bool?
    public var recoveryLockEnabled: Bool?
    public var firewallEnabled: Bool?
    /** Collected for macOS 10.15.0 or later */
    public var secureBootLevel: SecureBootLevel?
    /** Collected for macOS 10.15.0 or later */
    public var externalBootLevel: ExternalBootLevel?
    /** Collected for macOS 11 or later */
    public var bootstrapTokenAllowed: Bool?

    public init(sipStatus: SipStatus? = nil, gatekeeperStatus: GatekeeperStatus? = nil, xprotectVersion: String? = nil, autoLoginDisabled: Bool? = nil, remoteDesktopEnabled: Bool? = nil, activationLockEnabled: Bool? = nil, recoveryLockEnabled: Bool? = nil, firewallEnabled: Bool? = nil, secureBootLevel: SecureBootLevel? = nil, externalBootLevel: ExternalBootLevel? = nil, bootstrapTokenAllowed: Bool? = nil) {
        self.sipStatus = sipStatus
        self.gatekeeperStatus = gatekeeperStatus
        self.xprotectVersion = xprotectVersion
        self.autoLoginDisabled = autoLoginDisabled
        self.remoteDesktopEnabled = remoteDesktopEnabled
        self.activationLockEnabled = activationLockEnabled
        self.recoveryLockEnabled = recoveryLockEnabled
        self.firewallEnabled = firewallEnabled
        self.secureBootLevel = secureBootLevel
        self.externalBootLevel = externalBootLevel
        self.bootstrapTokenAllowed = bootstrapTokenAllowed
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case sipStatus
        case gatekeeperStatus
        case xprotectVersion
        case autoLoginDisabled
        case remoteDesktopEnabled
        case activationLockEnabled
        case recoveryLockEnabled
        case firewallEnabled
        case secureBootLevel
        case externalBootLevel
        case bootstrapTokenAllowed
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(sipStatus, forKey: .sipStatus)
        try container.encodeIfPresent(gatekeeperStatus, forKey: .gatekeeperStatus)
        try container.encodeIfPresent(xprotectVersion, forKey: .xprotectVersion)
        try container.encodeIfPresent(autoLoginDisabled, forKey: .autoLoginDisabled)
        try container.encodeIfPresent(remoteDesktopEnabled, forKey: .remoteDesktopEnabled)
        try container.encodeIfPresent(activationLockEnabled, forKey: .activationLockEnabled)
        try container.encodeIfPresent(recoveryLockEnabled, forKey: .recoveryLockEnabled)
        try container.encodeIfPresent(firewallEnabled, forKey: .firewallEnabled)
        try container.encodeIfPresent(secureBootLevel, forKey: .secureBootLevel)
        try container.encodeIfPresent(externalBootLevel, forKey: .externalBootLevel)
        try container.encodeIfPresent(bootstrapTokenAllowed, forKey: .bootstrapTokenAllowed)
    }
}

