//
// ConnectionConfigurationCandidateRequest.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** Request that creates configuration and initialize connection between Jamf Pro and Team Viewer */
public struct ConnectionConfigurationCandidateRequest: Codable, JSONEncodable, Hashable {

    static let displayNameRule = StringRule(minLength: 1, maxLength: 255, pattern: nil)
    static let scriptTokenRule = StringRule(minLength: 1, maxLength: 255, pattern: nil)
    static let sessionTimeoutRule = NumericRule<Int>(minimum: 1, exclusiveMinimum: false, maximum: 1440, exclusiveMaximum: false, multipleOf: nil)
    /** An identifier of a site which Team Viewer Remote Administration will be configured on */
    public var siteId: String
    /** Name for Team Viewer Connection Configuration */
    public var displayName: String
    /** Token which is used for connecting to Team Viewer */
    public var scriptToken: String
    /** Defines the intent to enable or disable Team Viewer connection */
    public var enabled: Bool
    /** Number of minutes before the session expires */
    public var sessionTimeout: Int

    public init(siteId: String, displayName: String, scriptToken: String, enabled: Bool, sessionTimeout: Int) {
        self.siteId = siteId
        self.displayName = displayName
        self.scriptToken = scriptToken
        self.enabled = enabled
        self.sessionTimeout = sessionTimeout
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case siteId
        case displayName
        case scriptToken
        case enabled
        case sessionTimeout
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(siteId, forKey: .siteId)
        try container.encode(displayName, forKey: .displayName)
        try container.encode(scriptToken, forKey: .scriptToken)
        try container.encode(enabled, forKey: .enabled)
        try container.encode(sessionTimeout, forKey: .sessionTimeout)
    }
}

