//
// ConnectionConfigurationResponse.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** Response that contains information about connection configuration for Team Viewer */
public struct ConnectionConfigurationResponse: Codable, JSONEncodable, Hashable {

    static let sessionTimeoutRule = NumericRule<Int>(minimum: 1, exclusiveMinimum: false, maximum: 1440, exclusiveMaximum: false, multipleOf: nil)
    /** An identifier of connection configuration for Team Viewer Remote Administration */
    public var id: String
    /** An identifier of a site which Team Viewer Remote Administration is configured on */
    public var siteId: String
    /** Name for Team Viewer Connection Configuration */
    public var displayName: String
    /** Describes if Team Viewer connection is enabled or disabled */
    public var enabled: Bool
    /** Number of minutes before the session expires */
    public var sessionTimeout: Int?

    public init(id: String, siteId: String, displayName: String, enabled: Bool, sessionTimeout: Int?) {
        self.id = id
        self.siteId = siteId
        self.displayName = displayName
        self.enabled = enabled
        self.sessionTimeout = sessionTimeout
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case siteId
        case displayName
        case enabled
        case sessionTimeout
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(id, forKey: .id)
        try container.encode(siteId, forKey: .siteId)
        try container.encode(displayName, forKey: .displayName)
        try container.encode(enabled, forKey: .enabled)
        try container.encode(sessionTimeout, forKey: .sessionTimeout)
    }
}

