//
// ConnectionConfigurationUpdateRequest.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** Request that updates configuration connection between Jamf Pro and Team Viewer */
public struct ConnectionConfigurationUpdateRequest: Codable, JSONEncodable, Hashable {

    static let displayNameRule = StringRule(minLength: nil, maxLength: 255, pattern: nil)
    static let sessionTimeoutRule = NumericRule<Int>(minimum: 1, exclusiveMinimum: false, maximum: 1440, exclusiveMaximum: false, multipleOf: nil)
    static let tokenRule = StringRule(minLength: nil, maxLength: 255, pattern: nil)
    /** Name for Team Viewer Connection Configuration */
    public var displayName: String?
    /** Defines the intent to enable or disable Team Viewer connection */
    public var enabled: Bool?
    /** Number of minutes before the session expires */
    public var sessionTimeout: Int?
    /** Script token for Team Viewer Connection Configuration */
    public var token: String?

    public init(displayName: String? = nil, enabled: Bool? = nil, sessionTimeout: Int? = nil, token: String? = nil) {
        self.displayName = displayName
        self.enabled = enabled
        self.sessionTimeout = sessionTimeout
        self.token = token
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case displayName
        case enabled
        case sessionTimeout
        case token
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(displayName, forKey: .displayName)
        try container.encodeIfPresent(enabled, forKey: .enabled)
        try container.encodeIfPresent(sessionTimeout, forKey: .sessionTimeout)
        try container.encodeIfPresent(token, forKey: .token)
    }
}

