//
// DashboardSetupFeatureOptions.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct DashboardSetupFeatureOptions: Codable, JSONEncodable, Hashable {

    public enum Feature: String, Codable, CaseIterable {
        case iosConfigurationProfile = "TYPE_IOS_CONFIGURATION_PROFILE"
        case macosConfigurationProfile = "TYPE_MACOS_CONFIGURATION_PROFILE"
        case userGroup = "TYPE_USER_GROUP"
        case licensedSoftware = "TYPE_LICENSED_SOFTWARE"
        case patchSoftwareTitleConfiguration = "TYPE_PATCH_SOFTWARE_TITLE_CONFIGURATION"
        case patchPolicy = "TYPE_PATCH_POLICY"
        case policy = "TYPE_POLICY"
        case computerGroup = "TYPE_COMPUTER_GROUP"
        case mobileDeviceGroup = "TYPE_MOBILE_DEVICE_GROUP"
        case digicertPkiManagerSettings = "TYPE_DIGICERT_PKI_MANAGER_SETTINGS"
    }
    public var feature: Feature?

    public init(feature: Feature? = nil) {
        self.feature = feature
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case feature
    }

    public var additionalProperties: [String: [DashboardItem]] = [:]

    public subscript(key: String) -> [DashboardItem]? {
        get {
            if let value = additionalProperties[key] {
                return value
            }
            return nil
        }

        set {
            additionalProperties[key] = newValue
        }
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(feature, forKey: .feature)
        var additionalPropertiesContainer = encoder.container(keyedBy: String.self)
        try additionalPropertiesContainer.encodeMap(additionalProperties)
    }

    // Decodable protocol methods

    public init(from decoder: Decoder) throws {
        let container = try decoder.container(keyedBy: CodingKeys.self)

        feature = try container.decodeIfPresent(Feature.self, forKey: .feature)
        var nonAdditionalPropertyKeys = Set<String>()
        nonAdditionalPropertyKeys.insert("feature")
        let additionalPropertiesContainer = try decoder.container(keyedBy: String.self)
        additionalProperties = try additionalPropertiesContainer.decodeMap([DashboardItem].self, excludedKeys: nonAdditionalPropertyKeys)
    }
}

