//
// EnrollmentSettingsV2.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct EnrollmentSettingsV2: Codable, JSONEncodable, Hashable {

    public enum FlushMdmCommandsOnReenroll: String, Codable, CaseIterable {
        case nothing = "DELETE_NOTHING"
        case errors = "DELETE_ERRORS"
        case everythingExceptAcknowledged = "DELETE_EVERYTHING_EXCEPT_ACKNOWLEDGED"
        case everything = "DELETE_EVERYTHING"
    }
    public enum PasswordType: String, Codable, CaseIterable {
        case _static = "STATIC"
        case random = "RANDOM"
    }
    public enum PersonalDeviceEnrollmentType: String, Codable, CaseIterable {
        case userenrollment = "USERENROLLMENT"
        case personaldeviceprofiles = "PERSONALDEVICEPROFILES"
    }
    public var installSingleProfile: Bool? = false
    public var signingMdmProfileEnabled: Bool? = false
    public var mdmSigningCertificate: CertificateIdentityV2?
    public var restrictReenrollment: Bool? = false
    public var flushLocationInformation: Bool? = false
    public var flushLocationHistoryInformation: Bool? = false
    public var flushPolicyHistory: Bool? = false
    public var flushExtensionAttributes: Bool? = false
    public var flushMdmCommandsOnReenroll: FlushMdmCommandsOnReenroll? = .everythingExceptAcknowledged
    public var macOsEnterpriseEnrollmentEnabled: Bool? = false
    public var managementUsername: String = ""
    /** managementPassword is no longer in use. Input value for managementPassword will be ignored. */
    @available(*, deprecated, message: "This property is deprecated.")
    public var managementPassword: String? = "null"
    /** managementPasswordSet is no longer in use. Input value for managementPasswordSet will be ignored. */
    @available(*, deprecated, message: "This property is deprecated.")
    public var managementPasswordSet: Bool?
    /** passwordType is no longer in use. Input value for passwordType will be ignored. */
    @available(*, deprecated, message: "This property is deprecated.")
    public var passwordType: PasswordType? = ._static
    /** randomPasswordLength is no longer in use. Input value for randomPasswordLength will be ignored. */
    @available(*, deprecated, message: "This property is deprecated.")
    public var randomPasswordLength: Int? = 8
    public var createManagementAccount: Bool? = true
    public var hideManagementAccount: Bool? = false
    public var allowSshOnlyManagementAccount: Bool? = false
    public var ensureSshRunning: Bool? = true
    public var launchSelfService: Bool? = false
    public var signQuickAdd: Bool? = false
    public var developerCertificateIdentity: CertificateIdentityV2?
    public var developerCertificateIdentityDetails: CertificateDetails?
    public var mdmSigningCertificateDetails: CertificateDetails?
    public var iosEnterpriseEnrollmentEnabled: Bool? = true
    public var iosPersonalEnrollmentEnabled: Bool? = false
    public var personalDeviceEnrollmentType: PersonalDeviceEnrollmentType? = .personaldeviceprofiles
    public var accountDrivenUserEnrollmentEnabled: Bool? = false

    public init(installSingleProfile: Bool? = false, signingMdmProfileEnabled: Bool? = false, mdmSigningCertificate: CertificateIdentityV2? = nil, restrictReenrollment: Bool? = false, flushLocationInformation: Bool? = false, flushLocationHistoryInformation: Bool? = false, flushPolicyHistory: Bool? = false, flushExtensionAttributes: Bool? = false, flushMdmCommandsOnReenroll: FlushMdmCommandsOnReenroll? = .everythingExceptAcknowledged, macOsEnterpriseEnrollmentEnabled: Bool? = false, managementUsername: String = "", managementPassword: String? = "null", managementPasswordSet: Bool? = nil, passwordType: PasswordType? = ._static, randomPasswordLength: Int? = 8, createManagementAccount: Bool? = true, hideManagementAccount: Bool? = false, allowSshOnlyManagementAccount: Bool? = false, ensureSshRunning: Bool? = true, launchSelfService: Bool? = false, signQuickAdd: Bool? = false, developerCertificateIdentity: CertificateIdentityV2? = nil, developerCertificateIdentityDetails: CertificateDetails? = nil, mdmSigningCertificateDetails: CertificateDetails? = nil, iosEnterpriseEnrollmentEnabled: Bool? = true, iosPersonalEnrollmentEnabled: Bool? = false, personalDeviceEnrollmentType: PersonalDeviceEnrollmentType? = .personaldeviceprofiles, accountDrivenUserEnrollmentEnabled: Bool? = false) {
        self.installSingleProfile = installSingleProfile
        self.signingMdmProfileEnabled = signingMdmProfileEnabled
        self.mdmSigningCertificate = mdmSigningCertificate
        self.restrictReenrollment = restrictReenrollment
        self.flushLocationInformation = flushLocationInformation
        self.flushLocationHistoryInformation = flushLocationHistoryInformation
        self.flushPolicyHistory = flushPolicyHistory
        self.flushExtensionAttributes = flushExtensionAttributes
        self.flushMdmCommandsOnReenroll = flushMdmCommandsOnReenroll
        self.macOsEnterpriseEnrollmentEnabled = macOsEnterpriseEnrollmentEnabled
        self.managementUsername = managementUsername
        self.managementPassword = managementPassword
        self.managementPasswordSet = managementPasswordSet
        self.passwordType = passwordType
        self.randomPasswordLength = randomPasswordLength
        self.createManagementAccount = createManagementAccount
        self.hideManagementAccount = hideManagementAccount
        self.allowSshOnlyManagementAccount = allowSshOnlyManagementAccount
        self.ensureSshRunning = ensureSshRunning
        self.launchSelfService = launchSelfService
        self.signQuickAdd = signQuickAdd
        self.developerCertificateIdentity = developerCertificateIdentity
        self.developerCertificateIdentityDetails = developerCertificateIdentityDetails
        self.mdmSigningCertificateDetails = mdmSigningCertificateDetails
        self.iosEnterpriseEnrollmentEnabled = iosEnterpriseEnrollmentEnabled
        self.iosPersonalEnrollmentEnabled = iosPersonalEnrollmentEnabled
        self.personalDeviceEnrollmentType = personalDeviceEnrollmentType
        self.accountDrivenUserEnrollmentEnabled = accountDrivenUserEnrollmentEnabled
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case installSingleProfile
        case signingMdmProfileEnabled
        case mdmSigningCertificate
        case restrictReenrollment
        case flushLocationInformation
        case flushLocationHistoryInformation
        case flushPolicyHistory
        case flushExtensionAttributes
        case flushMdmCommandsOnReenroll
        case macOsEnterpriseEnrollmentEnabled
        case managementUsername
        case managementPassword
        case managementPasswordSet
        case passwordType
        case randomPasswordLength
        case createManagementAccount
        case hideManagementAccount
        case allowSshOnlyManagementAccount
        case ensureSshRunning
        case launchSelfService
        case signQuickAdd
        case developerCertificateIdentity
        case developerCertificateIdentityDetails
        case mdmSigningCertificateDetails
        case iosEnterpriseEnrollmentEnabled
        case iosPersonalEnrollmentEnabled
        case personalDeviceEnrollmentType
        case accountDrivenUserEnrollmentEnabled
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(installSingleProfile, forKey: .installSingleProfile)
        try container.encodeIfPresent(signingMdmProfileEnabled, forKey: .signingMdmProfileEnabled)
        try container.encodeIfPresent(mdmSigningCertificate, forKey: .mdmSigningCertificate)
        try container.encodeIfPresent(restrictReenrollment, forKey: .restrictReenrollment)
        try container.encodeIfPresent(flushLocationInformation, forKey: .flushLocationInformation)
        try container.encodeIfPresent(flushLocationHistoryInformation, forKey: .flushLocationHistoryInformation)
        try container.encodeIfPresent(flushPolicyHistory, forKey: .flushPolicyHistory)
        try container.encodeIfPresent(flushExtensionAttributes, forKey: .flushExtensionAttributes)
        try container.encodeIfPresent(flushMdmCommandsOnReenroll, forKey: .flushMdmCommandsOnReenroll)
        try container.encodeIfPresent(macOsEnterpriseEnrollmentEnabled, forKey: .macOsEnterpriseEnrollmentEnabled)
        try container.encode(managementUsername, forKey: .managementUsername)
        try container.encodeIfPresent(managementPassword, forKey: .managementPassword)
        try container.encodeIfPresent(managementPasswordSet, forKey: .managementPasswordSet)
        try container.encodeIfPresent(passwordType, forKey: .passwordType)
        try container.encodeIfPresent(randomPasswordLength, forKey: .randomPasswordLength)
        try container.encodeIfPresent(createManagementAccount, forKey: .createManagementAccount)
        try container.encodeIfPresent(hideManagementAccount, forKey: .hideManagementAccount)
        try container.encodeIfPresent(allowSshOnlyManagementAccount, forKey: .allowSshOnlyManagementAccount)
        try container.encodeIfPresent(ensureSshRunning, forKey: .ensureSshRunning)
        try container.encodeIfPresent(launchSelfService, forKey: .launchSelfService)
        try container.encodeIfPresent(signQuickAdd, forKey: .signQuickAdd)
        try container.encodeIfPresent(developerCertificateIdentity, forKey: .developerCertificateIdentity)
        try container.encodeIfPresent(developerCertificateIdentityDetails, forKey: .developerCertificateIdentityDetails)
        try container.encodeIfPresent(mdmSigningCertificateDetails, forKey: .mdmSigningCertificateDetails)
        try container.encodeIfPresent(iosEnterpriseEnrollmentEnabled, forKey: .iosEnterpriseEnrollmentEnabled)
        try container.encodeIfPresent(iosPersonalEnrollmentEnabled, forKey: .iosPersonalEnrollmentEnabled)
        try container.encodeIfPresent(personalDeviceEnrollmentType, forKey: .personalDeviceEnrollmentType)
        try container.encodeIfPresent(accountDrivenUserEnrollmentEnabled, forKey: .accountDrivenUserEnrollmentEnabled)
    }
}

