//
// EraseDeviceCommand.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct EraseDeviceCommand: Codable, JSONEncodable, Hashable {

    public enum ObliterationBehavior: String, Codable, CaseIterable {
        case _default = "Default"
        case doNotObliterate = "DoNotObliterate"
        case obliterateWithWarning = "ObliterateWithWarning"
        case always = "Always"
    }
    static let pinRule = StringRule(minLength: 6, maxLength: 6, pattern: nil)
    /** If true, preserve the data plan on an iPhone or iPad with eSIM functionality, if one exists. This value is available in iOS 11 and later. */
    public var preserveDataPlan: Bool? = false
    /** If true, disable Proximity Setup on the next reboot and skip the pane in Setup Assistant. This value is available in iOS 11 and later. Prior to iOS 14, don’t use this option with any other option. */
    public var disallowProximitySetup: Bool? = false
    /** The six-character PIN for Find My. This value is available in macOS 10.8 and later. */
    public var pin: String?
    /** This key defines the fallback behavior for erasing a device. */
    public var obliterationBehavior: ObliterationBehavior?
    public var returnToService: EraseDeviceCommandReturnToService?

    public init(preserveDataPlan: Bool? = false, disallowProximitySetup: Bool? = false, pin: String? = nil, obliterationBehavior: ObliterationBehavior? = nil, returnToService: EraseDeviceCommandReturnToService? = nil) {
        self.preserveDataPlan = preserveDataPlan
        self.disallowProximitySetup = disallowProximitySetup
        self.pin = pin
        self.obliterationBehavior = obliterationBehavior
        self.returnToService = returnToService
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case preserveDataPlan
        case disallowProximitySetup
        case pin
        case obliterationBehavior
        case returnToService
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(preserveDataPlan, forKey: .preserveDataPlan)
        try container.encodeIfPresent(disallowProximitySetup, forKey: .disallowProximitySetup)
        try container.encodeIfPresent(pin, forKey: .pin)
        try container.encodeIfPresent(obliterationBehavior, forKey: .obliterationBehavior)
        try container.encodeIfPresent(returnToService, forKey: .returnToService)
    }
}

