//
// InitializeV1.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** Initial Jamf Pro setup data */
public struct InitializeV1: Codable, JSONEncodable, Hashable {

    static let activationCodeRule = StringRule(minLength: 39, maxLength: 39, pattern: nil)
    static let institutionNameRule = StringRule(minLength: 1, maxLength: nil, pattern: nil)
    static let usernameRule = StringRule(minLength: 1, maxLength: nil, pattern: nil)
    static let passwordRule = StringRule(minLength: 1, maxLength: nil, pattern: nil)
    static let jssUrlRule = StringRule(minLength: 1, maxLength: nil, pattern: nil)
    public var activationCode: String
    public var institutionName: String
    public var eulaAccepted: Bool
    public var username: String
    public var password: String
    public var email: String?
    public var jssUrl: String

    public init(activationCode: String, institutionName: String, eulaAccepted: Bool, username: String, password: String, email: String? = nil, jssUrl: String) {
        self.activationCode = activationCode
        self.institutionName = institutionName
        self.eulaAccepted = eulaAccepted
        self.username = username
        self.password = password
        self.email = email
        self.jssUrl = jssUrl
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case activationCode
        case institutionName
        case eulaAccepted
        case username
        case password
        case email
        case jssUrl
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(activationCode, forKey: .activationCode)
        try container.encode(institutionName, forKey: .institutionName)
        try container.encode(eulaAccepted, forKey: .eulaAccepted)
        try container.encode(username, forKey: .username)
        try container.encode(password, forKey: .password)
        try container.encodeIfPresent(email, forKey: .email)
        try container.encode(jssUrl, forKey: .jssUrl)
    }
}

