//
// InventoryInformation.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** Jamf Pro Inventory statistics object. Aggregates managed/unmanaged devices and computers counters */
public struct InventoryInformation: Codable, JSONEncodable, Hashable {

    static let managedComputersRule = NumericRule<Int>(minimum: 0, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    static let unmanagedComputersRule = NumericRule<Int>(minimum: 0, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    static let managedDevicesRule = NumericRule<Int>(minimum: 0, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    static let unmanagedDevicesRule = NumericRule<Int>(minimum: 0, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    /** Number of managed computers in inventory. */
    public var managedComputers: Int?
    /** Number of unmanaged computers in inventory. */
    public var unmanagedComputers: Int?
    /** Number of managed devices in inventory. */
    public var managedDevices: Int?
    /** Number of unmanaged devices in inventory. */
    public var unmanagedDevices: Int?

    public init(managedComputers: Int? = nil, unmanagedComputers: Int? = nil, managedDevices: Int? = nil, unmanagedDevices: Int? = nil) {
        self.managedComputers = managedComputers
        self.unmanagedComputers = unmanagedComputers
        self.managedDevices = managedDevices
        self.unmanagedDevices = unmanagedDevices
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case managedComputers
        case unmanagedComputers
        case managedDevices
        case unmanagedDevices
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(managedComputers, forKey: .managedComputers)
        try container.encodeIfPresent(unmanagedComputers, forKey: .unmanagedComputers)
        try container.encodeIfPresent(managedDevices, forKey: .managedDevices)
        try container.encodeIfPresent(unmanagedDevices, forKey: .unmanagedDevices)
    }
}

