//
// LapsSettingsResponseV2.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct LapsSettingsResponseV2: Codable, JSONEncodable, Hashable {

    /** When enabled, all appropriate computers will have the SetAutoAdminPassword command sent to them automatically. */
    public var autoDeployEnabled: Bool?
    /** The amount of time in seconds that the local admin password will be rotated after viewing. */
    public var passwordRotationTime: Int?
    /** When enabled, all appropriate computers will automatically have their password expired and rotated after the configured autoRotateExpirationTime */
    public var autoRotateEnabled: Bool?
    /** The amount of time in seconds that the local admin password will be rotated automatically if it is never viewed. */
    public var autoRotateExpirationTime: Int?

    public init(autoDeployEnabled: Bool? = nil, passwordRotationTime: Int? = nil, autoRotateEnabled: Bool? = nil, autoRotateExpirationTime: Int? = nil) {
        self.autoDeployEnabled = autoDeployEnabled
        self.passwordRotationTime = passwordRotationTime
        self.autoRotateEnabled = autoRotateEnabled
        self.autoRotateExpirationTime = autoRotateExpirationTime
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case autoDeployEnabled
        case passwordRotationTime
        case autoRotateEnabled
        case autoRotateExpirationTime
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(autoDeployEnabled, forKey: .autoDeployEnabled)
        try container.encodeIfPresent(passwordRotationTime, forKey: .passwordRotationTime)
        try container.encodeIfPresent(autoRotateEnabled, forKey: .autoRotateEnabled)
        try container.encodeIfPresent(autoRotateExpirationTime, forKey: .autoRotateExpirationTime)
    }
}

