//
// LinkedConnectProfile.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct LinkedConnectProfile: Codable, JSONEncodable, Hashable {

    public enum AutoDeploymentType: String, Codable, CaseIterable {
        case patchUpdates = "PATCH_UPDATES"
        case minorAndPatchUpdates = "MINOR_AND_PATCH_UPDATES"
        case initialInstallationOnly = "INITIAL_INSTALLATION_ONLY"
        case _none = "NONE"
    }
    public var uuid: String?
    public var profileId: String?
    public var profileName: String?
    public var profileScopeDescription: String?
    /** Must be a valid Jamf Connect version 2.3.0 or higher. Versions are listed here `https://www.jamf.com/resources/product-documentation/jamf-connect-administrators-guide/` */
    public var version: String?
    /** Determines how the server will behave regarding application updates and installs on the devices that have the configuration profile installed. * `PATCH_UPDATES` - Server handles initial installation of the application and any patch updates. * `MINOR_AND_PATCH_UPDATES` - Server handles initial installation of the application and any patch and minor updates. * `INITIAL_INSTALLATION_ONLY` - Server only handles initial installation of the application. Updates will have to be done manually. * `NONE` - Server does not handle any installations or updates for the application. Version is ignored for this type.  */
    public var autoDeploymentType: AutoDeploymentType? = ._none

    public init(uuid: String? = nil, profileId: String? = nil, profileName: String? = nil, profileScopeDescription: String? = nil, version: String? = nil, autoDeploymentType: AutoDeploymentType? = ._none) {
        self.uuid = uuid
        self.profileId = profileId
        self.profileName = profileName
        self.profileScopeDescription = profileScopeDescription
        self.version = version
        self.autoDeploymentType = autoDeploymentType
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case uuid
        case profileId
        case profileName
        case profileScopeDescription
        case version
        case autoDeploymentType
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(uuid, forKey: .uuid)
        try container.encodeIfPresent(profileId, forKey: .profileId)
        try container.encodeIfPresent(profileName, forKey: .profileName)
        try container.encodeIfPresent(profileScopeDescription, forKey: .profileScopeDescription)
        try container.encodeIfPresent(version, forKey: .version)
        try container.encodeIfPresent(autoDeploymentType, forKey: .autoDeploymentType)
    }
}

