//
// MacOsManagedSoftwareUpdate.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct MacOsManagedSoftwareUpdate: Codable, JSONEncodable, Hashable {

    public enum UpdateAction: String, Codable, CaseIterable {
        case andInstall = "DOWNLOAD_AND_INSTALL"
        case only = "DOWNLOAD_ONLY"
    }
    public enum Priority: String, Codable, CaseIterable {
        case high = "HIGH"
        case low = "LOW"
    }
    static let maxDeferralsRule = NumericRule<Int>(minimum: 0, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    public var deviceIds: [String]?
    public var groupId: String?
    /** Allow users to defer the update the provided number of times before macOS forces the update. If a value is provided, the Software Update will use the InstallLater install action. */
    public var maxDeferrals: Int?
    /** If no value is provided, the version will default to latest version based on device eligibility. */
    public var version: String?
    /** If no value is provided, the skipVersionVerification will default to false. If a value is provided, the specified version will be forced to complete DownloadAndInstall install action. */
    public var skipVersionVerification: Bool? = false
    /** ApplyMajorUpdate setting is available only when updating to the latest version based on device eligibility. If no value is provided, the calculated latest version will only include minor version updates. If a value is provided, the calculated latest version will include minor and major version updates. */
    public var applyMajorUpdate: Bool? = false
    /** MaxDeferral is ignored if using the DownloadOnly install action. */
    public var updateAction: UpdateAction?
    /** If not set, forceRestart will default to false. Can only be true if using the DownloadAndInstall install action and the devices the command is sent to are on macOs 11 or higher. If true, the DownloadAndInstall action is performed, a restart will be forced. MaxDeferral will be ignored if defined.  */
    public var forceRestart: Bool? = false
    /** Priority can only be configured on macOS 12.3 and above, for minor updates only. Any version below 12.3 is always Low and cannot be changed until prerequisites are met. When qualified, if not explicitly set, priority will default to High */
    public var priority: Priority? = .high

    public init(deviceIds: [String]? = nil, groupId: String? = nil, maxDeferrals: Int? = nil, version: String? = nil, skipVersionVerification: Bool? = false, applyMajorUpdate: Bool? = false, updateAction: UpdateAction? = nil, forceRestart: Bool? = false, priority: Priority? = .high) {
        self.deviceIds = deviceIds
        self.groupId = groupId
        self.maxDeferrals = maxDeferrals
        self.version = version
        self.skipVersionVerification = skipVersionVerification
        self.applyMajorUpdate = applyMajorUpdate
        self.updateAction = updateAction
        self.forceRestart = forceRestart
        self.priority = priority
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case deviceIds
        case groupId
        case maxDeferrals
        case version
        case skipVersionVerification
        case applyMajorUpdate
        case updateAction
        case forceRestart
        case priority
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(deviceIds, forKey: .deviceIds)
        try container.encodeIfPresent(groupId, forKey: .groupId)
        try container.encodeIfPresent(maxDeferrals, forKey: .maxDeferrals)
        try container.encodeIfPresent(version, forKey: .version)
        try container.encodeIfPresent(skipVersionVerification, forKey: .skipVersionVerification)
        try container.encodeIfPresent(applyMajorUpdate, forKey: .applyMajorUpdate)
        try container.encodeIfPresent(updateAction, forKey: .updateAction)
        try container.encodeIfPresent(forceRestart, forKey: .forceRestart)
        try container.encodeIfPresent(priority, forKey: .priority)
    }
}

