//
// ManagedSoftwareUpdatePlan.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ManagedSoftwareUpdatePlan: Codable, JSONEncodable, Hashable {

    public enum UpdateAction: String, Codable, CaseIterable {
        case downloadOnly = "DOWNLOAD_ONLY"
        case downloadInstall = "DOWNLOAD_INSTALL"
        case downloadInstallAllowDeferral = "DOWNLOAD_INSTALL_ALLOW_DEFERRAL"
        case downloadInstallRestart = "DOWNLOAD_INSTALL_RESTART"
        case downloadInstallSchedule = "DOWNLOAD_INSTALL_SCHEDULE"
        case unknown = "UNKNOWN"
    }
    public enum VersionType: String, Codable, CaseIterable {
        case latestMajor = "LATEST_MAJOR"
        case latestMinor = "LATEST_MINOR"
        case latestAny = "LATEST_ANY"
        case specificVersion = "SPECIFIC_VERSION"
        case unknown = "UNKNOWN"
    }
    static let planUuidRule = StringRule(minLength: 1, maxLength: nil, pattern: nil)
    static let maxDeferralsRule = NumericRule<Int>(minimum: 0, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    public var planUuid: String
    public var device: PlanDevice
    public var updateAction: UpdateAction
    public var versionType: VersionType
    /** Optional. Indicates the specific version to update to. Only available when the version type is set to specific version, otherwise defaults to NO_SPECIFIC_VERSION. */
    public var specificVersion: String? = "NO_SPECIFIC_VERSION"
    /** Not applicable to all managed software update plans */
    public var maxDeferrals: Int
    /** Optional. Indicates the local date and time of the device to force update by. */
    public var forceInstallLocalDateTime: String?
    public var status: PlanStatus

    public init(planUuid: String, device: PlanDevice, updateAction: UpdateAction, versionType: VersionType, specificVersion: String? = "NO_SPECIFIC_VERSION", maxDeferrals: Int, forceInstallLocalDateTime: String? = nil, status: PlanStatus) {
        self.planUuid = planUuid
        self.device = device
        self.updateAction = updateAction
        self.versionType = versionType
        self.specificVersion = specificVersion
        self.maxDeferrals = maxDeferrals
        self.forceInstallLocalDateTime = forceInstallLocalDateTime
        self.status = status
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case planUuid
        case device
        case updateAction
        case versionType
        case specificVersion
        case maxDeferrals
        case forceInstallLocalDateTime
        case status
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(planUuid, forKey: .planUuid)
        try container.encode(device, forKey: .device)
        try container.encode(updateAction, forKey: .updateAction)
        try container.encode(versionType, forKey: .versionType)
        try container.encodeIfPresent(specificVersion, forKey: .specificVersion)
        try container.encode(maxDeferrals, forKey: .maxDeferrals)
        try container.encodeIfPresent(forceInstallLocalDateTime, forKey: .forceInstallLocalDateTime)
        try container.encode(status, forKey: .status)
    }
}

