//
// ManagedSoftwareUpdateStatus.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ManagedSoftwareUpdateStatus: Codable, JSONEncodable, Hashable {

    public enum Status: String, Codable, CaseIterable {
        case downloading = "DOWNLOADING"
        case idle = "IDLE"
        case installing = "INSTALLING"
        case installed = "INSTALLED"
        case error = "ERROR"
        case downloadFailed = "DOWNLOAD_FAILED"
        case downloadRequiresComputer = "DOWNLOAD_REQUIRES_COMPUTER"
        case downloadInsufficientSpace = "DOWNLOAD_INSUFFICIENT_SPACE"
        case downloadInsufficientPower = "DOWNLOAD_INSUFFICIENT_POWER"
        case downloadInsufficientNetwork = "DOWNLOAD_INSUFFICIENT_NETWORK"
        case installInsufficientSpace = "INSTALL_INSUFFICIENT_SPACE"
        case installInsufficientPower = "INSTALL_INSUFFICIENT_POWER"
        case installPhoneCallInProgress = "INSTALL_PHONE_CALL_IN_PROGRESS"
        case installFailed = "INSTALL_FAILED"
        case unknown = "UNKNOWN"
    }
    public var osUpdatesStatusId: String?
    public var device: ManagedSoftwareUpdateStatusDevice?
    public var downloadPercentComplete: Double?
    public var downloaded: Bool?
    public var productKey: String?
    public var status: Status?
    /** not applicable to all managed software update statuses */
    public var deferralsRemaining: Int?
    /** not applicable to all managed software update statuses */
    public var maxDeferrals: Int?
    /** not applicable to all managed software update statuses */
    public var nextScheduledInstall: String?
    /** not applicable to all managed software update statuses */
    public var pastNotifications: [Date]?
    public var created: String?
    public var updated: String?

    public init(osUpdatesStatusId: String? = nil, device: ManagedSoftwareUpdateStatusDevice? = nil, downloadPercentComplete: Double? = nil, downloaded: Bool? = nil, productKey: String? = nil, status: Status? = nil, deferralsRemaining: Int? = nil, maxDeferrals: Int? = nil, nextScheduledInstall: String? = nil, pastNotifications: [Date]? = nil, created: String? = nil, updated: String? = nil) {
        self.osUpdatesStatusId = osUpdatesStatusId
        self.device = device
        self.downloadPercentComplete = downloadPercentComplete
        self.downloaded = downloaded
        self.productKey = productKey
        self.status = status
        self.deferralsRemaining = deferralsRemaining
        self.maxDeferrals = maxDeferrals
        self.nextScheduledInstall = nextScheduledInstall
        self.pastNotifications = pastNotifications
        self.created = created
        self.updated = updated
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case osUpdatesStatusId
        case device
        case downloadPercentComplete
        case downloaded
        case productKey
        case status
        case deferralsRemaining
        case maxDeferrals
        case nextScheduledInstall
        case pastNotifications
        case created
        case updated
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(osUpdatesStatusId, forKey: .osUpdatesStatusId)
        try container.encodeIfPresent(device, forKey: .device)
        try container.encodeIfPresent(downloadPercentComplete, forKey: .downloadPercentComplete)
        try container.encodeIfPresent(downloaded, forKey: .downloaded)
        try container.encodeIfPresent(productKey, forKey: .productKey)
        try container.encodeIfPresent(status, forKey: .status)
        try container.encodeIfPresent(deferralsRemaining, forKey: .deferralsRemaining)
        try container.encodeIfPresent(maxDeferrals, forKey: .maxDeferrals)
        try container.encodeIfPresent(nextScheduledInstall, forKey: .nextScheduledInstall)
        try container.encodeIfPresent(pastNotifications, forKey: .pastNotifications)
        try container.encodeIfPresent(created, forKey: .created)
        try container.encodeIfPresent(updated, forKey: .updated)
    }
}

