//
// MobileDeviceDetails.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct MobileDeviceDetails: Codable, JSONEncodable, Hashable {

    public enum ModelType: String, Codable, CaseIterable {
        case ios = "ios"
        case appletv = "appleTv"
        case android = "android"
        case unknown = "unknown"
    }
    public var id: Int?
    public var name: String?
    public var assetTag: String?
    public var lastInventoryUpdateTimestamp: String?
    public var osVersion: String?
    public var osBuild: String?
    /** Collected for iOS 16 and iPadOS 16.1 or later */
    public var osSupplementalBuildVersion: String?
    /** Collected for iOS 16 and iPadOS 16.1 or later */
    public var osRapidSecurityResponse: String?
    public var softwareUpdateDeviceId: String?
    public var serialNumber: String?
    public var udid: String?
    public var ipAddress: String?
    public var wifiMacAddress: String?
    public var bluetoothMacAddress: String?
    public var isManaged: Bool?
    public var initialEntryTimestamp: String?
    public var lastEnrollmentTimestamp: String?
    public var deviceOwnershipLevel: String?
    public var site: IdAndName?
    public var extensionAttributes: [ExtensionAttribute]?
    public var location: Location?
    /** Based on the value of this either ios, appleTv, android objects will be populated. */
    public var type: ModelType?
    public var ios: IosDetails?
    public var appleTv: AppleTvDetails?
    public var android: AndroidDetails?

    public init(id: Int? = nil, name: String? = nil, assetTag: String? = nil, lastInventoryUpdateTimestamp: String? = nil, osVersion: String? = nil, osBuild: String? = nil, osSupplementalBuildVersion: String? = nil, osRapidSecurityResponse: String? = nil, softwareUpdateDeviceId: String? = nil, serialNumber: String? = nil, udid: String? = nil, ipAddress: String? = nil, wifiMacAddress: String? = nil, bluetoothMacAddress: String? = nil, isManaged: Bool? = nil, initialEntryTimestamp: String? = nil, lastEnrollmentTimestamp: String? = nil, deviceOwnershipLevel: String? = nil, site: IdAndName? = nil, extensionAttributes: [ExtensionAttribute]? = nil, location: Location? = nil, type: ModelType? = nil, ios: IosDetails? = nil, appleTv: AppleTvDetails? = nil, android: AndroidDetails? = nil) {
        self.id = id
        self.name = name
        self.assetTag = assetTag
        self.lastInventoryUpdateTimestamp = lastInventoryUpdateTimestamp
        self.osVersion = osVersion
        self.osBuild = osBuild
        self.osSupplementalBuildVersion = osSupplementalBuildVersion
        self.osRapidSecurityResponse = osRapidSecurityResponse
        self.softwareUpdateDeviceId = softwareUpdateDeviceId
        self.serialNumber = serialNumber
        self.udid = udid
        self.ipAddress = ipAddress
        self.wifiMacAddress = wifiMacAddress
        self.bluetoothMacAddress = bluetoothMacAddress
        self.isManaged = isManaged
        self.initialEntryTimestamp = initialEntryTimestamp
        self.lastEnrollmentTimestamp = lastEnrollmentTimestamp
        self.deviceOwnershipLevel = deviceOwnershipLevel
        self.site = site
        self.extensionAttributes = extensionAttributes
        self.location = location
        self.type = type
        self.ios = ios
        self.appleTv = appleTv
        self.android = android
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case name
        case assetTag
        case lastInventoryUpdateTimestamp
        case osVersion
        case osBuild
        case osSupplementalBuildVersion
        case osRapidSecurityResponse
        case softwareUpdateDeviceId
        case serialNumber
        case udid
        case ipAddress
        case wifiMacAddress
        case bluetoothMacAddress
        case isManaged
        case initialEntryTimestamp
        case lastEnrollmentTimestamp
        case deviceOwnershipLevel
        case site
        case extensionAttributes
        case location
        case type
        case ios
        case appleTv
        case android
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(name, forKey: .name)
        try container.encodeIfPresent(assetTag, forKey: .assetTag)
        try container.encodeIfPresent(lastInventoryUpdateTimestamp, forKey: .lastInventoryUpdateTimestamp)
        try container.encodeIfPresent(osVersion, forKey: .osVersion)
        try container.encodeIfPresent(osBuild, forKey: .osBuild)
        try container.encodeIfPresent(osSupplementalBuildVersion, forKey: .osSupplementalBuildVersion)
        try container.encodeIfPresent(osRapidSecurityResponse, forKey: .osRapidSecurityResponse)
        try container.encodeIfPresent(softwareUpdateDeviceId, forKey: .softwareUpdateDeviceId)
        try container.encodeIfPresent(serialNumber, forKey: .serialNumber)
        try container.encodeIfPresent(udid, forKey: .udid)
        try container.encodeIfPresent(ipAddress, forKey: .ipAddress)
        try container.encodeIfPresent(wifiMacAddress, forKey: .wifiMacAddress)
        try container.encodeIfPresent(bluetoothMacAddress, forKey: .bluetoothMacAddress)
        try container.encodeIfPresent(isManaged, forKey: .isManaged)
        try container.encodeIfPresent(initialEntryTimestamp, forKey: .initialEntryTimestamp)
        try container.encodeIfPresent(lastEnrollmentTimestamp, forKey: .lastEnrollmentTimestamp)
        try container.encodeIfPresent(deviceOwnershipLevel, forKey: .deviceOwnershipLevel)
        try container.encodeIfPresent(site, forKey: .site)
        try container.encodeIfPresent(extensionAttributes, forKey: .extensionAttributes)
        try container.encodeIfPresent(location, forKey: .location)
        try container.encodeIfPresent(type, forKey: .type)
        try container.encodeIfPresent(ios, forKey: .ios)
        try container.encodeIfPresent(appleTv, forKey: .appleTv)
        try container.encodeIfPresent(android, forKey: .android)
    }
}

