//
// MobileDeviceDetailsGetV2.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct MobileDeviceDetailsGetV2: Codable, JSONEncodable, Hashable {

    public enum ModelType: String, Codable, CaseIterable {
        case ios = "ios"
        case tvos = "tvos"
        case watchos = "watchos"
        case visionos = "visionos"
        case unknown = "unknown"
    }
    public var id: String?
    /** Mobile device name. */
    public var name: String?
    /** Enforce the mobile device name. Device must be supervised. If set to true, Jamf Pro will revert the Mobile Device Name to the ‘name’ value each time the device checks in. */
    public var enforceName: Bool?
    public var assetTag: String?
    public var lastInventoryUpdateTimestamp: String?
    public var osVersion: String?
    public var osBuild: String?
    /** Collected for iOS 16 and iPadOS 16.1 or later */
    public var osSupplementalBuildVersion: String?
    /** Collected for iOS 16 and iPadOS 16.1 or later */
    public var osRapidSecurityResponse: String?
    public var softwareUpdateDeviceId: String?
    public var serialNumber: String?
    public var udid: String?
    public var ipAddress: String?
    public var wifiMacAddress: String?
    public var bluetoothMacAddress: String?
    public var managed: Bool?
    public var timeZone: String?
    public var initialEntryTimestamp: String?
    public var lastEnrollmentTimestamp: String?
    public var mdmProfileExpirationTimestamp: String?
    public var deviceOwnershipLevel: String?
    public var enrollmentMethod: String?
    public var enrollmentSessionTokenValid: Bool?
    public var declarativeDeviceManagementEnabled: Bool?
    public var site: V1Site?
    public var extensionAttributes: [ExtensionAttributeV2]?
    public var location: LocationV2?
    /** Based on the value of this either ios, appleTv, android objects will be populated. */
    public var type: ModelType?
    public var ios: IosDetailsV2?
    public var tvos: TvOsDetails?
    public var managementId: String?

    public init(id: String? = nil, name: String? = nil, enforceName: Bool? = nil, assetTag: String? = nil, lastInventoryUpdateTimestamp: String? = nil, osVersion: String? = nil, osBuild: String? = nil, osSupplementalBuildVersion: String? = nil, osRapidSecurityResponse: String? = nil, softwareUpdateDeviceId: String? = nil, serialNumber: String? = nil, udid: String? = nil, ipAddress: String? = nil, wifiMacAddress: String? = nil, bluetoothMacAddress: String? = nil, managed: Bool? = nil, timeZone: String? = nil, initialEntryTimestamp: String? = nil, lastEnrollmentTimestamp: String? = nil, mdmProfileExpirationTimestamp: String? = nil, deviceOwnershipLevel: String? = nil, enrollmentMethod: String? = nil, enrollmentSessionTokenValid: Bool? = nil, declarativeDeviceManagementEnabled: Bool? = nil, site: V1Site? = nil, extensionAttributes: [ExtensionAttributeV2]? = nil, location: LocationV2? = nil, type: ModelType? = nil, ios: IosDetailsV2? = nil, tvos: TvOsDetails? = nil, managementId: String? = nil) {
        self.id = id
        self.name = name
        self.enforceName = enforceName
        self.assetTag = assetTag
        self.lastInventoryUpdateTimestamp = lastInventoryUpdateTimestamp
        self.osVersion = osVersion
        self.osBuild = osBuild
        self.osSupplementalBuildVersion = osSupplementalBuildVersion
        self.osRapidSecurityResponse = osRapidSecurityResponse
        self.softwareUpdateDeviceId = softwareUpdateDeviceId
        self.serialNumber = serialNumber
        self.udid = udid
        self.ipAddress = ipAddress
        self.wifiMacAddress = wifiMacAddress
        self.bluetoothMacAddress = bluetoothMacAddress
        self.managed = managed
        self.timeZone = timeZone
        self.initialEntryTimestamp = initialEntryTimestamp
        self.lastEnrollmentTimestamp = lastEnrollmentTimestamp
        self.mdmProfileExpirationTimestamp = mdmProfileExpirationTimestamp
        self.deviceOwnershipLevel = deviceOwnershipLevel
        self.enrollmentMethod = enrollmentMethod
        self.enrollmentSessionTokenValid = enrollmentSessionTokenValid
        self.declarativeDeviceManagementEnabled = declarativeDeviceManagementEnabled
        self.site = site
        self.extensionAttributes = extensionAttributes
        self.location = location
        self.type = type
        self.ios = ios
        self.tvos = tvos
        self.managementId = managementId
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case name
        case enforceName
        case assetTag
        case lastInventoryUpdateTimestamp
        case osVersion
        case osBuild
        case osSupplementalBuildVersion
        case osRapidSecurityResponse
        case softwareUpdateDeviceId
        case serialNumber
        case udid
        case ipAddress
        case wifiMacAddress
        case bluetoothMacAddress
        case managed
        case timeZone
        case initialEntryTimestamp
        case lastEnrollmentTimestamp
        case mdmProfileExpirationTimestamp
        case deviceOwnershipLevel
        case enrollmentMethod
        case enrollmentSessionTokenValid
        case declarativeDeviceManagementEnabled
        case site
        case extensionAttributes
        case location
        case type
        case ios
        case tvos
        case managementId
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(name, forKey: .name)
        try container.encodeIfPresent(enforceName, forKey: .enforceName)
        try container.encodeIfPresent(assetTag, forKey: .assetTag)
        try container.encodeIfPresent(lastInventoryUpdateTimestamp, forKey: .lastInventoryUpdateTimestamp)
        try container.encodeIfPresent(osVersion, forKey: .osVersion)
        try container.encodeIfPresent(osBuild, forKey: .osBuild)
        try container.encodeIfPresent(osSupplementalBuildVersion, forKey: .osSupplementalBuildVersion)
        try container.encodeIfPresent(osRapidSecurityResponse, forKey: .osRapidSecurityResponse)
        try container.encodeIfPresent(softwareUpdateDeviceId, forKey: .softwareUpdateDeviceId)
        try container.encodeIfPresent(serialNumber, forKey: .serialNumber)
        try container.encodeIfPresent(udid, forKey: .udid)
        try container.encodeIfPresent(ipAddress, forKey: .ipAddress)
        try container.encodeIfPresent(wifiMacAddress, forKey: .wifiMacAddress)
        try container.encodeIfPresent(bluetoothMacAddress, forKey: .bluetoothMacAddress)
        try container.encodeIfPresent(managed, forKey: .managed)
        try container.encodeIfPresent(timeZone, forKey: .timeZone)
        try container.encodeIfPresent(initialEntryTimestamp, forKey: .initialEntryTimestamp)
        try container.encodeIfPresent(lastEnrollmentTimestamp, forKey: .lastEnrollmentTimestamp)
        try container.encodeIfPresent(mdmProfileExpirationTimestamp, forKey: .mdmProfileExpirationTimestamp)
        try container.encodeIfPresent(deviceOwnershipLevel, forKey: .deviceOwnershipLevel)
        try container.encodeIfPresent(enrollmentMethod, forKey: .enrollmentMethod)
        try container.encodeIfPresent(enrollmentSessionTokenValid, forKey: .enrollmentSessionTokenValid)
        try container.encodeIfPresent(declarativeDeviceManagementEnabled, forKey: .declarativeDeviceManagementEnabled)
        try container.encodeIfPresent(site, forKey: .site)
        try container.encodeIfPresent(extensionAttributes, forKey: .extensionAttributes)
        try container.encodeIfPresent(location, forKey: .location)
        try container.encodeIfPresent(type, forKey: .type)
        try container.encodeIfPresent(ios, forKey: .ios)
        try container.encodeIfPresent(tvos, forKey: .tvos)
        try container.encodeIfPresent(managementId, forKey: .managementId)
    }
}

