//
// MobileDeviceIosInventory.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct MobileDeviceIosInventory: Codable, JSONEncodable, Hashable {

    static let mobileDeviceIdRule = StringRule(minLength: 1, maxLength: nil, pattern: nil)
    public var mobileDeviceId: String?
    /** Based on the value of this type either ios or appleTv objects will be populated. */
    public var deviceType: String
    public var hardware: MobileDeviceHardware?
    public var userAndLocation: MobileDeviceUserAndLocation?
    public var purchasing: MobileDevicePurchasing?
    public var applications: [MobileDeviceApplicationInventoryDetail]?
    public var certificates: [MobileDeviceCertificate]?
    public var profiles: [MobileDeviceProfile]?
    public var userProfiles: [MobileDeviceUserProfile]?
    public var extensionAttributes: [MobileDeviceExtensionAttribute]?
    public var general: MobileDeviceIosGeneral?
    public var security: MobileDeviceSecurity?
    public var ebooks: [MobileDeviceEbookInventoryDetail]?
    public var network: MobileDeviceNetwork?
    public var serviceSubscriptions: [MobileDeviceServiceSubscriptions]?
    public var provisioningProfiles: [MobileDeviceProvisioningProfiles]?
    public var sharedUsers: [MobileDeviceSharedUser]?

    public init(mobileDeviceId: String? = nil, deviceType: String, hardware: MobileDeviceHardware? = nil, userAndLocation: MobileDeviceUserAndLocation? = nil, purchasing: MobileDevicePurchasing? = nil, applications: [MobileDeviceApplicationInventoryDetail]? = nil, certificates: [MobileDeviceCertificate]? = nil, profiles: [MobileDeviceProfile]? = nil, userProfiles: [MobileDeviceUserProfile]? = nil, extensionAttributes: [MobileDeviceExtensionAttribute]? = nil, general: MobileDeviceIosGeneral? = nil, security: MobileDeviceSecurity? = nil, ebooks: [MobileDeviceEbookInventoryDetail]? = nil, network: MobileDeviceNetwork? = nil, serviceSubscriptions: [MobileDeviceServiceSubscriptions]? = nil, provisioningProfiles: [MobileDeviceProvisioningProfiles]? = nil, sharedUsers: [MobileDeviceSharedUser]? = nil) {
        self.mobileDeviceId = mobileDeviceId
        self.deviceType = deviceType
        self.hardware = hardware
        self.userAndLocation = userAndLocation
        self.purchasing = purchasing
        self.applications = applications
        self.certificates = certificates
        self.profiles = profiles
        self.userProfiles = userProfiles
        self.extensionAttributes = extensionAttributes
        self.general = general
        self.security = security
        self.ebooks = ebooks
        self.network = network
        self.serviceSubscriptions = serviceSubscriptions
        self.provisioningProfiles = provisioningProfiles
        self.sharedUsers = sharedUsers
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case mobileDeviceId
        case deviceType
        case hardware
        case userAndLocation
        case purchasing
        case applications
        case certificates
        case profiles
        case userProfiles
        case extensionAttributes
        case general
        case security
        case ebooks
        case network
        case serviceSubscriptions
        case provisioningProfiles
        case sharedUsers
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(mobileDeviceId, forKey: .mobileDeviceId)
        try container.encode(deviceType, forKey: .deviceType)
        try container.encodeIfPresent(hardware, forKey: .hardware)
        try container.encodeIfPresent(userAndLocation, forKey: .userAndLocation)
        try container.encodeIfPresent(purchasing, forKey: .purchasing)
        try container.encodeIfPresent(applications, forKey: .applications)
        try container.encodeIfPresent(certificates, forKey: .certificates)
        try container.encodeIfPresent(profiles, forKey: .profiles)
        try container.encodeIfPresent(userProfiles, forKey: .userProfiles)
        try container.encodeIfPresent(extensionAttributes, forKey: .extensionAttributes)
        try container.encodeIfPresent(general, forKey: .general)
        try container.encodeIfPresent(security, forKey: .security)
        try container.encodeIfPresent(ebooks, forKey: .ebooks)
        try container.encodeIfPresent(network, forKey: .network)
        try container.encodeIfPresent(serviceSubscriptions, forKey: .serviceSubscriptions)
        try container.encodeIfPresent(provisioningProfiles, forKey: .provisioningProfiles)
        try container.encodeIfPresent(sharedUsers, forKey: .sharedUsers)
    }
}

