//
// PackageManifest.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct PackageManifest: Codable, JSONEncodable, Hashable {

    public enum HashType: String, Codable, CaseIterable {
        case md5 = "MD5"
        case sha256 = "SHA256"
    }
    public var url: String
    public var hash: String
    public var hashType: HashType
    public var displayImageUrl: String?
    public var fullSizeImageUrl: String?
    public var bundleId: String
    public var bundleVersion: String
    public var subtitle: String?
    public var title: String
    public var sizeInBytes: Int

    public init(url: String, hash: String, hashType: HashType, displayImageUrl: String? = nil, fullSizeImageUrl: String? = nil, bundleId: String, bundleVersion: String, subtitle: String? = nil, title: String, sizeInBytes: Int) {
        self.url = url
        self.hash = hash
        self.hashType = hashType
        self.displayImageUrl = displayImageUrl
        self.fullSizeImageUrl = fullSizeImageUrl
        self.bundleId = bundleId
        self.bundleVersion = bundleVersion
        self.subtitle = subtitle
        self.title = title
        self.sizeInBytes = sizeInBytes
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case url
        case hash
        case hashType
        case displayImageUrl
        case fullSizeImageUrl
        case bundleId
        case bundleVersion
        case subtitle
        case title
        case sizeInBytes
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(url, forKey: .url)
        try container.encode(hash, forKey: .hash)
        try container.encode(hashType, forKey: .hashType)
        try container.encodeIfPresent(displayImageUrl, forKey: .displayImageUrl)
        try container.encodeIfPresent(fullSizeImageUrl, forKey: .fullSizeImageUrl)
        try container.encode(bundleId, forKey: .bundleId)
        try container.encode(bundleVersion, forKey: .bundleVersion)
        try container.encodeIfPresent(subtitle, forKey: .subtitle)
        try container.encode(title, forKey: .title)
        try container.encode(sizeInBytes, forKey: .sizeInBytes)
    }
}

