//
// PlanConfigurationPost.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct PlanConfigurationPost: Codable, JSONEncodable, Hashable {

    public enum UpdateAction: String, Codable, CaseIterable {
        case downloadOnly = "DOWNLOAD_ONLY"
        case downloadInstall = "DOWNLOAD_INSTALL"
        case downloadInstallAllowDeferral = "DOWNLOAD_INSTALL_ALLOW_DEFERRAL"
        case downloadInstallRestart = "DOWNLOAD_INSTALL_RESTART"
        case downloadInstallSchedule = "DOWNLOAD_INSTALL_SCHEDULE"
        case unknown = "UNKNOWN"
    }
    public enum VersionType: String, Codable, CaseIterable {
        case latestMajor = "LATEST_MAJOR"
        case latestMinor = "LATEST_MINOR"
        case latestAny = "LATEST_ANY"
        case specificVersion = "SPECIFIC_VERSION"
        case unknown = "UNKNOWN"
    }
    static let specificVersionRule = StringRule(minLength: 0, maxLength: nil, pattern: nil)
    static let maxDeferralsRule = NumericRule<Int>(minimum: 0, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    public var updateAction: UpdateAction
    public var versionType: VersionType
    /** Optional. Indicates the specific version to update to. Only available when the version type is set to specific version, otherwise defaults to NO_SPECIFIC_VERSION. */
    public var specificVersion: String? = "NO_SPECIFIC_VERSION"
    /** Required when the provided updateAction is DOWNLOAD_INSTALL_ALLOW_DEFERRAL, not applicable to all managed software update plans */
    public var maxDeferrals: Int?
    /** Optional. Indicates the local date and time of the device to force update by. */
    public var forceInstallLocalDateTime: String?

    public init(updateAction: UpdateAction, versionType: VersionType, specificVersion: String? = "NO_SPECIFIC_VERSION", maxDeferrals: Int? = nil, forceInstallLocalDateTime: String? = nil) {
        self.updateAction = updateAction
        self.versionType = versionType
        self.specificVersion = specificVersion
        self.maxDeferrals = maxDeferrals
        self.forceInstallLocalDateTime = forceInstallLocalDateTime
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case updateAction
        case versionType
        case specificVersion
        case maxDeferrals
        case forceInstallLocalDateTime
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(updateAction, forKey: .updateAction)
        try container.encode(versionType, forKey: .versionType)
        try container.encodeIfPresent(specificVersion, forKey: .specificVersion)
        try container.encodeIfPresent(maxDeferrals, forKey: .maxDeferrals)
        try container.encodeIfPresent(forceInstallLocalDateTime, forKey: .forceInstallLocalDateTime)
    }
}

