//
// PlanStatus.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct PlanStatus: Codable, JSONEncodable, Hashable {

    public enum State: String, Codable, CaseIterable {
        case _init = "Init"
        case pendingPlanValidation = "PendingPlanValidation"
        case acceptingPlan = "AcceptingPlan"
        case rejectingPlan = "RejectingPlan"
        case processingPlanType = "ProcessingPlanType"
        case startingPlan = "StartingPlan"
        case planFailed = "PlanFailed"
        case schedulingScanForOSUpdates = "SchedulingScanForOSUpdates"
        case processingScheduleOSUpdateScanResponse = "ProcessingScheduleOSUpdateScanResponse"
        case waitingForScheduledOSUpdateScanToComplete = "WaitingForScheduledOSUpdateScanToComplete"
        case collectingAvailableOSUpdates = "CollectingAvailableOSUpdates"
        case processingAvailableOSUpdatesResponse = "ProcessingAvailableOSUpdatesResponse"
        case processingSchedulingType = "ProcessingSchedulingType"
        case schedulingDDM = "SchedulingDDM"
        case ddmplanscheduled = "DDMPlanScheduled"
        case waitingToStartDDMUpdate = "WaitingToStartDDMUpdate"
        case processingDDMStatusResponse = "ProcessingDDMStatusResponse"
        case collectingDDMStatus = "CollectingDDMStatus"
        case schedulingMDM = "SchedulingMDM"
        case mdmplanscheduled = "MDMPlanScheduled"
        case schedulingOSUpdate = "SchedulingOSUpdate"
        case processingScheduleOSUpdateResponse = "ProcessingScheduleOSUpdateResponse"
        case collectingOSUpdateStatus = "CollectingOSUpdateStatus"
        case processingOSUpdateStatusResponse = "ProcessingOSUpdateStatusResponse"
        case waitingToCollectOSUpdateStatus = "WaitingToCollectOSUpdateStatus"
        case verifyingInstallation = "VerifyingInstallation"
        case processingInstallationVerification = "ProcessingInstallationVerification"
        case planCompleted = "PlanCompleted"
        case planCanceled = "PlanCanceled"
        case planException = "PlanException"
        case unknown = "Unknown"
    }
    public enum ErrorReasons: String, Codable, CaseIterable {
        case appleSiliconNoEscrowKey = "APPLE_SILICON_NO_ESCROW_KEY"
        case notSupervised = "NOT_SUPERVISED"
        case notManaged = "NOT_MANAGED"
        case noDiskSpace = "NO_DISK_SPACE"
        case noUpdatesAvailable = "NO_UPDATES_AVAILABLE"
        case specificVersionUnavailable = "SPECIFIC_VERSION_UNAVAILABLE"
        case actionNotSupportedForDeviceType = "ACTION_NOT_SUPPORTED_FOR_DEVICE_TYPE"
        case declarativeDeviceManagementSoftwareUpdatesNotSupportedForDeviceOsVersion = "DECLARATIVE_DEVICE_MANAGEMENT_SOFTWARE_UPDATES_NOT_SUPPORTED_FOR_DEVICE_OS_VERSION"
        case declarativeDeviceManagementSoftwareUpdatesNotSupportedForDeviceType = "DECLARATIVE_DEVICE_MANAGEMENT_SOFTWARE_UPDATES_NOT_SUPPORTED_FOR_DEVICE_TYPE"
        case planNotFound = "PLAN_NOT_FOUND"
        case appleSoftwareLookupServiceError = "APPLE_SOFTWARE_LOOKUP_SERVICE_ERROR"
        case existingPlanForDeviceInProgress = "EXISTING_PLAN_FOR_DEVICE_IN_PROGRESS"
        case downgradeNotSupported = "DOWNGRADE_NOT_SUPPORTED"
        case declarativeServiceError = "DECLARATIVE_SERVICE_ERROR"
        case unknown = "UNKNOWN"
    }
    public var state: State?
    public var errorReasons: [ErrorReasons]?

    public init(state: State? = nil, errorReasons: [ErrorReasons]? = nil) {
        self.state = state
        self.errorReasons = errorReasons
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case state
        case errorReasons
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(state, forKey: .state)
        try container.encodeIfPresent(errorReasons, forKey: .errorReasons)
    }
}

