//
// ProtectSettingsResponse.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ProtectSettingsResponse: Codable, JSONEncodable, Hashable {

    public enum SyncStatus: String, Codable, CaseIterable {
        case inProgress = "IN_PROGRESS"
        case completed = "COMPLETED"
        case error = "ERROR"
        case unknown = "UNKNOWN"
    }
    public var id: String?
    public var apiClientId: String?
    /** display name used when creating the API Client in the Jamf Protect web console */
    public var apiClientName: String?
    /** ID used when making requests to identify this particular Protect registration. */
    public var registrationId: String?
    public var protectUrl: String?
    public var lastSyncTime: String?
    public var syncStatus: SyncStatus?
    /** determines whether the Jamf Protect agent will be automatically installed on client computers */
    public var autoInstall: Bool?

    public init(id: String? = nil, apiClientId: String? = nil, apiClientName: String? = nil, registrationId: String? = nil, protectUrl: String? = nil, lastSyncTime: String? = nil, syncStatus: SyncStatus? = nil, autoInstall: Bool? = nil) {
        self.id = id
        self.apiClientId = apiClientId
        self.apiClientName = apiClientName
        self.registrationId = registrationId
        self.protectUrl = protectUrl
        self.lastSyncTime = lastSyncTime
        self.syncStatus = syncStatus
        self.autoInstall = autoInstall
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case apiClientId
        case apiClientName
        case registrationId
        case protectUrl
        case lastSyncTime
        case syncStatus
        case autoInstall
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(apiClientId, forKey: .apiClientId)
        try container.encodeIfPresent(apiClientName, forKey: .apiClientName)
        try container.encodeIfPresent(registrationId, forKey: .registrationId)
        try container.encodeIfPresent(protectUrl, forKey: .protectUrl)
        try container.encodeIfPresent(lastSyncTime, forKey: .lastSyncTime)
        try container.encodeIfPresent(syncStatus, forKey: .syncStatus)
        try container.encodeIfPresent(autoInstall, forKey: .autoInstall)
    }
}

