//
// PutComputerPrestageV3.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct PutComputerPrestageV3: Codable, JSONEncodable, Hashable {

    public enum RecoveryLockPasswordType: String, Codable, CaseIterable {
        case manual = "MANUAL"
        case random = "RANDOM"
    }
    static let recoveryLockPasswordRule = StringRule(minLength: 1, maxLength: nil, pattern: nil)
    static let versionLockRule = NumericRule<Int>(minimum: 0, exclusiveMinimum: false, maximum: nil, exclusiveMaximum: false, multipleOf: nil)
    public var displayName: String
    public var mandatory: Bool
    public var mdmRemovable: Bool
    public var supportPhoneNumber: String
    public var supportEmailAddress: String
    public var department: String
    public var defaultPrestage: Bool
    public var enrollmentSiteId: String
    public var keepExistingSiteMembership: Bool
    public var keepExistingLocationInformation: Bool
    public var requireAuthentication: Bool
    public var authenticationPrompt: String
    public var preventActivationLock: Bool
    public var enableDeviceBasedActivationLock: Bool
    public var deviceEnrollmentProgramInstanceId: String
    public var skipSetupItems: [String: Bool]?
    public var locationInformation: LocationInformationV2
    public var purchasingInformation: PrestagePurchasingInformationV2
    /** The Base64 encoded PEM Certificate */
    public var anchorCertificates: [String]?
    public var enrollmentCustomizationId: String?
    public var language: String?
    public var region: String?
    public var autoAdvanceSetup: Bool
    public var installProfilesDuringSetup: Bool
    public var prestageInstalledProfileIds: [String]
    public var customPackageIds: [String]
    public var customPackageDistributionPointId: String
    public var enableRecoveryLock: Bool?
    public var recoveryLockPasswordType: RecoveryLockPasswordType?
    public var rotateRecoveryLockPassword: Bool?
    public var accountSettings: AccountSettingsRequest?
    public var recoveryLockPassword: String?
    public var versionLock: Int?

    public init(displayName: String, mandatory: Bool, mdmRemovable: Bool, supportPhoneNumber: String, supportEmailAddress: String, department: String, defaultPrestage: Bool, enrollmentSiteId: String, keepExistingSiteMembership: Bool, keepExistingLocationInformation: Bool, requireAuthentication: Bool, authenticationPrompt: String, preventActivationLock: Bool, enableDeviceBasedActivationLock: Bool, deviceEnrollmentProgramInstanceId: String, skipSetupItems: [String: Bool]? = nil, locationInformation: LocationInformationV2, purchasingInformation: PrestagePurchasingInformationV2, anchorCertificates: [String]? = nil, enrollmentCustomizationId: String? = nil, language: String? = nil, region: String? = nil, autoAdvanceSetup: Bool, installProfilesDuringSetup: Bool, prestageInstalledProfileIds: [String], customPackageIds: [String], customPackageDistributionPointId: String, enableRecoveryLock: Bool? = nil, recoveryLockPasswordType: RecoveryLockPasswordType? = nil, rotateRecoveryLockPassword: Bool? = nil, accountSettings: AccountSettingsRequest? = nil, recoveryLockPassword: String? = nil, versionLock: Int? = nil) {
        self.displayName = displayName
        self.mandatory = mandatory
        self.mdmRemovable = mdmRemovable
        self.supportPhoneNumber = supportPhoneNumber
        self.supportEmailAddress = supportEmailAddress
        self.department = department
        self.defaultPrestage = defaultPrestage
        self.enrollmentSiteId = enrollmentSiteId
        self.keepExistingSiteMembership = keepExistingSiteMembership
        self.keepExistingLocationInformation = keepExistingLocationInformation
        self.requireAuthentication = requireAuthentication
        self.authenticationPrompt = authenticationPrompt
        self.preventActivationLock = preventActivationLock
        self.enableDeviceBasedActivationLock = enableDeviceBasedActivationLock
        self.deviceEnrollmentProgramInstanceId = deviceEnrollmentProgramInstanceId
        self.skipSetupItems = skipSetupItems
        self.locationInformation = locationInformation
        self.purchasingInformation = purchasingInformation
        self.anchorCertificates = anchorCertificates
        self.enrollmentCustomizationId = enrollmentCustomizationId
        self.language = language
        self.region = region
        self.autoAdvanceSetup = autoAdvanceSetup
        self.installProfilesDuringSetup = installProfilesDuringSetup
        self.prestageInstalledProfileIds = prestageInstalledProfileIds
        self.customPackageIds = customPackageIds
        self.customPackageDistributionPointId = customPackageDistributionPointId
        self.enableRecoveryLock = enableRecoveryLock
        self.recoveryLockPasswordType = recoveryLockPasswordType
        self.rotateRecoveryLockPassword = rotateRecoveryLockPassword
        self.accountSettings = accountSettings
        self.recoveryLockPassword = recoveryLockPassword
        self.versionLock = versionLock
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case displayName
        case mandatory
        case mdmRemovable
        case supportPhoneNumber
        case supportEmailAddress
        case department
        case defaultPrestage
        case enrollmentSiteId
        case keepExistingSiteMembership
        case keepExistingLocationInformation
        case requireAuthentication
        case authenticationPrompt
        case preventActivationLock
        case enableDeviceBasedActivationLock
        case deviceEnrollmentProgramInstanceId
        case skipSetupItems
        case locationInformation
        case purchasingInformation
        case anchorCertificates
        case enrollmentCustomizationId
        case language
        case region
        case autoAdvanceSetup
        case installProfilesDuringSetup
        case prestageInstalledProfileIds
        case customPackageIds
        case customPackageDistributionPointId
        case enableRecoveryLock
        case recoveryLockPasswordType
        case rotateRecoveryLockPassword
        case accountSettings
        case recoveryLockPassword
        case versionLock
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(displayName, forKey: .displayName)
        try container.encode(mandatory, forKey: .mandatory)
        try container.encode(mdmRemovable, forKey: .mdmRemovable)
        try container.encode(supportPhoneNumber, forKey: .supportPhoneNumber)
        try container.encode(supportEmailAddress, forKey: .supportEmailAddress)
        try container.encode(department, forKey: .department)
        try container.encode(defaultPrestage, forKey: .defaultPrestage)
        try container.encode(enrollmentSiteId, forKey: .enrollmentSiteId)
        try container.encode(keepExistingSiteMembership, forKey: .keepExistingSiteMembership)
        try container.encode(keepExistingLocationInformation, forKey: .keepExistingLocationInformation)
        try container.encode(requireAuthentication, forKey: .requireAuthentication)
        try container.encode(authenticationPrompt, forKey: .authenticationPrompt)
        try container.encode(preventActivationLock, forKey: .preventActivationLock)
        try container.encode(enableDeviceBasedActivationLock, forKey: .enableDeviceBasedActivationLock)
        try container.encode(deviceEnrollmentProgramInstanceId, forKey: .deviceEnrollmentProgramInstanceId)
        try container.encodeIfPresent(skipSetupItems, forKey: .skipSetupItems)
        try container.encode(locationInformation, forKey: .locationInformation)
        try container.encode(purchasingInformation, forKey: .purchasingInformation)
        try container.encodeIfPresent(anchorCertificates, forKey: .anchorCertificates)
        try container.encodeIfPresent(enrollmentCustomizationId, forKey: .enrollmentCustomizationId)
        try container.encodeIfPresent(language, forKey: .language)
        try container.encodeIfPresent(region, forKey: .region)
        try container.encode(autoAdvanceSetup, forKey: .autoAdvanceSetup)
        try container.encode(installProfilesDuringSetup, forKey: .installProfilesDuringSetup)
        try container.encode(prestageInstalledProfileIds, forKey: .prestageInstalledProfileIds)
        try container.encode(customPackageIds, forKey: .customPackageIds)
        try container.encode(customPackageDistributionPointId, forKey: .customPackageDistributionPointId)
        try container.encodeIfPresent(enableRecoveryLock, forKey: .enableRecoveryLock)
        try container.encodeIfPresent(recoveryLockPasswordType, forKey: .recoveryLockPasswordType)
        try container.encodeIfPresent(rotateRecoveryLockPassword, forKey: .rotateRecoveryLockPassword)
        try container.encodeIfPresent(accountSettings, forKey: .accountSettings)
        try container.encodeIfPresent(recoveryLockPassword, forKey: .recoveryLockPassword)
        try container.encodeIfPresent(versionLock, forKey: .versionLock)
    }
}

