//
// PutMobileDevicePrestageV2.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct PutMobileDevicePrestageV2: Codable, JSONEncodable, Hashable {

    public var displayName: String
    public var mandatory: Bool
    public var mdmRemovable: Bool
    public var supportPhoneNumber: String
    public var supportEmailAddress: String
    public var department: String
    public var defaultPrestage: Bool
    public var enrollmentSiteId: String
    public var keepExistingSiteMembership: Bool
    public var keepExistingLocationInformation: Bool
    public var requireAuthentication: Bool
    public var authenticationPrompt: String
    public var preventActivationLock: Bool
    public var enableDeviceBasedActivationLock: Bool
    public var deviceEnrollmentProgramInstanceId: String
    public var skipSetupItems: [String: Bool]?
    public var locationInformation: LocationInformationV2
    public var purchasingInformation: PrestagePurchasingInformationV2
    /** The Base64 encoded PEM Certificate */
    public var anchorCertificates: [String]?
    public var enrollmentCustomizationId: String?
    public var language: String?
    public var region: String?
    public var autoAdvanceSetup: Bool
    public var allowPairing: Bool
    public var multiUser: Bool
    public var supervised: Bool
    public var maximumSharedAccounts: Int
    public var configureDeviceBeforeSetupAssistant: Bool
    public var names: MobileDevicePrestageNamesV2?
    public var sendTimezone: Bool
    public var timezone: String
    public var storageQuotaSizeMegabytes: Int
    public var useStorageQuotaSize: Bool
    public var temporarySessionOnly: Bool?
    public var enforceTemporarySessionTimeout: Bool?
    public var temporarySessionTimeout: Int?
    public var enforceUserSessionTimeout: Bool?
    public var userSessionTimeout: Int?
    public var versionLock: Int?

    public init(displayName: String, mandatory: Bool, mdmRemovable: Bool, supportPhoneNumber: String, supportEmailAddress: String, department: String, defaultPrestage: Bool, enrollmentSiteId: String, keepExistingSiteMembership: Bool, keepExistingLocationInformation: Bool, requireAuthentication: Bool, authenticationPrompt: String, preventActivationLock: Bool, enableDeviceBasedActivationLock: Bool, deviceEnrollmentProgramInstanceId: String, skipSetupItems: [String: Bool]? = nil, locationInformation: LocationInformationV2, purchasingInformation: PrestagePurchasingInformationV2, anchorCertificates: [String]? = nil, enrollmentCustomizationId: String? = nil, language: String? = nil, region: String? = nil, autoAdvanceSetup: Bool, allowPairing: Bool, multiUser: Bool, supervised: Bool, maximumSharedAccounts: Int, configureDeviceBeforeSetupAssistant: Bool, names: MobileDevicePrestageNamesV2? = nil, sendTimezone: Bool, timezone: String, storageQuotaSizeMegabytes: Int, useStorageQuotaSize: Bool, temporarySessionOnly: Bool? = nil, enforceTemporarySessionTimeout: Bool? = nil, temporarySessionTimeout: Int? = nil, enforceUserSessionTimeout: Bool? = nil, userSessionTimeout: Int? = nil, versionLock: Int? = nil) {
        self.displayName = displayName
        self.mandatory = mandatory
        self.mdmRemovable = mdmRemovable
        self.supportPhoneNumber = supportPhoneNumber
        self.supportEmailAddress = supportEmailAddress
        self.department = department
        self.defaultPrestage = defaultPrestage
        self.enrollmentSiteId = enrollmentSiteId
        self.keepExistingSiteMembership = keepExistingSiteMembership
        self.keepExistingLocationInformation = keepExistingLocationInformation
        self.requireAuthentication = requireAuthentication
        self.authenticationPrompt = authenticationPrompt
        self.preventActivationLock = preventActivationLock
        self.enableDeviceBasedActivationLock = enableDeviceBasedActivationLock
        self.deviceEnrollmentProgramInstanceId = deviceEnrollmentProgramInstanceId
        self.skipSetupItems = skipSetupItems
        self.locationInformation = locationInformation
        self.purchasingInformation = purchasingInformation
        self.anchorCertificates = anchorCertificates
        self.enrollmentCustomizationId = enrollmentCustomizationId
        self.language = language
        self.region = region
        self.autoAdvanceSetup = autoAdvanceSetup
        self.allowPairing = allowPairing
        self.multiUser = multiUser
        self.supervised = supervised
        self.maximumSharedAccounts = maximumSharedAccounts
        self.configureDeviceBeforeSetupAssistant = configureDeviceBeforeSetupAssistant
        self.names = names
        self.sendTimezone = sendTimezone
        self.timezone = timezone
        self.storageQuotaSizeMegabytes = storageQuotaSizeMegabytes
        self.useStorageQuotaSize = useStorageQuotaSize
        self.temporarySessionOnly = temporarySessionOnly
        self.enforceTemporarySessionTimeout = enforceTemporarySessionTimeout
        self.temporarySessionTimeout = temporarySessionTimeout
        self.enforceUserSessionTimeout = enforceUserSessionTimeout
        self.userSessionTimeout = userSessionTimeout
        self.versionLock = versionLock
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case displayName
        case mandatory
        case mdmRemovable
        case supportPhoneNumber
        case supportEmailAddress
        case department
        case defaultPrestage
        case enrollmentSiteId
        case keepExistingSiteMembership
        case keepExistingLocationInformation
        case requireAuthentication
        case authenticationPrompt
        case preventActivationLock
        case enableDeviceBasedActivationLock
        case deviceEnrollmentProgramInstanceId
        case skipSetupItems
        case locationInformation
        case purchasingInformation
        case anchorCertificates
        case enrollmentCustomizationId
        case language
        case region
        case autoAdvanceSetup
        case allowPairing
        case multiUser
        case supervised
        case maximumSharedAccounts
        case configureDeviceBeforeSetupAssistant
        case names
        case sendTimezone
        case timezone
        case storageQuotaSizeMegabytes
        case useStorageQuotaSize
        case temporarySessionOnly
        case enforceTemporarySessionTimeout
        case temporarySessionTimeout
        case enforceUserSessionTimeout
        case userSessionTimeout
        case versionLock
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(displayName, forKey: .displayName)
        try container.encode(mandatory, forKey: .mandatory)
        try container.encode(mdmRemovable, forKey: .mdmRemovable)
        try container.encode(supportPhoneNumber, forKey: .supportPhoneNumber)
        try container.encode(supportEmailAddress, forKey: .supportEmailAddress)
        try container.encode(department, forKey: .department)
        try container.encode(defaultPrestage, forKey: .defaultPrestage)
        try container.encode(enrollmentSiteId, forKey: .enrollmentSiteId)
        try container.encode(keepExistingSiteMembership, forKey: .keepExistingSiteMembership)
        try container.encode(keepExistingLocationInformation, forKey: .keepExistingLocationInformation)
        try container.encode(requireAuthentication, forKey: .requireAuthentication)
        try container.encode(authenticationPrompt, forKey: .authenticationPrompt)
        try container.encode(preventActivationLock, forKey: .preventActivationLock)
        try container.encode(enableDeviceBasedActivationLock, forKey: .enableDeviceBasedActivationLock)
        try container.encode(deviceEnrollmentProgramInstanceId, forKey: .deviceEnrollmentProgramInstanceId)
        try container.encodeIfPresent(skipSetupItems, forKey: .skipSetupItems)
        try container.encode(locationInformation, forKey: .locationInformation)
        try container.encode(purchasingInformation, forKey: .purchasingInformation)
        try container.encodeIfPresent(anchorCertificates, forKey: .anchorCertificates)
        try container.encodeIfPresent(enrollmentCustomizationId, forKey: .enrollmentCustomizationId)
        try container.encodeIfPresent(language, forKey: .language)
        try container.encodeIfPresent(region, forKey: .region)
        try container.encode(autoAdvanceSetup, forKey: .autoAdvanceSetup)
        try container.encode(allowPairing, forKey: .allowPairing)
        try container.encode(multiUser, forKey: .multiUser)
        try container.encode(supervised, forKey: .supervised)
        try container.encode(maximumSharedAccounts, forKey: .maximumSharedAccounts)
        try container.encode(configureDeviceBeforeSetupAssistant, forKey: .configureDeviceBeforeSetupAssistant)
        try container.encodeIfPresent(names, forKey: .names)
        try container.encode(sendTimezone, forKey: .sendTimezone)
        try container.encode(timezone, forKey: .timezone)
        try container.encode(storageQuotaSizeMegabytes, forKey: .storageQuotaSizeMegabytes)
        try container.encode(useStorageQuotaSize, forKey: .useStorageQuotaSize)
        try container.encodeIfPresent(temporarySessionOnly, forKey: .temporarySessionOnly)
        try container.encodeIfPresent(enforceTemporarySessionTimeout, forKey: .enforceTemporarySessionTimeout)
        try container.encodeIfPresent(temporarySessionTimeout, forKey: .temporarySessionTimeout)
        try container.encodeIfPresent(enforceUserSessionTimeout, forKey: .enforceUserSessionTimeout)
        try container.encodeIfPresent(userSessionTimeout, forKey: .userSessionTimeout)
        try container.encodeIfPresent(versionLock, forKey: .versionLock)
    }
}

