//
// SelfServiceInteractionSettings.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** object representation of Self Service settings regarding user interaction  */
public struct SelfServiceInteractionSettings: Codable, JSONEncodable, Hashable {

    public enum DefaultLandingPage: String, Codable, CaseIterable {
        case home = "HOME"
        case browse = "BROWSE"
        case history = "HISTORY"
        case notifications = "NOTIFICATIONS"
    }
    /** global Self Service setting for if notifications are on or off  */
    public var notificationsEnabled: Bool? = false
    /** whether users should be notified they need to approve organization's MDM profile  */
    public var alertUserApprovedMdm: Bool? = true
    /** the default landing page in Self Service  */
    public var defaultLandingPage: DefaultLandingPage? = .home
    /** id for the default home category in Self Service  */
    public var defaultHomeCategoryId: Int? = -1
    /** renamed string for bookmarks if the admin wishes  */
    public var bookmarksName: String

    public init(notificationsEnabled: Bool? = false, alertUserApprovedMdm: Bool? = true, defaultLandingPage: DefaultLandingPage? = .home, defaultHomeCategoryId: Int? = -1, bookmarksName: String) {
        self.notificationsEnabled = notificationsEnabled
        self.alertUserApprovedMdm = alertUserApprovedMdm
        self.defaultLandingPage = defaultLandingPage
        self.defaultHomeCategoryId = defaultHomeCategoryId
        self.bookmarksName = bookmarksName
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case notificationsEnabled
        case alertUserApprovedMdm
        case defaultLandingPage
        case defaultHomeCategoryId
        case bookmarksName
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(notificationsEnabled, forKey: .notificationsEnabled)
        try container.encodeIfPresent(alertUserApprovedMdm, forKey: .alertUserApprovedMdm)
        try container.encodeIfPresent(defaultLandingPage, forKey: .defaultLandingPage)
        try container.encodeIfPresent(defaultHomeCategoryId, forKey: .defaultHomeCategoryId)
        try container.encode(bookmarksName, forKey: .bookmarksName)
    }
}

