//
// SelfServiceLoginSettings.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** object representation of Self Service settings regarding login  */
public struct SelfServiceLoginSettings: Codable, JSONEncodable, Hashable {

    public enum UserLoginLevel: String, Codable, CaseIterable {
        case notRequired = "NotRequired"
        case anonymous = "Anonymous"
        case _required = "Required"
    }
    public enum AuthType: String, Codable, CaseIterable {
        case basic = "Basic"
        case saml = "Saml"
    }
    /** login setting to tell clients how to let users log in  */
    public var userLoginLevel: UserLoginLevel
    /** true if remember me functionality is allowed, false if not  */
    public var allowRememberMe: Bool? = false
    /** login type to be used when asking users to log in  */
    public var authType: AuthType

    public init(userLoginLevel: UserLoginLevel, allowRememberMe: Bool? = false, authType: AuthType) {
        self.userLoginLevel = userLoginLevel
        self.allowRememberMe = allowRememberMe
        self.authType = authType
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case userLoginLevel
        case allowRememberMe
        case authType
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(userLoginLevel, forKey: .userLoginLevel)
        try container.encodeIfPresent(allowRememberMe, forKey: .allowRememberMe)
        try container.encode(authType, forKey: .authType)
    }
}

