//
// SessionDetails.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** Session details */
public struct SessionDetails: Codable, JSONEncodable, Hashable {

    public enum DeviceType: String, Codable, CaseIterable {
        case computer = "COMPUTER"
    }
    public enum State: String, Codable, CaseIterable {
        case _open = "OPEN"
        case closed = "CLOSED"
        case unknown = "UNKNOWN"
    }
    /** Session identifier */
    public var id: String?
    /** Sessions code */
    public var code: String?
    /** Session description. To be used for additional context on the reason of the session */
    public var description: String?
    /** Supporter session URL */
    public var supporterLink: String?
    /** End user session URL */
    public var endUserLink: String?
    /** Device identifier */
    public var deviceId: String?
    /** Device name if found - null otherwise */
    public var deviceName: String?
    /** Device type */
    public var deviceType: DeviceType?
    /** Session state */
    public var state: State?
    /** ID of session creator if session created by Jamf Pro local user, null otherwise */
    public var creatorId: String?
    /** Username of the session creator */
    public var creatorName: String?
    /** Session creation time */
    public var createdAt: String?

    public init(id: String? = nil, code: String? = nil, description: String? = nil, supporterLink: String? = nil, endUserLink: String? = nil, deviceId: String? = nil, deviceName: String? = nil, deviceType: DeviceType? = nil, state: State? = nil, creatorId: String? = nil, creatorName: String? = nil, createdAt: String? = nil) {
        self.id = id
        self.code = code
        self.description = description
        self.supporterLink = supporterLink
        self.endUserLink = endUserLink
        self.deviceId = deviceId
        self.deviceName = deviceName
        self.deviceType = deviceType
        self.state = state
        self.creatorId = creatorId
        self.creatorName = creatorName
        self.createdAt = createdAt
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case code
        case description
        case supporterLink
        case endUserLink
        case deviceId
        case deviceName
        case deviceType
        case state
        case creatorId
        case creatorName
        case createdAt
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(code, forKey: .code)
        try container.encodeIfPresent(description, forKey: .description)
        try container.encodeIfPresent(supporterLink, forKey: .supporterLink)
        try container.encodeIfPresent(endUserLink, forKey: .endUserLink)
        try container.encodeIfPresent(deviceId, forKey: .deviceId)
        try container.encodeIfPresent(deviceName, forKey: .deviceName)
        try container.encodeIfPresent(deviceType, forKey: .deviceType)
        try container.encodeIfPresent(state, forKey: .state)
        try container.encodeIfPresent(creatorId, forKey: .creatorId)
        try container.encodeIfPresent(creatorName, forKey: .creatorName)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
    }
}

