//
// SettingsCommand.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct SettingsCommand: Codable, JSONEncodable, Hashable {

    public var bootstrapTokenAllowed: Bool?
    public var bluetooth: Bool?
    public var appAnalytics: AppAnalyticsSetting?
    public var diagnosticSubmission: DiagnosticSubmissionSetting?
    public var dataRoaming: DataRoamingSetting?
    public var voiceRoaming: VoiceRoamingSetting?
    public var personalHotspot: PersonalHotspotSetting?
    public var maximumResidentUsers: Int?
    public var deviceName: String?
    public var applicationAttributes: ApplicationAttributes?
    public var sharedDeviceConfiguration: SharedDeviceConfiguration?
    public var applicationConfiguration: ApplicationConfiguration?
    public var timeZone: String?
    public var softwareUpdateSettings: SoftwareUpdateSettings?
    /** The number of seconds before a locked screen requires the user to enter the device passcode to unlock it. (Shared iPad Only) */
    public var passcodeLockGracePeriod: Int?

    public init(bootstrapTokenAllowed: Bool? = nil, bluetooth: Bool? = nil, appAnalytics: AppAnalyticsSetting? = nil, diagnosticSubmission: DiagnosticSubmissionSetting? = nil, dataRoaming: DataRoamingSetting? = nil, voiceRoaming: VoiceRoamingSetting? = nil, personalHotspot: PersonalHotspotSetting? = nil, maximumResidentUsers: Int? = nil, deviceName: String? = nil, applicationAttributes: ApplicationAttributes? = nil, sharedDeviceConfiguration: SharedDeviceConfiguration? = nil, applicationConfiguration: ApplicationConfiguration? = nil, timeZone: String? = nil, softwareUpdateSettings: SoftwareUpdateSettings? = nil, passcodeLockGracePeriod: Int? = nil) {
        self.bootstrapTokenAllowed = bootstrapTokenAllowed
        self.bluetooth = bluetooth
        self.appAnalytics = appAnalytics
        self.diagnosticSubmission = diagnosticSubmission
        self.dataRoaming = dataRoaming
        self.voiceRoaming = voiceRoaming
        self.personalHotspot = personalHotspot
        self.maximumResidentUsers = maximumResidentUsers
        self.deviceName = deviceName
        self.applicationAttributes = applicationAttributes
        self.sharedDeviceConfiguration = sharedDeviceConfiguration
        self.applicationConfiguration = applicationConfiguration
        self.timeZone = timeZone
        self.softwareUpdateSettings = softwareUpdateSettings
        self.passcodeLockGracePeriod = passcodeLockGracePeriod
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case bootstrapTokenAllowed
        case bluetooth
        case appAnalytics
        case diagnosticSubmission
        case dataRoaming
        case voiceRoaming
        case personalHotspot
        case maximumResidentUsers
        case deviceName
        case applicationAttributes
        case sharedDeviceConfiguration
        case applicationConfiguration
        case timeZone
        case softwareUpdateSettings
        case passcodeLockGracePeriod
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(bootstrapTokenAllowed, forKey: .bootstrapTokenAllowed)
        try container.encodeIfPresent(bluetooth, forKey: .bluetooth)
        try container.encodeIfPresent(appAnalytics, forKey: .appAnalytics)
        try container.encodeIfPresent(diagnosticSubmission, forKey: .diagnosticSubmission)
        try container.encodeIfPresent(dataRoaming, forKey: .dataRoaming)
        try container.encodeIfPresent(voiceRoaming, forKey: .voiceRoaming)
        try container.encodeIfPresent(personalHotspot, forKey: .personalHotspot)
        try container.encodeIfPresent(maximumResidentUsers, forKey: .maximumResidentUsers)
        try container.encodeIfPresent(deviceName, forKey: .deviceName)
        try container.encodeIfPresent(applicationAttributes, forKey: .applicationAttributes)
        try container.encodeIfPresent(sharedDeviceConfiguration, forKey: .sharedDeviceConfiguration)
        try container.encodeIfPresent(applicationConfiguration, forKey: .applicationConfiguration)
        try container.encodeIfPresent(timeZone, forKey: .timeZone)
        try container.encodeIfPresent(softwareUpdateSettings, forKey: .softwareUpdateSettings)
        try container.encodeIfPresent(passcodeLockGracePeriod, forKey: .passcodeLockGracePeriod)
    }
}

