//
// SsoKeystore.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct SsoKeystore: Codable, JSONEncodable, Hashable {

    public enum ModelType: String, Codable, CaseIterable {
        case pkcs12 = "PKCS12"
        case jks = "JKS"
        case _none = "NONE"
    }
    public enum KeystoreSetupType: String, Codable, CaseIterable {
        case _none = "NONE"
        case uploaded = "UPLOADED"
        case generated = "GENERATED"
    }
    public var keystorePassword: String
    public var keystoreFile: Data
    public var keystoreFileName: String
    public var keys: [CertificateKey]?
    public var key: String = " "
    public var password: String
    public var type: ModelType
    public var keystoreSetupType: KeystoreSetupType?

    public init(keystorePassword: String, keystoreFile: Data, keystoreFileName: String, keys: [CertificateKey]? = nil, key: String = " ", password: String, type: ModelType, keystoreSetupType: KeystoreSetupType? = nil) {
        self.keystorePassword = keystorePassword
        self.keystoreFile = keystoreFile
        self.keystoreFileName = keystoreFileName
        self.keys = keys
        self.key = key
        self.password = password
        self.type = type
        self.keystoreSetupType = keystoreSetupType
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case keystorePassword
        case keystoreFile
        case keystoreFileName
        case keys
        case key
        case password
        case type
        case keystoreSetupType
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(keystorePassword, forKey: .keystorePassword)
        try container.encode(keystoreFile, forKey: .keystoreFile)
        try container.encode(keystoreFileName, forKey: .keystoreFileName)
        try container.encodeIfPresent(keys, forKey: .keys)
        try container.encode(key, forKey: .key)
        try container.encode(password, forKey: .password)
        try container.encode(type, forKey: .type)
        try container.encodeIfPresent(keystoreSetupType, forKey: .keystoreSetupType)
    }
}

