//
// SsoSettings.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct SsoSettings: Codable, JSONEncodable, Hashable {

    public enum UserMapping: String, Codable, CaseIterable {
        case username = "USERNAME"
        case email = "EMAIL"
    }
    public enum IdpProviderType: String, Codable, CaseIterable {
        case adfs = "ADFS"
        case okta = "OKTA"
        case google = "GOOGLE"
        case shibboleth = "SHIBBOLETH"
        case onelogin = "ONELOGIN"
        case ping = "PING"
        case centrify = "CENTRIFY"
        case azure = "AZURE"
        case other = "OTHER"
    }
    public enum MetadataSource: String, Codable, CaseIterable {
        case url = "URL"
        case file = "FILE"
        case unknown = "UNKNOWN"
    }
    public var ssoForEnrollmentEnabled: Bool = false
    public var ssoBypassAllowed: Bool = false
    public var ssoEnabled: Bool = false
    public var ssoForMacOsSelfServiceEnabled: Bool = false
    public var tokenExpirationDisabled: Bool = false
    public var userAttributeEnabled: Bool = false
    public var userAttributeName: String? = " "
    public var userMapping: UserMapping
    public var enrollmentSsoForAdueEnabled: Bool = false
    public var enrollmentSsoConfig: EnrollmentSsoConfig?
    public var groupEnrollmentAccessEnabled: Bool = false
    public var groupAttributeName: String = "http://schemas.xmlsoap.org/claims/Group"
    public var groupRdnKey: String = " "
    public var groupEnrollmentAccessName: String? = " "
    public var idpProviderType: IdpProviderType
    public var idpUrl: String?
    public var entityId: String
    public var metadataFileName: String?
    public var otherProviderTypeName: String? = " "
    public var federationMetadataFile: Data?
    public var metadataSource: MetadataSource
    public var sessionTimeout: Int? = 480

    public init(ssoForEnrollmentEnabled: Bool = false, ssoBypassAllowed: Bool = false, ssoEnabled: Bool = false, ssoForMacOsSelfServiceEnabled: Bool = false, tokenExpirationDisabled: Bool = false, userAttributeEnabled: Bool = false, userAttributeName: String? = " ", userMapping: UserMapping, enrollmentSsoForAdueEnabled: Bool = false, enrollmentSsoConfig: EnrollmentSsoConfig? = nil, groupEnrollmentAccessEnabled: Bool = false, groupAttributeName: String = "http://schemas.xmlsoap.org/claims/Group", groupRdnKey: String = " ", groupEnrollmentAccessName: String? = " ", idpProviderType: IdpProviderType, idpUrl: String? = nil, entityId: String, metadataFileName: String? = nil, otherProviderTypeName: String? = " ", federationMetadataFile: Data? = nil, metadataSource: MetadataSource, sessionTimeout: Int? = 480) {
        self.ssoForEnrollmentEnabled = ssoForEnrollmentEnabled
        self.ssoBypassAllowed = ssoBypassAllowed
        self.ssoEnabled = ssoEnabled
        self.ssoForMacOsSelfServiceEnabled = ssoForMacOsSelfServiceEnabled
        self.tokenExpirationDisabled = tokenExpirationDisabled
        self.userAttributeEnabled = userAttributeEnabled
        self.userAttributeName = userAttributeName
        self.userMapping = userMapping
        self.enrollmentSsoForAdueEnabled = enrollmentSsoForAdueEnabled
        self.enrollmentSsoConfig = enrollmentSsoConfig
        self.groupEnrollmentAccessEnabled = groupEnrollmentAccessEnabled
        self.groupAttributeName = groupAttributeName
        self.groupRdnKey = groupRdnKey
        self.groupEnrollmentAccessName = groupEnrollmentAccessName
        self.idpProviderType = idpProviderType
        self.idpUrl = idpUrl
        self.entityId = entityId
        self.metadataFileName = metadataFileName
        self.otherProviderTypeName = otherProviderTypeName
        self.federationMetadataFile = federationMetadataFile
        self.metadataSource = metadataSource
        self.sessionTimeout = sessionTimeout
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case ssoForEnrollmentEnabled
        case ssoBypassAllowed
        case ssoEnabled
        case ssoForMacOsSelfServiceEnabled
        case tokenExpirationDisabled
        case userAttributeEnabled
        case userAttributeName
        case userMapping
        case enrollmentSsoForAdueEnabled
        case enrollmentSsoConfig
        case groupEnrollmentAccessEnabled
        case groupAttributeName
        case groupRdnKey
        case groupEnrollmentAccessName
        case idpProviderType
        case idpUrl
        case entityId
        case metadataFileName
        case otherProviderTypeName
        case federationMetadataFile
        case metadataSource
        case sessionTimeout
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(ssoForEnrollmentEnabled, forKey: .ssoForEnrollmentEnabled)
        try container.encode(ssoBypassAllowed, forKey: .ssoBypassAllowed)
        try container.encode(ssoEnabled, forKey: .ssoEnabled)
        try container.encode(ssoForMacOsSelfServiceEnabled, forKey: .ssoForMacOsSelfServiceEnabled)
        try container.encode(tokenExpirationDisabled, forKey: .tokenExpirationDisabled)
        try container.encode(userAttributeEnabled, forKey: .userAttributeEnabled)
        try container.encodeIfPresent(userAttributeName, forKey: .userAttributeName)
        try container.encode(userMapping, forKey: .userMapping)
        try container.encode(enrollmentSsoForAdueEnabled, forKey: .enrollmentSsoForAdueEnabled)
        try container.encodeIfPresent(enrollmentSsoConfig, forKey: .enrollmentSsoConfig)
        try container.encode(groupEnrollmentAccessEnabled, forKey: .groupEnrollmentAccessEnabled)
        try container.encode(groupAttributeName, forKey: .groupAttributeName)
        try container.encode(groupRdnKey, forKey: .groupRdnKey)
        try container.encodeIfPresent(groupEnrollmentAccessName, forKey: .groupEnrollmentAccessName)
        try container.encode(idpProviderType, forKey: .idpProviderType)
        try container.encodeIfPresent(idpUrl, forKey: .idpUrl)
        try container.encode(entityId, forKey: .entityId)
        try container.encodeIfPresent(metadataFileName, forKey: .metadataFileName)
        try container.encodeIfPresent(otherProviderTypeName, forKey: .otherProviderTypeName)
        try container.encodeIfPresent(federationMetadataFile, forKey: .federationMetadataFile)
        try container.encode(metadataSource, forKey: .metadataSource)
        try container.encodeIfPresent(sessionTimeout, forKey: .sessionTimeout)
    }
}

