//
// UpdateMobileDeviceV2.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct UpdateMobileDeviceV2: Codable, JSONEncodable, Hashable {

    /** Mobile Device Name. When updated, Jamf Pro sends an MDM settings command to the device (device must be supervised). */
    public var name: String?
    /** Enforce the mobile device name. Device must be supervised. If set to true, Jamf Pro will revert the Mobile Device Name to the ‘name’ value each time the device checks in. */
    public var enforceName: Bool?
    public var assetTag: String?
    public var siteId: String?
    /** IANA time zone database name */
    public var timeZone: String?
    public var location: LocationV2?
    public var updatedExtensionAttributes: [ExtensionAttributeV2]?
    public var ios: UpdateIosV2?
    public var tvos: UpdateTvOs?

    public init(name: String? = nil, enforceName: Bool? = nil, assetTag: String? = nil, siteId: String? = nil, timeZone: String? = nil, location: LocationV2? = nil, updatedExtensionAttributes: [ExtensionAttributeV2]? = nil, ios: UpdateIosV2? = nil, tvos: UpdateTvOs? = nil) {
        self.name = name
        self.enforceName = enforceName
        self.assetTag = assetTag
        self.siteId = siteId
        self.timeZone = timeZone
        self.location = location
        self.updatedExtensionAttributes = updatedExtensionAttributes
        self.ios = ios
        self.tvos = tvos
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case name
        case enforceName
        case assetTag
        case siteId
        case timeZone
        case location
        case updatedExtensionAttributes
        case ios
        case tvos
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(name, forKey: .name)
        try container.encodeIfPresent(enforceName, forKey: .enforceName)
        try container.encodeIfPresent(assetTag, forKey: .assetTag)
        try container.encodeIfPresent(siteId, forKey: .siteId)
        try container.encodeIfPresent(timeZone, forKey: .timeZone)
        try container.encodeIfPresent(location, forKey: .location)
        try container.encodeIfPresent(updatedExtensionAttributes, forKey: .updatedExtensionAttributes)
        try container.encodeIfPresent(ios, forKey: .ios)
        try container.encodeIfPresent(tvos, forKey: .tvos)
    }
}

