//
// UserMappings.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** Cloud Identity Provider user mappings configuration */
public struct UserMappings: Codable, JSONEncodable, Hashable {

    public enum ObjectClassLimitation: String, Codable, CaseIterable {
        case anyObjectClasses = "ANY_OBJECT_CLASSES"
        case allObjectClasses = "ALL_OBJECT_CLASSES"
    }
    public enum SearchScope: String, Codable, CaseIterable {
        case allSubtrees = "ALL_SUBTREES"
        case firstLevelOnly = "FIRST_LEVEL_ONLY"
    }
    public var objectClassLimitation: ObjectClassLimitation
    public var objectClasses: String
    public var searchBase: String
    public var searchScope: SearchScope
    public var additionalSearchBase: String? = ""
    public var userID: String
    public var username: String
    public var realName: String
    public var emailAddress: String
    public var department: String
    public var building: String = ""
    public var room: String = ""
    public var phone: String = ""
    public var position: String
    public var userUuid: String

    public init(objectClassLimitation: ObjectClassLimitation, objectClasses: String, searchBase: String, searchScope: SearchScope, additionalSearchBase: String? = "", userID: String, username: String, realName: String, emailAddress: String, department: String, building: String = "", room: String = "", phone: String = "", position: String, userUuid: String) {
        self.objectClassLimitation = objectClassLimitation
        self.objectClasses = objectClasses
        self.searchBase = searchBase
        self.searchScope = searchScope
        self.additionalSearchBase = additionalSearchBase
        self.userID = userID
        self.username = username
        self.realName = realName
        self.emailAddress = emailAddress
        self.department = department
        self.building = building
        self.room = room
        self.phone = phone
        self.position = position
        self.userUuid = userUuid
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case objectClassLimitation
        case objectClasses
        case searchBase
        case searchScope
        case additionalSearchBase
        case userID
        case username
        case realName
        case emailAddress
        case department
        case building
        case room
        case phone
        case position
        case userUuid
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(objectClassLimitation, forKey: .objectClassLimitation)
        try container.encode(objectClasses, forKey: .objectClasses)
        try container.encode(searchBase, forKey: .searchBase)
        try container.encode(searchScope, forKey: .searchScope)
        try container.encodeIfPresent(additionalSearchBase, forKey: .additionalSearchBase)
        try container.encode(userID, forKey: .userID)
        try container.encode(username, forKey: .username)
        try container.encode(realName, forKey: .realName)
        try container.encode(emailAddress, forKey: .emailAddress)
        try container.encode(department, forKey: .department)
        try container.encode(building, forKey: .building)
        try container.encode(room, forKey: .room)
        try container.encode(phone, forKey: .phone)
        try container.encode(position, forKey: .position)
        try container.encode(userUuid, forKey: .userUuid)
    }
}

