# Swift5 API client for OpenAPIClient

## Overview
The Jamf Pro API is a RESTful API for Jamf Pro built to enable consistent and efficient programmatic access to Jamf Pro.<br/><br/>
The swagger schema can be found [here](/api/schema/).


## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://github.com/OAI/OpenAPI-Specification) from a remote server, you can easily generate an API client.

- API version: production
- Package version: 
- Build package: org.openapitools.codegen.languages.Swift5ClientCodegen

## Installation

### Carthage

Run `carthage update`

### CocoaPods

Run `pod install`

## Documentation for API Endpoints

All URIs are relative to */api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AdvancedMobileDeviceSearchesAPI* | [**v1AdvancedMobileDeviceSearchesChoicesGet**](docs/AdvancedMobileDeviceSearchesAPI.md#v1advancedmobiledevicesearcheschoicesget) | **GET** /v1/advanced-mobile-device-searches/choices | Get Mobile Device Advanced Search criteria choices 
*AdvancedMobileDeviceSearchesAPI* | [**v1AdvancedMobileDeviceSearchesDeleteMultiplePost**](docs/AdvancedMobileDeviceSearchesAPI.md#v1advancedmobiledevicesearchesdeletemultiplepost) | **POST** /v1/advanced-mobile-device-searches/delete-multiple | Remove specified Advanced Search objects 
*AdvancedMobileDeviceSearchesAPI* | [**v1AdvancedMobileDeviceSearchesGet**](docs/AdvancedMobileDeviceSearchesAPI.md#v1advancedmobiledevicesearchesget) | **GET** /v1/advanced-mobile-device-searches | Get Advanced Search objects 
*AdvancedMobileDeviceSearchesAPI* | [**v1AdvancedMobileDeviceSearchesIdDelete**](docs/AdvancedMobileDeviceSearchesAPI.md#v1advancedmobiledevicesearchesiddelete) | **DELETE** /v1/advanced-mobile-device-searches/{id} | Remove specified Advanced Search object 
*AdvancedMobileDeviceSearchesAPI* | [**v1AdvancedMobileDeviceSearchesIdGet**](docs/AdvancedMobileDeviceSearchesAPI.md#v1advancedmobiledevicesearchesidget) | **GET** /v1/advanced-mobile-device-searches/{id} | Get specified Advanced Search object 
*AdvancedMobileDeviceSearchesAPI* | [**v1AdvancedMobileDeviceSearchesIdPut**](docs/AdvancedMobileDeviceSearchesAPI.md#v1advancedmobiledevicesearchesidput) | **PUT** /v1/advanced-mobile-device-searches/{id} | Get specified Advanced Search object 
*AdvancedMobileDeviceSearchesAPI* | [**v1AdvancedMobileDeviceSearchesPost**](docs/AdvancedMobileDeviceSearchesAPI.md#v1advancedmobiledevicesearchespost) | **POST** /v1/advanced-mobile-device-searches | Create Advanced Search object 
*AdvancedUserContentSearchesAPI* | [**v1AdvancedUserContentSearchesGet**](docs/AdvancedUserContentSearchesAPI.md#v1advancedusercontentsearchesget) | **GET** /v1/advanced-user-content-searches | Get All Advanced User Content Search objects 
*AdvancedUserContentSearchesAPI* | [**v1AdvancedUserContentSearchesIdDelete**](docs/AdvancedUserContentSearchesAPI.md#v1advancedusercontentsearchesiddelete) | **DELETE** /v1/advanced-user-content-searches/{id} | Remove specified Advanced User Content Search object 
*AdvancedUserContentSearchesAPI* | [**v1AdvancedUserContentSearchesIdGet**](docs/AdvancedUserContentSearchesAPI.md#v1advancedusercontentsearchesidget) | **GET** /v1/advanced-user-content-searches/{id} | Get Specified Advanced User Content Search object 
*AdvancedUserContentSearchesAPI* | [**v1AdvancedUserContentSearchesIdPut**](docs/AdvancedUserContentSearchesAPI.md#v1advancedusercontentsearchesidput) | **PUT** /v1/advanced-user-content-searches/{id} | Get Specified Advanced User Content Search object 
*AdvancedUserContentSearchesAPI* | [**v1AdvancedUserContentSearchesPost**](docs/AdvancedUserContentSearchesAPI.md#v1advancedusercontentsearchespost) | **POST** /v1/advanced-user-content-searches | Create Advanced User Content Search object 
*ApiAuthenticationAPI* | [**authCurrentPost**](docs/ApiAuthenticationAPI.md#authcurrentpost) | **POST** /auth/current | Get the authorization details associated with the current API token 
*ApiAuthenticationAPI* | [**authGet**](docs/ApiAuthenticationAPI.md#authget) | **GET** /auth | Get all the Authorization details associated with the current api 
*ApiAuthenticationAPI* | [**authInvalidateTokenPost**](docs/ApiAuthenticationAPI.md#authinvalidatetokenpost) | **POST** /auth/invalidateToken | Invalidate current token 
*ApiAuthenticationAPI* | [**authKeepAlivePost**](docs/ApiAuthenticationAPI.md#authkeepalivepost) | **POST** /auth/keepAlive | Invalidate existing token and generates new token 
*ApiAuthenticationAPI* | [**authTokensPost**](docs/ApiAuthenticationAPI.md#authtokenspost) | **POST** /auth/tokens | Create a token based on other authentication details (basic, etc.) 
*ApiAuthenticationAPI* | [**v1AuthGet**](docs/ApiAuthenticationAPI.md#v1authget) | **GET** /v1/auth | Get all the Authorization details associated with the current api 
*ApiAuthenticationAPI* | [**v1AuthInvalidateTokenPost**](docs/ApiAuthenticationAPI.md#v1authinvalidatetokenpost) | **POST** /v1/auth/invalidate-token | Invalidate current token 
*ApiAuthenticationAPI* | [**v1AuthKeepAlivePost**](docs/ApiAuthenticationAPI.md#v1authkeepalivepost) | **POST** /v1/auth/keep-alive | Invalidate existing token and generates new token 
*ApiAuthenticationAPI* | [**v1AuthTokenPost**](docs/ApiAuthenticationAPI.md#v1authtokenpost) | **POST** /v1/auth/token | Create a token based on other authentication details (basic, etc.) 
*ApiIntegrationsAPI* | [**deleteApiIntegration**](docs/ApiIntegrationsAPI.md#deleteapiintegration) | **DELETE** /v1/api-integrations/{id} | Remove specified API integration
*ApiIntegrationsAPI* | [**getOneApiIntegration**](docs/ApiIntegrationsAPI.md#getoneapiintegration) | **GET** /v1/api-integrations/{id} | Get specified API integration object
*ApiIntegrationsAPI* | [**postCreateApiIntegration**](docs/ApiIntegrationsAPI.md#postcreateapiintegration) | **POST** /v1/api-integrations | Create API integration object
*ApiIntegrationsAPI* | [**postCreateClientCredentials**](docs/ApiIntegrationsAPI.md#postcreateclientcredentials) | **POST** /v1/api-integrations/{id}/client-credentials | Create client credentials for specified API integration
*ApiIntegrationsAPI* | [**putUpdateApiIntegration**](docs/ApiIntegrationsAPI.md#putupdateapiintegration) | **PUT** /v1/api-integrations/{id} | Update specified API integration object
*ApiIntegrationsAPI* | [**v1ApiIntegrationsGet**](docs/ApiIntegrationsAPI.md#v1apiintegrationsget) | **GET** /v1/api-integrations | Get the current API Integrations
*ApiRolePrivilegesAPI* | [**v1ApiRolePrivilegesGet**](docs/ApiRolePrivilegesAPI.md#v1apiroleprivilegesget) | **GET** /v1/api-role-privileges | Get the current Jamf API Role Privileges
*ApiRolePrivilegesAPI* | [**v1ApiRolePrivilegesSearchGet**](docs/ApiRolePrivilegesAPI.md#v1apiroleprivilegessearchget) | **GET** /v1/api-role-privileges/search | Search the current Jamf API Role Privileges
*ApiRolesAPI* | [**deleteApiRole**](docs/ApiRolesAPI.md#deleteapirole) | **DELETE** /v1/api-roles/{id} | Delete API Integrations Role
*ApiRolesAPI* | [**getAllApiRoles**](docs/ApiRolesAPI.md#getallapiroles) | **GET** /v1/api-roles | Get the current Jamf API Roles
*ApiRolesAPI* | [**getOneApiRole**](docs/ApiRolesAPI.md#getoneapirole) | **GET** /v1/api-roles/{id} | Get the specific Jamf API Role
*ApiRolesAPI* | [**postCreateApiRole**](docs/ApiRolesAPI.md#postcreateapirole) | **POST** /v1/api-roles | Create a new API role
*ApiRolesAPI* | [**putUpdateApiRole**](docs/ApiRolesAPI.md#putupdateapirole) | **PUT** /v1/api-roles/{id} | Update API Integrations Role
*AppRequestPreviewAPI* | [**v1AppRequestFormInputFieldsGet**](docs/AppRequestPreviewAPI.md#v1apprequestforminputfieldsget) | **GET** /v1/app-request/form-input-fields | Search for Form Input Fields 
*AppRequestPreviewAPI* | [**v1AppRequestFormInputFieldsIdDelete**](docs/AppRequestPreviewAPI.md#v1apprequestforminputfieldsiddelete) | **DELETE** /v1/app-request/form-input-fields/{id} | Remove specified Form Input Field record 
*AppRequestPreviewAPI* | [**v1AppRequestFormInputFieldsIdGet**](docs/AppRequestPreviewAPI.md#v1apprequestforminputfieldsidget) | **GET** /v1/app-request/form-input-fields/{id} | Get specified Form Input Field object 
*AppRequestPreviewAPI* | [**v1AppRequestFormInputFieldsIdPut**](docs/AppRequestPreviewAPI.md#v1apprequestforminputfieldsidput) | **PUT** /v1/app-request/form-input-fields/{id} | Update specified Form Input Field object 
*AppRequestPreviewAPI* | [**v1AppRequestFormInputFieldsPost**](docs/AppRequestPreviewAPI.md#v1apprequestforminputfieldspost) | **POST** /v1/app-request/form-input-fields | Create Form Input Field record 
*AppRequestPreviewAPI* | [**v1AppRequestFormInputFieldsPut**](docs/AppRequestPreviewAPI.md#v1apprequestforminputfieldsput) | **PUT** /v1/app-request/form-input-fields | Replace all Form Input Fields 
*AppRequestPreviewAPI* | [**v1AppRequestSettingsGet**](docs/AppRequestPreviewAPI.md#v1apprequestsettingsget) | **GET** /v1/app-request/settings | Get Applicastion Request Settings 
*AppRequestPreviewAPI* | [**v1AppRequestSettingsPut**](docs/AppRequestPreviewAPI.md#v1apprequestsettingsput) | **PUT** /v1/app-request/settings | Update Application Request Settings 
*AppStoreCountryCodesPreviewAPI* | [**v1AppStoreCountryCodesGet**](docs/AppStoreCountryCodesPreviewAPI.md#v1appstorecountrycodesget) | **GET** /v1/app-store-country-codes | Return a list of Countries and the associated Codes 
*BrandingAPI* | [**v1BrandingImagesDownloadIdGet**](docs/BrandingAPI.md#v1brandingimagesdownloadidget) | **GET** /v1/branding-images/download/{id} | Download a self service branding image 
*BuildingsAPI* | [**v1BuildingsDeleteMultiplePost**](docs/BuildingsAPI.md#v1buildingsdeletemultiplepost) | **POST** /v1/buildings/delete-multiple | Delete multiple Buildings by their ids 
*BuildingsAPI* | [**v1BuildingsExportPost**](docs/BuildingsAPI.md#v1buildingsexportpost) | **POST** /v1/buildings/export | Export Buildings collection 
*BuildingsAPI* | [**v1BuildingsGet**](docs/BuildingsAPI.md#v1buildingsget) | **GET** /v1/buildings | Search for sorted and paged Buildings 
*BuildingsAPI* | [**v1BuildingsIdDelete**](docs/BuildingsAPI.md#v1buildingsiddelete) | **DELETE** /v1/buildings/{id} | Remove specified Building record 
*BuildingsAPI* | [**v1BuildingsIdGet**](docs/BuildingsAPI.md#v1buildingsidget) | **GET** /v1/buildings/{id} | Get specified Building object 
*BuildingsAPI* | [**v1BuildingsIdHistoryExportPost**](docs/BuildingsAPI.md#v1buildingsidhistoryexportpost) | **POST** /v1/buildings/{id}/history/export | Export history object collection in specified format for specified Buildings 
*BuildingsAPI* | [**v1BuildingsIdHistoryGet**](docs/BuildingsAPI.md#v1buildingsidhistoryget) | **GET** /v1/buildings/{id}/history | Get specified Building History object 
*BuildingsAPI* | [**v1BuildingsIdHistoryPost**](docs/BuildingsAPI.md#v1buildingsidhistorypost) | **POST** /v1/buildings/{id}/history | Add specified Building history object notes 
*BuildingsAPI* | [**v1BuildingsIdPut**](docs/BuildingsAPI.md#v1buildingsidput) | **PUT** /v1/buildings/{id} | Update specified Building object 
*BuildingsAPI* | [**v1BuildingsPost**](docs/BuildingsAPI.md#v1buildingspost) | **POST** /v1/buildings | Create Building record 
*CacheSettingsAPI* | [**v1CacheSettingsGet**](docs/CacheSettingsAPI.md#v1cachesettingsget) | **GET** /v1/cache-settings | Get Cache Settings 
*CacheSettingsAPI* | [**v1CacheSettingsPut**](docs/CacheSettingsAPI.md#v1cachesettingsput) | **PUT** /v1/cache-settings | Update Cache Settings 
*CategoriesAPI* | [**v1CategoriesDeleteMultiplePost**](docs/CategoriesAPI.md#v1categoriesdeletemultiplepost) | **POST** /v1/categories/delete-multiple | Delete multiple Categories by their IDs 
*CategoriesAPI* | [**v1CategoriesGet**](docs/CategoriesAPI.md#v1categoriesget) | **GET** /v1/categories | Get Category objects 
*CategoriesAPI* | [**v1CategoriesIdDelete**](docs/CategoriesAPI.md#v1categoriesiddelete) | **DELETE** /v1/categories/{id} | Remove specified Category record 
*CategoriesAPI* | [**v1CategoriesIdGet**](docs/CategoriesAPI.md#v1categoriesidget) | **GET** /v1/categories/{id} | Get specified Category object 
*CategoriesAPI* | [**v1CategoriesIdHistoryGet**](docs/CategoriesAPI.md#v1categoriesidhistoryget) | **GET** /v1/categories/{id}/history | Get specified Category history object 
*CategoriesAPI* | [**v1CategoriesIdHistoryPost**](docs/CategoriesAPI.md#v1categoriesidhistorypost) | **POST** /v1/categories/{id}/history | Add specified Category history object notes 
*CategoriesAPI* | [**v1CategoriesIdPut**](docs/CategoriesAPI.md#v1categoriesidput) | **PUT** /v1/categories/{id} | Update specified Category object 
*CategoriesAPI* | [**v1CategoriesPost**](docs/CategoriesAPI.md#v1categoriespost) | **POST** /v1/categories | Create Category record 
*CertificateAuthorityAPI* | [**v1PkiCertificateAuthorityActiveDerGet**](docs/CertificateAuthorityAPI.md#v1pkicertificateauthorityactivederget) | **GET** /v1/pki/certificate-authority/active/der | Returns X.509 of active Certificate Authority (CA) in DER format
*CertificateAuthorityAPI* | [**v1PkiCertificateAuthorityActiveGet**](docs/CertificateAuthorityAPI.md#v1pkicertificateauthorityactiveget) | **GET** /v1/pki/certificate-authority/active | Returns X.509 details of the active Certificate Authority (CA)
*CertificateAuthorityAPI* | [**v1PkiCertificateAuthorityActivePemGet**](docs/CertificateAuthorityAPI.md#v1pkicertificateauthorityactivepemget) | **GET** /v1/pki/certificate-authority/active/pem | Returns active Certificate Authority (CA) in PEM format
*CertificateAuthorityAPI* | [**v1PkiCertificateAuthorityIdDerGet**](docs/CertificateAuthorityAPI.md#v1pkicertificateauthorityidderget) | **GET** /v1/pki/certificate-authority/{id}/der | Returns X.509 current Certificate Authority (CA) with provided ID in DER format
*CertificateAuthorityAPI* | [**v1PkiCertificateAuthorityIdGet**](docs/CertificateAuthorityAPI.md#v1pkicertificateauthorityidget) | **GET** /v1/pki/certificate-authority/{id} | Returns X.509 details of Certificate Authority (CA) with provided ID
*CertificateAuthorityAPI* | [**v1PkiCertificateAuthorityIdPemGet**](docs/CertificateAuthorityAPI.md#v1pkicertificateauthorityidpemget) | **GET** /v1/pki/certificate-authority/{id}/pem | Returns current Certificate Authority (CA) with provided ID in PEM format
*ClassicLdapAPI* | [**v1ClassicLdapIdGet**](docs/ClassicLdapAPI.md#v1classicldapidget) | **GET** /v1/classic-ldap/{id} | Get mappings for OnPrem Ldap configuration with given id.
*ClientCheckInAPI* | [**v2CheckInGet**](docs/ClientCheckInAPI.md#v2checkinget) | **GET** /v2/check-in | Get Client Check-In settings 
*ClientCheckInAPI* | [**v2CheckInHistoryGet**](docs/ClientCheckInAPI.md#v2checkinhistoryget) | **GET** /v2/check-in/history | Get Client Check-In history object 
*ClientCheckInAPI* | [**v2CheckInHistoryPost**](docs/ClientCheckInAPI.md#v2checkinhistorypost) | **POST** /v2/check-in/history | Add a Note to Client Check-In History 
*ClientCheckInAPI* | [**v2CheckInPut**](docs/ClientCheckInAPI.md#v2checkinput) | **PUT** /v2/check-in | Update Client Check-In object 
*ClientCheckInAPI* | [**v3CheckInGet**](docs/ClientCheckInAPI.md#v3checkinget) | **GET** /v3/check-in | Get Client Check-In settings 
*ClientCheckInAPI* | [**v3CheckInHistoryGet**](docs/ClientCheckInAPI.md#v3checkinhistoryget) | **GET** /v3/check-in/history | Get Client Check-In history object 
*ClientCheckInAPI* | [**v3CheckInHistoryPost**](docs/ClientCheckInAPI.md#v3checkinhistorypost) | **POST** /v3/check-in/history | Add a Note to Client Check-In History 
*ClientCheckInAPI* | [**v3CheckInPut**](docs/ClientCheckInAPI.md#v3checkinput) | **PUT** /v3/check-in | Update Client Check-In object 
*CloudAzureAPI* | [**v1CloudAzureDefaultsMappingsGet**](docs/CloudAzureAPI.md#v1cloudazuredefaultsmappingsget) | **GET** /v1/cloud-azure/defaults/mappings | Get default mappings
*CloudAzureAPI* | [**v1CloudAzureDefaultsServerConfigurationGet**](docs/CloudAzureAPI.md#v1cloudazuredefaultsserverconfigurationget) | **GET** /v1/cloud-azure/defaults/server-configuration | Get default server configuration
*CloudAzureAPI* | [**v1CloudAzureIdDelete**](docs/CloudAzureAPI.md#v1cloudazureiddelete) | **DELETE** /v1/cloud-azure/{id} | Delete Cloud Identity Provider configuration.
*CloudAzureAPI* | [**v1CloudAzureIdGet**](docs/CloudAzureAPI.md#v1cloudazureidget) | **GET** /v1/cloud-azure/{id} | Get Azure Cloud Identity Provider configuration with given ID.
*CloudAzureAPI* | [**v1CloudAzureIdPut**](docs/CloudAzureAPI.md#v1cloudazureidput) | **PUT** /v1/cloud-azure/{id} | Update Azure Cloud Identity Provider configuration
*CloudAzureAPI* | [**v1CloudAzurePost**](docs/CloudAzureAPI.md#v1cloudazurepost) | **POST** /v1/cloud-azure | Create Azure Cloud Identity Provider configuration
*CloudIdpAPI* | [**v1CloudIdpExportPost**](docs/CloudIdpAPI.md#v1cloudidpexportpost) | **POST** /v1/cloud-idp/export | Export Cloud Identity Providers collection 
*CloudIdpAPI* | [**v1CloudIdpGet**](docs/CloudIdpAPI.md#v1cloudidpget) | **GET** /v1/cloud-idp | Get information about all Cloud Identity Providers configurations.
*CloudIdpAPI* | [**v1CloudIdpIdGet**](docs/CloudIdpAPI.md#v1cloudidpidget) | **GET** /v1/cloud-idp/{id} | Get Cloud Identity Provider configuration with given ID.
*CloudIdpAPI* | [**v1CloudIdpIdHistoryGet**](docs/CloudIdpAPI.md#v1cloudidpidhistoryget) | **GET** /v1/cloud-idp/{id}/history | Get Cloud Identity Provider history
*CloudIdpAPI* | [**v1CloudIdpIdHistoryPost**](docs/CloudIdpAPI.md#v1cloudidpidhistorypost) | **POST** /v1/cloud-idp/{id}/history | Add Cloud Identity Provider history note
*CloudIdpAPI* | [**v1CloudIdpIdTestGroupPost**](docs/CloudIdpAPI.md#v1cloudidpidtestgrouppost) | **POST** /v1/cloud-idp/{id}/test-group | Get group test search
*CloudIdpAPI* | [**v1CloudIdpIdTestUserMembershipPost**](docs/CloudIdpAPI.md#v1cloudidpidtestusermembershippost) | **POST** /v1/cloud-idp/{id}/test-user-membership | Get membership test search
*CloudIdpAPI* | [**v1CloudIdpIdTestUserPost**](docs/CloudIdpAPI.md#v1cloudidpidtestuserpost) | **POST** /v1/cloud-idp/{id}/test-user | Get user test search
*CloudInformationAPI* | [**v1CloudInformationGet**](docs/CloudInformationAPI.md#v1cloudinformationget) | **GET** /v1/cloud-information | Retrieve information related to cloud setup. 
*CloudLdapAPI* | [**v1LdapKeystoreVerifyPost**](docs/CloudLdapAPI.md#v1ldapkeystoreverifypost) | **POST** /v1/ldap-keystore/verify | Validate keystore for Cloud Identity Provider secure connection
*CloudLdapAPI* | [**v2CloudLdapsDefaultsProviderMappingsGet**](docs/CloudLdapAPI.md#v2cloudldapsdefaultsprovidermappingsget) | **GET** /v2/cloud-ldaps/defaults/{provider}/mappings | Get default mappings
*CloudLdapAPI* | [**v2CloudLdapsDefaultsProviderServerConfigurationGet**](docs/CloudLdapAPI.md#v2cloudldapsdefaultsproviderserverconfigurationget) | **GET** /v2/cloud-ldaps/defaults/{provider}/server-configuration | Get default server configuration
*CloudLdapAPI* | [**v2CloudLdapsIdConnectionBindGet**](docs/CloudLdapAPI.md#v2cloudldapsidconnectionbindget) | **GET** /v2/cloud-ldaps/{id}/connection/bind | Get bind connection pool statistics
*CloudLdapAPI* | [**v2CloudLdapsIdConnectionSearchGet**](docs/CloudLdapAPI.md#v2cloudldapsidconnectionsearchget) | **GET** /v2/cloud-ldaps/{id}/connection/search | Get search connection pool statistics
*CloudLdapAPI* | [**v2CloudLdapsIdConnectionStatusGet**](docs/CloudLdapAPI.md#v2cloudldapsidconnectionstatusget) | **GET** /v2/cloud-ldaps/{id}/connection/status | Tests the communication with the specified cloud connection 
*CloudLdapAPI* | [**v2CloudLdapsIdDelete**](docs/CloudLdapAPI.md#v2cloudldapsiddelete) | **DELETE** /v2/cloud-ldaps/{id} | Delete Cloud Identity Provider configuration.
*CloudLdapAPI* | [**v2CloudLdapsIdGet**](docs/CloudLdapAPI.md#v2cloudldapsidget) | **GET** /v2/cloud-ldaps/{id} | Get Cloud Identity Provider configuration with given id.
*CloudLdapAPI* | [**v2CloudLdapsIdMappingsGet**](docs/CloudLdapAPI.md#v2cloudldapsidmappingsget) | **GET** /v2/cloud-ldaps/{id}/mappings | Get mappings configurations for Cloud Identity Providers server configuration.
*CloudLdapAPI* | [**v2CloudLdapsIdMappingsPut**](docs/CloudLdapAPI.md#v2cloudldapsidmappingsput) | **PUT** /v2/cloud-ldaps/{id}/mappings | Update Cloud Identity Provider mappings configuration.
*CloudLdapAPI* | [**v2CloudLdapsIdPut**](docs/CloudLdapAPI.md#v2cloudldapsidput) | **PUT** /v2/cloud-ldaps/{id} | Update Cloud Identity Provider configuration
*CloudLdapAPI* | [**v2CloudLdapsPost**](docs/CloudLdapAPI.md#v2cloudldapspost) | **POST** /v2/cloud-ldaps | Create Cloud Identity Provider configuration
*ComputerGroupsAPI* | [**v1ComputerGroupsGet**](docs/ComputerGroupsAPI.md#v1computergroupsget) | **GET** /v1/computer-groups | Returns the list of all computer groups 
*ComputerInventoryAPI* | [**v1ComputersInventoryDetailIdGet**](docs/ComputerInventoryAPI.md#v1computersinventorydetailidget) | **GET** /v1/computers-inventory-detail/{id} | Return all sections of a computer
*ComputerInventoryAPI* | [**v1ComputersInventoryDetailIdPatch**](docs/ComputerInventoryAPI.md#v1computersinventorydetailidpatch) | **PATCH** /v1/computers-inventory-detail/{id} | Update specific fields on a computer
*ComputerInventoryAPI* | [**v1ComputersInventoryFilevaultGet**](docs/ComputerInventoryAPI.md#v1computersinventoryfilevaultget) | **GET** /v1/computers-inventory/filevault | Return paginated FileVault information for all computers
*ComputerInventoryAPI* | [**v1ComputersInventoryGet**](docs/ComputerInventoryAPI.md#v1computersinventoryget) | **GET** /v1/computers-inventory | Return paginated Computer Inventory records
*ComputerInventoryAPI* | [**v1ComputersInventoryIdAttachmentsAttachmentIdDelete**](docs/ComputerInventoryAPI.md#v1computersinventoryidattachmentsattachmentiddelete) | **DELETE** /v1/computers-inventory/{id}/attachments/{attachmentId} | Remove attachment
*ComputerInventoryAPI* | [**v1ComputersInventoryIdAttachmentsAttachmentIdGet**](docs/ComputerInventoryAPI.md#v1computersinventoryidattachmentsattachmentidget) | **GET** /v1/computers-inventory/{id}/attachments/{attachmentId} | Download attachment file
*ComputerInventoryAPI* | [**v1ComputersInventoryIdAttachmentsPost**](docs/ComputerInventoryAPI.md#v1computersinventoryidattachmentspost) | **POST** /v1/computers-inventory/{id}/attachments | Upload attachment and assign to computer
*ComputerInventoryAPI* | [**v1ComputersInventoryIdDelete**](docs/ComputerInventoryAPI.md#v1computersinventoryiddelete) | **DELETE** /v1/computers-inventory/{id} | Remove specified Computer record
*ComputerInventoryAPI* | [**v1ComputersInventoryIdFilevaultGet**](docs/ComputerInventoryAPI.md#v1computersinventoryidfilevaultget) | **GET** /v1/computers-inventory/{id}/filevault | Return FileVault information for a specific computer
*ComputerInventoryAPI* | [**v1ComputersInventoryIdGet**](docs/ComputerInventoryAPI.md#v1computersinventoryidget) | **GET** /v1/computers-inventory/{id} | Return General section of a Computer
*ComputerInventoryAPI* | [**v1ComputersInventoryIdViewRecoveryLockPasswordGet**](docs/ComputerInventoryAPI.md#v1computersinventoryidviewrecoverylockpasswordget) | **GET** /v1/computers-inventory/{id}/view-recovery-lock-password | Return a Computers Recovery Lock Password
*ComputerInventoryCollectionSettingsAPI* | [**v1ComputerInventoryCollectionSettingsCustomPathIdDelete**](docs/ComputerInventoryCollectionSettingsAPI.md#v1computerinventorycollectionsettingscustompathiddelete) | **DELETE** /v1/computer-inventory-collection-settings/custom-path/{id} | Delete Custom Path from Computer Inventory Collection Settings
*ComputerInventoryCollectionSettingsAPI* | [**v1ComputerInventoryCollectionSettingsCustomPathPost**](docs/ComputerInventoryCollectionSettingsAPI.md#v1computerinventorycollectionsettingscustompathpost) | **POST** /v1/computer-inventory-collection-settings/custom-path | Create Computer Inventory Collection Settings Custom Path
*ComputerInventoryCollectionSettingsAPI* | [**v1ComputerInventoryCollectionSettingsGet**](docs/ComputerInventoryCollectionSettingsAPI.md#v1computerinventorycollectionsettingsget) | **GET** /v1/computer-inventory-collection-settings | Returns computer inventory settings
*ComputerInventoryCollectionSettingsAPI* | [**v1ComputerInventoryCollectionSettingsPatch**](docs/ComputerInventoryCollectionSettingsAPI.md#v1computerinventorycollectionsettingspatch) | **PATCH** /v1/computer-inventory-collection-settings | Update computer inventory settings
*ComputerPrestagesAPI* | [**v1ComputerPrestagesIdScopeDelete**](docs/ComputerPrestagesAPI.md#v1computerprestagesidscopedelete) | **DELETE** /v1/computer-prestages/{id}/scope | Remove device Scope for a specific Computer Prestage 
*ComputerPrestagesAPI* | [**v1ComputerPrestagesIdScopeGet**](docs/ComputerPrestagesAPI.md#v1computerprestagesidscopeget) | **GET** /v1/computer-prestages/{id}/scope | Get device Scope for a specific Computer Prestage 
*ComputerPrestagesAPI* | [**v1ComputerPrestagesIdScopePost**](docs/ComputerPrestagesAPI.md#v1computerprestagesidscopepost) | **POST** /v1/computer-prestages/{id}/scope | Add device Scope for a specific Computer Prestage 
*ComputerPrestagesAPI* | [**v1ComputerPrestagesIdScopePut**](docs/ComputerPrestagesAPI.md#v1computerprestagesidscopeput) | **PUT** /v1/computer-prestages/{id}/scope | Replace device Scope for a specific Computer Prestage 
*ComputerPrestagesAPI* | [**v1ComputerPrestagesScopeGet**](docs/ComputerPrestagesAPI.md#v1computerprestagesscopeget) | **GET** /v1/computer-prestages/scope | Get all device Scope for all Computer Prestages 
*ComputerPrestagesAPI* | [**v2ComputerPrestagesGet**](docs/ComputerPrestagesAPI.md#v2computerprestagesget) | **GET** /v2/computer-prestages | Get sorted and paged Computer Prestages 
*ComputerPrestagesAPI* | [**v2ComputerPrestagesIdDelete**](docs/ComputerPrestagesAPI.md#v2computerprestagesiddelete) | **DELETE** /v2/computer-prestages/{id} | Delete a Computer Prestage with the supplied id 
*ComputerPrestagesAPI* | [**v2ComputerPrestagesIdGet**](docs/ComputerPrestagesAPI.md#v2computerprestagesidget) | **GET** /v2/computer-prestages/{id} | Retrieve a Computer Prestage with the supplied id 
*ComputerPrestagesAPI* | [**v2ComputerPrestagesIdPut**](docs/ComputerPrestagesAPI.md#v2computerprestagesidput) | **PUT** /v2/computer-prestages/{id} | Update a Computer Prestage 
*ComputerPrestagesAPI* | [**v2ComputerPrestagesIdScopeDeleteMultiplePost**](docs/ComputerPrestagesAPI.md#v2computerprestagesidscopedeletemultiplepost) | **POST** /v2/computer-prestages/{id}/scope/delete-multiple | Remove device Scope for a specific Computer Prestage 
*ComputerPrestagesAPI* | [**v2ComputerPrestagesIdScopeGet**](docs/ComputerPrestagesAPI.md#v2computerprestagesidscopeget) | **GET** /v2/computer-prestages/{id}/scope | Get device Scope for a specific Computer Prestage 
*ComputerPrestagesAPI* | [**v2ComputerPrestagesIdScopePost**](docs/ComputerPrestagesAPI.md#v2computerprestagesidscopepost) | **POST** /v2/computer-prestages/{id}/scope | Add device Scope for a specific Computer Prestage 
*ComputerPrestagesAPI* | [**v2ComputerPrestagesIdScopePut**](docs/ComputerPrestagesAPI.md#v2computerprestagesidscopeput) | **PUT** /v2/computer-prestages/{id}/scope | Replace device Scope for a specific Computer Prestage 
*ComputerPrestagesAPI* | [**v2ComputerPrestagesPost**](docs/ComputerPrestagesAPI.md#v2computerprestagespost) | **POST** /v2/computer-prestages | Create a Computer Prestage 
*ComputerPrestagesAPI* | [**v2ComputerPrestagesScopeGet**](docs/ComputerPrestagesAPI.md#v2computerprestagesscopeget) | **GET** /v2/computer-prestages/scope | Get all device Scope for all Computer Prestages 
*ComputerPrestagesAPI* | [**v3ComputerPrestagesGet**](docs/ComputerPrestagesAPI.md#v3computerprestagesget) | **GET** /v3/computer-prestages | Get sorted and paged Computer Prestages 
*ComputerPrestagesAPI* | [**v3ComputerPrestagesIdDelete**](docs/ComputerPrestagesAPI.md#v3computerprestagesiddelete) | **DELETE** /v3/computer-prestages/{id} | Delete a Computer Prestage with the supplied id 
*ComputerPrestagesAPI* | [**v3ComputerPrestagesIdGet**](docs/ComputerPrestagesAPI.md#v3computerprestagesidget) | **GET** /v3/computer-prestages/{id} | Retrieve a Computer Prestage with the supplied id 
*ComputerPrestagesAPI* | [**v3ComputerPrestagesIdPut**](docs/ComputerPrestagesAPI.md#v3computerprestagesidput) | **PUT** /v3/computer-prestages/{id} | Update a Computer Prestage 
*ComputerPrestagesAPI* | [**v3ComputerPrestagesPost**](docs/ComputerPrestagesAPI.md#v3computerprestagespost) | **POST** /v3/computer-prestages | Create a Computer Prestage 
*ComputersPreviewAPI* | [**previewComputersGet**](docs/ComputersPreviewAPI.md#previewcomputersget) | **GET** /preview/computers | Return a list of Computers 
*ConditionalAccessAPI* | [**v1ConditionalAccessDeviceComplianceInformationComputerDeviceIdGet**](docs/ConditionalAccessAPI.md#v1conditionalaccessdevicecomplianceinformationcomputerdeviceidget) | **GET** /v1/conditional-access/device-compliance-information/computer/{deviceId} | Get compliance information for a single computer device
*ConditionalAccessAPI* | [**v1ConditionalAccessDeviceComplianceInformationMobileDeviceIdGet**](docs/ConditionalAccessAPI.md#v1conditionalaccessdevicecomplianceinformationmobiledeviceidget) | **GET** /v1/conditional-access/device-compliance-information/mobile/{deviceId} | Get compliance information for a single mobile device
*CsaAPI* | [**v1CsaTokenDelete**](docs/CsaAPI.md#v1csatokendelete) | **DELETE** /v1/csa/token | Delete the CSA token exchange - This will disable Jamf Pro&#39;s ability to authenticate with cloud-hosted services 
*CsaAPI* | [**v1CsaTokenGet**](docs/CsaAPI.md#v1csatokenget) | **GET** /v1/csa/token | Get details regarding the CSA token exchange 
*CsaAPI* | [**v1CsaTokenPost**](docs/CsaAPI.md#v1csatokenpost) | **POST** /v1/csa/token | Initialize the CSA token exchange 
*CsaAPI* | [**v1CsaTokenPut**](docs/CsaAPI.md#v1csatokenput) | **PUT** /v1/csa/token | Re-initialize the CSA token exchange with new credentials 
*DashboardAPI* | [**v1DashboardGet**](docs/DashboardAPI.md#v1dashboardget) | **GET** /v1/dashboard | Get all the dashboard setup information 
*DepartmentsAPI* | [**v1DepartmentsDeleteMultiplePost**](docs/DepartmentsAPI.md#v1departmentsdeletemultiplepost) | **POST** /v1/departments/delete-multiple | Deletes all departments by ids passed in body 
*DepartmentsAPI* | [**v1DepartmentsGet**](docs/DepartmentsAPI.md#v1departmentsget) | **GET** /v1/departments | Search for Departments 
*DepartmentsAPI* | [**v1DepartmentsIdDelete**](docs/DepartmentsAPI.md#v1departmentsiddelete) | **DELETE** /v1/departments/{id} | Remove specified department record 
*DepartmentsAPI* | [**v1DepartmentsIdGet**](docs/DepartmentsAPI.md#v1departmentsidget) | **GET** /v1/departments/{id} | Get specified Department object 
*DepartmentsAPI* | [**v1DepartmentsIdHistoryGet**](docs/DepartmentsAPI.md#v1departmentsidhistoryget) | **GET** /v1/departments/{id}/history | Get specified Department history object 
*DepartmentsAPI* | [**v1DepartmentsIdHistoryPost**](docs/DepartmentsAPI.md#v1departmentsidhistorypost) | **POST** /v1/departments/{id}/history | Add specified Department history object notes 
*DepartmentsAPI* | [**v1DepartmentsIdPut**](docs/DepartmentsAPI.md#v1departmentsidput) | **PUT** /v1/departments/{id} | Update specified department object 
*DepartmentsAPI* | [**v1DepartmentsPost**](docs/DepartmentsAPI.md#v1departmentspost) | **POST** /v1/departments | Create department record 
*DeviceCommunicationSettingsAPI* | [**v1DeviceCommunicationSettingsGet**](docs/DeviceCommunicationSettingsAPI.md#v1devicecommunicationsettingsget) | **GET** /v1/device-communication-settings | Retrieves all settings for device communication 
*DeviceCommunicationSettingsAPI* | [**v1DeviceCommunicationSettingsHistoryGet**](docs/DeviceCommunicationSettingsAPI.md#v1devicecommunicationsettingshistoryget) | **GET** /v1/device-communication-settings/history | Get Device Communication settings history 
*DeviceCommunicationSettingsAPI* | [**v1DeviceCommunicationSettingsHistoryPost**](docs/DeviceCommunicationSettingsAPI.md#v1devicecommunicationsettingshistorypost) | **POST** /v1/device-communication-settings/history | Add Device Communication Settings history notes 
*DeviceCommunicationSettingsAPI* | [**v1DeviceCommunicationSettingsPut**](docs/DeviceCommunicationSettingsAPI.md#v1devicecommunicationsettingsput) | **PUT** /v1/device-communication-settings | Update device communication settings 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsGet**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentsget) | **GET** /v1/device-enrollments | Read all sorted and paged Device Enrollment instances 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsIdDelete**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentsiddelete) | **DELETE** /v1/device-enrollments/{id} | Delete a Device Enrollment Instance with the supplied id 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsIdDisownPost**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentsiddisownpost) | **POST** /v1/device-enrollments/{id}/disown | Disown devices from the given Device Enrollment Instance 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsIdGet**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentsidget) | **GET** /v1/device-enrollments/{id} | Retrieve a Device Enrollment Instance with the supplied id 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsIdHistoryGet**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentsidhistoryget) | **GET** /v1/device-enrollments/{id}/history | Get sorted and paged Device Enrollment history objects 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsIdHistoryPost**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentsidhistorypost) | **POST** /v1/device-enrollments/{id}/history | Add Device Enrollment history object notes 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsIdPut**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentsidput) | **PUT** /v1/device-enrollments/{id} | Update a Device Enrollment Instance with the supplied id 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsIdSyncsGet**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentsidsyncsget) | **GET** /v1/device-enrollments/{id}/syncs | Get all instance sync states for a single Device Enrollment Instance 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsIdSyncsLatestGet**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentsidsyncslatestget) | **GET** /v1/device-enrollments/{id}/syncs/latest | Get the latest sync state for a single Device Enrollment Instance 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsIdUploadTokenPut**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentsiduploadtokenput) | **PUT** /v1/device-enrollments/{id}/upload-token | Update a Device Enrollment Instance with the supplied Token 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsPublicKeyGet**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentspublickeyget) | **GET** /v1/device-enrollments/public-key | Retrieve the Jamf Pro Device Enrollment public key 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsSyncsGet**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentssyncsget) | **GET** /v1/device-enrollments/syncs | Get all instance sync states for all Device Enrollment Instances 
*DeviceEnrollmentsAPI* | [**v1DeviceEnrollmentsUploadTokenPost**](docs/DeviceEnrollmentsAPI.md#v1deviceenrollmentsuploadtokenpost) | **POST** /v1/device-enrollments/upload-token | Create a Device Enrollment Instance with the supplied Token 
*DeviceEnrollmentsDevicesAPI* | [**v1DeviceEnrollmentsIdDevicesGet**](docs/DeviceEnrollmentsDevicesAPI.md#v1deviceenrollmentsiddevicesget) | **GET** /v1/device-enrollments/{id}/devices | Retrieve a list of Devices assigned to the supplied id 
*EbooksAPI* | [**v1EbooksGet**](docs/EbooksAPI.md#v1ebooksget) | **GET** /v1/ebooks | Get Ebook object 
*EbooksAPI* | [**v1EbooksIdGet**](docs/EbooksAPI.md#v1ebooksidget) | **GET** /v1/ebooks/{id} | Get specified Ebook object 
*EbooksAPI* | [**v1EbooksIdScopeGet**](docs/EbooksAPI.md#v1ebooksidscopeget) | **GET** /v1/ebooks/{id}/scope | Get specified scope of Ebook object 
*EngageAPI* | [**v1EngageGet**](docs/EngageAPI.md#v1engageget) | **GET** /v1/engage | Get Engage settings 
*EngageAPI* | [**v1EngageHistoryGet**](docs/EngageAPI.md#v1engagehistoryget) | **GET** /v1/engage/history | Get Engage settings history 
*EngageAPI* | [**v1EngageHistoryPost**](docs/EngageAPI.md#v1engagehistorypost) | **POST** /v1/engage/history | Add Engage settings history notes 
*EngageAPI* | [**v1EngagePut**](docs/EngageAPI.md#v1engageput) | **PUT** /v1/engage | Update Engage settings 
*EngageAPI* | [**v2EngageGet**](docs/EngageAPI.md#v2engageget) | **GET** /v2/engage | Get Engage settings 
*EngageAPI* | [**v2EngageHistoryGet**](docs/EngageAPI.md#v2engagehistoryget) | **GET** /v2/engage/history | Get Engage settings history 
*EngageAPI* | [**v2EngageHistoryPost**](docs/EngageAPI.md#v2engagehistorypost) | **POST** /v2/engage/history | Add Engage settings history notes 
*EngageAPI* | [**v2EngagePut**](docs/EngageAPI.md#v2engageput) | **PUT** /v2/engage | Update Engage settings 
*EnrollmentAPI* | [**v1AdueSessionTokenSettingsGet**](docs/EnrollmentAPI.md#v1aduesessiontokensettingsget) | **GET** /v1/adue-session-token-settings | Retrieve the Account Driven User Enrollment Session Token Settings 
*EnrollmentAPI* | [**v1AdueSessionTokenSettingsPut**](docs/EnrollmentAPI.md#v1aduesessiontokensettingsput) | **PUT** /v1/adue-session-token-settings | Update Account Driven User Enrollment Session Token Settings. 
*EnrollmentAPI* | [**v2EnrollmentAccessGroupsGet**](docs/EnrollmentAPI.md#v2enrollmentaccessgroupsget) | **GET** /v2/enrollment/access-groups | Retrieve the configured LDAP groups configured for User-Initiated Enrollment 
*EnrollmentAPI* | [**v2EnrollmentAccessGroupsPost**](docs/EnrollmentAPI.md#v2enrollmentaccessgroupspost) | **POST** /v2/enrollment/access-groups | Add the configured LDAP group for User-Initiated Enrollment. 
*EnrollmentAPI* | [**v2EnrollmentAccessGroupsServerIdGroupIdDelete**](docs/EnrollmentAPI.md#v2enrollmentaccessgroupsserveridgroupiddelete) | **DELETE** /v2/enrollment/access-groups/{serverId}/{groupId} | Delete an LDAP group&#39;s access to user initiated Enrollment 
*EnrollmentAPI* | [**v2EnrollmentAccessGroupsServerIdGroupIdGet**](docs/EnrollmentAPI.md#v2enrollmentaccessgroupsserveridgroupidget) | **GET** /v2/enrollment/access-groups/{serverId}/{groupId} | Retrieve the configured LDAP groups configured for User-Initiated Enrollment 
*EnrollmentAPI* | [**v2EnrollmentAccessGroupsServerIdGroupIdPut**](docs/EnrollmentAPI.md#v2enrollmentaccessgroupsserveridgroupidput) | **PUT** /v2/enrollment/access-groups/{serverId}/{groupId} | Modify the configured LDAP groups configured for User-Initiated Enrollment 
*EnrollmentAPI* | [**v2EnrollmentFilteredLanguageCodesGet**](docs/EnrollmentAPI.md#v2enrollmentfilteredlanguagecodesget) | **GET** /v2/enrollment/filtered-language-codes | Retrieve the list of languages and corresponding ISO 639-1 Codes but only those not already added to Enrollment 
*EnrollmentAPI* | [**v2EnrollmentGet**](docs/EnrollmentAPI.md#v2enrollmentget) | **GET** /v2/enrollment | Get Enrollment object and Re-enrollment settings 
*EnrollmentAPI* | [**v2EnrollmentHistoryExportPost**](docs/EnrollmentAPI.md#v2enrollmenthistoryexportpost) | **POST** /v2/enrollment/history/export | Export enrollment history collection 
*EnrollmentAPI* | [**v2EnrollmentHistoryGet**](docs/EnrollmentAPI.md#v2enrollmenthistoryget) | **GET** /v2/enrollment/history | Get sorted and paged Enrollment history object 
*EnrollmentAPI* | [**v2EnrollmentHistoryPost**](docs/EnrollmentAPI.md#v2enrollmenthistorypost) | **POST** /v2/enrollment/history | Add Enrollment history object notes 
*EnrollmentAPI* | [**v2EnrollmentLanguageCodesGet**](docs/EnrollmentAPI.md#v2enrollmentlanguagecodesget) | **GET** /v2/enrollment/language-codes | Retrieve the list of languages and corresponding ISO 639-1 Codes 
*EnrollmentAPI* | [**v2EnrollmentLanguagesDeleteMultiplePost**](docs/EnrollmentAPI.md#v2enrollmentlanguagesdeletemultiplepost) | **POST** /v2/enrollment/languages/delete-multiple | Delete multiple configured languages from User-Initiated Enrollment settings 
*EnrollmentAPI* | [**v2EnrollmentLanguagesGet**](docs/EnrollmentAPI.md#v2enrollmentlanguagesget) | **GET** /v2/enrollment/languages | Get an array of the language codes that have Enrollment messaging 
*EnrollmentAPI* | [**v2EnrollmentLanguagesLanguageIdDelete**](docs/EnrollmentAPI.md#v2enrollmentlanguageslanguageiddelete) | **DELETE** /v2/enrollment/languages/{languageId} | Delete the Enrollment messaging for a language 
*EnrollmentAPI* | [**v2EnrollmentLanguagesLanguageIdGet**](docs/EnrollmentAPI.md#v2enrollmentlanguageslanguageidget) | **GET** /v2/enrollment/languages/{languageId} | Retrieve the Enrollment messaging for a language 
*EnrollmentAPI* | [**v2EnrollmentLanguagesLanguageIdPut**](docs/EnrollmentAPI.md#v2enrollmentlanguageslanguageidput) | **PUT** /v2/enrollment/languages/{languageId} | Edit Enrollment messaging for a language 
*EnrollmentAPI* | [**v2EnrollmentPut**](docs/EnrollmentAPI.md#v2enrollmentput) | **PUT** /v2/enrollment | Update Enrollment object 
*EnrollmentAPI* | [**v3EnrollmentAccessGroupsGet**](docs/EnrollmentAPI.md#v3enrollmentaccessgroupsget) | **GET** /v3/enrollment/access-groups | Retrieve the configured LDAP groups configured for User-Initiated Enrollment. 
*EnrollmentAPI* | [**v3EnrollmentAccessGroupsIdDelete**](docs/EnrollmentAPI.md#v3enrollmentaccessgroupsiddelete) | **DELETE** /v3/enrollment/access-groups/{id} | Delete an LDAP group&#39;s access to user initiated Enrollment. 
*EnrollmentAPI* | [**v3EnrollmentAccessGroupsIdGet**](docs/EnrollmentAPI.md#v3enrollmentaccessgroupsidget) | **GET** /v3/enrollment/access-groups/{id} | Retrieve the configured LDAP groups configured for User-Initiated Enrollment 
*EnrollmentAPI* | [**v3EnrollmentAccessGroupsIdPut**](docs/EnrollmentAPI.md#v3enrollmentaccessgroupsidput) | **PUT** /v3/enrollment/access-groups/{id} | Modify the configured LDAP groups configured for User-Initiated Enrollment. Only exiting Access Groups can be updated. 
*EnrollmentAPI* | [**v3EnrollmentAccessGroupsPost**](docs/EnrollmentAPI.md#v3enrollmentaccessgroupspost) | **POST** /v3/enrollment/access-groups | Add the configured LDAP group for User-Initiated Enrollment. 
*EnrollmentAPI* | [**v3EnrollmentFilteredLanguageCodesGet**](docs/EnrollmentAPI.md#v3enrollmentfilteredlanguagecodesget) | **GET** /v3/enrollment/filtered-language-codes | Retrieve the list of languages and corresponding ISO 639-1 Codes but only those not already added to Enrollment 
*EnrollmentAPI* | [**v3EnrollmentGet**](docs/EnrollmentAPI.md#v3enrollmentget) | **GET** /v3/enrollment | Get Enrollment object and Re-enrollment settings 
*EnrollmentAPI* | [**v3EnrollmentLanguageCodesGet**](docs/EnrollmentAPI.md#v3enrollmentlanguagecodesget) | **GET** /v3/enrollment/language-codes | Retrieve the list of languages and corresponding ISO 639-1 Codes 
*EnrollmentAPI* | [**v3EnrollmentLanguagesDeleteMultiplePost**](docs/EnrollmentAPI.md#v3enrollmentlanguagesdeletemultiplepost) | **POST** /v3/enrollment/languages/delete-multiple | Delete multiple configured languages from User-Initiated Enrollment settings 
*EnrollmentAPI* | [**v3EnrollmentLanguagesGet**](docs/EnrollmentAPI.md#v3enrollmentlanguagesget) | **GET** /v3/enrollment/languages | Get an array of the language codes that have Enrollment messaging 
*EnrollmentAPI* | [**v3EnrollmentLanguagesLanguageIdDelete**](docs/EnrollmentAPI.md#v3enrollmentlanguageslanguageiddelete) | **DELETE** /v3/enrollment/languages/{languageId} | Delete the Enrollment messaging for a language 
*EnrollmentAPI* | [**v3EnrollmentLanguagesLanguageIdGet**](docs/EnrollmentAPI.md#v3enrollmentlanguageslanguageidget) | **GET** /v3/enrollment/languages/{languageId} | Retrieve the Enrollment messaging for a language 
*EnrollmentAPI* | [**v3EnrollmentLanguagesLanguageIdPut**](docs/EnrollmentAPI.md#v3enrollmentlanguageslanguageidput) | **PUT** /v3/enrollment/languages/{languageId} | Edit Enrollment messaging for a language 
*EnrollmentAPI* | [**v3EnrollmentPut**](docs/EnrollmentAPI.md#v3enrollmentput) | **PUT** /v3/enrollment | Update Enrollment object 
*EnrollmentCustomizationAPI* | [**v1EnrollmentCustomizationGet**](docs/EnrollmentCustomizationAPI.md#v1enrollmentcustomizationget) | **GET** /v1/enrollment-customization | Retrieve sorted and paged Enrollment Customizations 
*EnrollmentCustomizationAPI* | [**v1EnrollmentCustomizationIdDelete**](docs/EnrollmentCustomizationAPI.md#v1enrollmentcustomizationiddelete) | **DELETE** /v1/enrollment-customization/{id} | Delete an Enrollment Customization with the supplied id 
*EnrollmentCustomizationAPI* | [**v1EnrollmentCustomizationIdGet**](docs/EnrollmentCustomizationAPI.md#v1enrollmentcustomizationidget) | **GET** /v1/enrollment-customization/{id} | Retrieve an Enrollment Customization with the supplied id 
*EnrollmentCustomizationAPI* | [**v1EnrollmentCustomizationIdHistoryGet**](docs/EnrollmentCustomizationAPI.md#v1enrollmentcustomizationidhistoryget) | **GET** /v1/enrollment-customization/{id}/history | Get sorted and paged Enrollment Customization history objects 
*EnrollmentCustomizationAPI* | [**v1EnrollmentCustomizationIdHistoryPost**](docs/EnrollmentCustomizationAPI.md#v1enrollmentcustomizationidhistorypost) | **POST** /v1/enrollment-customization/{id}/history | Add Enrollment Customization history object notes 
*EnrollmentCustomizationAPI* | [**v1EnrollmentCustomizationIdPrestagesGet**](docs/EnrollmentCustomizationAPI.md#v1enrollmentcustomizationidprestagesget) | **GET** /v1/enrollment-customization/{id}/prestages | Retrieve the list of Prestages using this Enrollment Customization 
*EnrollmentCustomizationAPI* | [**v1EnrollmentCustomizationIdPut**](docs/EnrollmentCustomizationAPI.md#v1enrollmentcustomizationidput) | **PUT** /v1/enrollment-customization/{id} | Update an Enrollment Customization 
*EnrollmentCustomizationAPI* | [**v1EnrollmentCustomizationImagesPost**](docs/EnrollmentCustomizationAPI.md#v1enrollmentcustomizationimagespost) | **POST** /v1/enrollment-customization/images | Upload an image
*EnrollmentCustomizationAPI* | [**v1EnrollmentCustomizationPost**](docs/EnrollmentCustomizationAPI.md#v1enrollmentcustomizationpost) | **POST** /v1/enrollment-customization | Create an Enrollment Customization 
*EnrollmentCustomizationAPI* | [**v2EnrollmentCustomizationsGet**](docs/EnrollmentCustomizationAPI.md#v2enrollmentcustomizationsget) | **GET** /v2/enrollment-customizations | Retrieve sorted and paged Enrollment Customizations 
*EnrollmentCustomizationAPI* | [**v2EnrollmentCustomizationsIdDelete**](docs/EnrollmentCustomizationAPI.md#v2enrollmentcustomizationsiddelete) | **DELETE** /v2/enrollment-customizations/{id} | Delete an Enrollment Customization with the supplied id 
*EnrollmentCustomizationAPI* | [**v2EnrollmentCustomizationsIdGet**](docs/EnrollmentCustomizationAPI.md#v2enrollmentcustomizationsidget) | **GET** /v2/enrollment-customizations/{id} | Retrieve an Enrollment Customization with the supplied id 
*EnrollmentCustomizationAPI* | [**v2EnrollmentCustomizationsIdHistoryGet**](docs/EnrollmentCustomizationAPI.md#v2enrollmentcustomizationsidhistoryget) | **GET** /v2/enrollment-customizations/{id}/history | Get sorted and paged Enrollment Customization history objects 
*EnrollmentCustomizationAPI* | [**v2EnrollmentCustomizationsIdHistoryPost**](docs/EnrollmentCustomizationAPI.md#v2enrollmentcustomizationsidhistorypost) | **POST** /v2/enrollment-customizations/{id}/history | Add Enrollment Customization history object notes 
*EnrollmentCustomizationAPI* | [**v2EnrollmentCustomizationsIdPrestagesGet**](docs/EnrollmentCustomizationAPI.md#v2enrollmentcustomizationsidprestagesget) | **GET** /v2/enrollment-customizations/{id}/prestages | Retrieve the list of Prestages using this Enrollment Customization 
*EnrollmentCustomizationAPI* | [**v2EnrollmentCustomizationsIdPut**](docs/EnrollmentCustomizationAPI.md#v2enrollmentcustomizationsidput) | **PUT** /v2/enrollment-customizations/{id} | Update an Enrollment Customization 
*EnrollmentCustomizationAPI* | [**v2EnrollmentCustomizationsImagesIdGet**](docs/EnrollmentCustomizationAPI.md#v2enrollmentcustomizationsimagesidget) | **GET** /v2/enrollment-customizations/images/{id} | Download an enrollment customization image 
*EnrollmentCustomizationAPI* | [**v2EnrollmentCustomizationsImagesPost**](docs/EnrollmentCustomizationAPI.md#v2enrollmentcustomizationsimagespost) | **POST** /v2/enrollment-customizations/images | Upload an image
*EnrollmentCustomizationAPI* | [**v2EnrollmentCustomizationsPost**](docs/EnrollmentCustomizationAPI.md#v2enrollmentcustomizationspost) | **POST** /v2/enrollment-customizations | Create an Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdAllGet**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidallget) | **GET** /v1/enrollment-customization/{id}/all | Get all Panels for single Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdAllPanelIdDelete**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidallpaneliddelete) | **DELETE** /v1/enrollment-customization/{id}/all/{panel-id} | Delete a single Panel from an Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdAllPanelIdGet**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidallpanelidget) | **GET** /v1/enrollment-customization/{id}/all/{panel-id} | Get a single Panel for a single Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdLdapPanelIdDelete**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidldappaneliddelete) | **DELETE** /v1/enrollment-customization/{id}/ldap/{panel-id} | Delete an LDAP single panel from an Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdLdapPanelIdGet**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidldappanelidget) | **GET** /v1/enrollment-customization/{id}/ldap/{panel-id} | Get a single LDAP panel for a single Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdLdapPanelIdPut**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidldappanelidput) | **PUT** /v1/enrollment-customization/{id}/ldap/{panel-id} | Update a single LDAP Panel for a single Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdLdapPost**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidldappost) | **POST** /v1/enrollment-customization/{id}/ldap | Create an LDAP Panel for a single Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdSsoPanelIdDelete**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidssopaneliddelete) | **DELETE** /v1/enrollment-customization/{id}/sso/{panel-id} | Delete a single SSO Panel from an Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdSsoPanelIdGet**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidssopanelidget) | **GET** /v1/enrollment-customization/{id}/sso/{panel-id} | Get a single SSO Panel for a single Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdSsoPanelIdPut**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidssopanelidput) | **PUT** /v1/enrollment-customization/{id}/sso/{panel-id} | Update a single SSO Panel for a single Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdSsoPost**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidssopost) | **POST** /v1/enrollment-customization/{id}/sso | Create an SSO Panel for a single Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdTextPanelIdDelete**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidtextpaneliddelete) | **DELETE** /v1/enrollment-customization/{id}/text/{panel-id} | Delete a Text single Panel from an Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdTextPanelIdGet**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidtextpanelidget) | **GET** /v1/enrollment-customization/{id}/text/{panel-id} | Get a single Text Panel for a single Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdTextPanelIdMarkdownGet**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidtextpanelidmarkdownget) | **GET** /v1/enrollment-customization/{id}/text/{panel-id}/markdown | Get the markdown output of a single Text Panel for a single Enrollment 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdTextPanelIdPut**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidtextpanelidput) | **PUT** /v1/enrollment-customization/{id}/text/{panel-id} | Update a single Text Panel for a single Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationIdTextPost**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationidtextpost) | **POST** /v1/enrollment-customization/{id}/text | Create a Text Panel for a single Enrollment Customization 
*EnrollmentCustomizationPreviewAPI* | [**v1EnrollmentCustomizationParseMarkdownPost**](docs/EnrollmentCustomizationPreviewAPI.md#v1enrollmentcustomizationparsemarkdownpost) | **POST** /v1/enrollment-customization/parse-markdown | Parse the given string as markdown text and return Html output 
*IconAPI* | [**v1IconDownloadIdGet**](docs/IconAPI.md#v1icondownloadidget) | **GET** /v1/icon/download/{id} | Download a self service icon 
*IconAPI* | [**v1IconIdGet**](docs/IconAPI.md#v1iconidget) | **GET** /v1/icon/{id} | Get an icon 
*IconAPI* | [**v1IconPost**](docs/IconAPI.md#v1iconpost) | **POST** /v1/icon | Upload an icon 
*InventoryInformationAPI* | [**v1InventoryInformationGet**](docs/InventoryInformationAPI.md#v1inventoryinformationget) | **GET** /v1/inventory-information | Get statistics about managed/unmanaged devices and computers in the inventory 
*InventoryPreloadAPI* | [**inventoryPreloadCsvTemplateGet**](docs/InventoryPreloadAPI.md#inventorypreloadcsvtemplateget) | **GET** /inventory-preload/csv-template | Get the Inventory Preload CSV template 
*InventoryPreloadAPI* | [**inventoryPreloadDelete**](docs/InventoryPreloadAPI.md#inventorypreloaddelete) | **DELETE** /inventory-preload | Delete all Inventory Preload records 
*InventoryPreloadAPI* | [**inventoryPreloadGet**](docs/InventoryPreloadAPI.md#inventorypreloadget) | **GET** /inventory-preload | Return all Inventory Preload records 
*InventoryPreloadAPI* | [**inventoryPreloadHistoryGet**](docs/InventoryPreloadAPI.md#inventorypreloadhistoryget) | **GET** /inventory-preload/history | Get Inventory Preload history entries 
*InventoryPreloadAPI* | [**inventoryPreloadHistoryNotesPost**](docs/InventoryPreloadAPI.md#inventorypreloadhistorynotespost) | **POST** /inventory-preload/history/notes | Add Inventory Preload history object notes 
*InventoryPreloadAPI* | [**inventoryPreloadIdDelete**](docs/InventoryPreloadAPI.md#inventorypreloadiddelete) | **DELETE** /inventory-preload/{id} | Delete an Inventory Preload record 
*InventoryPreloadAPI* | [**inventoryPreloadIdGet**](docs/InventoryPreloadAPI.md#inventorypreloadidget) | **GET** /inventory-preload/{id} | Get an Inventory Preload record 
*InventoryPreloadAPI* | [**inventoryPreloadIdPut**](docs/InventoryPreloadAPI.md#inventorypreloadidput) | **PUT** /inventory-preload/{id} | Update an Inventory Preload record 
*InventoryPreloadAPI* | [**inventoryPreloadPost**](docs/InventoryPreloadAPI.md#inventorypreloadpost) | **POST** /inventory-preload | Create a new Inventory Preload record using JSON or CSV 
*InventoryPreloadAPI* | [**inventoryPreloadValidateCsvPost**](docs/InventoryPreloadAPI.md#inventorypreloadvalidatecsvpost) | **POST** /inventory-preload/validate-csv | Validate a given CSV file 
*InventoryPreloadAPI* | [**v1InventoryPreloadCsvTemplateGet**](docs/InventoryPreloadAPI.md#v1inventorypreloadcsvtemplateget) | **GET** /v1/inventory-preload/csv-template | Retrieve the Inventory Preload CSV template 
*InventoryPreloadAPI* | [**v1InventoryPreloadDelete**](docs/InventoryPreloadAPI.md#v1inventorypreloaddelete) | **DELETE** /v1/inventory-preload | Delete all Inventory Preload records 
*InventoryPreloadAPI* | [**v1InventoryPreloadGet**](docs/InventoryPreloadAPI.md#v1inventorypreloadget) | **GET** /v1/inventory-preload | Return all Inventory Preload records 
*InventoryPreloadAPI* | [**v1InventoryPreloadHistoryGet**](docs/InventoryPreloadAPI.md#v1inventorypreloadhistoryget) | **GET** /v1/inventory-preload/history | Get Inventory Preload history entries 
*InventoryPreloadAPI* | [**v1InventoryPreloadHistoryPost**](docs/InventoryPreloadAPI.md#v1inventorypreloadhistorypost) | **POST** /v1/inventory-preload/history | Add Inventory Preload history object notes 
*InventoryPreloadAPI* | [**v1InventoryPreloadIdDelete**](docs/InventoryPreloadAPI.md#v1inventorypreloadiddelete) | **DELETE** /v1/inventory-preload/{id} | Delete an Inventory Preload record 
*InventoryPreloadAPI* | [**v1InventoryPreloadIdGet**](docs/InventoryPreloadAPI.md#v1inventorypreloadidget) | **GET** /v1/inventory-preload/{id} | Get an Inventory Preload record 
*InventoryPreloadAPI* | [**v1InventoryPreloadIdPut**](docs/InventoryPreloadAPI.md#v1inventorypreloadidput) | **PUT** /v1/inventory-preload/{id} | Update an Inventory Preload record 
*InventoryPreloadAPI* | [**v1InventoryPreloadPost**](docs/InventoryPreloadAPI.md#v1inventorypreloadpost) | **POST** /v1/inventory-preload | Create a new Inventory Preload record using JSON or CSV 
*InventoryPreloadAPI* | [**v1InventoryPreloadValidateCsvPost**](docs/InventoryPreloadAPI.md#v1inventorypreloadvalidatecsvpost) | **POST** /v1/inventory-preload/validate-csv | Validate a given CSV file 
*InventoryPreloadAPI* | [**v2InventoryPreloadCsvGet**](docs/InventoryPreloadAPI.md#v2inventorypreloadcsvget) | **GET** /v2/inventory-preload/csv | Download all Inventory Preload records
*InventoryPreloadAPI* | [**v2InventoryPreloadCsvPost**](docs/InventoryPreloadAPI.md#v2inventorypreloadcsvpost) | **POST** /v2/inventory-preload/csv | Create one or more new Inventory Preload records using CSV 
*InventoryPreloadAPI* | [**v2InventoryPreloadCsvTemplateGet**](docs/InventoryPreloadAPI.md#v2inventorypreloadcsvtemplateget) | **GET** /v2/inventory-preload/csv-template | Download the Inventory Preload CSV template
*InventoryPreloadAPI* | [**v2InventoryPreloadCsvValidatePost**](docs/InventoryPreloadAPI.md#v2inventorypreloadcsvvalidatepost) | **POST** /v2/inventory-preload/csv-validate | Validate a given CSV file 
*InventoryPreloadAPI* | [**v2InventoryPreloadEaColumnsGet**](docs/InventoryPreloadAPI.md#v2inventorypreloadeacolumnsget) | **GET** /v2/inventory-preload/ea-columns | Retrieve a list of extension attribute columns 
*InventoryPreloadAPI* | [**v2InventoryPreloadExportPost**](docs/InventoryPreloadAPI.md#v2inventorypreloadexportpost) | **POST** /v2/inventory-preload/export | Export a collection of inventory preload records 
*InventoryPreloadAPI* | [**v2InventoryPreloadHistoryGet**](docs/InventoryPreloadAPI.md#v2inventorypreloadhistoryget) | **GET** /v2/inventory-preload/history | Get Inventory Preload history entries 
*InventoryPreloadAPI* | [**v2InventoryPreloadHistoryPost**](docs/InventoryPreloadAPI.md#v2inventorypreloadhistorypost) | **POST** /v2/inventory-preload/history | Add Inventory Preload history object notes
*InventoryPreloadAPI* | [**v2InventoryPreloadRecordsDeleteAllPost**](docs/InventoryPreloadAPI.md#v2inventorypreloadrecordsdeleteallpost) | **POST** /v2/inventory-preload/records/delete-all | Delete all Inventory Preload records 
*InventoryPreloadAPI* | [**v2InventoryPreloadRecordsGet**](docs/InventoryPreloadAPI.md#v2inventorypreloadrecordsget) | **GET** /v2/inventory-preload/records | Return all Inventory Preload records
*InventoryPreloadAPI* | [**v2InventoryPreloadRecordsIdDelete**](docs/InventoryPreloadAPI.md#v2inventorypreloadrecordsiddelete) | **DELETE** /v2/inventory-preload/records/{id} | Delete an Inventory Preload record 
*InventoryPreloadAPI* | [**v2InventoryPreloadRecordsIdGet**](docs/InventoryPreloadAPI.md#v2inventorypreloadrecordsidget) | **GET** /v2/inventory-preload/records/{id} | Get an Inventory Preload record
*InventoryPreloadAPI* | [**v2InventoryPreloadRecordsIdPut**](docs/InventoryPreloadAPI.md#v2inventorypreloadrecordsidput) | **PUT** /v2/inventory-preload/records/{id} | Update an Inventory Preload record
*InventoryPreloadAPI* | [**v2InventoryPreloadRecordsPost**](docs/InventoryPreloadAPI.md#v2inventorypreloadrecordspost) | **POST** /v2/inventory-preload/records | Create a new Inventory Preload record using JSON
*JamfConnectAPI* | [**v1JamfConnectConfigProfilesGet**](docs/JamfConnectAPI.md#v1jamfconnectconfigprofilesget) | **GET** /v1/jamf-connect/config-profiles | Search for config profiles linked to Jamf Connect 
*JamfConnectAPI* | [**v1JamfConnectConfigProfilesIdPut**](docs/JamfConnectAPI.md#v1jamfconnectconfigprofilesidput) | **PUT** /v1/jamf-connect/config-profiles/{id} | Update the way the Jamf Connect app gets updated on computers within scope of the associated configuration profile. 
*JamfConnectAPI* | [**v1JamfConnectDeploymentsIdTasksGet**](docs/JamfConnectAPI.md#v1jamfconnectdeploymentsidtasksget) | **GET** /v1/jamf-connect/deployments/{id}/tasks | Search for deployment tasks for a config profile linked to Jamf Connect 
*JamfConnectAPI* | [**v1JamfConnectDeploymentsIdTasksRetryPost**](docs/JamfConnectAPI.md#v1jamfconnectdeploymentsidtasksretrypost) | **POST** /v1/jamf-connect/deployments/{id}/tasks/retry | Request a retry of Connect install tasks 
*JamfConnectAPI* | [**v1JamfConnectGet**](docs/JamfConnectAPI.md#v1jamfconnectget) | **GET** /v1/jamf-connect | Get the Jamf Connect settings that you have access to see 
*JamfConnectAPI* | [**v1JamfConnectHistoryGet**](docs/JamfConnectAPI.md#v1jamfconnecthistoryget) | **GET** /v1/jamf-connect/history | Get Jamf Connect history 
*JamfConnectAPI* | [**v1JamfConnectHistoryPost**](docs/JamfConnectAPI.md#v1jamfconnecthistorypost) | **POST** /v1/jamf-connect/history | Add Jamf Connect history notes 
*JamfManagementFrameworkAPI* | [**v1JamfManagementFrameworkRedeployIdPost**](docs/JamfManagementFrameworkAPI.md#v1jamfmanagementframeworkredeployidpost) | **POST** /v1/jamf-management-framework/redeploy/{id} | Redeploy Jamf Management Framework 
*JamfPackageAPI* | [**v1JamfPackageGet**](docs/JamfPackageAPI.md#v1jamfpackageget) | **GET** /v1/jamf-package | Get the packages for a given Jamf application 
*JamfPackageAPI* | [**v2JamfPackageGet**](docs/JamfPackageAPI.md#v2jamfpackageget) | **GET** /v2/jamf-package | Get the packages for a given Jamf application 
*JamfProInformationAPI* | [**v1JamfProInformationGet**](docs/JamfProInformationAPI.md#v1jamfproinformationget) | **GET** /v1/jamf-pro-information | Get basic information about the Jamf Pro Server 
*JamfProInformationAPI* | [**v2JamfProInformationGet**](docs/JamfProInformationAPI.md#v2jamfproinformationget) | **GET** /v2/jamf-pro-information | Get basic information about the Jamf Pro Server 
*JamfProInitializationAPI* | [**v1SystemInitializeDatabaseConnectionPost**](docs/JamfProInitializationAPI.md#v1systeminitializedatabaseconnectionpost) | **POST** /v1/system/initialize-database-connection | Provide Database Password during startup 
*JamfProInitializationAPI* | [**v1SystemInitializePost**](docs/JamfProInitializationAPI.md#v1systeminitializepost) | **POST** /v1/system/initialize | Set up fresh installed Jamf Pro Server 
*JamfProInitializationPreviewAPI* | [**systemInitializeDatabaseConnectionPost**](docs/JamfProInitializationPreviewAPI.md#systeminitializedatabaseconnectionpost) | **POST** /system/initialize-database-connection | Provide Database Password during startup 
*JamfProInitializationPreviewAPI* | [**systemInitializePost**](docs/JamfProInitializationPreviewAPI.md#systeminitializepost) | **POST** /system/initialize | Set up fresh installed Jamf Pro Server 
*JamfProNotificationsAPI* | [**v1NotificationsGet**](docs/JamfProNotificationsAPI.md#v1notificationsget) | **GET** /v1/notifications | Get Notifications for user and site 
*JamfProNotificationsAPI* | [**v1NotificationsTypeIdDelete**](docs/JamfProNotificationsAPI.md#v1notificationstypeiddelete) | **DELETE** /v1/notifications/{type}/{id} | Delete Notifications 
*JamfProNotificationsPreviewAPI* | [**notificationsAlertsGet**](docs/JamfProNotificationsPreviewAPI.md#notificationsalertsget) | **GET** /notifications/alerts | Get Notifications for user and site 
*JamfProNotificationsPreviewAPI* | [**notificationsAlertsIdDelete**](docs/JamfProNotificationsPreviewAPI.md#notificationsalertsiddelete) | **DELETE** /notifications/alerts/{id} | DEPRECATED - USE \&quot;alerts/{type}/{id}\&quot; INSTEAD. Deletes only Patch Management notifications. 
*JamfProNotificationsPreviewAPI* | [**notificationsAlertsTypeIdDelete**](docs/JamfProNotificationsPreviewAPI.md#notificationsalertstypeiddelete) | **DELETE** /notifications/alerts/{type}/{id} | Delete Notifications 
*JamfProServerUrlPreviewAPI* | [**v1JamfProServerUrlGet**](docs/JamfProServerUrlPreviewAPI.md#v1jamfproserverurlget) | **GET** /v1/jamf-pro-server-url | Get Jamf Pro Server URL settings 
*JamfProServerUrlPreviewAPI* | [**v1JamfProServerUrlHistoryGet**](docs/JamfProServerUrlPreviewAPI.md#v1jamfproserverurlhistoryget) | **GET** /v1/jamf-pro-server-url/history | Get Jamf Pro Server URL settings history 
*JamfProServerUrlPreviewAPI* | [**v1JamfProServerUrlHistoryPost**](docs/JamfProServerUrlPreviewAPI.md#v1jamfproserverurlhistorypost) | **POST** /v1/jamf-pro-server-url/history | Add Jamf Pro Server URL settings history notes 
*JamfProServerUrlPreviewAPI* | [**v1JamfProServerUrlPut**](docs/JamfProServerUrlPreviewAPI.md#v1jamfproserverurlput) | **PUT** /v1/jamf-pro-server-url | Update Jamf Pro Server URL settings 
*JamfProUserAccountSettingsAPI* | [**v1UserPreferencesKeyIdDelete**](docs/JamfProUserAccountSettingsAPI.md#v1userpreferenceskeyiddelete) | **DELETE** /v1/user/preferences/{keyId} | Remove specified setting for authenticated user 
*JamfProUserAccountSettingsAPI* | [**v1UserPreferencesKeyIdGet**](docs/JamfProUserAccountSettingsAPI.md#v1userpreferenceskeyidget) | **GET** /v1/user/preferences/{keyId} | Get the user setting for the authenticated user and key 
*JamfProUserAccountSettingsAPI* | [**v1UserPreferencesKeyIdPut**](docs/JamfProUserAccountSettingsAPI.md#v1userpreferenceskeyidput) | **PUT** /v1/user/preferences/{keyId} | Persist the user setting 
*JamfProUserAccountSettingsAPI* | [**v1UserPreferencesSettingsKeyIdGet**](docs/JamfProUserAccountSettingsAPI.md#v1userpreferencessettingskeyidget) | **GET** /v1/user/preferences/settings/{keyId} | Get the user preferences for the authenticated user and key. 
*JamfProUserAccountSettingsPreviewAPI* | [**userObjPreferenceKeyDelete**](docs/JamfProUserAccountSettingsPreviewAPI.md#userobjpreferencekeydelete) | **DELETE** /user/obj/preference/{key} | Remove specified setting for authenticated user 
*JamfProUserAccountSettingsPreviewAPI* | [**userObjPreferenceKeyGet**](docs/JamfProUserAccountSettingsPreviewAPI.md#userobjpreferencekeyget) | **GET** /user/obj/preference/{key} | Get the user setting for the authenticated user and key 
*JamfProUserAccountSettingsPreviewAPI* | [**userObjPreferenceKeyPut**](docs/JamfProUserAccountSettingsPreviewAPI.md#userobjpreferencekeyput) | **PUT** /user/obj/preference/{key} | Persist the user setting 
*JamfProVersionAPI* | [**v1JamfProVersionGet**](docs/JamfProVersionAPI.md#v1jamfproversionget) | **GET** /v1/jamf-pro-version | Return information about the Jamf Pro including the current version 
*JamfProtectAPI* | [**v1JamfProtectDelete**](docs/JamfProtectAPI.md#v1jamfprotectdelete) | **DELETE** /v1/jamf-protect | Delete Jamf Protect API registration.
*JamfProtectAPI* | [**v1JamfProtectDeploymentsIdTasksGet**](docs/JamfProtectAPI.md#v1jamfprotectdeploymentsidtasksget) | **GET** /v1/jamf-protect/deployments/{id}/tasks | Search for deployment tasks for a config profile linked to Jamf Protect 
*JamfProtectAPI* | [**v1JamfProtectDeploymentsIdTasksRetryPost**](docs/JamfProtectAPI.md#v1jamfprotectdeploymentsidtasksretrypost) | **POST** /v1/jamf-protect/deployments/{id}/tasks/retry | Request a retry of Protect install tasks 
*JamfProtectAPI* | [**v1JamfProtectGet**](docs/JamfProtectAPI.md#v1jamfprotectget) | **GET** /v1/jamf-protect | Jamf Protect integration settings
*JamfProtectAPI* | [**v1JamfProtectHistoryGet**](docs/JamfProtectAPI.md#v1jamfprotecthistoryget) | **GET** /v1/jamf-protect/history | Get Jamf Protect history 
*JamfProtectAPI* | [**v1JamfProtectHistoryPost**](docs/JamfProtectAPI.md#v1jamfprotecthistorypost) | **POST** /v1/jamf-protect/history | Add Jamf Protect history notes 
*JamfProtectAPI* | [**v1JamfProtectPlansGet**](docs/JamfProtectAPI.md#v1jamfprotectplansget) | **GET** /v1/jamf-protect/plans | Get all of the previously synced Jamf Protect Plans with information about their associated configuration profile
*JamfProtectAPI* | [**v1JamfProtectPlansSyncPost**](docs/JamfProtectAPI.md#v1jamfprotectplanssyncpost) | **POST** /v1/jamf-protect/plans/sync | Sync Plans with Jamf Protect
*JamfProtectAPI* | [**v1JamfProtectPut**](docs/JamfProtectAPI.md#v1jamfprotectput) | **PUT** /v1/jamf-protect | Jamf Protect integration settings
*JamfProtectAPI* | [**v1JamfProtectRegisterPost**](docs/JamfProtectAPI.md#v1jamfprotectregisterpost) | **POST** /v1/jamf-protect/register | Register a Jamf Protect API configuration with Jamf Pro
*LdapAPI* | [**ldapGroupsGet**](docs/LdapAPI.md#ldapgroupsget) | **GET** /ldap/groups | Retrieve the configured access groups that contain the text in the search param 
*LdapAPI* | [**ldapServersGet**](docs/LdapAPI.md#ldapserversget) | **GET** /ldap/servers | Retrieve all Servers including LDAP and Cloud Identity Providers. 
*LdapAPI* | [**v1LdapGroupsGet**](docs/LdapAPI.md#v1ldapgroupsget) | **GET** /v1/ldap/groups | Retrieve the configured access groups that contain the text in the search param 
*LdapAPI* | [**v1LdapLdapServersGet**](docs/LdapAPI.md#v1ldapldapserversget) | **GET** /v1/ldap/ldap-servers | Retrieve all LDAP Servers. 
*LdapAPI* | [**v1LdapServersGet**](docs/LdapAPI.md#v1ldapserversget) | **GET** /v1/ldap/servers | Retrieve all Servers including LDAP and Cloud Identity Providers. 
*LocalAdminPasswordAPI* | [**v1LocalAdminPasswordClientManagementIdAccountUsernameAuditGet**](docs/LocalAdminPasswordAPI.md#v1localadminpasswordclientmanagementidaccountusernameauditget) | **GET** /v1/local-admin-password/{clientManagementId}/account/{username}/audit | Get LAPS password viewed history.
*LocalAdminPasswordAPI* | [**v1LocalAdminPasswordClientManagementIdAccountUsernamePasswordGet**](docs/LocalAdminPasswordAPI.md#v1localadminpasswordclientmanagementidaccountusernamepasswordget) | **GET** /v1/local-admin-password/{clientManagementId}/account/{username}/password | Get current LAPS password for specified username on a client.
*LocalAdminPasswordAPI* | [**v1LocalAdminPasswordClientManagementIdAccountsGet**](docs/LocalAdminPasswordAPI.md#v1localadminpasswordclientmanagementidaccountsget) | **GET** /v1/local-admin-password/{clientManagementId}/accounts | Get the LAPS capable admin accounts for a device.
*LocalAdminPasswordAPI* | [**v1LocalAdminPasswordClientManagementIdSetPasswordPut**](docs/LocalAdminPasswordAPI.md#v1localadminpasswordclientmanagementidsetpasswordput) | **PUT** /v1/local-admin-password/{clientManagementId}/set-password | Set the LAPS password for a device.
*LocalAdminPasswordAPI* | [**v1LocalAdminPasswordSettingsGet**](docs/LocalAdminPasswordAPI.md#v1localadminpasswordsettingsget) | **GET** /v1/local-admin-password/settings | Get the current LAPS settings.
*LocalAdminPasswordAPI* | [**v1LocalAdminPasswordSettingsPut**](docs/LocalAdminPasswordAPI.md#v1localadminpasswordsettingsput) | **PUT** /v1/local-admin-password/settings | Update settings for LAPS.
*LocalAdminPasswordAPI* | [**v2LocalAdminPasswordClientManagementIdAccountUsernameAuditGet**](docs/LocalAdminPasswordAPI.md#v2localadminpasswordclientmanagementidaccountusernameauditget) | **GET** /v2/local-admin-password/{clientManagementId}/account/{username}/audit | Get LAPS password viewed history.
*LocalAdminPasswordAPI* | [**v2LocalAdminPasswordClientManagementIdAccountUsernameHistoryGet**](docs/LocalAdminPasswordAPI.md#v2localadminpasswordclientmanagementidaccountusernamehistoryget) | **GET** /v2/local-admin-password/{clientManagementId}/account/{username}/history | Get LAPS historical records for target device and username.
*LocalAdminPasswordAPI* | [**v2LocalAdminPasswordClientManagementIdAccountUsernamePasswordGet**](docs/LocalAdminPasswordAPI.md#v2localadminpasswordclientmanagementidaccountusernamepasswordget) | **GET** /v2/local-admin-password/{clientManagementId}/account/{username}/password | Get current LAPS password for specified username on a client.
*LocalAdminPasswordAPI* | [**v2LocalAdminPasswordClientManagementIdAccountsGet**](docs/LocalAdminPasswordAPI.md#v2localadminpasswordclientmanagementidaccountsget) | **GET** /v2/local-admin-password/{clientManagementId}/accounts | Get the LAPS capable admin accounts for a device.
*LocalAdminPasswordAPI* | [**v2LocalAdminPasswordClientManagementIdSetPasswordPut**](docs/LocalAdminPasswordAPI.md#v2localadminpasswordclientmanagementidsetpasswordput) | **PUT** /v2/local-admin-password/{clientManagementId}/set-password | Set the LAPS password for a device.
*LocalAdminPasswordAPI* | [**v2LocalAdminPasswordPendingRotationsGet**](docs/LocalAdminPasswordAPI.md#v2localadminpasswordpendingrotationsget) | **GET** /v2/local-admin-password/pending-rotations | Get a list of the current devices and usernames with pending LAPS rotations
*LocalAdminPasswordAPI* | [**v2LocalAdminPasswordSettingsGet**](docs/LocalAdminPasswordAPI.md#v2localadminpasswordsettingsget) | **GET** /v2/local-admin-password/settings | Get the current LAPS settings.
*LocalAdminPasswordAPI* | [**v2LocalAdminPasswordSettingsPut**](docs/LocalAdminPasswordAPI.md#v2localadminpasswordsettingsput) | **PUT** /v2/local-admin-password/settings | Update settings for LAPS.
*LocalesPreviewAPI* | [**v1LocalesGet**](docs/LocalesPreviewAPI.md#v1localesget) | **GET** /v1/locales | Return locales that can be used in other features 
*MacosManagedSoftwareUpdatesAPI* | [**v1MacosManagedSoftwareUpdatesAvailableUpdatesGet**](docs/MacosManagedSoftwareUpdatesAPI.md#v1macosmanagedsoftwareupdatesavailableupdatesget) | **GET** /v1/macos-managed-software-updates/available-updates | Retrieve available MacOs Managed Software Updates
*MacosManagedSoftwareUpdatesAPI* | [**v1MacosManagedSoftwareUpdatesSendUpdatesPost**](docs/MacosManagedSoftwareUpdatesAPI.md#v1macosmanagedsoftwareupdatessendupdatespost) | **POST** /v1/macos-managed-software-updates/send-updates | Send MacOs Managed Software Updates
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesAvailableUpdatesGet**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesavailableupdatesget) | **GET** /v1/managed-software-updates/available-updates | Retrieve available macOS and iOS Managed Software Updates
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesPlansFeatureToggleGet**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesplansfeaturetoggleget) | **GET** /v1/managed-software-updates/plans/feature-toggle | Retrieve Status of the Feature Toggle
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesPlansFeatureTogglePut**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesplansfeaturetoggleput) | **PUT** /v1/managed-software-updates/plans/feature-toggle | Updates Feature Toggle Value
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesPlansGet**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesplansget) | **GET** /v1/managed-software-updates/plans | Retrieve Managed Software Update Plans
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesPlansGroupIdGet**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesplansgroupidget) | **GET** /v1/managed-software-updates/plans/group/{id} | Retrieve Managed Software Update Plans for a Group
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesPlansGroupPost**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesplansgrouppost) | **POST** /v1/managed-software-updates/plans/group | Create Managed Software Update Plans for a Group
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesPlansIdGet**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesplansidget) | **GET** /v1/managed-software-updates/plans/{id} | Retrieve a Managed Software Update Plan
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesPlansPost**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesplanspost) | **POST** /v1/managed-software-updates/plans | Create a Managed Software Update Plan
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesUpdateStatusesComputerGroupsIdGet**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesupdatestatusescomputergroupsidget) | **GET** /v1/managed-software-updates/update-statuses/computer-groups/{id} | Retrieve Managed Software Update Statuses for Computer Groups
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesUpdateStatusesComputersIdGet**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesupdatestatusescomputersidget) | **GET** /v1/managed-software-updates/update-statuses/computers/{id} | Retrieve Managed Software Update Statuses for Computers
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesUpdateStatusesGet**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesupdatestatusesget) | **GET** /v1/managed-software-updates/update-statuses | Retrieve Managed Software Update Statuses
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesUpdateStatusesMobileDeviceGroupsIdGet**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesupdatestatusesmobiledevicegroupsidget) | **GET** /v1/managed-software-updates/update-statuses/mobile-device-groups/{id} | Retrieve Managed Software Update Statuses for Mobile Device Groups
*ManagedSoftwareUpdatesAPI* | [**v1ManagedSoftwareUpdatesUpdateStatusesMobileDevicesIdGet**](docs/ManagedSoftwareUpdatesAPI.md#v1managedsoftwareupdatesupdatestatusesmobiledevicesidget) | **GET** /v1/managed-software-updates/update-statuses/mobile-devices/{id} | Retrieve Managed Software Update Statuses for Mobile Devices
*MdmAPI* | [**previewMdmCommandsPost**](docs/MdmAPI.md#previewmdmcommandspost) | **POST** /preview/mdm/commands | Post a command for creation and queuing 
*MdmAPI* | [**v1DeployPackagePost**](docs/MdmAPI.md#v1deploypackagepost) | **POST** /v1/deploy-package | Deploy packages using MDM
*MdmAPI* | [**v1MdmCommandsGet**](docs/MdmAPI.md#v1mdmcommandsget) | **GET** /v1/mdm/commands | Get information about mdm commands made by Jamf Pro.
*MdmAPI* | [**v1MdmRenewProfilePost**](docs/MdmAPI.md#v1mdmrenewprofilepost) | **POST** /v1/mdm/renew-profile | Renew MDM Profile 
*MdmAPI* | [**v2MdmCommandsGet**](docs/MdmAPI.md#v2mdmcommandsget) | **GET** /v2/mdm/commands | Get information about mdm commands made by Jamf Pro. 
*MobileDeviceAppsAPI* | [**v1MobileDeviceAppsReinstallAppConfigPost**](docs/MobileDeviceAppsAPI.md#v1mobiledeviceappsreinstallappconfigpost) | **POST** /v1/mobile-device-apps/reinstall-app-config | Reinstall App Config for Managed iOS Apps 
*MobileDeviceEnrollmentProfileAPI* | [**v1MobileDeviceEnrollmentProfileIdDownloadProfileGet**](docs/MobileDeviceEnrollmentProfileAPI.md#v1mobiledeviceenrollmentprofileiddownloadprofileget) | **GET** /v1/mobile-device-enrollment-profile/{id}/download-profile | Retrieve the MDM Enrollment Profile 
*MobileDeviceExtensionAttributesPreviewAPI* | [**devicesExtensionAttributesGet**](docs/MobileDeviceExtensionAttributesPreviewAPI.md#devicesextensionattributesget) | **GET** /devices/extensionAttributes | Get Mobile Device Extension Attribute values placed in select paramter 
*MobileDeviceGroupsAPI* | [**v1MobileDeviceGroupsGet**](docs/MobileDeviceGroupsAPI.md#v1mobiledevicegroupsget) | **GET** /v1/mobile-device-groups | Return the list of all Mobile Device Groups 
*MobileDeviceGroupsAPI* | [**v1MobileDeviceGroupsStaticGroupMembershipIdGet**](docs/MobileDeviceGroupsAPI.md#v1mobiledevicegroupsstaticgroupmembershipidget) | **GET** /v1/mobile-device-groups/static-group-membership/{id} | Get Static Group Membership by Id 
*MobileDeviceGroupsAPI* | [**v1MobileDeviceGroupsStaticGroupsGet**](docs/MobileDeviceGroupsAPI.md#v1mobiledevicegroupsstaticgroupsget) | **GET** /v1/mobile-device-groups/static-groups | Get Static Groups 
*MobileDeviceGroupsAPI* | [**v1MobileDeviceGroupsStaticGroupsIdDelete**](docs/MobileDeviceGroupsAPI.md#v1mobiledevicegroupsstaticgroupsiddelete) | **DELETE** /v1/mobile-device-groups/static-groups/{id} | Remove Static Group by Id 
*MobileDeviceGroupsAPI* | [**v1MobileDeviceGroupsStaticGroupsIdGet**](docs/MobileDeviceGroupsAPI.md#v1mobiledevicegroupsstaticgroupsidget) | **GET** /v1/mobile-device-groups/static-groups/{id} | Get Static Group by Id 
*MobileDeviceGroupsAPI* | [**v1MobileDeviceGroupsStaticGroupsIdPatch**](docs/MobileDeviceGroupsAPI.md#v1mobiledevicegroupsstaticgroupsidpatch) | **PATCH** /v1/mobile-device-groups/static-groups/{id} | Update membership of a static group. 
*MobileDeviceGroupsAPI* | [**v1MobileDeviceGroupsStaticGroupsPost**](docs/MobileDeviceGroupsAPI.md#v1mobiledevicegroupsstaticgroupspost) | **POST** /v1/mobile-device-groups/static-groups | Create membership of a static group. 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesGet**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesget) | **GET** /v1/mobile-device-prestages | Search for sorted and paged Mobile Device Prestages 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesIdAttachmentsDelete**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesidattachmentsdelete) | **DELETE** /v1/mobile-device-prestages/{id}/attachments | Remove an attachment for a Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesIdAttachmentsGet**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesidattachmentsget) | **GET** /v1/mobile-device-prestages/{id}/attachments | Get attachments for a Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesIdAttachmentsPost**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesidattachmentspost) | **POST** /v1/mobile-device-prestages/{id}/attachments | Add an attachment to a Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesIdDelete**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesiddelete) | **DELETE** /v1/mobile-device-prestages/{id} | Delete a Mobile Device Prestage with the supplied id 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesIdGet**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesidget) | **GET** /v1/mobile-device-prestages/{id} | Retrieve a Mobile Device Prestage with the supplied id 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesIdHistoryGet**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesidhistoryget) | **GET** /v1/mobile-device-prestages/{id}/history | Get sorted and paged Mobile Device Prestage history objects 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesIdHistoryPost**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesidhistorypost) | **POST** /v1/mobile-device-prestages/{id}/history | Add Mobile Device Prestage history object notes 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesIdPut**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesidput) | **PUT** /v1/mobile-device-prestages/{id} | Update a Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesIdScopeDelete**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesidscopedelete) | **DELETE** /v1/mobile-device-prestages/{id}/scope | Remove Device Scope for a specific Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesIdScopeGet**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesidscopeget) | **GET** /v1/mobile-device-prestages/{id}/scope | Get Device Scope for a specific Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesIdScopePost**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesidscopepost) | **POST** /v1/mobile-device-prestages/{id}/scope | Add Device Scope for a specific Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesIdScopePut**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesidscopeput) | **PUT** /v1/mobile-device-prestages/{id}/scope | Replace Device Scope for a specific Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesPost**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagespost) | **POST** /v1/mobile-device-prestages | Create a Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesScopeGet**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagesscopeget) | **GET** /v1/mobile-device-prestages/scope | Get all Device Scope for all Mobile Device Prestages 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesSyncGet**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagessyncget) | **GET** /v1/mobile-device-prestages/sync | Get all Prestage sync States for all prestages 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesSyncIdGet**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagessyncidget) | **GET** /v1/mobile-device-prestages/sync/{id} | Get all prestage sync states for a single prestage 
*MobileDevicePrestagesAPI* | [**v1MobileDevicePrestagesSyncIdLatestGet**](docs/MobileDevicePrestagesAPI.md#v1mobiledeviceprestagessyncidlatestget) | **GET** /v1/mobile-device-prestages/sync/{id}/latest | Get the latest Sync State for a single Prestage 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesGet**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesget) | **GET** /v2/mobile-device-prestages | Get sorted and paged Mobile Device Prestages 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdAttachmentsDeleteMultiplePost**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidattachmentsdeletemultiplepost) | **POST** /v2/mobile-device-prestages/{id}/attachments/delete-multiple | Remove an attachment for a Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdAttachmentsGet**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidattachmentsget) | **GET** /v2/mobile-device-prestages/{id}/attachments | Get attachments for a Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdAttachmentsPost**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidattachmentspost) | **POST** /v2/mobile-device-prestages/{id}/attachments | Add an attachment to a Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdDelete**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesiddelete) | **DELETE** /v2/mobile-device-prestages/{id} | Delete a Mobile Device Prestage with the supplied id 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdGet**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidget) | **GET** /v2/mobile-device-prestages/{id} | Retrieve a Mobile Device Prestage with the supplied id 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdHistoryGet**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidhistoryget) | **GET** /v2/mobile-device-prestages/{id}/history | Get sorted and paged Mobile Device Prestage history objects 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdHistoryPost**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidhistorypost) | **POST** /v2/mobile-device-prestages/{id}/history | Add Mobile Device Prestage history object notes 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdPut**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidput) | **PUT** /v2/mobile-device-prestages/{id} | Update a Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdScopeDeleteMultiplePost**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidscopedeletemultiplepost) | **POST** /v2/mobile-device-prestages/{id}/scope/delete-multiple | Remove Device Scope for a specific Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdScopeGet**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidscopeget) | **GET** /v2/mobile-device-prestages/{id}/scope | Get Device Scope for a specific Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdScopePost**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidscopepost) | **POST** /v2/mobile-device-prestages/{id}/scope | Add Device Scope for a specific Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdScopePut**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidscopeput) | **PUT** /v2/mobile-device-prestages/{id}/scope | Replace Device Scope for a specific Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdSyncsGet**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidsyncsget) | **GET** /v2/mobile-device-prestages/{id}/syncs | Get all prestage sync states for a single prestage 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesIdSyncsLatestGet**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesidsyncslatestget) | **GET** /v2/mobile-device-prestages/{id}/syncs/latest | Get the latest Sync State for a single Prestage 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesPost**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagespost) | **POST** /v2/mobile-device-prestages | Create a Mobile Device Prestage 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesScopeGet**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagesscopeget) | **GET** /v2/mobile-device-prestages/scope | Get all Device Scope for all Mobile Device Prestages 
*MobileDevicePrestagesAPI* | [**v2MobileDevicePrestagesSyncsGet**](docs/MobileDevicePrestagesAPI.md#v2mobiledeviceprestagessyncsget) | **GET** /v2/mobile-device-prestages/syncs | Get all Prestage sync States for all prestages 
*MobileDevicesAPI* | [**v1MobileDevicesGet**](docs/MobileDevicesAPI.md#v1mobiledevicesget) | **GET** /v1/mobile-devices | Get Mobile Device objects 
*MobileDevicesAPI* | [**v1MobileDevicesIdDetailGet**](docs/MobileDevicesAPI.md#v1mobiledevicesiddetailget) | **GET** /v1/mobile-devices/{id}/detail | Get Mobile Device 
*MobileDevicesAPI* | [**v1MobileDevicesIdGet**](docs/MobileDevicesAPI.md#v1mobiledevicesidget) | **GET** /v1/mobile-devices/{id} | Get Mobile Device 
*MobileDevicesAPI* | [**v1MobileDevicesIdPatch**](docs/MobileDevicesAPI.md#v1mobiledevicesidpatch) | **PATCH** /v1/mobile-devices/{id} | Update fields on a mobile device that are allowed to be modified by users 
*MobileDevicesAPI* | [**v1SearchMobileDevicesPost**](docs/MobileDevicesAPI.md#v1searchmobiledevicespost) | **POST** /v1/search-mobile-devices | Search Mobile Devices 
*MobileDevicesAPI* | [**v2MobileDevicesDetailGet**](docs/MobileDevicesAPI.md#v2mobiledevicesdetailget) | **GET** /v2/mobile-devices/detail | Return paginated Mobile Device Inventory records
*MobileDevicesAPI* | [**v2MobileDevicesGet**](docs/MobileDevicesAPI.md#v2mobiledevicesget) | **GET** /v2/mobile-devices | Get Mobile Device objects 
*MobileDevicesAPI* | [**v2MobileDevicesIdDetailGet**](docs/MobileDevicesAPI.md#v2mobiledevicesiddetailget) | **GET** /v2/mobile-devices/{id}/detail | Get Mobile Device 
*MobileDevicesAPI* | [**v2MobileDevicesIdGet**](docs/MobileDevicesAPI.md#v2mobiledevicesidget) | **GET** /v2/mobile-devices/{id} | Get Mobile Device 
*MobileDevicesAPI* | [**v2MobileDevicesIdPatch**](docs/MobileDevicesAPI.md#v2mobiledevicesidpatch) | **PATCH** /v2/mobile-devices/{id} | Update fields on a mobile device that are allowed to be modified by users 
*ParentAppPreviewAPI* | [**v1ParentAppGet**](docs/ParentAppPreviewAPI.md#v1parentappget) | **GET** /v1/parent-app | Get the current Jamf Parent app settings 
*ParentAppPreviewAPI* | [**v1ParentAppHistoryGet**](docs/ParentAppPreviewAPI.md#v1parentapphistoryget) | **GET** /v1/parent-app/history | Get Jamf Parent app settings history 
*ParentAppPreviewAPI* | [**v1ParentAppHistoryPost**](docs/ParentAppPreviewAPI.md#v1parentapphistorypost) | **POST** /v1/parent-app/history | Add Jamf Parent app settings history notes 
*ParentAppPreviewAPI* | [**v1ParentAppPut**](docs/ParentAppPreviewAPI.md#v1parentappput) | **PUT** /v1/parent-app | Update Jamf Parent app settings 
*PatchManagementAPI* | [**v2PatchManagementAcceptDisclaimerPost**](docs/PatchManagementAPI.md#v2patchmanagementacceptdisclaimerpost) | **POST** /v2/patch-management-accept-disclaimer | Accept Patch Management disclaimer 
*PatchPoliciesAPI* | [**v2PatchPoliciesGet**](docs/PatchPoliciesAPI.md#v2patchpoliciesget) | **GET** /v2/patch-policies | Retrieve Patch Policies
*PatchPoliciesAPI* | [**v2PatchPoliciesIdDashboardDelete**](docs/PatchPoliciesAPI.md#v2patchpoliciesiddashboarddelete) | **DELETE** /v2/patch-policies/{id}/dashboard | Remove a patch policy from the dashboard 
*PatchPoliciesAPI* | [**v2PatchPoliciesIdDashboardGet**](docs/PatchPoliciesAPI.md#v2patchpoliciesiddashboardget) | **GET** /v2/patch-policies/{id}/dashboard | Return whether or not the requested patch policy is on the dashboard 
*PatchPoliciesAPI* | [**v2PatchPoliciesIdDashboardPost**](docs/PatchPoliciesAPI.md#v2patchpoliciesiddashboardpost) | **POST** /v2/patch-policies/{id}/dashboard | Add a patch policy to the dashboard 
*PatchPoliciesAPI* | [**v2PatchPoliciesPolicyDetailsGet**](docs/PatchPoliciesAPI.md#v2patchpoliciespolicydetailsget) | **GET** /v2/patch-policies/policy-details | Retrieve Patch Policies
*PatchPolicyLogsAPI* | [**v2PatchPoliciesIdLogsDeviceIdDetailsGet**](docs/PatchPolicyLogsAPI.md#v2patchpoliciesidlogsdeviceiddetailsget) | **GET** /v2/patch-policies/{id}/logs/{deviceId}/details | Return attempt details for a specific log
*PatchPolicyLogsAPI* | [**v2PatchPoliciesIdLogsDeviceIdGet**](docs/PatchPolicyLogsAPI.md#v2patchpoliciesidlogsdeviceidget) | **GET** /v2/patch-policies/{id}/logs/{deviceId} | Retrieves a single Patch Policy Log 
*PatchPolicyLogsAPI* | [**v2PatchPoliciesIdLogsEligibleRetryCountGet**](docs/PatchPolicyLogsAPI.md#v2patchpoliciesidlogseligibleretrycountget) | **GET** /v2/patch-policies/{id}/logs/eligible-retry-count | Return the count of the Patch Policy Logs for the patch policy id that are eligible for a retry attempt 
*PatchPolicyLogsAPI* | [**v2PatchPoliciesIdLogsGet**](docs/PatchPolicyLogsAPI.md#v2patchpoliciesidlogsget) | **GET** /v2/patch-policies/{id}/logs | Retrieve Patch Policy Logs 
*PatchPolicyLogsAPI* | [**v2PatchPoliciesIdLogsRetryAllPost**](docs/PatchPolicyLogsAPI.md#v2patchpoliciesidlogsretryallpost) | **POST** /v2/patch-policies/{id}/logs/retry-all | Send retry attempts for all devices
*PatchPolicyLogsAPI* | [**v2PatchPoliciesIdLogsRetryPost**](docs/PatchPolicyLogsAPI.md#v2patchpoliciesidlogsretrypost) | **POST** /v2/patch-policies/{id}/logs/retry | Send retry attempts for specific devices
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsGet**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsget) | **GET** /v2/patch-software-title-configurations | Retrieve Patch Software Title Configurations
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdDashboardDelete**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsiddashboarddelete) | **DELETE** /v2/patch-software-title-configurations/{id}/dashboard | Remove a software title configuration from the dashboard 
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdDashboardGet**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsiddashboardget) | **GET** /v2/patch-software-title-configurations/{id}/dashboard | Return whether or not the requested software title configuration is on the dashboard 
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdDashboardPost**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsiddashboardpost) | **POST** /v2/patch-software-title-configurations/{id}/dashboard | Add a software title configuration to the dashboard 
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdDefinitionsGet**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsiddefinitionsget) | **GET** /v2/patch-software-title-configurations/{id}/definitions | Retrieve Patch Software Title Definitions with the supplied id
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdDelete**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsiddelete) | **DELETE** /v2/patch-software-title-configurations/{id} | Delete Patch Software Title Configurations with the supplied id
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdDependenciesGet**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsiddependenciesget) | **GET** /v2/patch-software-title-configurations/{id}/dependencies | Retrieve list of Patch Software Title Configuration Dependencies
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdExportReportGet**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsidexportreportget) | **GET** /v2/patch-software-title-configurations/{id}/export-report | Export Patch Reporting Data
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdExtensionAttributesGet**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsidextensionattributesget) | **GET** /v2/patch-software-title-configurations/{id}/extension-attributes | Retrieve Software Title Extension Attributes with the supplied id
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdGet**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsidget) | **GET** /v2/patch-software-title-configurations/{id} | Retrieve Patch Software Title Configurations with the supplied id
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdHistoryGet**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsidhistoryget) | **GET** /v2/patch-software-title-configurations/{id}/history | Get specified Patch Software Title Configuration history object 
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdHistoryPost**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsidhistorypost) | **POST** /v2/patch-software-title-configurations/{id}/history | Add Patch Software Title Configuration history object notes 
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdPatch**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsidpatch) | **PATCH** /v2/patch-software-title-configurations/{id} | Update Patch Software Title Configurations
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdPatchReportGet**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsidpatchreportget) | **GET** /v2/patch-software-title-configurations/{id}/patch-report | Retrieve Patch Software Title Configuration Patch Report
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdPatchSummaryGet**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsidpatchsummaryget) | **GET** /v2/patch-software-title-configurations/{id}/patch-summary | Return Active Patch Summary
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsIdPatchSummaryVersionsGet**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationsidpatchsummaryversionsget) | **GET** /v2/patch-software-title-configurations/{id}/patch-summary/versions | Returns patch versions
*PatchSoftwareTitleConfigurationsAPI* | [**v2PatchSoftwareTitleConfigurationsPost**](docs/PatchSoftwareTitleConfigurationsAPI.md#v2patchsoftwaretitleconfigurationspost) | **POST** /v2/patch-software-title-configurations | Create Patch Software Title Configurations
*PoliciesPreviewAPI* | [**settingsObjPolicyPropertiesGet**](docs/PoliciesPreviewAPI.md#settingsobjpolicypropertiesget) | **GET** /settings/obj/policyProperties | Get Policy Properties object 
*PoliciesPreviewAPI* | [**settingsObjPolicyPropertiesPut**](docs/PoliciesPreviewAPI.md#settingsobjpolicypropertiesput) | **PUT** /settings/obj/policyProperties | Update Policy Properties object 
*PoliciesPreviewAPI* | [**v1PolicyPropertiesGet**](docs/PoliciesPreviewAPI.md#v1policypropertiesget) | **GET** /v1/policy-properties | Get Policy Properties object 
*PoliciesPreviewAPI* | [**v1PolicyPropertiesPut**](docs/PoliciesPreviewAPI.md#v1policypropertiesput) | **PUT** /v1/policy-properties | Update Policy Properties object 
*ReEnrollmentPreviewAPI* | [**v1ReenrollmentGet**](docs/ReEnrollmentPreviewAPI.md#v1reenrollmentget) | **GET** /v1/reenrollment | Get Re-enrollment object 
*ReEnrollmentPreviewAPI* | [**v1ReenrollmentHistoryExportPost**](docs/ReEnrollmentPreviewAPI.md#v1reenrollmenthistoryexportpost) | **POST** /v1/reenrollment/history/export | Export reenrollment history collection 
*ReEnrollmentPreviewAPI* | [**v1ReenrollmentHistoryGet**](docs/ReEnrollmentPreviewAPI.md#v1reenrollmenthistoryget) | **GET** /v1/reenrollment/history | Get Re-enrollment history object 
*ReEnrollmentPreviewAPI* | [**v1ReenrollmentHistoryPost**](docs/ReEnrollmentPreviewAPI.md#v1reenrollmenthistorypost) | **POST** /v1/reenrollment/history | Add specified Re-enrollment history object notes 
*ReEnrollmentPreviewAPI* | [**v1ReenrollmentPut**](docs/ReEnrollmentPreviewAPI.md#v1reenrollmentput) | **PUT** /v1/reenrollment | Update the Re-enrollment object 
*RemoteAdministrationAPI* | [**previewRemoteAdministrationConfigurationsGet**](docs/RemoteAdministrationAPI.md#previewremoteadministrationconfigurationsget) | **GET** /preview/remote-administration-configurations | Get information about all remote administration configurations.
*ScriptsAPI* | [**v1ScriptsGet**](docs/ScriptsAPI.md#v1scriptsget) | **GET** /v1/scripts | Search for sorted and paged Scripts 
*ScriptsAPI* | [**v1ScriptsIdDelete**](docs/ScriptsAPI.md#v1scriptsiddelete) | **DELETE** /v1/scripts/{id} | Delete a Script at the specified id 
*ScriptsAPI* | [**v1ScriptsIdDownloadGet**](docs/ScriptsAPI.md#v1scriptsiddownloadget) | **GET** /v1/scripts/{id}/download | Download a text file of the Script contents 
*ScriptsAPI* | [**v1ScriptsIdGet**](docs/ScriptsAPI.md#v1scriptsidget) | **GET** /v1/scripts/{id} | Retrieve a full script object 
*ScriptsAPI* | [**v1ScriptsIdHistoryGet**](docs/ScriptsAPI.md#v1scriptsidhistoryget) | **GET** /v1/scripts/{id}/history | Get specified Script history object 
*ScriptsAPI* | [**v1ScriptsIdHistoryPost**](docs/ScriptsAPI.md#v1scriptsidhistorypost) | **POST** /v1/scripts/{id}/history | Add specified Script history object notes 
*ScriptsAPI* | [**v1ScriptsIdPut**](docs/ScriptsAPI.md#v1scriptsidput) | **PUT** /v1/scripts/{id} | Replace the script at the id with the supplied information 
*ScriptsAPI* | [**v1ScriptsPost**](docs/ScriptsAPI.md#v1scriptspost) | **POST** /v1/scripts | Create a Script 
*SelfServiceAPI* | [**v1SelfServiceSettingsGet**](docs/SelfServiceAPI.md#v1selfservicesettingsget) | **GET** /v1/self-service/settings | Get an object representation of Self Service settings 
*SelfServiceAPI* | [**v1SelfServiceSettingsPut**](docs/SelfServiceAPI.md#v1selfservicesettingsput) | **PUT** /v1/self-service/settings | Put an object representation of Self Service settings 
*SelfServiceBrandingIosAPI* | [**v1SelfServiceBrandingIosGet**](docs/SelfServiceBrandingIosAPI.md#v1selfservicebrandingiosget) | **GET** /v1/self-service/branding/ios | Search for sorted and paged iOS branding configurations 
*SelfServiceBrandingIosAPI* | [**v1SelfServiceBrandingIosIdDelete**](docs/SelfServiceBrandingIosAPI.md#v1selfservicebrandingiosiddelete) | **DELETE** /v1/self-service/branding/ios/{id} | Delete the Self Service iOS branding configuration indicated by the provided id 
*SelfServiceBrandingIosAPI* | [**v1SelfServiceBrandingIosIdGet**](docs/SelfServiceBrandingIosAPI.md#v1selfservicebrandingiosidget) | **GET** /v1/self-service/branding/ios/{id} | Read a single Self Service iOS branding configuration indicated by the provided id 
*SelfServiceBrandingIosAPI* | [**v1SelfServiceBrandingIosIdPut**](docs/SelfServiceBrandingIosAPI.md#v1selfservicebrandingiosidput) | **PUT** /v1/self-service/branding/ios/{id} | Update a Self Service iOS branding configuration with the supplied details 
*SelfServiceBrandingIosAPI* | [**v1SelfServiceBrandingIosPost**](docs/SelfServiceBrandingIosAPI.md#v1selfservicebrandingiospost) | **POST** /v1/self-service/branding/ios | Create a Self Service iOS branding configuration with the supplied 
*SelfServiceBrandingMacosAPI* | [**v1SelfServiceBrandingMacosGet**](docs/SelfServiceBrandingMacosAPI.md#v1selfservicebrandingmacosget) | **GET** /v1/self-service/branding/macos | Search for sorted and paged macOS branding configurations 
*SelfServiceBrandingMacosAPI* | [**v1SelfServiceBrandingMacosIdDelete**](docs/SelfServiceBrandingMacosAPI.md#v1selfservicebrandingmacosiddelete) | **DELETE** /v1/self-service/branding/macos/{id} | Delete the Self Service macOS branding configuration indicated by the provided id 
*SelfServiceBrandingMacosAPI* | [**v1SelfServiceBrandingMacosIdGet**](docs/SelfServiceBrandingMacosAPI.md#v1selfservicebrandingmacosidget) | **GET** /v1/self-service/branding/macos/{id} | Read a single Self Service macOS branding configuration indicated by the provided id 
*SelfServiceBrandingMacosAPI* | [**v1SelfServiceBrandingMacosIdPut**](docs/SelfServiceBrandingMacosAPI.md#v1selfservicebrandingmacosidput) | **PUT** /v1/self-service/branding/macos/{id} | Update a Self Service macOS branding configuration with the supplied details 
*SelfServiceBrandingMacosAPI* | [**v1SelfServiceBrandingMacosPost**](docs/SelfServiceBrandingMacosAPI.md#v1selfservicebrandingmacospost) | **POST** /v1/self-service/branding/macos | Create a Self Service macOS branding configuration with the supplied 
*SelfServiceBrandingPreviewAPI* | [**selfServiceBrandingImagesPost**](docs/SelfServiceBrandingPreviewAPI.md#selfservicebrandingimagespost) | **POST** /self-service/branding/images | Upload an image 
*SitesAPI* | [**v1SitesGet**](docs/SitesAPI.md#v1sitesget) | **GET** /v1/sites | Find all sites 
*SitesPreviewAPI* | [**settingsSitesGet**](docs/SitesPreviewAPI.md#settingssitesget) | **GET** /settings/sites | Find all sites 
*SmartComputerGroupsPreviewAPI* | [**v1ComputersIdRecalculateSmartGroupsPost**](docs/SmartComputerGroupsPreviewAPI.md#v1computersidrecalculatesmartgroupspost) | **POST** /v1/computers/{id}/recalculate-smart-groups | Recalculate a smart group for the given id 
*SmartComputerGroupsPreviewAPI* | [**v1SmartComputerGroupsIdRecalculatePost**](docs/SmartComputerGroupsPreviewAPI.md#v1smartcomputergroupsidrecalculatepost) | **POST** /v1/smart-computer-groups/{id}/recalculate | Recalculate the smart group for the given id 
*SmartMobileDeviceGroupsPreviewAPI* | [**v1MobileDevicesIdRecalculateSmartGroupsPost**](docs/SmartMobileDeviceGroupsPreviewAPI.md#v1mobiledevicesidrecalculatesmartgroupspost) | **POST** /v1/mobile-devices/{id}/recalculate-smart-groups | Recalculate all smart groups for the given device id and then return count of smart groups that device fall into 
*SmartMobileDeviceGroupsPreviewAPI* | [**v1SmartMobileDeviceGroupsIdRecalculatePost**](docs/SmartMobileDeviceGroupsPreviewAPI.md#v1smartmobiledevicegroupsidrecalculatepost) | **POST** /v1/smart-mobile-device-groups/{id}/recalculate | Recalculate a smart group for the given id then return the ids for the devices in the smart group 
*SmartUserGroupsPreviewAPI* | [**v1SmartUserGroupsIdRecalculatePost**](docs/SmartUserGroupsPreviewAPI.md#v1smartusergroupsidrecalculatepost) | **POST** /v1/smart-user-groups/{id}/recalculate | Recalculate the smart group for the given id and then return the ids for the users in the smart group 
*SmartUserGroupsPreviewAPI* | [**v1UsersIdRecalculateSmartGroupsPost**](docs/SmartUserGroupsPreviewAPI.md#v1usersidrecalculatesmartgroupspost) | **POST** /v1/users/{id}/recalculate-smart-groups | Recalculate a smart group for the given user id and then return the count of smart groups the user falls into 
*SsoCertificateAPI* | [**v2SsoCertDelete**](docs/SsoCertificateAPI.md#v2ssocertdelete) | **DELETE** /v2/sso/cert | Delete the currently configured certificate used by SSO 
*SsoCertificateAPI* | [**v2SsoCertDownloadGet**](docs/SsoCertificateAPI.md#v2ssocertdownloadget) | **GET** /v2/sso/cert/download | Download the certificate currently configured for use with Jamf Pro&#39;s SSO configuration 
*SsoCertificateAPI* | [**v2SsoCertGet**](docs/SsoCertificateAPI.md#v2ssocertget) | **GET** /v2/sso/cert | Retrieve the certificate currently configured for use with SSO 
*SsoCertificateAPI* | [**v2SsoCertParsePost**](docs/SsoCertificateAPI.md#v2ssocertparsepost) | **POST** /v2/sso/cert/parse | Parse the certificate to get details about certificate type and keys needed to upload certificate file 
*SsoCertificateAPI* | [**v2SsoCertPost**](docs/SsoCertificateAPI.md#v2ssocertpost) | **POST** /v2/sso/cert | Jamf Pro will generate a new certificate and use it to sign SSO 
*SsoCertificateAPI* | [**v2SsoCertPut**](docs/SsoCertificateAPI.md#v2ssocertput) | **PUT** /v2/sso/cert | Update the certificate used by Jamf Pro to sign SSO requests to the identify provider 
*SsoCertificatePreviewAPI* | [**v1SsoCertDelete**](docs/SsoCertificatePreviewAPI.md#v1ssocertdelete) | **DELETE** /v1/sso/cert | Delete the currently configured certificate used by SSO 
*SsoCertificatePreviewAPI* | [**v1SsoCertDownloadGet**](docs/SsoCertificatePreviewAPI.md#v1ssocertdownloadget) | **GET** /v1/sso/cert/download | Download the certificate currently configured for use with Jamf Pro&#39;s SSO configuration 
*SsoCertificatePreviewAPI* | [**v1SsoCertGet**](docs/SsoCertificatePreviewAPI.md#v1ssocertget) | **GET** /v1/sso/cert | Retrieve the certificate currently configured for use with SSO 
*SsoCertificatePreviewAPI* | [**v1SsoCertParsePost**](docs/SsoCertificatePreviewAPI.md#v1ssocertparsepost) | **POST** /v1/sso/cert/parse | Parse the certificate to get details about certificate type and keys needed to upload certificate file 
*SsoCertificatePreviewAPI* | [**v1SsoCertPost**](docs/SsoCertificatePreviewAPI.md#v1ssocertpost) | **POST** /v1/sso/cert | Jamf Pro will generate a new certificate and use it to sign SSO 
*SsoCertificatePreviewAPI* | [**v1SsoCertPut**](docs/SsoCertificatePreviewAPI.md#v1ssocertput) | **PUT** /v1/sso/cert | Update the certificate used by Jamf Pro to sign SSO requests to the identify provider 
*SsoFailoverAPI* | [**v1SsoFailoverGeneratePost**](docs/SsoFailoverAPI.md#v1ssofailovergeneratepost) | **POST** /v1/sso/failover/generate | Regenerates failover url
*SsoFailoverAPI* | [**v1SsoFailoverGet**](docs/SsoFailoverAPI.md#v1ssofailoverget) | **GET** /v1/sso/failover | Retrieve the current failover settings
*SsoSettingsAPI* | [**v1SsoDependenciesGet**](docs/SsoSettingsAPI.md#v1ssodependenciesget) | **GET** /v1/sso/dependencies | Retrieve the list of Enrollment Customizations using SSO 
*SsoSettingsAPI* | [**v1SsoDisablePost**](docs/SsoSettingsAPI.md#v1ssodisablepost) | **POST** /v1/sso/disable | Disable SSO 
*SsoSettingsAPI* | [**v1SsoGet**](docs/SsoSettingsAPI.md#v1ssoget) | **GET** /v1/sso | Retrieve the current Single Sign On configuration settings 
*SsoSettingsAPI* | [**v1SsoHistoryGet**](docs/SsoSettingsAPI.md#v1ssohistoryget) | **GET** /v1/sso/history | Get SSO history object 
*SsoSettingsAPI* | [**v1SsoHistoryPost**](docs/SsoSettingsAPI.md#v1ssohistorypost) | **POST** /v1/sso/history | Add SSO history object notes 
*SsoSettingsAPI* | [**v1SsoMetadataDownloadGet**](docs/SsoSettingsAPI.md#v1ssometadatadownloadget) | **GET** /v1/sso/metadata/download | Download the Jamf Pro SAML metadata file 
*SsoSettingsAPI* | [**v1SsoPut**](docs/SsoSettingsAPI.md#v1ssoput) | **PUT** /v1/sso | Updates the current Single Sign On configuration settings 
*SsoSettingsAPI* | [**v1SsoValidatePost**](docs/SsoSettingsAPI.md#v1ssovalidatepost) | **POST** /v1/sso/validate | Endpoint for validation of a saml metadata url 
*StartupStatusAPI* | [**startupStatusGet**](docs/StartupStatusAPI.md#startupstatusget) | **GET** /startup-status | Retrieve information about application startup 
*StaticUserGroupsPreviewAPI* | [**v1StaticUserGroupsGet**](docs/StaticUserGroupsPreviewAPI.md#v1staticusergroupsget) | **GET** /v1/static-user-groups | Return a list of all Static User Groups 
*StaticUserGroupsPreviewAPI* | [**v1StaticUserGroupsIdGet**](docs/StaticUserGroupsPreviewAPI.md#v1staticusergroupsidget) | **GET** /v1/static-user-groups/{id} | Return a specific Static User Group by id 
*SupervisionIdentitiesPreviewAPI* | [**v1SupervisionIdentitiesGet**](docs/SupervisionIdentitiesPreviewAPI.md#v1supervisionidentitiesget) | **GET** /v1/supervision-identities | Search for sorted and paged Supervision Identities 
*SupervisionIdentitiesPreviewAPI* | [**v1SupervisionIdentitiesIdDelete**](docs/SupervisionIdentitiesPreviewAPI.md#v1supervisionidentitiesiddelete) | **DELETE** /v1/supervision-identities/{id} | Delete a Supervision Identity with the supplied id 
*SupervisionIdentitiesPreviewAPI* | [**v1SupervisionIdentitiesIdDownloadGet**](docs/SupervisionIdentitiesPreviewAPI.md#v1supervisionidentitiesiddownloadget) | **GET** /v1/supervision-identities/{id}/download | Download the Supervision Identity .p12 file 
*SupervisionIdentitiesPreviewAPI* | [**v1SupervisionIdentitiesIdGet**](docs/SupervisionIdentitiesPreviewAPI.md#v1supervisionidentitiesidget) | **GET** /v1/supervision-identities/{id} | Retrieve a Supervision Identity with the supplied id 
*SupervisionIdentitiesPreviewAPI* | [**v1SupervisionIdentitiesIdPut**](docs/SupervisionIdentitiesPreviewAPI.md#v1supervisionidentitiesidput) | **PUT** /v1/supervision-identities/{id} | Update a Supervision Identity with the supplied information 
*SupervisionIdentitiesPreviewAPI* | [**v1SupervisionIdentitiesPost**](docs/SupervisionIdentitiesPreviewAPI.md#v1supervisionidentitiespost) | **POST** /v1/supervision-identities | Create a Supervision Identity for the supplied information 
*SupervisionIdentitiesPreviewAPI* | [**v1SupervisionIdentitiesUploadPost**](docs/SupervisionIdentitiesPreviewAPI.md#v1supervisionidentitiesuploadpost) | **POST** /v1/supervision-identities/upload | Upload the Supervision Identity .p12 file 
*TeacherAppAPI* | [**v1TeacherAppGet**](docs/TeacherAppAPI.md#v1teacherappget) | **GET** /v1/teacher-app | Get the Jamf Teacher settings that you have access to see 
*TeacherAppAPI* | [**v1TeacherAppHistoryGet**](docs/TeacherAppAPI.md#v1teacherapphistoryget) | **GET** /v1/teacher-app/history | Get Jamf Teacher app settings history 
*TeacherAppAPI* | [**v1TeacherAppHistoryPost**](docs/TeacherAppAPI.md#v1teacherapphistorypost) | **POST** /v1/teacher-app/history | Add Jamf Teacher app settings history notes 
*TeacherAppAPI* | [**v1TeacherAppPut**](docs/TeacherAppAPI.md#v1teacherappput) | **PUT** /v1/teacher-app | Update a Jamf Teacher settings object 
*TeamViewerRemoteAdministrationAPI* | [**previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsGet**](docs/TeamViewerRemoteAdministrationAPI.md#previewremoteadministrationconfigurationsteamviewerconfigurationidsessionsget) | **GET** /preview/remote-administration-configurations/team-viewer/{configurationId}/sessions | Get a paginated list of sessions 
*TeamViewerRemoteAdministrationAPI* | [**previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsPost**](docs/TeamViewerRemoteAdministrationAPI.md#previewremoteadministrationconfigurationsteamviewerconfigurationidsessionspost) | **POST** /preview/remote-administration-configurations/team-viewer/{configurationId}/sessions | Create a new session
*TeamViewerRemoteAdministrationAPI* | [**previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdClosePost**](docs/TeamViewerRemoteAdministrationAPI.md#previewremoteadministrationconfigurationsteamviewerconfigurationidsessionssessionidclosepost) | **POST** /preview/remote-administration-configurations/team-viewer/{configurationId}/sessions/{sessionId}/close | Close a session
*TeamViewerRemoteAdministrationAPI* | [**previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdGet**](docs/TeamViewerRemoteAdministrationAPI.md#previewremoteadministrationconfigurationsteamviewerconfigurationidsessionssessionidget) | **GET** /preview/remote-administration-configurations/team-viewer/{configurationId}/sessions/{sessionId} | Get a session by its ID 
*TeamViewerRemoteAdministrationAPI* | [**previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdResendNotificationPost**](docs/TeamViewerRemoteAdministrationAPI.md#previewremoteadministrationconfigurationsteamviewerconfigurationidsessionssessionidresendnotificationpost) | **POST** /preview/remote-administration-configurations/team-viewer/{configurationId}/sessions/{sessionId}/resend-notification | Resend nofications for a session
*TeamViewerRemoteAdministrationAPI* | [**previewRemoteAdministrationConfigurationsTeamViewerConfigurationIdSessionsSessionIdStatusGet**](docs/TeamViewerRemoteAdministrationAPI.md#previewremoteadministrationconfigurationsteamviewerconfigurationidsessionssessionidstatusget) | **GET** /preview/remote-administration-configurations/team-viewer/{configurationId}/sessions/{sessionId}/status | Get a session status by its ID 
*TeamViewerRemoteAdministrationAPI* | [**previewRemoteAdministrationConfigurationsTeamViewerIdDelete**](docs/TeamViewerRemoteAdministrationAPI.md#previewremoteadministrationconfigurationsteamvieweriddelete) | **DELETE** /preview/remote-administration-configurations/team-viewer/{id} | Delete Team Viewer Remote Administration connection configuration
*TeamViewerRemoteAdministrationAPI* | [**previewRemoteAdministrationConfigurationsTeamViewerIdGet**](docs/TeamViewerRemoteAdministrationAPI.md#previewremoteadministrationconfigurationsteamvieweridget) | **GET** /preview/remote-administration-configurations/team-viewer/{id} | Get Team Viewer Remote Administration connection configuration
*TeamViewerRemoteAdministrationAPI* | [**previewRemoteAdministrationConfigurationsTeamViewerIdPatch**](docs/TeamViewerRemoteAdministrationAPI.md#previewremoteadministrationconfigurationsteamvieweridpatch) | **PATCH** /preview/remote-administration-configurations/team-viewer/{id} | Update Team Viewer Remote Administration connection configuration
*TeamViewerRemoteAdministrationAPI* | [**previewRemoteAdministrationConfigurationsTeamViewerIdStatusGet**](docs/TeamViewerRemoteAdministrationAPI.md#previewremoteadministrationconfigurationsteamvieweridstatusget) | **GET** /preview/remote-administration-configurations/team-viewer/{id}/status | Get Team Viewer Remote Administration connection status
*TeamViewerRemoteAdministrationAPI* | [**previewRemoteAdministrationConfigurationsTeamViewerPost**](docs/TeamViewerRemoteAdministrationAPI.md#previewremoteadministrationconfigurationsteamviewerpost) | **POST** /preview/remote-administration-configurations/team-viewer | Create Team Viewer Remote Administration connection configuration
*TimeZonesPreviewAPI* | [**v1TimeZonesGet**](docs/TimeZonesPreviewAPI.md#v1timezonesget) | **GET** /v1/time-zones | Return information about the currently supported Time Zones 
*TomcatSettingsPreviewAPI* | [**settingsIssueTomcatSslCertificatePost**](docs/TomcatSettingsPreviewAPI.md#settingsissuetomcatsslcertificatepost) | **POST** /settings/issueTomcatSslCertificate | Generate a SSL Certificate using Jamf Certificate Authority 
*UserSessionPreviewAPI* | [**userGet**](docs/UserSessionPreviewAPI.md#userget) | **GET** /user | Return all Jamf Pro user acounts 
*UserSessionPreviewAPI* | [**userUpdateSessionPost**](docs/UserSessionPreviewAPI.md#userupdatesessionpost) | **POST** /user/updateSession | Update values in the User&#39;s current session 
*VenafiPreviewAPI* | [**v1PkiVenafiIdConnectionStatusGet**](docs/VenafiPreviewAPI.md#v1pkivenafiidconnectionstatusget) | **GET** /v1/pki/venafi/{id}/connection-status | Tests the communication between Jamf Pro and a Jamf Pro PKI Proxy Server 
*VenafiPreviewAPI* | [**v1PkiVenafiIdDelete**](docs/VenafiPreviewAPI.md#v1pkivenafiiddelete) | **DELETE** /v1/pki/venafi/{id} | Delete a Venafi PKI configuration from Jamf Pro 
*VenafiPreviewAPI* | [**v1PkiVenafiIdDependentProfilesGet**](docs/VenafiPreviewAPI.md#v1pkivenafiiddependentprofilesget) | **GET** /v1/pki/venafi/{id}/dependent-profiles | Get configuration profile data using specified Venafi CA object 
*VenafiPreviewAPI* | [**v1PkiVenafiIdGet**](docs/VenafiPreviewAPI.md#v1pkivenafiidget) | **GET** /v1/pki/venafi/{id} | Retrieve a Venafi PKI configuration from Jamf Pro 
*VenafiPreviewAPI* | [**v1PkiVenafiIdHistoryGet**](docs/VenafiPreviewAPI.md#v1pkivenafiidhistoryget) | **GET** /v1/pki/venafi/{id}/history | Get specified Venafi CA history object 
*VenafiPreviewAPI* | [**v1PkiVenafiIdHistoryPost**](docs/VenafiPreviewAPI.md#v1pkivenafiidhistorypost) | **POST** /v1/pki/venafi/{id}/history | Add specified Venafi CA Object Note 
*VenafiPreviewAPI* | [**v1PkiVenafiIdJamfPublicKeyGet**](docs/VenafiPreviewAPI.md#v1pkivenafiidjamfpublickeyget) | **GET** /v1/pki/venafi/{id}/jamf-public-key | Downloads a certificate used to secure communication between Jamf Pro and a Jamf Pro PKI Proxy Server 
*VenafiPreviewAPI* | [**v1PkiVenafiIdJamfPublicKeyRegeneratePost**](docs/VenafiPreviewAPI.md#v1pkivenafiidjamfpublickeyregeneratepost) | **POST** /v1/pki/venafi/{id}/jamf-public-key/regenerate | Regenerates a certificate used to secure communication between Jamf Pro and a Jamf Pro PKI Proxy Server 
*VenafiPreviewAPI* | [**v1PkiVenafiIdPatch**](docs/VenafiPreviewAPI.md#v1pkivenafiidpatch) | **PATCH** /v1/pki/venafi/{id} | Update a Venafi PKI configuration in Jamf Pro 
*VenafiPreviewAPI* | [**v1PkiVenafiIdProxyTrustStoreDelete**](docs/VenafiPreviewAPI.md#v1pkivenafiidproxytruststoredelete) | **DELETE** /v1/pki/venafi/{id}/proxy-trust-store | Removes the PKI Proxy Server public key used to secure communication between Jamf Pro and a Jamf Pro PKI Proxy Server 
*VenafiPreviewAPI* | [**v1PkiVenafiIdProxyTrustStoreGet**](docs/VenafiPreviewAPI.md#v1pkivenafiidproxytruststoreget) | **GET** /v1/pki/venafi/{id}/proxy-trust-store | Downloads the PKI Proxy Server public key to secure communication between Jamf Pro and a Jamf Pro PKI Proxy Server 
*VenafiPreviewAPI* | [**v1PkiVenafiIdProxyTrustStorePost**](docs/VenafiPreviewAPI.md#v1pkivenafiidproxytruststorepost) | **POST** /v1/pki/venafi/{id}/proxy-trust-store | Uploads the PKI Proxy Server public key to secure communication between Jamf Pro and a Jamf Pro PKI Proxy Server 
*VenafiPreviewAPI* | [**v1PkiVenafiPost**](docs/VenafiPreviewAPI.md#v1pkivenafipost) | **POST** /v1/pki/venafi | Create a PKI configuration in Jamf Pro for Venafi 
*VolumePurchasingLocationsAPI* | [**v1VolumePurchasingLocationsGet**](docs/VolumePurchasingLocationsAPI.md#v1volumepurchasinglocationsget) | **GET** /v1/volume-purchasing-locations | Retrieve Volume Purchasing Locations
*VolumePurchasingLocationsAPI* | [**v1VolumePurchasingLocationsIdContentGet**](docs/VolumePurchasingLocationsAPI.md#v1volumepurchasinglocationsidcontentget) | **GET** /v1/volume-purchasing-locations/{id}/content | Retrieve the Volume Purchasing Content for the Volume Purchasing Location with the supplied id
*VolumePurchasingLocationsAPI* | [**v1VolumePurchasingLocationsIdDelete**](docs/VolumePurchasingLocationsAPI.md#v1volumepurchasinglocationsiddelete) | **DELETE** /v1/volume-purchasing-locations/{id} | Delete a Volume Purchasing Location with the supplied id
*VolumePurchasingLocationsAPI* | [**v1VolumePurchasingLocationsIdGet**](docs/VolumePurchasingLocationsAPI.md#v1volumepurchasinglocationsidget) | **GET** /v1/volume-purchasing-locations/{id} | Retrieve a Volume Purchasing Location with the supplied id
*VolumePurchasingLocationsAPI* | [**v1VolumePurchasingLocationsIdHistoryGet**](docs/VolumePurchasingLocationsAPI.md#v1volumepurchasinglocationsidhistoryget) | **GET** /v1/volume-purchasing-locations/{id}/history | Get specified Volume Purchasing Location history object 
*VolumePurchasingLocationsAPI* | [**v1VolumePurchasingLocationsIdHistoryPost**](docs/VolumePurchasingLocationsAPI.md#v1volumepurchasinglocationsidhistorypost) | **POST** /v1/volume-purchasing-locations/{id}/history | Add specified Volume Purchasing Location history object notes 
*VolumePurchasingLocationsAPI* | [**v1VolumePurchasingLocationsIdPatch**](docs/VolumePurchasingLocationsAPI.md#v1volumepurchasinglocationsidpatch) | **PATCH** /v1/volume-purchasing-locations/{id} | Update a Volume Purchasing Location
*VolumePurchasingLocationsAPI* | [**v1VolumePurchasingLocationsIdReclaimPost**](docs/VolumePurchasingLocationsAPI.md#v1volumepurchasinglocationsidreclaimpost) | **POST** /v1/volume-purchasing-locations/{id}/reclaim | Reclaim a Volume Purchasing Location with the supplied id
*VolumePurchasingLocationsAPI* | [**v1VolumePurchasingLocationsIdRevokeLicensesPost**](docs/VolumePurchasingLocationsAPI.md#v1volumepurchasinglocationsidrevokelicensespost) | **POST** /v1/volume-purchasing-locations/{id}/revoke-licenses | Revoke licenses for a Volume Purchasing Location with the supplied id
*VolumePurchasingLocationsAPI* | [**v1VolumePurchasingLocationsPost**](docs/VolumePurchasingLocationsAPI.md#v1volumepurchasinglocationspost) | **POST** /v1/volume-purchasing-locations | Create a Volume Purchasing Location
*VolumePurchasingSubscriptionsAPI* | [**v1VolumePurchasingSubscriptionsGet**](docs/VolumePurchasingSubscriptionsAPI.md#v1volumepurchasingsubscriptionsget) | **GET** /v1/volume-purchasing-subscriptions | Retrieve Volume Purchasing Subscriptions
*VolumePurchasingSubscriptionsAPI* | [**v1VolumePurchasingSubscriptionsIdDelete**](docs/VolumePurchasingSubscriptionsAPI.md#v1volumepurchasingsubscriptionsiddelete) | **DELETE** /v1/volume-purchasing-subscriptions/{id} | Delete a Volume Purchasing Subscription with the supplied id
*VolumePurchasingSubscriptionsAPI* | [**v1VolumePurchasingSubscriptionsIdGet**](docs/VolumePurchasingSubscriptionsAPI.md#v1volumepurchasingsubscriptionsidget) | **GET** /v1/volume-purchasing-subscriptions/{id} | Retrieve a Volume Purchasing Subscription with the supplied id
*VolumePurchasingSubscriptionsAPI* | [**v1VolumePurchasingSubscriptionsIdPut**](docs/VolumePurchasingSubscriptionsAPI.md#v1volumepurchasingsubscriptionsidput) | **PUT** /v1/volume-purchasing-subscriptions/{id} | Update a Volume Purchasing Subscription
*VolumePurchasingSubscriptionsAPI* | [**v1VolumePurchasingSubscriptionsPost**](docs/VolumePurchasingSubscriptionsAPI.md#v1volumepurchasingsubscriptionspost) | **POST** /v1/volume-purchasing-subscriptions | Create a Volume Purchasing Subscription
*VppAdminAccountsPreviewAPI* | [**vppAdminAccountsGet**](docs/VppAdminAccountsPreviewAPI.md#vppadminaccountsget) | **GET** /vpp/admin-accounts | Found all VPP Admin Accounts 
*VppSubscriptionsPreviewAPI* | [**vppSubscriptionsGet**](docs/VppSubscriptionsPreviewAPI.md#vppsubscriptionsget) | **GET** /vpp/subscriptions | Found all VPP - subscriptions 
*VppSubscriptionsPreviewAPI* | [**vppSubscriptionsIdGet**](docs/VppSubscriptionsPreviewAPI.md#vppsubscriptionsidget) | **GET** /vpp/subscriptions/{id} | Found VPP subscription by id 


## Documentation For Models

 - [AccessGroupsPreviewSearchResults](docs/AccessGroupsPreviewSearchResults.md)
 - [AccessGroupsV2SearchResults](docs/AccessGroupsV2SearchResults.md)
 - [Account](docs/Account.md)
 - [AccountDrivenUserEnrollmentSessionTokenSettings](docs/AccountDrivenUserEnrollmentSessionTokenSettings.md)
 - [AccountGroup](docs/AccountGroup.md)
 - [AccountPreferences](docs/AccountPreferences.md)
 - [AccountPreferencesV1](docs/AccountPreferencesV1.md)
 - [AccountPreferencesV4](docs/AccountPreferencesV4.md)
 - [AccountSettingsRequest](docs/AccountSettingsRequest.md)
 - [AccountSettingsResponse](docs/AccountSettingsResponse.md)
 - [AdminAccount](docs/AdminAccount.md)
 - [AdvancedSearch](docs/AdvancedSearch.md)
 - [AdvancedSearchCriteriaChoices](docs/AdvancedSearchCriteriaChoices.md)
 - [AdvancedSearchSearchResults](docs/AdvancedSearchSearchResults.md)
 - [AdvancedUserContentSearch](docs/AdvancedUserContentSearch.md)
 - [AdvancedUserContentSearchSearchResults](docs/AdvancedUserContentSearchSearchResults.md)
 - [AndroidDetails](docs/AndroidDetails.md)
 - [ApiError](docs/ApiError.md)
 - [ApiErrorCause](docs/ApiErrorCause.md)
 - [ApiIntegrationRequest](docs/ApiIntegrationRequest.md)
 - [ApiIntegrationResponse](docs/ApiIntegrationResponse.md)
 - [ApiIntegrationSearchResult](docs/ApiIntegrationSearchResult.md)
 - [ApiRole](docs/ApiRole.md)
 - [ApiRolePrivileges](docs/ApiRolePrivileges.md)
 - [ApiRoleRequest](docs/ApiRoleRequest.md)
 - [ApiRoleResult](docs/ApiRoleResult.md)
 - [AppAnalyticsSetting](docs/AppAnalyticsSetting.md)
 - [AppConfigReinstallCode](docs/AppConfigReinstallCode.md)
 - [AppPath](docs/AppPath.md)
 - [AppRequestFormInputField](docs/AppRequestFormInputField.md)
 - [AppRequestFormInputFieldSearchResults](docs/AppRequestFormInputFieldSearchResults.md)
 - [AppRequestSettings](docs/AppRequestSettings.md)
 - [AppleTvDetails](docs/AppleTvDetails.md)
 - [ApplicationAttributes](docs/ApplicationAttributes.md)
 - [ApplicationConfiguration](docs/ApplicationConfiguration.md)
 - [AssignRemoveProfileResponseSyncState](docs/AssignRemoveProfileResponseSyncState.md)
 - [Assignment](docs/Assignment.md)
 - [Attributes](docs/Attributes.md)
 - [AuthAccount](docs/AuthAccount.md)
 - [AuthAccountV1](docs/AuthAccountV1.md)
 - [AuthToken](docs/AuthToken.md)
 - [AuthTokenV1](docs/AuthTokenV1.md)
 - [AuthenticationType](docs/AuthenticationType.md)
 - [Authorization](docs/Authorization.md)
 - [AuthorizationV1](docs/AuthorizationV1.md)
 - [AvailableOsUpdates](docs/AvailableOsUpdates.md)
 - [AvailableOsUpdatesAvailableUpdates](docs/AvailableOsUpdatesAvailableUpdates.md)
 - [AvailableUpdates](docs/AvailableUpdates.md)
 - [AzureConfiguration](docs/AzureConfiguration.md)
 - [AzureConfigurationRequest](docs/AzureConfigurationRequest.md)
 - [AzureConfigurationUpdate](docs/AzureConfigurationUpdate.md)
 - [AzureMappings](docs/AzureMappings.md)
 - [AzureServerConfiguration](docs/AzureServerConfiguration.md)
 - [AzureServerConfigurationRequest](docs/AzureServerConfigurationRequest.md)
 - [AzureServerConfigurationUpdate](docs/AzureServerConfigurationUpdate.md)
 - [BrandingImageUrl](docs/BrandingImageUrl.md)
 - [Building](docs/Building.md)
 - [BuildingSearchResults](docs/BuildingSearchResults.md)
 - [CacheSettings](docs/CacheSettings.md)
 - [CategoriesSearchResults](docs/CategoriesSearchResults.md)
 - [Category](docs/Category.md)
 - [CertificateDetails](docs/CertificateDetails.md)
 - [CertificateIdentityV2](docs/CertificateIdentityV2.md)
 - [CertificateKey](docs/CertificateKey.md)
 - [CertificateRecord](docs/CertificateRecord.md)
 - [ClassicLdapMappings](docs/ClassicLdapMappings.md)
 - [ClientCheckInV2](docs/ClientCheckInV2.md)
 - [ClientCheckInV3](docs/ClientCheckInV3.md)
 - [CloudIdPCommon](docs/CloudIdPCommon.md)
 - [CloudIdPCommonRequest](docs/CloudIdPCommonRequest.md)
 - [CloudIdPCommonResponse](docs/CloudIdPCommonResponse.md)
 - [CloudLdapConnectionPoolStatistics](docs/CloudLdapConnectionPoolStatistics.md)
 - [CloudLdapConnectionStatus](docs/CloudLdapConnectionStatus.md)
 - [CloudLdapKeystore](docs/CloudLdapKeystore.md)
 - [CloudLdapKeystoreFile](docs/CloudLdapKeystoreFile.md)
 - [CloudLdapMappingsRequest](docs/CloudLdapMappingsRequest.md)
 - [CloudLdapMappingsResponse](docs/CloudLdapMappingsResponse.md)
 - [CloudLdapServerRequest](docs/CloudLdapServerRequest.md)
 - [CloudLdapServerResponse](docs/CloudLdapServerResponse.md)
 - [CloudLdapServerUpdate](docs/CloudLdapServerUpdate.md)
 - [CloudResponse](docs/CloudResponse.md)
 - [ComplianceVendorDeviceInformation](docs/ComplianceVendorDeviceInformation.md)
 - [ComputerApplication](docs/ComputerApplication.md)
 - [ComputerAttachment](docs/ComputerAttachment.md)
 - [ComputerCertificate](docs/ComputerCertificate.md)
 - [ComputerConfigurationProfile](docs/ComputerConfigurationProfile.md)
 - [ComputerContentCaching](docs/ComputerContentCaching.md)
 - [ComputerContentCachingAlert](docs/ComputerContentCachingAlert.md)
 - [ComputerContentCachingCacheDetail](docs/ComputerContentCachingCacheDetail.md)
 - [ComputerContentCachingDataMigrationError](docs/ComputerContentCachingDataMigrationError.md)
 - [ComputerContentCachingDataMigrationErrorUserInfo](docs/ComputerContentCachingDataMigrationErrorUserInfo.md)
 - [ComputerContentCachingParent](docs/ComputerContentCachingParent.md)
 - [ComputerContentCachingParentAlert](docs/ComputerContentCachingParentAlert.md)
 - [ComputerContentCachingParentCapabilities](docs/ComputerContentCachingParentCapabilities.md)
 - [ComputerContentCachingParentDetails](docs/ComputerContentCachingParentDetails.md)
 - [ComputerContentCachingParentLocalNetwork](docs/ComputerContentCachingParentLocalNetwork.md)
 - [ComputerDisk](docs/ComputerDisk.md)
 - [ComputerDiskEncryption](docs/ComputerDiskEncryption.md)
 - [ComputerExtensionAttribute](docs/ComputerExtensionAttribute.md)
 - [ComputerFont](docs/ComputerFont.md)
 - [ComputerGeneral](docs/ComputerGeneral.md)
 - [ComputerGeneralUpdate](docs/ComputerGeneralUpdate.md)
 - [ComputerGroup](docs/ComputerGroup.md)
 - [ComputerHardware](docs/ComputerHardware.md)
 - [ComputerHardwareUpdate](docs/ComputerHardwareUpdate.md)
 - [ComputerIbeacon](docs/ComputerIbeacon.md)
 - [ComputerInventory](docs/ComputerInventory.md)
 - [ComputerInventoryCollectionPreferences](docs/ComputerInventoryCollectionPreferences.md)
 - [ComputerInventoryCollectionSettings](docs/ComputerInventoryCollectionSettings.md)
 - [ComputerInventoryFileVault](docs/ComputerInventoryFileVault.md)
 - [ComputerInventoryFileVaultSearchResults](docs/ComputerInventoryFileVaultSearchResults.md)
 - [ComputerInventoryRecoveryLockPasswordResponse](docs/ComputerInventoryRecoveryLockPasswordResponse.md)
 - [ComputerInventorySearchResults](docs/ComputerInventorySearchResults.md)
 - [ComputerInventoryUpdateRequest](docs/ComputerInventoryUpdateRequest.md)
 - [ComputerLicensedSoftware](docs/ComputerLicensedSoftware.md)
 - [ComputerLocalUserAccount](docs/ComputerLocalUserAccount.md)
 - [ComputerLocation](docs/ComputerLocation.md)
 - [ComputerMdmCapability](docs/ComputerMdmCapability.md)
 - [ComputerOperatingSystem](docs/ComputerOperatingSystem.md)
 - [ComputerOperatingSystemUpdate](docs/ComputerOperatingSystemUpdate.md)
 - [ComputerOverview](docs/ComputerOverview.md)
 - [ComputerPackageReceipts](docs/ComputerPackageReceipts.md)
 - [ComputerPartition](docs/ComputerPartition.md)
 - [ComputerPartitionEncryption](docs/ComputerPartitionEncryption.md)
 - [ComputerPartitionFileVault2State](docs/ComputerPartitionFileVault2State.md)
 - [ComputerPlugin](docs/ComputerPlugin.md)
 - [ComputerPrestageSearchResultsV2](docs/ComputerPrestageSearchResultsV2.md)
 - [ComputerPrestageSearchResultsV3](docs/ComputerPrestageSearchResultsV3.md)
 - [ComputerPrestageV2](docs/ComputerPrestageV2.md)
 - [ComputerPrestageV3](docs/ComputerPrestageV3.md)
 - [ComputerPrinter](docs/ComputerPrinter.md)
 - [ComputerPurchase](docs/ComputerPurchase.md)
 - [ComputerRemoteManagement](docs/ComputerRemoteManagement.md)
 - [ComputerSection](docs/ComputerSection.md)
 - [ComputerSecurity](docs/ComputerSecurity.md)
 - [ComputerService](docs/ComputerService.md)
 - [ComputerSoftwareUpdate](docs/ComputerSoftwareUpdate.md)
 - [ComputerStorage](docs/ComputerStorage.md)
 - [ComputerUserAndLocation](docs/ComputerUserAndLocation.md)
 - [ComputersSearchResults](docs/ComputersSearchResults.md)
 - [ConfigurationProfile](docs/ConfigurationProfile.md)
 - [ConfigurationSearchResults](docs/ConfigurationSearchResults.md)
 - [ConnectionConfigurationCandidateRequest](docs/ConnectionConfigurationCandidateRequest.md)
 - [ConnectionConfigurationResponse](docs/ConnectionConfigurationResponse.md)
 - [ConnectionConfigurationStatusResponse](docs/ConnectionConfigurationStatusResponse.md)
 - [ConnectionConfigurationUpdateRequest](docs/ConnectionConfigurationUpdateRequest.md)
 - [Country](docs/Country.md)
 - [CountryCodes](docs/CountryCodes.md)
 - [CreatePath](docs/CreatePath.md)
 - [CsaToken](docs/CsaToken.md)
 - [CurrentAccount](docs/CurrentAccount.md)
 - [CurrentAuthorization](docs/CurrentAuthorization.md)
 - [DashboardApiError](docs/DashboardApiError.md)
 - [DashboardDetail](docs/DashboardDetail.md)
 - [DashboardItem](docs/DashboardItem.md)
 - [DashboardMetric](docs/DashboardMetric.md)
 - [DashboardSetup](docs/DashboardSetup.md)
 - [DashboardSetupFeatureOptions](docs/DashboardSetupFeatureOptions.md)
 - [DashboardSetupSetupTaskOptions](docs/DashboardSetupSetupTaskOptions.md)
 - [DashboardSetupTask](docs/DashboardSetupTask.md)
 - [DataRoamingSetting](docs/DataRoamingSetting.md)
 - [DatabasePassword](docs/DatabasePassword.md)
 - [DayOfWeek](docs/DayOfWeek.md)
 - [DeclarativeManagementCommand](docs/DeclarativeManagementCommand.md)
 - [DeleteUserCommand](docs/DeleteUserCommand.md)
 - [Department](docs/Department.md)
 - [DepartmentsSearchResults](docs/DepartmentsSearchResults.md)
 - [DeploymentTask](docs/DeploymentTask.md)
 - [DeploymentTaskSearchResults](docs/DeploymentTaskSearchResults.md)
 - [DeviceCommunicationSettings](docs/DeviceCommunicationSettings.md)
 - [DeviceComplianceInformation](docs/DeviceComplianceInformation.md)
 - [DeviceEnrollmentDevice](docs/DeviceEnrollmentDevice.md)
 - [DeviceEnrollmentDeviceSearchResults](docs/DeviceEnrollmentDeviceSearchResults.md)
 - [DeviceEnrollmentDisownBody](docs/DeviceEnrollmentDisownBody.md)
 - [DeviceEnrollmentDisownResponse](docs/DeviceEnrollmentDisownResponse.md)
 - [DeviceEnrollmentInstance](docs/DeviceEnrollmentInstance.md)
 - [DeviceEnrollmentInstanceSearchResults](docs/DeviceEnrollmentInstanceSearchResults.md)
 - [DeviceEnrollmentInstanceSyncStatus](docs/DeviceEnrollmentInstanceSyncStatus.md)
 - [DeviceEnrollmentPrestage](docs/DeviceEnrollmentPrestage.md)
 - [DeviceEnrollmentPrestageV2](docs/DeviceEnrollmentPrestageV2.md)
 - [DeviceEnrollmentToken](docs/DeviceEnrollmentToken.md)
 - [DiagnosticSubmissionSetting](docs/DiagnosticSubmissionSetting.md)
 - [Ebook](docs/Ebook.md)
 - [EbookExclusions](docs/EbookExclusions.md)
 - [EbookLimitations](docs/EbookLimitations.md)
 - [EbookLimitationsUsersInner](docs/EbookLimitationsUsersInner.md)
 - [EbookScope](docs/EbookScope.md)
 - [EbookSearchResults](docs/EbookSearchResults.md)
 - [EnableLostModeCommand](docs/EnableLostModeCommand.md)
 - [Engage](docs/Engage.md)
 - [EnrollmentAccessGroupPreview](docs/EnrollmentAccessGroupPreview.md)
 - [EnrollmentAccessGroupV2](docs/EnrollmentAccessGroupV2.md)
 - [EnrollmentCustomization](docs/EnrollmentCustomization.md)
 - [EnrollmentCustomizationBrandingSettings](docs/EnrollmentCustomizationBrandingSettings.md)
 - [EnrollmentCustomizationDependencies](docs/EnrollmentCustomizationDependencies.md)
 - [EnrollmentCustomizationDependency](docs/EnrollmentCustomizationDependency.md)
 - [EnrollmentCustomizationLdapGroupAccess](docs/EnrollmentCustomizationLdapGroupAccess.md)
 - [EnrollmentCustomizationPanel](docs/EnrollmentCustomizationPanel.md)
 - [EnrollmentCustomizationPanelLdapAuth](docs/EnrollmentCustomizationPanelLdapAuth.md)
 - [EnrollmentCustomizationPanelList](docs/EnrollmentCustomizationPanelList.md)
 - [EnrollmentCustomizationPanelSsoAuth](docs/EnrollmentCustomizationPanelSsoAuth.md)
 - [EnrollmentCustomizationPanelText](docs/EnrollmentCustomizationPanelText.md)
 - [EnrollmentCustomizationSearchResults](docs/EnrollmentCustomizationSearchResults.md)
 - [EnrollmentCustomizationSearchResultsV2](docs/EnrollmentCustomizationSearchResultsV2.md)
 - [EnrollmentCustomizationV2](docs/EnrollmentCustomizationV2.md)
 - [EnrollmentMethod](docs/EnrollmentMethod.md)
 - [EnrollmentMethodPrestage](docs/EnrollmentMethodPrestage.md)
 - [EnrollmentProcessTextObject](docs/EnrollmentProcessTextObject.md)
 - [EnrollmentSettingsV2](docs/EnrollmentSettingsV2.md)
 - [EnrollmentSettingsV3](docs/EnrollmentSettingsV3.md)
 - [EnrollmentSsoConfig](docs/EnrollmentSsoConfig.md)
 - [EraseDeviceCommand](docs/EraseDeviceCommand.md)
 - [EraseDeviceCommandReturnToService](docs/EraseDeviceCommandReturnToService.md)
 - [ExportField](docs/ExportField.md)
 - [ExportParameters](docs/ExportParameters.md)
 - [ExtensionAttribute](docs/ExtensionAttribute.md)
 - [ExtensionAttributeV2](docs/ExtensionAttributeV2.md)
 - [ExternalRecipient](docs/ExternalRecipient.md)
 - [FileAttachment](docs/FileAttachment.md)
 - [FileAttachmentDelete](docs/FileAttachmentDelete.md)
 - [FileAttachmentV2](docs/FileAttachmentV2.md)
 - [FontPath](docs/FontPath.md)
 - [GetComputerPrestageV2](docs/GetComputerPrestageV2.md)
 - [GetComputerPrestageV3](docs/GetComputerPrestageV3.md)
 - [GetEnrollmentCustomization](docs/GetEnrollmentCustomization.md)
 - [GetEnrollmentCustomizationPanel](docs/GetEnrollmentCustomizationPanel.md)
 - [GetEnrollmentCustomizationPanelLdapAuth](docs/GetEnrollmentCustomizationPanelLdapAuth.md)
 - [GetEnrollmentCustomizationPanelSsoAuth](docs/GetEnrollmentCustomizationPanelSsoAuth.md)
 - [GetEnrollmentCustomizationPanelText](docs/GetEnrollmentCustomizationPanelText.md)
 - [GetMobileDevicePrestage](docs/GetMobileDevicePrestage.md)
 - [GetMobileDevicePrestageV2](docs/GetMobileDevicePrestageV2.md)
 - [GroupMappings](docs/GroupMappings.md)
 - [GroupMembership](docs/GroupMembership.md)
 - [GroupTestSearch](docs/GroupTestSearch.md)
 - [GroupTestSearchRequest](docs/GroupTestSearchRequest.md)
 - [GroupTestSearchResponse](docs/GroupTestSearchResponse.md)
 - [HistorySearchResults](docs/HistorySearchResults.md)
 - [HistorySearchResultsV1](docs/HistorySearchResultsV1.md)
 - [HrefResponse](docs/HrefResponse.md)
 - [IconResponse](docs/IconResponse.md)
 - [IdAndName](docs/IdAndName.md)
 - [IdAndNameV2](docs/IdAndNameV2.md)
 - [Ids](docs/Ids.md)
 - [Initialize](docs/Initialize.md)
 - [InitializeV1](docs/InitializeV1.md)
 - [InstallPackage](docs/InstallPackage.md)
 - [InternalRecipient](docs/InternalRecipient.md)
 - [InventoryInformation](docs/InventoryInformation.md)
 - [InventoryListMobileDevice](docs/InventoryListMobileDevice.md)
 - [InventoryListMobileDeviceSearchResults](docs/InventoryListMobileDeviceSearchResults.md)
 - [InventoryPreloadCsvError](docs/InventoryPreloadCsvError.md)
 - [InventoryPreloadCsvValidationError](docs/InventoryPreloadCsvValidationError.md)
 - [InventoryPreloadCsvValidationErrorCause](docs/InventoryPreloadCsvValidationErrorCause.md)
 - [InventoryPreloadCsvValidationSuccess](docs/InventoryPreloadCsvValidationSuccess.md)
 - [InventoryPreloadExtensionAttribute](docs/InventoryPreloadExtensionAttribute.md)
 - [InventoryPreloadExtensionAttributeColumn](docs/InventoryPreloadExtensionAttributeColumn.md)
 - [InventoryPreloadExtensionAttributeColumnResult](docs/InventoryPreloadExtensionAttributeColumnResult.md)
 - [InventoryPreloadInvalidCsvResponse](docs/InventoryPreloadInvalidCsvResponse.md)
 - [InventoryPreloadRecord](docs/InventoryPreloadRecord.md)
 - [InventoryPreloadRecordSearchResults](docs/InventoryPreloadRecordSearchResults.md)
 - [InventoryPreloadRecordSearchResultsV2](docs/InventoryPreloadRecordSearchResultsV2.md)
 - [InventoryPreloadRecordV2](docs/InventoryPreloadRecordV2.md)
 - [IosBrandingConfiguration](docs/IosBrandingConfiguration.md)
 - [IosBrandingSearchResults](docs/IosBrandingSearchResults.md)
 - [IosDetails](docs/IosDetails.md)
 - [IosDetailsV2](docs/IosDetailsV2.md)
 - [JamfApplicationResponse](docs/JamfApplicationResponse.md)
 - [JamfNationCredentials](docs/JamfNationCredentials.md)
 - [JamfPackageResponse](docs/JamfPackageResponse.md)
 - [JamfProInformation](docs/JamfProInformation.md)
 - [JamfProInformationV2](docs/JamfProInformationV2.md)
 - [JamfProServerUrl](docs/JamfProServerUrl.md)
 - [JamfProVersion](docs/JamfProVersion.md)
 - [JamfProtectPlan](docs/JamfProtectPlan.md)
 - [LanguageCode](docs/LanguageCode.md)
 - [LapsAudit](docs/LapsAudit.md)
 - [LapsAuditV2](docs/LapsAuditV2.md)
 - [LapsHistory](docs/LapsHistory.md)
 - [LapsHistoryResponse](docs/LapsHistoryResponse.md)
 - [LapsPasswordAndAudits](docs/LapsPasswordAndAudits.md)
 - [LapsPasswordAndAuditsV2](docs/LapsPasswordAndAuditsV2.md)
 - [LapsPasswordAuditsResults](docs/LapsPasswordAuditsResults.md)
 - [LapsPasswordAuditsResultsV2](docs/LapsPasswordAuditsResultsV2.md)
 - [LapsPasswordResponse](docs/LapsPasswordResponse.md)
 - [LapsPasswordResponseV2](docs/LapsPasswordResponseV2.md)
 - [LapsPendingRotation](docs/LapsPendingRotation.md)
 - [LapsPendingRotationResponse](docs/LapsPendingRotationResponse.md)
 - [LapsSettingsRequest](docs/LapsSettingsRequest.md)
 - [LapsSettingsRequestV2](docs/LapsSettingsRequestV2.md)
 - [LapsSettingsResponse](docs/LapsSettingsResponse.md)
 - [LapsSettingsResponseV2](docs/LapsSettingsResponseV2.md)
 - [LapsUser](docs/LapsUser.md)
 - [LapsUserPassword](docs/LapsUserPassword.md)
 - [LapsUserPasswordRequest](docs/LapsUserPasswordRequest.md)
 - [LapsUserPasswordRequestV2](docs/LapsUserPasswordRequestV2.md)
 - [LapsUserPasswordResponse](docs/LapsUserPasswordResponse.md)
 - [LapsUserPasswordResponseV2](docs/LapsUserPasswordResponseV2.md)
 - [LapsUserPasswordV2](docs/LapsUserPasswordV2.md)
 - [LapsUserResults](docs/LapsUserResults.md)
 - [LapsUserResultsV2](docs/LapsUserResultsV2.md)
 - [LapsUserV2](docs/LapsUserV2.md)
 - [LdapConfigurationRequest](docs/LdapConfigurationRequest.md)
 - [LdapConfigurationResponse](docs/LdapConfigurationResponse.md)
 - [LdapConfigurationUpdate](docs/LdapConfigurationUpdate.md)
 - [LdapGroup](docs/LdapGroup.md)
 - [LdapGroupSearchResults](docs/LdapGroupSearchResults.md)
 - [LdapServer](docs/LdapServer.md)
 - [LinkedConnectProfile](docs/LinkedConnectProfile.md)
 - [LinkedConnectProfileSearchResults](docs/LinkedConnectProfileSearchResults.md)
 - [Locale](docs/Locale.md)
 - [Location](docs/Location.md)
 - [LocationInformation](docs/LocationInformation.md)
 - [LocationInformationV2](docs/LocationInformationV2.md)
 - [LocationV2](docs/LocationV2.md)
 - [MacOsBrandingConfiguration](docs/MacOsBrandingConfiguration.md)
 - [MacOsBrandingSearchResults](docs/MacOsBrandingSearchResults.md)
 - [MacOsManagedSoftwareUpdate](docs/MacOsManagedSoftwareUpdate.md)
 - [MacOsManagedSoftwareUpdateResponse](docs/MacOsManagedSoftwareUpdateResponse.md)
 - [ManagedSoftwareUpdatePlan](docs/ManagedSoftwareUpdatePlan.md)
 - [ManagedSoftwareUpdatePlanGroupPost](docs/ManagedSoftwareUpdatePlanGroupPost.md)
 - [ManagedSoftwareUpdatePlanPost](docs/ManagedSoftwareUpdatePlanPost.md)
 - [ManagedSoftwareUpdatePlanPostResponse](docs/ManagedSoftwareUpdatePlanPostResponse.md)
 - [ManagedSoftwareUpdatePlanToggle](docs/ManagedSoftwareUpdatePlanToggle.md)
 - [ManagedSoftwareUpdatePlans](docs/ManagedSoftwareUpdatePlans.md)
 - [ManagedSoftwareUpdateStatus](docs/ManagedSoftwareUpdateStatus.md)
 - [ManagedSoftwareUpdateStatusDevice](docs/ManagedSoftwareUpdateStatusDevice.md)
 - [ManagedSoftwareUpdateStatuses](docs/ManagedSoftwareUpdateStatuses.md)
 - [Markdown](docs/Markdown.md)
 - [MdmClientType](docs/MdmClientType.md)
 - [MdmCommand](docs/MdmCommand.md)
 - [MdmCommandClient](docs/MdmCommandClient.md)
 - [MdmCommandClientRequest](docs/MdmCommandClientRequest.md)
 - [MdmCommandRequest](docs/MdmCommandRequest.md)
 - [MdmCommandRequestCommandData](docs/MdmCommandRequestCommandData.md)
 - [MdmCommandResults](docs/MdmCommandResults.md)
 - [MdmCommandState](docs/MdmCommandState.md)
 - [MdmCommandType](docs/MdmCommandType.md)
 - [MembershipMappings](docs/MembershipMappings.md)
 - [MembershipTestSearchRequest](docs/MembershipTestSearchRequest.md)
 - [MembershipTestSearchResponse](docs/MembershipTestSearchResponse.md)
 - [MemcachedEndpoints](docs/MemcachedEndpoints.md)
 - [MobileDevice](docs/MobileDevice.md)
 - [MobileDeviceApplication](docs/MobileDeviceApplication.md)
 - [MobileDeviceApplicationInventoryDetail](docs/MobileDeviceApplicationInventoryDetail.md)
 - [MobileDeviceAttachment](docs/MobileDeviceAttachment.md)
 - [MobileDeviceAttachmentV2](docs/MobileDeviceAttachmentV2.md)
 - [MobileDeviceCertificate](docs/MobileDeviceCertificate.md)
 - [MobileDeviceCertificateV1](docs/MobileDeviceCertificateV1.md)
 - [MobileDeviceCertificateV2](docs/MobileDeviceCertificateV2.md)
 - [MobileDeviceDetails](docs/MobileDeviceDetails.md)
 - [MobileDeviceDetailsGetV2](docs/MobileDeviceDetailsGetV2.md)
 - [MobileDeviceDetailsV2](docs/MobileDeviceDetailsV2.md)
 - [MobileDeviceEbook](docs/MobileDeviceEbook.md)
 - [MobileDeviceEbookInventoryDetail](docs/MobileDeviceEbookInventoryDetail.md)
 - [MobileDeviceExtensionAttribute](docs/MobileDeviceExtensionAttribute.md)
 - [MobileDeviceExtensionAttributeResults](docs/MobileDeviceExtensionAttributeResults.md)
 - [MobileDeviceExtensionAttributeResultsExtensionAttributesInner](docs/MobileDeviceExtensionAttributeResultsExtensionAttributesInner.md)
 - [MobileDeviceGeneral](docs/MobileDeviceGeneral.md)
 - [MobileDeviceGroup](docs/MobileDeviceGroup.md)
 - [MobileDeviceHardware](docs/MobileDeviceHardware.md)
 - [MobileDeviceInventory](docs/MobileDeviceInventory.md)
 - [MobileDeviceInventorySearchResults](docs/MobileDeviceInventorySearchResults.md)
 - [MobileDeviceIosGeneral](docs/MobileDeviceIosGeneral.md)
 - [MobileDeviceIosInventory](docs/MobileDeviceIosInventory.md)
 - [MobileDeviceLostModeLocation](docs/MobileDeviceLostModeLocation.md)
 - [MobileDeviceNetwork](docs/MobileDeviceNetwork.md)
 - [MobileDevicePrestage](docs/MobileDevicePrestage.md)
 - [MobileDevicePrestageName](docs/MobileDevicePrestageName.md)
 - [MobileDevicePrestageNameV2](docs/MobileDevicePrestageNameV2.md)
 - [MobileDevicePrestageNames](docs/MobileDevicePrestageNames.md)
 - [MobileDevicePrestageNamesV2](docs/MobileDevicePrestageNamesV2.md)
 - [MobileDevicePrestageSearchResults](docs/MobileDevicePrestageSearchResults.md)
 - [MobileDevicePrestageSearchResultsV2](docs/MobileDevicePrestageSearchResultsV2.md)
 - [MobileDevicePrestageV2](docs/MobileDevicePrestageV2.md)
 - [MobileDeviceProfile](docs/MobileDeviceProfile.md)
 - [MobileDeviceProvisioningProfiles](docs/MobileDeviceProvisioningProfiles.md)
 - [MobileDevicePurchasing](docs/MobileDevicePurchasing.md)
 - [MobileDeviceResponse](docs/MobileDeviceResponse.md)
 - [MobileDeviceSearchParams](docs/MobileDeviceSearchParams.md)
 - [MobileDeviceSearchResults](docs/MobileDeviceSearchResults.md)
 - [MobileDeviceSearchResultsV2](docs/MobileDeviceSearchResultsV2.md)
 - [MobileDeviceSection](docs/MobileDeviceSection.md)
 - [MobileDeviceSecurity](docs/MobileDeviceSecurity.md)
 - [MobileDeviceServiceSubscriptions](docs/MobileDeviceServiceSubscriptions.md)
 - [MobileDeviceSharedUser](docs/MobileDeviceSharedUser.md)
 - [MobileDeviceTvOsGeneral](docs/MobileDeviceTvOsGeneral.md)
 - [MobileDeviceTvOsInventory](docs/MobileDeviceTvOsInventory.md)
 - [MobileDeviceUserAndLocation](docs/MobileDeviceUserAndLocation.md)
 - [MobileDeviceUserProfile](docs/MobileDeviceUserProfile.md)
 - [MobileDeviceV2](docs/MobileDeviceV2.md)
 - [Network](docs/Network.md)
 - [NetworkV2](docs/NetworkV2.md)
 - [Notification](docs/Notification.md)
 - [NotificationType](docs/NotificationType.md)
 - [NotificationV1](docs/NotificationV1.md)
 - [OAuthClientCredentials](docs/OAuthClientCredentials.md)
 - [ObjectHistory](docs/ObjectHistory.md)
 - [ObjectHistoryNote](docs/ObjectHistoryNote.md)
 - [ObjectHistoryV1](docs/ObjectHistoryV1.md)
 - [OrderBy](docs/OrderBy.md)
 - [PackageManifest](docs/PackageManifest.md)
 - [ParentApp](docs/ParentApp.md)
 - [ParentAppRestrictedTimes](docs/ParentAppRestrictedTimes.md)
 - [PatchPolicies](docs/PatchPolicies.md)
 - [PatchPolicyDetail](docs/PatchPolicyDetail.md)
 - [PatchPolicyDetails](docs/PatchPolicyDetails.md)
 - [PatchPolicyListView](docs/PatchPolicyListView.md)
 - [PatchPolicyLogDetail](docs/PatchPolicyLogDetail.md)
 - [PatchPolicyLogDetailAction](docs/PatchPolicyLogDetailAction.md)
 - [PatchPolicyLogEligibleRetryCount](docs/PatchPolicyLogEligibleRetryCount.md)
 - [PatchPolicyLogRetry](docs/PatchPolicyLogRetry.md)
 - [PatchPolicyLogV2](docs/PatchPolicyLogV2.md)
 - [PatchPolicyLogs](docs/PatchPolicyLogs.md)
 - [PatchPolicyV2OnDashboard](docs/PatchPolicyV2OnDashboard.md)
 - [PatchSoftwareTitleConfiguration](docs/PatchSoftwareTitleConfiguration.md)
 - [PatchSoftwareTitleConfigurationBase](docs/PatchSoftwareTitleConfigurationBase.md)
 - [PatchSoftwareTitleConfigurationDefinitionKillApp](docs/PatchSoftwareTitleConfigurationDefinitionKillApp.md)
 - [PatchSoftwareTitleConfigurationDependencies](docs/PatchSoftwareTitleConfigurationDependencies.md)
 - [PatchSoftwareTitleConfigurationDependency](docs/PatchSoftwareTitleConfigurationDependency.md)
 - [PatchSoftwareTitleConfigurationExtensionAttributes](docs/PatchSoftwareTitleConfigurationExtensionAttributes.md)
 - [PatchSoftwareTitleConfigurationPatch](docs/PatchSoftwareTitleConfigurationPatch.md)
 - [PatchSoftwareTitleDefinition](docs/PatchSoftwareTitleDefinition.md)
 - [PatchSoftwareTitleDefinitions](docs/PatchSoftwareTitleDefinitions.md)
 - [PatchSoftwareTitleExtensionAttributes](docs/PatchSoftwareTitleExtensionAttributes.md)
 - [PatchSoftwareTitlePackages](docs/PatchSoftwareTitlePackages.md)
 - [PatchSoftwareTitleReport](docs/PatchSoftwareTitleReport.md)
 - [PatchSoftwareTitleReportSearchResult](docs/PatchSoftwareTitleReportSearchResult.md)
 - [PatchSummary](docs/PatchSummary.md)
 - [PatchSummaryVersion](docs/PatchSummaryVersion.md)
 - [PersonalHotspotSetting](docs/PersonalHotspotSetting.md)
 - [PlanConfigurationPost](docs/PlanConfigurationPost.md)
 - [PlanDevice](docs/PlanDevice.md)
 - [PlanDevicePost](docs/PlanDevicePost.md)
 - [PlanDeviceResponse](docs/PlanDeviceResponse.md)
 - [PlanGroupPost](docs/PlanGroupPost.md)
 - [PlanSearchResults](docs/PlanSearchResults.md)
 - [PlanStatus](docs/PlanStatus.md)
 - [PluginPath](docs/PluginPath.md)
 - [PolicyProperties](docs/PolicyProperties.md)
 - [PolicyPropertiesV1](docs/PolicyPropertiesV1.md)
 - [PostComputerPrestageV2](docs/PostComputerPrestageV2.md)
 - [PostComputerPrestageV3](docs/PostComputerPrestageV3.md)
 - [PrestageDependencies](docs/PrestageDependencies.md)
 - [PrestageDependency](docs/PrestageDependency.md)
 - [PrestageFileAttachment](docs/PrestageFileAttachment.md)
 - [PrestageFileAttachmentV2](docs/PrestageFileAttachmentV2.md)
 - [PrestagePurchasingInformation](docs/PrestagePurchasingInformation.md)
 - [PrestagePurchasingInformationV2](docs/PrestagePurchasingInformationV2.md)
 - [PrestageScope](docs/PrestageScope.md)
 - [PrestageScopeAssignment](docs/PrestageScopeAssignment.md)
 - [PrestageScopeAssignmentV2](docs/PrestageScopeAssignmentV2.md)
 - [PrestageScopeResponse](docs/PrestageScopeResponse.md)
 - [PrestageScopeResponseV2](docs/PrestageScopeResponseV2.md)
 - [PrestageScopeUpdate](docs/PrestageScopeUpdate.md)
 - [PrestageScopeV2](docs/PrestageScopeV2.md)
 - [PrestageSyncStatus](docs/PrestageSyncStatus.md)
 - [PrestageSyncStatusV2](docs/PrestageSyncStatusV2.md)
 - [ProcessTextsSearchResults](docs/ProcessTextsSearchResults.md)
 - [ProtectRegistrationRequest](docs/ProtectRegistrationRequest.md)
 - [ProtectSettingsResponse](docs/ProtectSettingsResponse.md)
 - [ProtectUpdatableSettingsRequest](docs/ProtectUpdatableSettingsRequest.md)
 - [Purchasing](docs/Purchasing.md)
 - [PurchasingV2](docs/PurchasingV2.md)
 - [PutComputerPrestageV2](docs/PutComputerPrestageV2.md)
 - [PutComputerPrestageV3](docs/PutComputerPrestageV3.md)
 - [PutMobileDevicePrestage](docs/PutMobileDevicePrestage.md)
 - [PutMobileDevicePrestageV2](docs/PutMobileDevicePrestageV2.md)
 - [RecalculationResults](docs/RecalculationResults.md)
 - [Recipient](docs/Recipient.md)
 - [Recipients](docs/Recipients.md)
 - [RedeployJamfManagementFrameworkResponse](docs/RedeployJamfManagementFrameworkResponse.md)
 - [Reenrollment](docs/Reenrollment.md)
 - [RemoteAdministrationResponse](docs/RemoteAdministrationResponse.md)
 - [RemoteAdministrationSearchResults](docs/RemoteAdministrationSearchResults.md)
 - [RenewMdmProfileResponse](docs/RenewMdmProfileResponse.md)
 - [RestartDeviceCommand](docs/RestartDeviceCommand.md)
 - [SafelistedApp](docs/SafelistedApp.md)
 - [Script](docs/Script.md)
 - [ScriptsSearchResults](docs/ScriptsSearchResults.md)
 - [Security](docs/Security.md)
 - [SecurityV2](docs/SecurityV2.md)
 - [SelfServiceInstallSettings](docs/SelfServiceInstallSettings.md)
 - [SelfServiceInteractionSettings](docs/SelfServiceInteractionSettings.md)
 - [SelfServiceLoginSettings](docs/SelfServiceLoginSettings.md)
 - [SelfServiceSettings](docs/SelfServiceSettings.md)
 - [Session](docs/Session.md)
 - [SessionCandidateRequest](docs/SessionCandidateRequest.md)
 - [SessionDetails](docs/SessionDetails.md)
 - [SessionDetailsSearchResults](docs/SessionDetailsSearchResults.md)
 - [SessionStatus](docs/SessionStatus.md)
 - [SetAutoAdminPasswordCommand](docs/SetAutoAdminPasswordCommand.md)
 - [SetRecoveryLockCommand](docs/SetRecoveryLockCommand.md)
 - [SettingsCommand](docs/SettingsCommand.md)
 - [SharedDeviceConfiguration](docs/SharedDeviceConfiguration.md)
 - [Signature](docs/Signature.md)
 - [Site](docs/Site.md)
 - [SmartSearchCriterion](docs/SmartSearchCriterion.md)
 - [SoftwareTitleConfigurationOnDashboard](docs/SoftwareTitleConfigurationOnDashboard.md)
 - [SoftwareUpdateSettings](docs/SoftwareUpdateSettings.md)
 - [SsoFailoverData](docs/SsoFailoverData.md)
 - [SsoKeystore](docs/SsoKeystore.md)
 - [SsoKeystoreCertParseResponse](docs/SsoKeystoreCertParseResponse.md)
 - [SsoKeystoreDetails](docs/SsoKeystoreDetails.md)
 - [SsoKeystoreParse](docs/SsoKeystoreParse.md)
 - [SsoKeystoreResponse](docs/SsoKeystoreResponse.md)
 - [SsoKeystoreResponseWithDetails](docs/SsoKeystoreResponseWithDetails.md)
 - [SsoKeystoreWithDetails](docs/SsoKeystoreWithDetails.md)
 - [SsoMetadataUrl](docs/SsoMetadataUrl.md)
 - [SsoSettings](docs/SsoSettings.md)
 - [StartupStatus](docs/StartupStatus.md)
 - [StaticGroup](docs/StaticGroup.md)
 - [StaticGroupAssignment](docs/StaticGroupAssignment.md)
 - [StaticGroupSearchResults](docs/StaticGroupSearchResults.md)
 - [StaticGroupSummary](docs/StaticGroupSummary.md)
 - [StaticUserGroup](docs/StaticUserGroup.md)
 - [SupervisionIdentity](docs/SupervisionIdentity.md)
 - [SupervisionIdentityCertificateUpload](docs/SupervisionIdentityCertificateUpload.md)
 - [SupervisionIdentityCreate](docs/SupervisionIdentityCreate.md)
 - [SupervisionIdentitySearchResults](docs/SupervisionIdentitySearchResults.md)
 - [SupervisionIdentityUpdate](docs/SupervisionIdentityUpdate.md)
 - [TeacherFeatures](docs/TeacherFeatures.md)
 - [TeacherSettingsRequest](docs/TeacherSettingsRequest.md)
 - [TeacherSettingsResponse](docs/TeacherSettingsResponse.md)
 - [TimeFrame](docs/TimeFrame.md)
 - [TimeZone](docs/TimeZone.md)
 - [TvOsDetails](docs/TvOsDetails.md)
 - [Udids](docs/Udids.md)
 - [UpdateAppleTv](docs/UpdateAppleTv.md)
 - [UpdateIos](docs/UpdateIos.md)
 - [UpdateIosV2](docs/UpdateIosV2.md)
 - [UpdateMobileDevice](docs/UpdateMobileDevice.md)
 - [UpdateMobileDeviceV2](docs/UpdateMobileDeviceV2.md)
 - [UpdateTvOs](docs/UpdateTvOs.md)
 - [UserMappings](docs/UserMappings.md)
 - [UserPreferencesSettings](docs/UserPreferencesSettings.md)
 - [UserTestAttributes](docs/UserTestAttributes.md)
 - [UserTestSearch](docs/UserTestSearch.md)
 - [UserTestSearchRequest](docs/UserTestSearchRequest.md)
 - [UserTestSearchResponse](docs/UserTestSearchResponse.md)
 - [V1Site](docs/V1Site.md)
 - [VenafiCaRecord](docs/VenafiCaRecord.md)
 - [VenafiPkiPayloadRecord](docs/VenafiPkiPayloadRecord.md)
 - [VenafiPkiPayloadRecordSearchResults](docs/VenafiPkiPayloadRecordSearchResults.md)
 - [VenafiServiceStatus](docs/VenafiServiceStatus.md)
 - [VerbosePackageDeploymentResponse](docs/VerbosePackageDeploymentResponse.md)
 - [VerbosePackageDeploymentResponseErrorsInner](docs/VerbosePackageDeploymentResponseErrorsInner.md)
 - [VerbosePackageDeploymentResponseQueuedCommandsInner](docs/VerbosePackageDeploymentResponseQueuedCommandsInner.md)
 - [VoiceRoamingSetting](docs/VoiceRoamingSetting.md)
 - [VolumePurchasingContent](docs/VolumePurchasingContent.md)
 - [VolumePurchasingContentList](docs/VolumePurchasingContentList.md)
 - [VolumePurchasingLocation](docs/VolumePurchasingLocation.md)
 - [VolumePurchasingLocationListView](docs/VolumePurchasingLocationListView.md)
 - [VolumePurchasingLocationPatch](docs/VolumePurchasingLocationPatch.md)
 - [VolumePurchasingLocationPost](docs/VolumePurchasingLocationPost.md)
 - [VolumePurchasingLocations](docs/VolumePurchasingLocations.md)
 - [VolumePurchasingSubscription](docs/VolumePurchasingSubscription.md)
 - [VolumePurchasingSubscriptionBase](docs/VolumePurchasingSubscriptionBase.md)
 - [VolumePurchasingSubscriptions](docs/VolumePurchasingSubscriptions.md)
 - [VppAdminAccount](docs/VppAdminAccount.md)
 - [VppTokenSubscription](docs/VppTokenSubscription.md)
 - [WebLink](docs/WebLink.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="Bearer"></a>
### Bearer

- **Type**: HTTP Bearer Token authentication (JWT)

<a id="BasicAuth"></a>
### BasicAuth

- **Type**: HTTP basic authentication


## Author



